import Vue from 'vue'
import VueRouter from 'vue-router'
import ElementUI from 'element-ui'
import locale from 'element-ui/lib/locale/lang/en'
import 'element-ui/lib/theme-default/index.css';
import App from './app.vue'
import timeShareChart from './router/timeShareChart.vue'
import candlestickChart from './router/candlestickChart.vue'
import stockDeallas from './router/stockDeallas.vue'
import PricePointsTable from './router/pricePointsTable.vue'

Vue.use(ElementUI, { locale })
Vue.use(VueRouter)

const routes = [
  { path: '/', component: timeShareChart },
  { path: '/candlestickChart', component: candlestickChart },
  { path: '/stockDeallas', component: stockDeallas },
  { path: '/pricePointsTable', component: PricePointsTable },
];

const router = new VueRouter({
  routes 
})

new Vue({
  el: '#app',
  router,
  render: h => h(App)
})