/*
    封装图形控件 (微信小程序版本)
*/

function JSCanvasElement() {
  this.Height;
  this.Width;
  this.ID;

  //获取画布
  this.GetContext = function () {
    return wx.createCanvasContext(this.ID);
  }
}

function JSChart(element) {
  this.JSChartContainer;              //画图控件
  this.CanvasElement = element;

  this.OnSize = function () {
    if (this.JSChartContainer && this.JSChartContainer.Frame)
      this.JSChartContainer.Frame.SetSizeChage(true);

    if (this.JSChartContainer) this.JSChartContainer.Draw();
  }

  //历史K线图
  this.CreateKLineChartContainer = function (option) {
    var chart = new KLineChartContainer(this.CanvasElement);

    if (option.KLine)   //k线图的属性设置
    {
      if (option.KLine.DragMode >= 0) chart.DragMode = option.KLine.DragMode;
      if (option.KLine.Right >= 0) chart.Right = option.KLine.Right;
      if (option.KLine.Period >= 0) chart.Period = option.KLine.Period;
      if (option.KLine.MaxReqeustDataCount > 0) chart.MaxReqeustDataCount = option.KLine.MaxReqeustDataCount;
      if (option.KLine.Info && option.KLine.Info.length > 0) chart.SetKLineInfo(option.KLine.Info, false);
      if (option.KLine.KLineDoubleClick == false) chart.MinuteDialog = this.MinuteDialog = null;

      if (option.KLine.MaxRequestMinuteDayCount > 0) chart.MaxRequestMinuteDayCount = option.KLine.MaxRequestMinuteDayCount;
    }

    if (!option.Windows || option.Windows.length <= 0) return null;

    //创建子窗口
    chart.Create(option.Windows.length);

    if (option.Border) {
      if (!isNaN(option.Border.Left)) chart.Frame.ChartBorder.Left = option.Border.Left;
      if (!isNaN(option.Border.Right)) chart.Frame.ChartBorder.Right = option.Border.Right;
      if (!isNaN(option.Border.Top)) chart.Frame.ChartBorder.Top = option.Border.Top;
      if (!isNaN(option.Border.Bottom)) chart.Frame.ChartBorder.Bottom = option.Border.Bottom;
    }

    if (option.KLine) {
      if (option.KLine.PageSize > 0) {
        let maxPageSize = chart.GetMaxPageSize();
        if (maxPageSize < option.KLine.PageSize) chart.PageSize = maxPageSize;
        else chart.PageSize = option.KLine.PageSize;
      }
    }

    if (option.IsShowCorssCursorInfo == false)    //取消显示十字光标刻度信息
      chart.ChartCorssCursor.IsShowText = option.IsShowCorssCursorInfo;

    if (option.IsShowCorssCursor == false)
      chart.ChartCorssCursor.IsShow = option.IsShowCorssCursor;

    if (option.Frame) {
      for (var i in option.Frame) {
        var item = option.Frame[i];
        if (item.SplitCount) chart.Frame.SubFrame[i].Frame.YSplitOperator.SplitCount = item.SplitCount;
        if (item.StringFormat) chart.Frame.SubFrame[i].Frame.YSplitOperator.StringFormat = item.StringFormat;
        if (!isNaN(item.Height)) chart.Frame.SubFrame[i].Height = item.Height;
        if (item.IsShowBorder == false) chart.Frame.SubFrame[i].Frame.IsShowBorder = item.IsShowBorder;
        if (item.IsShowXLine == false) chart.Frame.SubFrame[i].Frame.IsShowXLine = item.IsShowXLine;
        if (item.XMessageAlign == 'bottom') chart.Frame.SubFrame[i].Frame.XMessageAlign = item.XMessageAlign;
      }
    }

    if (option.KLine) {
      if (option.KLine.ShowKLine == false) chart.ChartPaint[0].IsShow = false;
    }

    if (option.KLineTitle) {
      if (option.KLineTitle.IsShowName == false) chart.TitlePaint[0].IsShowName = false;
      if (option.KLineTitle.IsShowSettingInfo == false) chart.TitlePaint[0].IsShowSettingInfo = false;
    }

    //创建子窗口的指标
    for (var i in option.Windows) {
      var item = option.Windows[i];
      if (!isNaN(item.TitleHeight)) chart.Frame.SubFrame[i].Frame.ChartBorder.TitleHeight = item.TitleHeight;
      if (!item.Index) continue;

      var indexItem = JSIndexMap.Get(item.Index);
      if (!indexItem) continue;

      chart.WindowIndex[i] = indexItem.Create();
      chart.CreateWindowIndex(i);

      if (item.Modify != null)
        chart.Frame.SubFrame[i].Frame.ModifyIndex = item.Modify;
      if (item.Change != null)
        chart.Frame.SubFrame[i].Frame.ChangeIndex = item.Change;
      if (typeof (item.UpdateUICallback) == 'function')
        chart.WindowIndex[i].UpdateUICallback = item.UpdateUICallback;
    }

    return chart;
  }

  //自定义指数历史K线图
  this.CreateCustomKLineChartContainer = function (option) {
    var chart = new CustomKLineChartContainer(this.CanvasElement);

    if (option.KLine)   //k线图的属性设置
    {
      if (option.KLine.DragMode >= 0) chart.DragMode = option.KLine.DragMode;
      if (option.KLine.Right >= 0) chart.Right = option.KLine.Right;
      if (option.KLine.Period >= 0) chart.Period = option.KLine.Period;
      if (option.KLine.MaxReqeustDataCount > 0) chart.MaxReqeustDataCount = option.KLine.MaxReqeustDataCount;
      if (option.KLine.Info && option.KLine.Info.length > 0) chart.SetKLineInfo(option.KLine.Info, false);
      if (option.KLine.KLineDoubleClick == false) chart.MinuteDialog = this.MinuteDialog = null;
      if (option.KLine.PageSize > 0) chart.PageSize = option.KLine.PageSize;
      if (option.KLine.IsShowTooltip == false) chart.IsShowTooltip = false;
    }

    if (option.CustomStock) chart.CustomStock = option.CustomStock;
    if (option.QueryDate) chart.QueryDate = option.QueryDate;
    if (typeof (option.UpdateUICallback) == 'function') chart.UpdateUICallback = option.UpdateUICallback;

    if (!option.Windows || option.Windows.length <= 0) return null;

    //创建子窗口
    chart.Create(option.Windows.length);

    if (option.Border) {
      if (!isNaN(option.Border.Left)) chart.Frame.ChartBorder.Left = option.Border.Left;
      if (!isNaN(option.Border.Right)) chart.Frame.ChartBorder.Right = option.Border.Right;
      if (!isNaN(option.Border.Top)) chart.Frame.ChartBorder.Top = option.Border.Top;
      if (!isNaN(option.Border.Bottom)) chart.Frame.ChartBorder.Bottom = option.Border.Bottom;

    }

    if (option.IsShowCorssCursorInfo == false)    //取消显示十字光标刻度信息
    {
      chart.ChartCorssCursor.IsShowText = option.IsShowCorssCursorInfo;
    }

    if (option.Frame) {
      for (var i in option.Frame) {
        var item = option.Frame[i];
        if (item.SplitCount) chart.Frame.SubFrame[i].Frame.YSplitOperator.SplitCount = item.SplitCount;
        if (item.StringFormat) chart.Frame.SubFrame[i].Frame.YSplitOperator.StringFormat = item.StringFormat;
        if (item.XMessageAlign == 'bottom') chart.Frame.SubFrame[i].Frame.XMessageAlign = item.XMessageAlign;
      }
    }

    if (option.KLineTitle) {
      if (option.KLineTitle.IsShowName == false) chart.TitlePaint[0].IsShowName = false;
      if (option.KLineTitle.IsShowSettingInfo == false) chart.TitlePaint[0].IsShowSettingInfo = false;
    }

    //创建子窗口的指标
    for (var i in option.Windows) {
      var item = option.Windows[i];
      var indexItem = JSIndexMap.Get(item.Index);
      if (!indexItem) return null;

      chart.WindowIndex[i] = indexItem.Create();
      chart.CreateWindowIndex(i);

      if (item.Modify != null)
        chart.Frame.SubFrame[i].Frame.ModifyIndex = item.Modify;
      if (item.Change != null)
        chart.Frame.SubFrame[i].Frame.ChangeIndex = item.Change;

      if (!isNaN(item.TitleHeight)) chart.Frame.SubFrame[i].Frame.ChartBorder.TitleHeight = item.TitleHeight;
    }

    return chart;
  }

  //分钟走势图
  this.CreateMinuteChartContainer = function (option) {
    var chart = new MinuteChartContainer(this.CanvasElement);

    var windowsCount = 2;
    if (option.Windows && option.Windows.length > 0) windowsCount += option.Windows.length; //指标窗口从第3个窗口开始

    chart.Create(windowsCount);                            //创建子窗口

    if (option.IsShowCorssCursorInfo == false)    //取消显示十字光标刻度信息
    {
      chart.ChartCorssCursor.IsShowText = option.IsShowCorssCursorInfo;
    }

    if (option.Border) {
      if (!isNaN(option.Border.Left)) chart.Frame.ChartBorder.Left = option.Border.Left;
      if (!isNaN(option.Border.Right)) chart.Frame.ChartBorder.Right = option.Border.Right;
      if (!isNaN(option.Border.Top)) chart.Frame.ChartBorder.Top = option.Border.Top;
      if (!isNaN(option.Border.Bottom)) chart.Frame.ChartBorder.Bottom = option.Border.Bottom;
    }

    if (option.Frame) {
      for (var i in option.Frame) {
        var item = option.Frame[i];
        if (item.SplitCount) chart.Frame.SubFrame[i].Frame.YSplitOperator.SplitCount = item.SplitCount;
        if (item.StringFormat) chart.Frame.SubFrame[i].Frame.YSplitOperator.StringFormat = item.StringFormat;
        if (item.XMessageAlign == 'bottom') chart.Frame.SubFrame[i].Frame.XMessageAlign = item.XMessageAlign;
      }
    }

    for (var i in option.Windows) {
      var item = option.Windows[i];
      var indexItem = JSIndexMap.Get(item.Index);
      if (!indexItem) return null;

      chart.WindowIndex[2 + parseInt(i)] = indexItem.Create();       //创建子窗口3的指标
      chart.CreateWindowIndex(2 + parseInt(i));
    }

    return chart;
  }

  //历史分钟走势图
  this.CreateHistoryMinuteChartContainer = function (option) {
    var chart = new HistoryMinuteChartContainer(this.CanvasElement);

    var windowsCount = 2;
    if (option.Windows && option.Windows.length > 0) windowsCount += option.Windows.length; //指标窗口从第3个窗口开始

    chart.Create(windowsCount);                            //创建子窗口

    for (var i in option.Windows) {
      var item = option.Windows[i];
      var indexItem = JSIndexMap.Get(item.Index);
      if (!indexItem) return null;

      chart.WindowIndex[2 + parseInt(i)] = indexItem.Create();       //创建子窗口3的指标
      chart.CreateWindowIndex(2 + parseInt(i));
    }

    if (!option.HistoryMinute.TradeDate) return null;

    chart.TradeDate = option.HistoryMinute.TradeDate;
    if (option.HistoryMinute.IsShowName != null) chart.TitlePaint[0].IsShowName = option.HistoryMinute.IsShowName;  //动态标题是否显示股票名称
    if (option.HistoryMinute.IsShowDate != null) chart.TitlePaint[0].IsShowDate = option.HistoryMinute.IsShowDate;  //动态标题是否显示日期

    return chart;
  }

  //根据option内容绘制图形
  this.SetOption = function (option) {
    console.log(option, 'option')
    var chart = null;
    switch (option.Type) {
      case "历史K线图":
        chart = this.CreateKLineChartContainer(option);
        break;
      case "自定义指数历史K线图":
        chart = this.CreateCustomKLineChartContainer(option);
        break;
      case "分钟走势图":
        chart = this.CreateMinuteChartContainer(option);
        break;
      case "历史分钟走势图":
        chart = this.CreateHistoryMinuteChartContainer(option);
        break;
      case "简单图形":
        return this.CreateSimpleChart(option);
      case "饼图":
        return this.CreatePieChart(option);
      case '地图':
        return this.CreateMapChart(option);
      default:
        return false;
    }

    if (!chart) return false;

    //是否自动更新
    if (option.IsAutoUpate != null) chart.IsAutoUpate = option.IsAutoUpate;

    //设置股票代码
    if (!option.Symbol) return false;
    chart.Draw();
    chart.ChangeSymbol(option.Symbol);

    this.JSChartContainer = chart;
    this.JSChartContainer.Draw();
  }

  //切换股票代码接口
  this.ChangeSymbol = function (symbol) {
    if (this.JSChartContainer) this.JSChartContainer.ChangeSymbol(symbol);
  }

  //K线切换指标
  this.ChangeIndex = function (windowIndex, indexName) {
    if (this.JSChartContainer && typeof (this.JSChartContainer.ChangeIndex) == 'function')
      this.JSChartContainer.ChangeIndex(windowIndex, indexName);
  }

  //切换K线指标
  this.ChangeScriptIndex = function (windowIndex, indexData) {
    if (this.JSChartContainer && typeof (this.JSChartContainer.ChangeScriptIndex) == 'function')
      this.JSChartContainer.ChangeScriptIndex(windowIndex, indexData);
  }

  //K线周期切换
  this.ChangePeriod = function (period) {
    if (this.JSChartContainer && typeof (this.JSChartContainer.ChangePeriod) == 'function')
      this.JSChartContainer.ChangePeriod(period);
  }

  //K线复权切换
  this.ChangeRight = function (right) {
    if (this.JSChartContainer && typeof (this.JSChartContainer.ChangeRight) == 'function')
      this.JSChartContainer.ChangeRight(right);
  }

  //切换数据类
  this.ChangMainDataControl = function (dataControl) {
    if (this.JSChartContainer && typeof (this.JSChartContainer.SetMainDataConotrl) == 'function')
      this.JSChartContainer.SetMainDataConotrl(dataControl);
  }

  //叠加股票
  this.OverlaySymbol = function (symbol) {
    if (this.JSChartContainer && typeof (this.JSChartContainer.OverlaySymbol) == 'function')
      this.JSChartContainer.OverlaySymbol(symbol);
  }

  //设置强制横屏
  this.ForceLandscape = function (bForceLandscape) {
    if (this.JSChartContainer) {
      console.log("[JSChart::ForceLandscape] bForceLandscape=" + bForceLandscape);
      this.JSChartContainer.IsForceLandscape = bForceLandscape;
    }
  }

  this.StopAutoUpdata = function () {
    if (this.JSChartContainer && typeof (this.JSChartContainer.Stop) == 'function') {
      console.log("[JSChart::StopAutoUpdata] Stop.");
      this.JSChartContainer.Stop();
    }
  }

  this.CreateSimpleChart = function (option) {
    var chart = new SimlpleChartContainer(this.CanvasElement);
    if (option.MainDataControl) chart.MainDataControl = option.MainDataControl;
    if (option.FrameType > 0) chart.FrameType = option.FrameType;
    if (!isNaN(option.SplitCount)) chart.YSplitCount = option.SplitCount;

    chart.Create();

    if (option.Border)  //边框设置
    {
      if (!isNaN(option.Border.Left)) chart.Frame.ChartBorder.Left = option.Border.Left;
      if (!isNaN(option.Border.Right)) chart.Frame.ChartBorder.Right = option.Border.Right;
      if (!isNaN(option.Border.Top)) chart.Frame.ChartBorder.Top = option.Border.Top;
      if (!isNaN(option.Border.Bottom)) chart.Frame.ChartBorder.Bottom = option.Border.Bottom;
      if (!isNaN(option.Border.TitleHeight)) chart.Frame.ChartBorder.TitleHeight = option.Border.TitleHeight;
    }

    if (option.XFontType) chart.Frame.XFontType = option.XFontType;

    if (option.Frame) {
      if (option.Frame[0].MaxDistanceWidth) chart.Frame.MaxDistanceWidth = option.Frame[0].MaxDistanceWidth;
      if (option.Frame[0].IsShowBorder != null) chart.Frame.IsShowBorder = option.Frame[0].IsShowBorder;
      if (option.Frame[0].StringFormat) chart.Frame.YSplitOperator.StringFormat = option.Frame[0].StringFormat;
    }

    chart.Draw();
    chart.RequestData();

    this.JSChartContainer = chart;
    this.JSChartContainer.Draw();
  }

  //创建饼图
  this.CreatePieChart = function (option) {
    var chart = new PieChartContainer(this.CanvasElement);
    if (option.MainDataControl) chart.MainDataControl = option.MainDataControl;

    if (option.Radius) chart.Radius = option.Radius;

    chart.Create();

    if (option.Border)  //边框设置
    {
      if (!isNaN(option.Border.Left)) chart.Frame.ChartBorder.Left = option.Border.Left;
      if (!isNaN(option.Border.Right)) chart.Frame.ChartBorder.Right = option.Border.Right;
      if (!isNaN(option.Border.Top)) chart.Frame.ChartBorder.Top = option.Border.Top;
      if (!isNaN(option.Border.Bottom)) chart.Frame.ChartBorder.Bottom = option.Border.Bottom;
    }

    if (option.Frame) {
      if (option.Frame[0].IsShowBorder == false) chart.Frame.IsShowBorder = option.Frame[0].IsShowBorder;
    }

    chart.Draw();
    chart.RequestData();

    this.JSChartContainer = chart;
    this.JSChartContainer.Draw();

  }

  //中国地图
  this.CreateMapChart = function (option) {
    var chart = new MapChartContainer(this.CanvasElement);
    if (option.MainDataControl) chart.MainDataControl = option.MainDataControl;

    chart.Create();

    if (option.Border)  //边框设置
    {
      if (!isNaN(option.Border.Left)) chart.Frame.ChartBorder.Left = option.Border.Left;
      if (!isNaN(option.Border.Right)) chart.Frame.ChartBorder.Right = option.Border.Right;
      if (!isNaN(option.Border.Top)) chart.Frame.ChartBorder.Top = option.Border.Top;
      if (!isNaN(option.Border.Bottom)) chart.Frame.ChartBorder.Bottom = option.Border.Bottom;
    }

    if (option.Frame) {
      if (option.Frame[0].IsShowBorder == false) chart.Frame.IsShowBorder = option.Frame[0].IsShowBorder;
    }

    chart.Draw();
    chart.RequestData();

    this.JSChartContainer = chart;
    this.JSChartContainer.Draw();
  }

  this.OnTouchStart = function (e) {
    if (this.JSChartContainer) this.JSChartContainer.ontouchstart(e);
  }

  this.OnTouchMove = function (e) {
    if (this.JSChartContainer) this.JSChartContainer.ontouchmove(e);
  }

  this.OnTouchEnd = function (e) {
    if (this.JSChartContainer) this.JSChartContainer.ontouchend(e);
  }

  this.SaveToImage = function (callback) {
    if (this.JSChartContainer && typeof (this.JSChartContainer.SaveToImage) == 'function')
      this.JSChartContainer.SaveToImage(callback);
  }
}

//初始化
JSChart.Init = function (uielement) {
  var jsChartControl = new JSChart(uielement);
  jsChartControl.OnSize();

  return jsChartControl;
}

JSChart.SetDomain = function (domain, cacheDomain) {
  if (domain) {
    g_JSChartResource.Domain = domain;

    g_JSChartResource.Index.StockHistoryDayApiUrl = domain + "/API/StockHistoryDay";  //历史数据api
    g_JSChartResource.Index.MarketLongShortApiUrl = domain + "/API/FactorTiming";     //市场多空
    g_JSChartResource.Index.MarketAttentionApiUrl = domain + "/API/MarketAttention";  //市场关注度
    g_JSChartResource.Index.MarketHeatApiUrl = domain + "/API/MarketHeat";            //行业,指数热度

  }

  if (cacheDomain) g_JSChartResource.CacheDomain = cacheDomain;
}

/*//把给外界调用的方法暴露出来
export default {
    jsChartInit: JSChart.Init
}*/

/*
    图形控件
*/
function JSChartContainer(uielement) {
  var _self = this;
  this.Frame;                                     //框架画法
  this.ChartPaint = new Array();                    //图形画法
  this.ChartInfo = new Array();                     //K线上信息地雷
  this.ExtendChartPaint = new Array();              //扩展画法
  this.TitlePaint = new Array();                    //标题画法
  this.OverlayChartPaint = new Array();             //叠加信息画法
  this.ChartDrawPicture = new Array();              //画图工具
  this.CurrentChartDrawPicture = null;              //当前的画图工具
  this.SelectChartDrawPicture = null;               //当前选中的画图
  this.ChartCorssCursor;                          //十字光标
  this.ChartSplashPaint = null;                     //等待提示
  this.SplashTitle = '数据加载中';
  this.Canvas = uielement.GetContext("2d");         //画布
  this.UIElement = uielement;
  this.MouseDrag;
  this.DragMode = 1;                                //拖拽模式 0 禁止拖拽 1 数据拖拽 2 区间选择

  this.TouchTimer = null;         //触屏定时器  

  this.CursorIndex = 0;             //十字光标X轴索引
  this.LastPoint = new Point();     //鼠标位置
  this.IsForceLandscape = false;    //是否强制横屏

  //坐标轴风格方法 double-更加数值型分割  price-更加股票价格分割
  this.FrameSplitData = new Map();
  this.FrameSplitData.set("double", new SplitData());
  this.FrameSplitData.set("price", new PriceSplitData());

  this.UpdateUICallback;  //数据到达通知前端

  //判断是单个手指
  function IsPhoneDragging(e) {
    // console.log(e);
    var changed = e.changedTouches.length;
    var touching = e.touches.length;

    return changed == 1 && touching == 1;
  }

  //是否是2个手指操所
  function IsPhonePinching(e) {
    var changed = e.changedTouches.length;
    var touching = e.touches.length;

    return (changed == 1 || changed == 2) && touching == 2;
  }

  function GetToucheData(e, isForceLandscape) {
    var touches = new Array();
    for (var i = 0; i < e.touches.length; ++i) {
      var item = e.touches[i];
      if (isForceLandscape) {
        touches.push(
          {
            clientX: item.y, clientY: item.x,
            pageX: item.y, pageY: item.x
          });
      }
      else {
        touches.push(
          {
            clientX: item.x, clientY: item.y,
            pageX: item.x, pageY: item.y
          });
      }
    }

    return touches;
  }

  //手机拖拽
  this.ontouchstart = function (e) {
    var jsChart = this;
    if (jsChart.DragMode == 0) return;

    jsChart.PhonePinch = null;

    if (IsPhoneDragging(e)) {
      //长按2秒,十字光标
      if (this.TouchTimer != null) clearTimeout(this.TouchTimer);
      if (this.ChartCorssCursor.IsShow == true) {
        this.TouchTimer = setTimeout(function () {
          if (drag.Click.X == drag.LastMove.X && drag.Click.Y == drag.LastMove.Y) //手指没有移动，出现十字光标
          {
            var mouseDrag = jsChart.MouseDrag;
            jsChart.MouseDrag = null;
            //移动十字光标
            var x = drag.Click.X;
            var y = drag.Click.Y;
            if (jsChart.IsForceLandscape) y = jsChart.UIElement.Height - drag.Click.Y;    //强制横屏Y计算
            jsChart.OnMouseMove(x, y, e);
          }

        }, 800);
      }

      var drag =
        {
          "Click": {},
          "LastMove": {},  //最后移动的位置
        };

      var touches = GetToucheData(e, jsChart.IsForceLandscape);

      drag.Click.X = touches[0].clientX;
      drag.Click.Y = touches[0].clientY;
      drag.LastMove.X = touches[0].clientX;
      drag.LastMove.Y = touches[0].clientY;

      jsChart.MouseDrag = drag;
    }
    else if (IsPhonePinching(e)) {
      var phonePinch =
        {
          "Start": {},
          "Last": {}
        };

      var touches = GetToucheData(e, jsChart.IsForceLandscape);

      phonePinch.Start = { "X": touches[0].pageX, "Y": touches[0].pageY, "X2": touches[1].pageX, "Y2": touches[1].pageY };
      phonePinch.Last = { "X": touches[0].pageX, "Y": touches[0].pageY, "X2": touches[1].pageX, "Y2": touches[1].pageY };

      jsChart.PhonePinch = phonePinch;
    }
  }


  this.ontouchmove = function (e) {
    var jsChart = this;

    var touches = GetToucheData(e, jsChart.IsForceLandscape);

    if (IsPhoneDragging(e)) {
      var drag = jsChart.MouseDrag;
      if (drag == null) {
        var x = touches[0].clientX;
        var y = touches[0].clientY;
        jsChart.OnMouseMove(x, y, e);
      }
      else {
        var moveSetp = Math.abs(drag.LastMove.X - touches[0].clientX);
        moveSetp = parseInt(moveSetp);
        if (jsChart.DragMode == 1)  //数据左右拖拽
        {
          if (moveSetp < 5) return;

          var isLeft = true;
          if (drag.LastMove.X < touches[0].clientX) isLeft = false;//右移数据

          if (jsChart.DataMove(moveSetp, isLeft)) {
            jsChart.UpdataDataoffset();
            jsChart.UpdatePointByCursorIndex();
            jsChart.UpdateFrameMaxMin();
            jsChart.Draw();
          }

          drag.LastMove.X = touches[0].clientX;
          drag.LastMove.Y = touches[0].clientY;
        }
      }
    }
    else if (IsPhonePinching(e)) {
      var phonePinch = jsChart.PhonePinch;
      if (!phonePinch) return;

      var yHeight = Math.abs(touches[0].pageY - touches[1].pageY);
      var yLastHeight = Math.abs(phonePinch.Last.Y - phonePinch.Last.Y2);
      var yStep = yHeight - yLastHeight;
      if (Math.abs(yStep) < 5) return;

      if (yStep > 0)    //放大
      {
        var cursorIndex = {};
        cursorIndex.Index = parseInt(Math.abs(jsChart.CursorIndex - 0.5).toFixed(0));
        if (!jsChart.Frame.ZoomUp(cursorIndex)) return;
        jsChart.CursorIndex = cursorIndex.Index;
        jsChart.UpdatePointByCursorIndex();
        jsChart.UpdataDataoffset();
        jsChart.UpdateFrameMaxMin();
        jsChart.Draw();
      }
      else        //缩小
      {
        var cursorIndex = {};
        cursorIndex.Index = parseInt(Math.abs(jsChart.CursorIndex - 0.5).toFixed(0));
        if (!jsChart.Frame.ZoomDown(cursorIndex)) return;
        jsChart.CursorIndex = cursorIndex.Index;
        jsChart.UpdataDataoffset();
        jsChart.UpdatePointByCursorIndex();
        jsChart.UpdateFrameMaxMin();
        jsChart.Draw();
      }

      phonePinch.Last = { "X": touches[0].pageX, "Y": touches[0].pageY, "X2": touches[1].pageX, "Y2": touches[1].pageY };
    }
  }

  this.ontouchend = function (e) {
    if (this.TouchTimer != null)
      clearTimeout(this.TouchTimer);
  }

  this.Draw = function () {
    var self = this;
    this.Canvas.clearRect(0, 0, this.UIElement.Width, this.UIElement.Height);

    //框架 
    this.Frame.Draw();

    if (this.ChartSplashPaint && this.ChartSplashPaint.IsEnableSplash) {
      this.Frame.DrawInsideHorizontal();
      this.ChartSplashPaint.Draw();
      this.Canvas.draw();
      return;
    }

    for (var i in this.ChartPaint) {
      var item = this.ChartPaint[i];
      if (item.IsDrawFirst)
        item.Draw();
    }

    //框架内图形
    for (var i in this.ChartPaint) {
      var item = this.ChartPaint[i];
      if (!item.IsDrawFirst)
        item.Draw();
    }


    //叠加股票
    for (var i in this.OverlayChartPaint) {
      var item = this.OverlayChartPaint[i];
      item.Draw();
    }

    //框架外图形
    for (var i in this.ExtendChartPaint) {
      var item = this.ExtendChartPaint[i];
      item.Draw();
    }

    //框架内部坐标
    this.Frame.DrawInsideHorizontal();

    for (var i in this.TitlePaint) {
      var item = this.TitlePaint[i];
      if (!item.IsDynamic) continue;
      if (typeof (item.DrawTitle) == 'function')
        item.DrawTitle();
    }

    //坑!!.画图是异步, 保存当前屏图放在回调里面
    console.log('[JSChartContainer:Draw][ID=' + this.UIElement.ID + '] draw and save snapshot .....');

    this.Canvas.draw(false, function () {
      self.Frame.Snapshot();
    });

    //console.log('[JSChartContainer:Draw][ID=' + this.UIElement.ID + '] draw dynamic info ......');

    //动态标题都不画了(Canvas.draw 异步画的,如果下面再画会被截屏进去) 只有数据移动的时候在画
    /*
    if (this.LastPoint.X != null || this.LastPoint.Y != null)
    {
      if (this.ChartCorssCursor) 
      {
        this.ChartCorssCursor.LastPoint = this.LastPoint;
        this.ChartCorssCursor.Draw();
      }
    }

    for (var i in self.TitlePaint) 
    {
      var item = self.TitlePaint[i];
      if (!item.IsDynamic) continue;

      item.CursorIndex = self.CursorIndex;
      item.Draw();
    }

    self.Canvas.draw(true); 
    */
  }

  //画动态信息
  this.DrawDynamicInfo = function () {
    if (this.Frame.ScreenImagePath == null) return;

    var self = this;
    var isErase = false;
    if (this.ChartCorssCursor) {
      if (this.ChartCorssCursor.PointX != null || this.ChartCorssCursor.PointY != null)
        isErase = true;
    }

    isErase = true;

    if (isErase) {
      var width = this.Frame.ChartBorder.GetChartWidth();
      var height = this.Frame.ChartBorder.GetChartHeight();
      self.Canvas.drawImage(this.Frame.ScreenImagePath, 0, 0, width, height);
    }

    if (self.ChartCorssCursor) {
      self.ChartCorssCursor.LastPoint = self.LastPoint;
      self.ChartCorssCursor.Draw();
    }

    for (var i in self.TitlePaint) {
      var item = self.TitlePaint[i];
      if (!item.IsDynamic) continue;

      item.CursorIndex = self.CursorIndex;
      item.Draw();
    }

    self.Canvas.draw();
  }

  this.OnMouseMove = function (x, y, e) {
    this.LastPoint.X = x;
    this.LastPoint.Y = y;
    var lastCursorIndex = this.CursorIndex;
    this.CursorIndex = this.Frame.GetXData(x);
    if (parseInt(lastCursorIndex - 0.5) == parseInt(this.CursorIndex - 0.5)) return;  //一个一个数据移动

    if (this.IsForceLandscape) {
      //横屏图片太大不让贴,分两张图贴,多次截图的函数是坏的, 直接重画了
      this.Draw();
    }
    else {
      this.DrawDynamicInfo();
    }
  }


  this.OnDoubleClick = function (x, y, e) {
    //console.log(e);
  }

  this.UpdatePointByCursorIndex = function () {
    this.LastPoint.X = this.Frame.GetXFromIndex(this.CursorIndex);

    var index = Math.abs(this.CursorIndex - 0.5);
    index = parseInt(index.toFixed(0));
    var data = this.Frame.Data;
    if (data.DataOffset + index >= data.Data.length) {
      return;
    }
    var close = data.Data[data.DataOffset + index].Close;

    this.LastPoint.Y = this.Frame.GetYFromData(close);
  }

  this.UpdateFrameMaxMin = function () {
    var frameMaxMinData = new Array();

    var chartPaint = new Array();

    for (var i in this.ChartPaint) {
      chartPaint.push(this.ChartPaint[i]);
    }
    for (var i in this.OverlayChartPaint) {
      chartPaint.push(this.OverlayChartPaint[i]);
    }

    for (var i in chartPaint) {
      var paint = chartPaint[i];
      var range = paint.GetMaxMin();
      if (range == null || range.Max == null || range.Min == null) continue;
      var frameItem = null;
      for (var j in frameMaxMinData) {
        if (frameMaxMinData[j].Frame == paint.ChartFrame) {
          frameItem = frameMaxMinData[j];
          break;
        }
      }

      if (frameItem) {
        if (frameItem.Range.Max < range.Max) frameItem.Range.Max = range.Max;
        if (frameItem.Range.Min > range.Min) frameItem.Range.Min = range.Min;
      }
      else {
        frameItem = {};
        frameItem.Frame = paint.ChartFrame;
        frameItem.Range = range;
        frameMaxMinData.push(frameItem);
      }
    }

    for (var i in frameMaxMinData) {
      var item = frameMaxMinData[i];
      if (!item.Frame || !item.Range) continue;
      if (item.Range.Max == null || item.Range.Min == null) continue;
      if (item.Frame.YSpecificMaxMin) {
        item.Frame.HorizontalMax = item.Frame.YSpecificMaxMin.Max;
        item.Frame.HorizontalMin = item.Frame.YSpecificMaxMin.Min;
      }
      else {
        item.Frame.HorizontalMax = item.Range.Max;
        item.Frame.HorizontalMin = item.Range.Min;
      }
      item.Frame.XYSplit = true;
    }
  }

  this.DataMoveLeft = function () {
    var data = null;
    if (!this.Frame.Data) data = this.Frame.Data;
    else data = this.Frame.SubFrame[0].Frame.Data;
    if (!data) return false;
    if (data.DataOffset <= 0) return false;
    --data.DataOffset;
    return true;
  }

  this.DataMoveRight = function () {
    var data = null;
    if (!this.Frame.Data) data = this.Frame.Data;
    else data = this.Frame.SubFrame[0].Frame.Data;
    if (!data) return false;

    var xPointcount = 0;
    if (this.Frame.XPointCount) xPointcount = this.Frame.XPointCount;
    else xPointcount = this.Frame.SubFrame[0].Frame.XPointCount;
    if (!xPointcount) return false;

    if (xPointcount + data.DataOffset >= data.Data.length) return false;

    ++data.DataOffset;
    return true;
  }

  this.UpdataDataoffset = function () {
    var data = null;
    if (this.Frame.Data)
      data = this.Frame.Data;
    else
      data = this.Frame.SubFrame[0].Frame.Data;

    if (!data) return;

    for (var i in this.ChartPaint) {
      var item = this.ChartPaint[i];
      if (!item.Data) continue;
      item.Data.DataOffset = data.DataOffset;
    }

    for (var i in this.OverlayChartPaint) {
      var item = this.OverlayChartPaint[i];
      if (!item.Data) continue;
      item.Data.DataOffset = data.DataOffset;
    }
  }

  this.DataMove = function (step, isLeft) {
    var data = null;

    if (!this.Frame.Data) data = this.Frame.Data;
    else data = this.Frame.SubFrame[0].Frame.Data;
    if (!data) return false;

    var xPointcount = 0;
    if (this.Frame.XPointCount) xPointcount = this.Frame.XPointCount;
    else xPointcount = this.Frame.SubFrame[0].Frame.XPointCount;
    if (!xPointcount) return false;

    if (isLeft) //-->
    {
      if (xPointcount + data.DataOffset >= data.Data.length) return false;

      data.DataOffset += step;

      if (data.DataOffset + xPointcount >= data.Data.length)
        data.DataOffset = data.Data.length - xPointcount;

      return true;
    }
    else        //<--
    {
      if (data.DataOffset <= 0) return false;

      data.DataOffset -= step;
      if (data.DataOffset < 0) data.DataOffset = 0;

      return true;
    }
  }

  //获取鼠标在当前子窗口id
  this.GetSubFrameIndex = function (x, y) {
    if (!this.Frame.SubFrame || this.Frame.SubFrame.length <= 0) return -1;

    for (var i in this.Frame.SubFrame) {
      var frame = this.Frame.SubFrame[i].Frame;
      var left = frame.ChartBorder.GetLeft();
      var top = frame.ChartBorder.GetTop();
      var height = frame.ChartBorder.GetHeight();
      var width = frame.ChartBorder.GetWidth();

      this.Canvas.rect(left, top, width, height);
      if (this.Canvas.isPointInPath(x, y)) return parseInt(i);

    }
    return 0;
  }

  //根据X坐标获取数据索引
  this.GetDataIndexByPoint = function (x) {
    var frame = this.Frame;
    if (this.Frame.SubFrame && this.Frame.SubFrame.length > 0) frame = this.Frame.SubFrame[0].Frame;

    var data = null;
    if (this.Frame.Data)
      data = this.Frame.Data;
    else
      data = this.Frame.SubFrame[0].Frame.Data;

    if (!data || !frame) return;

    var index = parseInt(frame.GetXData(x));

    //console.log('x='+ x +' date='+data.Data[data.DataOffset+index].Date);
    return data.DataOffset + index;
  }

  this.SaveToImage = function (callback) {
    let width = this.UIElement.Width;
    let height = this.UIElement.Height;;

    console.log('[JSChartContainer::SaveToImage]', this.UIElement);

    wx.canvasToTempFilePath({
      x: 0,
      y: 0,
      width: width,
      height: height,
      canvasId: this.UIElement.ID,
      success: function (res) {
        let data = { ImagePath: res.tempFilePath, Width: width, Height: height };
        if (typeof (callback) == 'function') callback(data);
      }
    })
  }
}

function ToFixed(number, precision) {
  var b = 1;
  if (isNaN(number)) return number;
  if (number < 0) b = -1;
  var multiplier = Math.pow(10, precision);
  var value = Math.round(Math.abs(number) * multiplier) / multiplier * b;

  var s = value.toString();
  var rs = s.indexOf('.');
  if (rs < 0 && precision > 0) {
    rs = s.length;
    s += '.';
  }

  while (s.length <= rs + precision) {
    s += '0';
  }

  return s;
}

Number.prototype.toFixed = function (precision) {
  return ToFixed(this, precision)
}

function Guid() {
  function S4() {
    return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
  }
  return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
}

function GetScrollPosition() {
  var scrollPos = {};
  var scrollTop = 0;
  var scrollLeft = 0;
  if (document.documentElement && document.documentElement.scrollTop) {
    scrollTop = document.documentElement.scrollTop;
    scrollLeft = document.documentElement.scrollLeft;
  } else if (document.body) {
    scrollTop = document.body.scrollTop;
    scrollLeft = document.body.scrollLeft;
  }

  scrollPos.Top = scrollTop;
  scrollPos.Left = scrollLeft;
  return scrollPos;
}

//修正线段有毛刺
function ToFixedPoint(value) {
  //return value;
  return parseInt(value) + 0.5;
}

function ToFixedRect(value) {
  // With a bitwise or.
  //rounded = (0.5 + somenum) | 0;
  // A double bitwise not.
  //rounded = ~~ (0.5 + somenum);
  // Finally, a left bitwise shift.
  var rounded;
  return rounded = (0.5 + value) << 0;
}



function Point() {
  this.X;
  this.Y;
}

function SelectRectData() {
  this.Data;                  //主数据
  this.JSChartContainer;      //行情控件

  this.Start; //数据起始位子
  this.End;   //数据结束位置

  this.XStart;//X坐标起始位置
  this.XEnd;  //X位置结束为止
}

//坐标信息
function CoordinateInfo() {
  this.Value;                                                 //坐标数据
  this.Message = new Array();                                   //坐标输出文字信息
  this.TextColor = g_JSChartResource.FrameSplitTextColor        //文字颜色
  this.Font = g_JSChartResource.FrameSplitTextFont;             //字体
  this.LineColor = g_JSChartResource.FrameSplitPen;             //线段颜色
}


//边框信息
function ChartBorder() {
  this.UIElement;

  //四周间距
  this.Left = 50;
  this.Right = 80;
  this.Top = 50;
  this.Bottom = 50;
  this.TitleHeight = 24;    //标题高度

  this.GetChartWidth = function () {
    return this.UIElement.Width;
  }

  this.GetChartHeight = function () {
    return this.UIElement.Height;
  }

  this.GetLeft = function () {
    return this.Left;
  }

  this.GetRight = function () {
    return this.UIElement.Width - this.Right;
  }

  this.GetTop = function () {
    return this.Top;
  }

  this.GetTopEx = function ()    //去掉标题
  {
    return this.Top + this.TitleHeight;
  }

  this.GetBottom = function () {
    return this.UIElement.Height - this.Bottom;
  }

  this.GetWidth = function () {
    return this.UIElement.Width - this.Left - this.Right;
  }

  this.GetHeight = function () {
    return this.UIElement.Height - this.Top - this.Bottom;
  }

  this.GetHeightEx = function () //去掉标题的高度
  {
    return this.UIElement.Height - this.Top - this.Bottom - this.TitleHeight;
  }

  this.GetTitleHeight = function () {
    return this.TitleHeight;
  }
}

function IChartFramePainting() {
  this.HorizontalInfo = new Array();    //Y轴
  this.VerticalInfo = new Array();      //X轴

  this.Canvas;                        //画布

  this.Identify;                      //窗口标识

  this.ChartBorder;
  this.PenBorder = g_JSChartResource.FrameBorderPen;        //边框颜色
  this.TitleBGColor = g_JSChartResource.FrameTitleBGColor;  //标题背景色
  this.IsShow = true;                   //是否显示
  this.SizeChange = true;               //大小是否改变
  this.XYSplit = true;                  //XY轴坐标信息改变

  this.HorizontalMax;                 //Y轴最大值
  this.HorizontalMin;                 //Y轴最小值
  this.XPointCount = 10;                //X轴数据个数

  this.YSplitOperator;               //Y轴分割
  this.XSplitOperator;               //X轴分割
  this.Data;                         //主数据

  this.YSpecificMaxMin = null;         //指定Y轴最大最小值

  this.IsShowBorder = true;            //是否显示边框

  this.Draw = function () {
    this.DrawFrame();
    this.DrawBorder();

    this.SizeChange = false;
    this.XYSplit = false;
  }

  this.DrawFrame = function () { }

  //画边框
  this.DrawBorder = function () {
    if (!this.IsShowBorder) return;

    var left = ToFixedPoint(this.ChartBorder.GetLeft());
    var top = ToFixedPoint(this.ChartBorder.GetTop());
    var right = ToFixedPoint(this.ChartBorder.GetRight());
    var bottom = ToFixedPoint(this.ChartBorder.GetBottom());
    var width = right - left;
    var height = bottom - top;
    this.Canvas.strokeStyle = this.PenBorder;
    this.Canvas.strokeRect(left, top, width, height);
  }

  //画标题背景色
  this.DrawTitleBG = function () {
    /* 指标信息背景色不画,画了感觉框架变小了
    if (this.ChartBorder.TitleHeight<=0) return;

    var left=ToFixedPoint(this.ChartBorder.GetLeft());
    var top=ToFixedPoint(this.ChartBorder.GetTop());
    var right=ToFixedPoint(this.ChartBorder.GetRight());
    var bottom=ToFixedPoint(this.ChartBorder.GetTopEx());
    var width=right-left;
    var height=bottom-top;

    this.Canvas.fillStyle=this.TitleBGColor;
    this.Canvas.fillRect(left,top,width,height);
    */
  }
}


//空框架只画边框
function NoneFrame() {
  this.newMethod = IChartFramePainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Snapshot = function () {

  }

  this.DrawInsideHorizontal = function () {

  }

  this.SetSizeChage = function (sizeChange) {
    this.SizeChange = sizeChange;

    //画布的位置
    this.Position =
      {
        X: this.ChartBorder.UIElement.offsetLeft,
        Y: this.ChartBorder.UIElement.offsetTop,
        W: this.ChartBorder.UIElement.clientWidth,
        H: this.ChartBorder.UIElement.clientHeight
      };
  }
}

function AverageWidthFrame() {
  this.newMethod = IChartFramePainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.DataWidth = 50;
  this.DistanceWidth = 10;
  this.MinXDistance = 30;       //X轴刻度最小间距
  this.IsShowXLine = true;      //是否显示X轴分割线
  this.XMessageAlign = 'top';         //X轴刻度文字上下对齐方式

  this.DrawFrame = function () {
    if (this.XPointCount > 0) {
      this.DistanceWidth = this.ChartBorder.GetWidth() / (4 * this.XPointCount);
      this.DataWidth = 2 * this.DistanceWidth;
    }

    this.DrawHorizontal();
    this.DrawVertical();
  }

  this.GetYFromData = function (value) {
    if (value <= this.HorizontalMin) return this.ChartBorder.GetBottom();
    if (value >= this.HorizontalMax) return this.ChartBorder.GetTopEx();

    var height = this.ChartBorder.GetHeightEx() * (value - this.HorizontalMin) / (this.HorizontalMax - this.HorizontalMin);
    return this.ChartBorder.GetBottom() - height;
  }

  //Y刻度画在内部
  this.DrawInsideHorizontal = function () {
    var left = this.ChartBorder.GetLeft();
    var right = this.ChartBorder.GetRight();
    var bottom = this.ChartBorder.GetBottom();
    var top = this.ChartBorder.GetTopEx();
    var borderRight = this.ChartBorder.Right;
    var borderLeft = this.ChartBorder.Left;
    var titleHeight = this.ChartBorder.TitleHeight;
    if (borderLeft >= 10) return;

    var yPrev = null; //上一个坐标y的值
    for (var i = this.HorizontalInfo.length - 1; i >= 0; --i)  //从上往下画分割线
    {
      var item = this.HorizontalInfo[i];
      var y = this.GetYFromData(item.Value);
      if (y != null && Math.abs(y - yPrev) < 15) continue;  //两个坐标在近了 就不画了

      //坐标信息 左边 间距小于10 画在内部
      if (item.Message[0] != null && borderLeft < 10) {
        if (item.Font != null) this.Canvas.font = item.Font;
        this.Canvas.fillStyle = item.TextColor;
        this.Canvas.textAlign = "left";
        if (y >= bottom - 2)
          this.Canvas.textBaseline = 'bottom';
        else if (y <= top + 2)
          this.Canvas.textBaseline = 'top';
        else
          this.Canvas.textBaseline = "middle";
        this.Canvas.fillText(item.Message[0], left + 1, y);
      }

      yPrev = y;
    }
  }

  //画Y轴
  this.DrawHorizontal = function () {
    var left = this.ChartBorder.GetLeft();
    var right = this.ChartBorder.GetRight();
    var borderRight = this.ChartBorder.Right;
    var borderLeft = this.ChartBorder.Left;
    var titleHeight = this.ChartBorder.TitleHeight;

    this.Canvas.save();
    this.Canvas.setLineDash([2, 2]);   //虚线

    var yPrev = null; //上一个坐标y的值
    for (var i = this.HorizontalInfo.length - 1; i >= 0; --i)  //从上往下画分割线
    {
      var item = this.HorizontalInfo[i];
      var y = this.GetYFromData(item.Value);
      if (y != null && yPrev != null && Math.abs(y - yPrev) < 15) continue;  //两个坐标在近了 就不画了

      this.Canvas.strokeStyle = item.LineColor;
      this.Canvas.beginPath();
      this.Canvas.moveTo(left, ToFixedPoint(y));
      this.Canvas.lineTo(right, ToFixedPoint(y));
      this.Canvas.stroke();

      //坐标信息 左边 间距小于10 不画坐标
      if (item.Message[0] != null && borderLeft > 10) {
        if (item.Font != null) this.Canvas.font = item.Font;

        this.Canvas.fillStyle = item.TextColor;
        this.Canvas.textAlign = "right";
        this.Canvas.textBaseline = "middle";
        this.Canvas.fillText(item.Message[0], left - 2, y);
      }

      //坐标信息 右边 间距小于10 不画坐标
      if (item.Message[1] != null && borderRight > 10) {
        if (item.Font != null) this.Canvas.font = item.Font;

        this.Canvas.fillStyle = item.TextColor;
        this.Canvas.textAlign = "left";
        this.Canvas.textBaseline = "middle";
        this.Canvas.fillText(item.Message[1], right + 2, y);
      }

      yPrev = y;
    }

    this.Canvas.restore();
  }

  this.GetXFromIndex = function (index) {
    var count = this.XPointCount;

    if (count == 1) {
      if (index == 0) return this.ChartBorder.GetLeft();
      else return this.ChartBorder.GetRight();
    }
    else if (count <= 0) {
      return this.ChartBorder.GetLeft();
    }
    else if (index >= count) {
      return this.ChartBorder.GetRight();
    }
    else {
      var offset = this.ChartBorder.GetLeft() + this.ChartBorder.GetWidth() * index / count;
      return offset;
    }
  }

  //画X轴
  this.DrawVertical = function () {
    var top = this.ChartBorder.GetTopEx();
    var bottom = this.ChartBorder.GetBottom();
    var right = this.ChartBorder.GetRight();

    var yText = bottom;
    if (this.XMessageAlign == 'bottom')
      yText = this.ChartBorder.GetChartHeight();
    else this.XMessageAlign = 'top';

    var xPrev = null; //上一个坐标x的值
    let xPrevTextRight = null;
    for (var i in this.VerticalInfo) {
      var x = this.GetXFromIndex(this.VerticalInfo[i].Value);
      if (x >= right) break;
      if (xPrev != null && Math.abs(x - xPrev) < this.MinXDistance) continue;

      if (this.IsShowXLine) {
        this.Canvas.strokeStyle = this.VerticalInfo[i].LineColor;
        this.Canvas.beginPath();
        this.Canvas.moveTo(ToFixedPoint(x), top);
        this.Canvas.lineTo(ToFixedPoint(x), bottom);
        this.Canvas.stroke();
      }

      if (this.VerticalInfo[i].Message[0] != null) {
        let xTextRight = null;
        let xTextLeft = null;
        if (this.VerticalInfo[i].Font != null)
          this.Canvas.font = this.VerticalInfo[i].Font;

        this.Canvas.fillStyle = this.VerticalInfo[i].TextColor;

        var testWidth = this.Canvas.measureText(this.VerticalInfo[i].Message[0]).width;
        if (x < testWidth / 2) {
          this.Canvas.textAlign = "left";
          this.Canvas.textBaseline = this.XMessageAlign;
          xTextRight = x + testWidth;
          xTextLeft = x;
        }
        else {
          this.Canvas.textAlign = "center";
          this.Canvas.textBaseline = this.XMessageAlign;
          xTextRight = x + testWidth / 2;
          xTextLeft = x - testWidth / 2;
        }

        if (xPrevTextRight != null && xPrevTextRight > xTextLeft) continue;

        //console.log('[AverageWidthFrame::DrawVertical]', this.Canvas.fillStyle,x, yText);

        this.Canvas.fillText(this.VerticalInfo[i].Message[0], x, yText);
        xPrevTextRight = xTextRight;
      }

      xPrev = x;
    }
  }

  //Y坐标转y轴数值
  this.GetYData = function (y) {
    if (y < this.ChartBorder.GetTopEx()) return this.HorizontalMax;
    if (y > this.ChartBorder.GetBottom()) return this.HorizontalMin;

    return (this.ChartBorder.GetBottom() - y) / this.ChartBorder.GetHeightEx() * (this.HorizontalMax - this.HorizontalMin) + this.HorizontalMin;
  }

  //X坐标转x轴数值
  this.GetXData = function (x) {
    if (x <= this.ChartBorder.GetLeft()) return 0;
    if (x >= this.ChartBorder.GetRight()) return this.XPointCount;

    return (x - this.ChartBorder.GetLeft()) * (this.XPointCount * 1.0 / this.ChartBorder.GetWidth());
  }
}

function MinuteFrame() {
  this.newMethod = AverageWidthFrame;   //派生
  this.newMethod();
  delete this.newMethod;

  this.DrawFrame = function () {
    this.SplitXYCoordinate();

    this.DrawTitleBG();
    this.DrawHorizontal();
    this.DrawVertical();
  }

  //分割x,y轴坐标信息
  this.SplitXYCoordinate = function () {
    if (this.XYSplit == false) return;
    if (this.YSplitOperator != null) this.YSplitOperator.Operator();
    if (this.XSplitOperator != null) this.XSplitOperator.Operator();
  }

  this.GetXFromIndex = function (index) {
    var count = this.XPointCount - 1;

    if (count == 1) {
      if (index == 0) return this.ChartBorder.GetLeft();
      else return this.ChartBorder.GetRight();
    }
    else if (count <= 0) {
      return this.ChartBorder.GetLeft();
    }
    else if (index >= count) {
      return this.ChartBorder.GetRight();
    }
    else {
      var offset = this.ChartBorder.GetLeft() + this.ChartBorder.GetWidth() * index / count;
      return offset;
    }
  }
}

//K线框架
function KLineFrame() {
  this.newMethod = AverageWidthFrame;   //派生
  this.newMethod();
  delete this.newMethod;

  this.ToolbarID = Guid();  //工具条Div id

  this.ModifyIndex = true;  //是否显示'改参数'菜单
  this.ChangeIndex = true;  //是否显示'换指标'菜单

  this.DrawFrame = function () {
    this.SplitXYCoordinate();

    if (this.SizeChange == true) this.CalculateDataWidth();

    this.DrawTitleBG();
    this.DrawHorizontal();
    this.DrawVertical();
  }

  this.GetXFromIndex = function (index) {
    if (index < 0) index = 0;
    if (index > this.xPointCount - 1) index = this.xPointCount - 1;

    var offset = this.ChartBorder.GetLeft() + 2 + this.DistanceWidth / 2 + this.DataWidth / 2;
    for (var i = 1; i <= index; ++i) {
      offset += this.DistanceWidth + this.DataWidth;
    }

    return offset;
  }

  //计算数据宽度
  this.CalculateDataWidth = function () {
    if (this.XPointCount < 2) return;

    var width = this.ChartBorder.GetWidth();

    for (var i = 0; i < ZOOM_SEED.length; ++i) {
      if ((ZOOM_SEED[i][0] + ZOOM_SEED[i][1]) * this.XPointCount < width) {
        this.ZoomIndex = i;
        this.DataWidth = ZOOM_SEED[i][0];
        this.DistanceWidth = ZOOM_SEED[i][1];
        if (i == 0) break;      // 如果是最大的缩放因子，不再调整数据宽度

        this.TrimKLineDataWidth(width);
        return;
      }
    }
  }

  this.TrimKLineDataWidth = function (width) {
    while (true) {
      if ((this.DistanceWidth + this.DataWidth) * this.XPointCount + this.DistanceWidth > width) {
        this.DataWidth -= 0.01;
        break;
      }
      this.DataWidth += 0.01;
    }
  }

  //分割x,y轴坐标信息
  this.SplitXYCoordinate = function () {
    if (this.XYSplit == false) return;
    if (this.YSplitOperator != null) this.YSplitOperator.Operator();
    if (this.XSplitOperator != null) this.XSplitOperator.Operator();
  }

  this.CalculateCount = function (zoomIndex) {
    var width = this.ChartBorder.GetWidth();

    return parseInt(width / (ZOOM_SEED[zoomIndex][0] + ZOOM_SEED[zoomIndex][1]));
  }

  this.ZoomUp = function (cursorIndex) {
    if (this.ZoomIndex <= 0) return false;
    if (this.Data.DataOffset < 0) return false;

    var lastDataIndex = this.Data.DataOffset + this.XPointCount - 1;    //最右边的数据索引
    var lastCursorIndex = this.Data.DataOffset + cursorIndex.Index;

    if (lastDataIndex > this.Data.Data.length) lastDataIndex = this.Data.Data.length - 1;

    --this.ZoomIndex;
    var xPointCount = this.CalculateCount(this.ZoomIndex);

    this.XPointCount = xPointCount;

    this.DataWidth = ZOOM_SEED[this.ZoomIndex][0];
    this.DistanceWidth = ZOOM_SEED[this.ZoomIndex][1];

    this.TrimKLineDataWidth(this.ChartBorder.GetWidth());

    if (lastDataIndex >= this.Data.Data.length) {
      this.Data.DataOffset = this.Data.Data.length - this.XPointCount - 2;
      cursorIndex.Index = this.Data.Data.length - this.Data.DataOffset - 1;
    }
    else {
      if (lastDataIndex < this.XPointCount) {
        this.Data.DataOffset = 0;
        cursorIndex.Index = lastCursorIndex;
      }
      else {
        this.Data.DataOffset = lastDataIndex - this.XPointCount + 1;
        cursorIndex.Index = lastCursorIndex - this.Data.DataOffset;
      }
    }

    return true;
  }

  this.ZoomDown = function (cursorIndex) {
    if (this.ZoomIndex + 1 >= ZOOM_SEED.length) return false;
    if (this.Data.DataOffset < 0) return false;

    var lastDataIndex = this.Data.DataOffset + this.XPointCount - 1;    //最右边的数据索引
    if (lastDataIndex >= this.Data.Data.length) lastDataIndex = this.Data.Data.length - 1;
    var xPointCount = this.CalculateCount(this.ZoomIndex + 1);

    var lastCursorIndex = this.Data.DataOffset + cursorIndex.Index;

    ++this.ZoomIndex;
    this.XPointCount = xPointCount;
    this.DataWidth = ZOOM_SEED[this.ZoomIndex][0];
    this.DistanceWidth = ZOOM_SEED[this.ZoomIndex][1];

    this.TrimKLineDataWidth(this.ChartBorder.GetWidth());

    if (lastDataIndex - xPointCount + 1 < 0)
      this.Data.DataOffset = 0;
    else
      this.Data.DataOffset = lastDataIndex - this.XPointCount + 1;

    cursorIndex.Index = lastCursorIndex - this.Data.DataOffset;

    return true;
  }
}

function SubFrameItem() {
  this.Frame;
  this.Height;
}

//行情框架
function HQTradeFrame() {
  this.SubFrame = new Array();              //SubFrameItem 数组
  this.SizeChange = true;                   //大小是否改变
  this.ChartBorder;
  this.Canvas;                            //画布
  this.ScreenImagePath;                   //截图路径           
  this.Data;                              //主数据
  this.Position;                          //画布的位置

  var SizeChange;

  this.CalculateChartBorder = function ()    //计算每个子框架的边框信息
  {
    if (this.SubFrame.length <= 0) return;

    var top = this.ChartBorder.GetTop();
    var height = this.ChartBorder.GetHeight();
    var totalHeight = 0;

    for (var i in this.SubFrame) {
      var item = this.SubFrame[i];
      totalHeight += item.Height;
    }

    for (var i in this.SubFrame) {
      var item = this.SubFrame[i];
      item.Frame.ChartBorder.Top = top;
      item.Frame.ChartBorder.Left = this.ChartBorder.Left;
      item.Frame.ChartBorder.Right = this.ChartBorder.Right;
      var frameHeight = height * (item.Height / totalHeight) + top;
      item.Frame.ChartBorder.Bottom = this.ChartBorder.GetChartHeight() - frameHeight;
      top = frameHeight;
    }

  }

  this.Draw = function () {
    if (this.SizeChange == true) this.CalculateChartBorder();

    for (var i in this.SubFrame) {
      var item = this.SubFrame[i];
      item.Frame.Draw();
    }

    SizeChange = false;
  }

  this.DrawInsideHorizontal = function () {
    for (var i in this.SubFrame) {
      var item = this.SubFrame[i];
      item.Frame.DrawInsideHorizontal();
    }
  }

  this.SetSizeChage = function (sizeChange) {
    this.SizeChange = sizeChange;

    for (var i in this.SubFrame) {
      var item = this.SubFrame[i];
      item.Frame.SizeChange = sizeChange;
    }

    //画布的位置
    this.Position = {
      X: this.ChartBorder.UIElement.offsetLeft,
      Y: this.ChartBorder.UIElement.offsetTop,
      W: this.ChartBorder.UIElement.clientWidth,
      H: this.ChartBorder.UIElement.clientHeight
    };
  }

  //图形快照
  this.Snapshot = function () {
    var self = this;
    var width = this.ChartBorder.GetChartWidth();
    var height = this.ChartBorder.GetChartHeight();

    console.log('[HQTradeFrame::Snapshot][ID=' + this.ChartBorder.UIElement.ID + '] invoke canvasToTempFilePath' + '(width=' + width + ',height=' + height + ')');

    wx.canvasToTempFilePath({
      x: 0,
      y: 0,
      width: width,
      height: height,
      canvasId: this.ChartBorder.UIElement.ID,
      success: function (res) {
        self.ScreenImagePath = res.tempFilePath;
        console.log(res.tempFilePath)
      }
    })
  }

  this.GetXData = function (x) {
    return this.SubFrame[0].Frame.GetXData(x);
  }

  this.GetYData = function (y) {
    var frame;
    for (var i in this.SubFrame) {
      var item = this.SubFrame[i];
      var left = item.Frame.ChartBorder.GetLeft();
      var top = item.Frame.ChartBorder.GetTopEx();
      var width = item.Frame.ChartBorder.GetWidth();
      var height = item.Frame.ChartBorder.GetHeightEx();

      var rtItem = new Rect(left, top, width, height);
      item.Frame.Canvas.beginPath();
      item.Frame.Canvas.rect(left, top, width, height);
      if (rtItem.IsPointIn(left, y)) {
        frame = item.Frame;
        break;
      }
    }

    if (frame != null) return frame.GetYData(y);
  }

  this.GetXFromIndex = function (index) {
    return this.SubFrame[0].Frame.GetXFromIndex(index);
  }

  this.GetYFromData = function (value) {
    return this.SubFrame[0].Frame.GetYFromData(value);
  }

  this.ZoomUp = function (cursorIndex) {
    var result = this.SubFrame[0].Frame.ZoomUp(cursorIndex);
    for (var i = 1; i < this.SubFrame.length; ++i) {
      this.SubFrame[i].Frame.XPointCount = this.SubFrame[0].Frame.XPointCount;
      this.SubFrame[i].Frame.ZoomIndex = this.SubFrame[0].Frame.ZoomIndex;
      this.SubFrame[i].Frame.DataWidth = this.SubFrame[0].Frame.DataWidth;
      this.SubFrame[i].Frame.DistanceWidth = this.SubFrame[0].Frame.DistanceWidth;
    }

    return result;
  }

  this.ZoomDown = function (cursorIndex) {
    var result = this.SubFrame[0].Frame.ZoomDown(cursorIndex);
    for (var i = 1; i < this.SubFrame.length; ++i) {
      this.SubFrame[i].Frame.XPointCount = this.SubFrame[0].Frame.XPointCount;
      this.SubFrame[i].Frame.ZoomIndex = this.SubFrame[0].Frame.ZoomIndex;
      this.SubFrame[i].Frame.DataWidth = this.SubFrame[0].Frame.DataWidth;
      this.SubFrame[i].Frame.DistanceWidth = this.SubFrame[0].Frame.DistanceWidth;
    }

    return result;
  }
}

//一般的图形框架
function SimpleChartFrame() {
  this.newMethod = AverageWidthFrame;   //派生
  this.newMethod();
  delete this.newMethod;

  this.ScreenImageData;                   //截图
  this.Position;                          //画布的位置

  this.IsShowBorder = false;                //是否显示边框
  this.IsShowVertical = false;              //是否显示X轴
  this.XFontType = 0;                       //X轴文本文字类型

  this.MaxDistanceWidth = 4;

  this.BarCount = 0;    //多柱子个数

  this.Draw = function () {
    this.DrawFrame();
    if (this.IsShowBorder) this.DrawBorder();

    this.SizeChange = false;
    this.XYSplit = false;
  }

  this.DrawFrame = function () {
    if (this.XPointCount > 0) {
      let dInterval = this.ChartBorder.GetWidth() / (10 * this.XPointCount); //分6份, 数据4 间距2
      this.DistanceWidth = 4 * dInterval;
      this.DataWidth = 6 * dInterval;

      if (this.DistanceWidth > this.MaxDistanceWidth) {
        this.DistanceWidth = this.MaxDistanceWidth;
        dInterval = this.ChartBorder.GetWidth() / this.XPointCount;
        this.DataWidth = dInterval - this.MaxDistanceWidth;
      }
    }

    this.SplitXYCoordinate();
    this.DrawHorizontal();
    this.DrawVertical();
  }

  this.GetXFromIndex = function (index) {
    if (index < 0) index = 0;
    if (index > this.xPointCount - 1) index = this.xPointCount - 1;

    var offset = this.ChartBorder.GetLeft() + 2 + this.DistanceWidth / 2 + this.DataWidth / 2;
    for (var i = 1; i <= index; ++i) {
      offset += this.DistanceWidth + this.DataWidth;
    }

    return offset;
  }

  //分割x,y轴坐标信息
  this.SplitXYCoordinate = function () {
    if (this.XYSplit == false) return;
    if (this.YSplitOperator != null) this.YSplitOperator.Operator();
    if (this.XSplitOperator != null) this.XSplitOperator.Operator();
  }

  //画X轴
  this.DrawVertical = function () {
    var top = this.ChartBorder.GetTopEx();
    var bottom = this.ChartBorder.GetBottom();
    var right = this.ChartBorder.GetRight();

    var xPrev = null; //上一个坐标x的值
    for (var i in this.VerticalInfo) {
      var x = this.GetXFromIndex(this.VerticalInfo[i].Value);
      if (x >= right) break;
      if (this.XFontType == 1) {
        if (xPrev != null && Math.abs(x - xPrev) < 20) continue;
      }
      else {
        if (xPrev != null && Math.abs(x - xPrev) < 60) continue;
      }

      if (this.IsShowVertical) {
        this.Canvas.strokeStyle = this.VerticalInfo[i].LineColor;
        this.Canvas.beginPath();
        this.Canvas.moveTo(ToFixedPoint(x), top);
        this.Canvas.lineTo(ToFixedPoint(x), bottom);
        this.Canvas.stroke();
      }

      if (this.VerticalInfo[i].Message[0] != null) {
        if (this.VerticalInfo[i].Font != null)
          this.Canvas.font = this.VerticalInfo[i].Font;

        this.Canvas.fillStyle = this.VerticalInfo[i].TextColor;
        var testWidth = this.Canvas.measureText(this.VerticalInfo[i].Message[0]).width;
        if (x < testWidth / 2) {
          this.Canvas.textAlign = "left";
          this.Canvas.textBaseline = "top";
        }
        else {
          this.Canvas.textAlign = "center";
          this.Canvas.textBaseline = "top";
        }

        if (this.XFontType == 1) {
          this.Canvas.textAlign = "left";
          this.Canvas.textBaseline = "middle";
          this.Canvas.save();
          this.Canvas.translate(x, bottom);
          this.Canvas.rotate(90 * Math.PI / 180);
          this.Canvas.fillText(this.VerticalInfo[i].Message[0], 2, 0);
          this.Canvas.restore();
        }
        else
          this.Canvas.fillText(this.VerticalInfo[i].Message[0], x, bottom);
      }

      xPrev = x;
    }
  }

  //图形快照
  this.Snapshot = function () {
    var self = this;
    var width = this.ChartBorder.GetChartWidth();
    var height = this.ChartBorder.GetChartHeight();

    console.log('[SimpleChartFrame::Snapshot][ID=' + this.ChartBorder.UIElement.ID + '] invoke canvasToTempFilePath' + '(width=' + width + ',height=' + height + ')');

    wx.canvasToTempFilePath({
      x: 0,
      y: 0,
      width: width,
      height: height,
      canvasId: this.ChartBorder.UIElement.ID,
      success: function (res) {
        self.ScreenImagePath = res.tempFilePath;
        console.log(res.tempFilePath)
      }
    })
  }

  this.SetSizeChage = function (sizeChange) {
    this.SizeChange = sizeChange;

    //画布的位置
    this.Position = {
      X: this.ChartBorder.UIElement.offsetLeft,
      Y: this.ChartBorder.UIElement.offsetTop,
      W: this.ChartBorder.UIElement.clientWidth,
      H: this.ChartBorder.UIElement.clientHeight
    };
  }
}

//旋转90度坐标
function Rotate90SimpleChartFrame() {
  this.newMethod = SimpleChartFrame;   //派生
  this.newMethod();
  delete this.newMethod;

  this.DrawFrame = function () {
    if (this.XPointCount > 0) {
      let dInterval = this.ChartBorder.GetHeightEx() / (10 * this.XPointCount); //分10份, 数据4 间距6
      this.DistanceWidth = 4 * dInterval;
      this.DataWidth = 6 * dInterval;

      if (this.DistanceWidth > this.MaxDistanceWidth) {
        this.DistanceWidth = this.MaxDistanceWidth;
        dInterval = this.ChartBorder.GetHeightEx() / this.XPointCount;
        this.DataWidth = dInterval - this.MaxDistanceWidth;
      }
    }

    this.SplitXYCoordinate();
    this.DrawHorizontal();
    this.DrawVertical();
  }

  this.GetXFromIndex = function (value) {
    if (value <= this.HorizontalMin) return this.ChartBorder.GetLeft();
    if (value >= this.HorizontalMax) return this.ChartBorder.GetRight();

    var width = this.ChartBorder.GetWidth() * (value - this.HorizontalMin) / (this.HorizontalMax - this.HorizontalMin);
    return this.ChartBorder.GetLeft() + width;
  }

  this.GetYFromData = function (index) {
    if (index < 0) index = 0;
    if (index > this.xPointCount - 1) index = this.xPointCount - 1;

    var offset = this.ChartBorder.GetBottom() - 2 - this.DistanceWidth / 2 - this.DataWidth / 2;
    for (var i = 1; i <= index; ++i) {
      offset -= this.DistanceWidth + this.DataWidth;
    }

    return offset;
  }

  //画Y轴
  this.DrawHorizontal = function () {
    var top = this.ChartBorder.GetTopEx();
    var bottom = this.ChartBorder.GetBottom();
    var right = this.ChartBorder.GetRight();
    var left = this.ChartBorder.GetLeft();

    var yPrev = null; //上一个坐标y的值
    for (var i in this.VerticalInfo) {
      let item = this.VerticalInfo[i];
      var y = this.GetYFromData(item.Value);
      if (y != null && yPrev != null && Math.abs(y - yPrev) < 15) continue;  //两个坐标在近了 就不画了

      if (item.Message[0] != null) {
        if (this.VerticalInfo[i].Font != null)
          this.Canvas.font = item.Font;

        this.Canvas.fillStyle = item.TextColor;
        this.Canvas.textAlign = "right";
        this.Canvas.textBaseline = "middle";
        this.Canvas.fillText(item.Message[0], left - 2, y);
      }
      yPrev = y;
    }
  }

  //画X轴
  this.DrawVertical = function () {
    var top = this.ChartBorder.GetTopEx();
    var bottom = this.ChartBorder.GetBottom();
    var right = this.ChartBorder.GetRight();
    var left = this.ChartBorder.GetLeft();

    var yText = bottom;
    if (this.XMessageAlign == 'bottom')
      yText = this.ChartBorder.GetChartHeight();
    else this.XMessageAlign = 'top';

    var xPrev = null; //上一个坐标x的值
    let xPrevTextRight = null;
    for (var i in this.HorizontalInfo) {
      let item = this.HorizontalInfo[i];
      var x = this.GetXFromIndex(item.Value);
      if (x > right) break;
      if (xPrev != null && Math.abs(x - xPrev) < this.MinXDistance) continue;

      if (this.IsShowXLine) {
        this.Canvas.strokeStyle = item.LineColor;
        this.Canvas.beginPath();
        this.Canvas.moveTo(ToFixedPoint(x), top);
        this.Canvas.lineTo(ToFixedPoint(x), bottom);
        this.Canvas.stroke();
      }

      if (item.Message[0] != null) {
        let xTextRight = null;
        let xTextLeft = null;
        if (item.Font != null)
          this.Canvas.font = item.Font;

        this.Canvas.fillStyle = item.TextColor;

        var testWidth = this.Canvas.measureText(item.Message[0]).width;
        if (x < testWidth / 2) {
          this.Canvas.textAlign = "left";
          this.Canvas.textBaseline = this.XMessageAlign;
          xTextRight = x + testWidth;
          xTextLeft = x;
        }
        else {
          this.Canvas.textAlign = "center";
          this.Canvas.textBaseline = this.XMessageAlign;
          xTextRight = x + testWidth / 2;
          xTextLeft = x - testWidth / 2;
        }

        if (xPrevTextRight != null && xPrevTextRight > xTextLeft) continue;

        //console.log('[AverageWidthFrame::DrawVertical]', this.Canvas.fillStyle,x, yText);

        this.Canvas.fillText(item.Message[0], x, yText);
        xPrevTextRight = xTextRight;
      }

      xPrev = x;
    }
  }

}


//历史K线数据
function HistoryData() {
  this.Date;
  this.YClose;
  this.Open;
  this.Close;
  this.High;
  this.Low;
  this.Vol;
  this.Amount;
  this.Time;
}

//数据复制
HistoryData.Copy = function (data) {
  var newData = new HistoryData();
  newData.Date = data.Date;
  newData.YClose = data.YClose;
  newData.Open = data.Open;
  newData.Close = data.Close;
  newData.High = data.High;
  newData.Low = data.Low;
  newData.Vol = data.Vol;
  newData.Amount = data.Amount;
  newData.Time = data.Time;

  return newData;
}

//数据复权拷贝
HistoryData.CopyRight = function (data, seed) {
  var newData = new HistoryData();
  newData.Date = data.Date;
  newData.YClose = data.YClose * seed;
  newData.Open = data.Open * seed;
  newData.Close = data.Close * seed;
  newData.High = data.High * seed;
  newData.Low = data.Low * seed;

  newData.Vol = data.Vol;
  newData.Amount = data.Amount;

  return newData;
}

function MinuteData() {
  this.Close;
  this.Open;
  this.High;
  this.Low;
  this.Vol;
  this.Amount;
  this.DateTime;
  this.Increate;
  this.Risefall;
  this.AvPrice;
}

//单指标数据
function SingleData() {
  this.Date;  //日期
  this.Value; //数据
}

var KLINE_INFO_TYPE =
  {
    INVESTOR: 1,         //互动易
    ANNOUNCEMENT: 2,     //公告
    PFORECAST: 3,        //业绩预告

    ANNOUNCEMENT_QUARTER_1: 4,   //一季度报
    ANNOUNCEMENT_QUARTER_2: 5,   //半年报
    ANNOUNCEMENT_QUARTER_3: 6,   //2季度报
    ANNOUNCEMENT_QUARTER_4: 7,   //年报

    RESEARCH: 8,                 //调研
    BLOCKTRADING: 9,             //大宗交易
    TRADEDETAIL: 10              //龙虎榜


  }

function KLineInfoData() {
  this.ID;
  this.Date;
  this.Title;
  this.InfoType;
  this.ExtendData;    //扩展数据
}

function ChartData() {
  this.Data = new Array();
  this.DataOffset = 0;                        //数据偏移
  this.Period = 0;                            //周期 0 日线 1 周线 2 月线 3年线
  this.Right = 0;                             //复权 0 不复权 1 前复权 2 后复权

  this.Data2 = new Array();                   //第1组数据 走势图:历史分钟数据

  this.GetCloseMA = function (dayCount) {
    var result = new Array();
    for (var i = 0, len = this.Data.length; i < len; i++) {
      if (i < dayCount) {
        result[i] = null;
        continue;
      }

      var sum = 0;
      for (var j = 0; j < dayCount; j++) {
        sum += this.Data[i - j].Close;
      }
      result[i] = sum / dayCount;
    }
    return result;
  }

  this.GetVolMA = function (dayCount) {
    var result = new Array();
    for (var i = 0, len = this.Data.length; i < len; i++) {
      if (i < dayCount) {
        result[i] = null;
        continue;
      }

      var sum = 0;
      for (var j = 0; j < dayCount; j++) {
        sum += this.Data[i - j].Vol;
      }
      result[i] = sum / dayCount;
    }
    return result;
  }

  this.GetAmountMA = function (dayCount) {
    var result = new Array();
    for (var i = 0, len = this.Data.length; i < len; i++) {
      if (i < dayCount) {
        result[i] = null;
        continue;
      }

      var sum = 0;
      for (var j = 0; j < dayCount; j++) {
        sum += this.Data[i - j].Amount;
      }
      result[i] = sum / dayCount;
    }
    return result;
  }

  //获取收盘价
  this.GetClose = function () {
    var result = new Array();
    for (var i in this.Data) {
      result[i] = this.Data[i].Close;
    }

    return result;
  }

  this.GetYClose = function () {
    var result = new Array();
    for (var i in this.Data) {
      result[i] = this.Data[i].YClose;
    }

    return result;
  }

  this.GetHigh = function () {
    var result = new Array();
    for (var i in this.Data) {
      result[i] = this.Data[i].High;
    }

    return result;
  }

  this.GetLow = function () {
    var result = new Array();
    for (var i in this.Data) {
      result[i] = this.Data[i].Low;
    }

    return result;
  }

  this.GetOpen = function () {
    var result = new Array();
    for (var i in this.Data) {
      result[i] = this.Data[i].Open;
    }

    return result;
  }

  this.GetVol = function () {
    var result = new Array();
    for (var i in this.Data) {
      result[i] = this.Data[i].Vol;
    }

    return result;
  }

  this.GetAmount = function () {
    var result = new Array();
    for (var i in this.Data) {
      result[i] = this.Data[i].Amount;
    }

    return result;
  }

  this.GetYear = function () {
    var result = new Array();
    for (var i in this.Data) {
      result[i] = parseInt(this.Data[i].Date / 10000);
    }

    return result;
  }

  this.GetMonth = function () {
    var result = new Array();
    for (var i in this.Data) {
      result[i] = parseInt(this.Data[i].Date % 10000 / 100);
    }

    return result;
  }

  this.GetMinutePeriodData = function (period) {
    var result = new Array();
    var periodDataCount = 5;
    if (period == 5)
      periodDataCount = 5;
    else if (period == 6)
      periodDataCount = 15;
    else if (period == 7)
      periodDataCount = 30;
    else if (period == 8)
      periodDataCount = 60;
    else
      return this.Data;
    var bFirstPeriodData = false;
    var newData = null;
    for (var i = 0; i < this.Data.length;) {
      bFirstPeriodData = true;
      for (var j = 0; j < periodDataCount && i < this.Data.length; ++i) {
        if (bFirstPeriodData) {
          newData = new HistoryData();
          result.push(newData);
          bFirstPeriodData = false;
        }
        var minData = this.Data[i];
        if (minData == null) {
          ++j;
          continue;
        }
        if (minData.Time == 925 || minData.Time == 930 || minData.Time == 1300)
          ;
        else
          ++j;
        newData.Date = minData.Date;
        newData.Time = minData.Time;
        if (minData.Open == null || minData.Close == null)
          continue;
        if (newData.Open == null || newData.Close == null) {
          newData.Open = minData.Open;
          newData.High = minData.High;
          newData.Low = minData.Low;
          newData.YClose = minData.YClose;
          newData.Close = minData.Close;
          newData.Vol = minData.Vol;
          newData.Amount = minData.Amount;
        }
        else {
          if (newData.High < minData.High)
            newData.High = minData.High;
          if (newData.Low > minData.Low)
            newData.Low = minData.Low;
          newData.Close = minData.Close;
          newData.Vol += minData.Vol;
          newData.Amount += minData.Amount;
        }
      }
    }
    return result;
  }

  this.GetDayPeriodData = function (period) {
    var result = new Array();
    var index = 0;
    var startDate = 0;
    var newData = null;
    for (var i in this.Data) {
      var isNewData = false;
      var dayData = this.Data[i];

      switch (period) {
        case 1: //周线
          var fridayDate = ChartData.GetFirday(dayData.Date);
          if (fridayDate != startDate) {
            isNewData = true;
            startDate = fridayDate;
          }
          break;
        case 2: //月线
          if (parseInt(dayData.Date / 100) != parseInt(startDate / 100)) {
            isNewData = true;
            startDate = dayData.Date;
          }
          break;
        case 3: //年线
          if (parseInt(dayData.Date / 10000) != parseInt(startDate / 10000)) {
            isNewData = true;
            startDate = dayData.Date;
          }
          break;
      }

      if (isNewData) {
        newData = new HistoryData();
        newData.Date = dayData.Date;
        result.push(newData);

        if (dayData.Open == null || dayData.Close == null) continue;

        newData.Open = dayData.Open;
        newData.High = dayData.High;
        newData.Low = dayData.Low;
        newData.YClose = dayData.YClose;
        newData.Close = dayData.Close;
        newData.Vol = dayData.Vol;
        newData.Amount = dayData.Amount;
      }
      else {
        if (newData == null) continue;
        if (dayData.Open == null || dayData.Close == null) continue;

        if (newData.Open == null || newData.Close == null) {
          newData.Open = dayData.Open;
          newData.High = dayData.High;
          newData.Low = dayData.Low;
          newData.YClose = dayData.YClose;
          newData.Close = dayData.Close;
          newData.Vol = dayData.Vol;
          newData.Amount = dayData.Amount;
        }
        else {
          if (newData.High < dayData.High) newData.High = dayData.High;
          if (newData.Low > dayData.Low) newData.Low = dayData.Low;

          newData.Close = dayData.Close;
          newData.Vol += dayData.Vol;
          newData.Amount += dayData.Amount;
          newData.Date = dayData.Date;
        }
      }
    }

    return result;
  }

  //周期数据 1=周 2=月 3=年
  this.GetPeriodData = function (period) {
    if (period == 1 || period == 2 || period == 3) return this.GetDayPeriodData(period);
    if (period == 5 || period == 6 || period == 7 || period == 8) return this.GetMinutePeriodData(period);
  }

  //复权  0 不复权 1 前复权 2 后复权
  this.GetRightDate = function (right) {
    var result = [];
    if (this.Data.length <= 0) return result;

    if (right == 1) {
      var index = this.Data.length - 1;
      var seed = 1; //复权系数
      var yClose = this.Data[index].YClose;

      result[index] = HistoryData.Copy(this.Data[index]);

      for (--index; index >= 0; --index) {
        if (yClose != this.Data[index].Close) break;
        result[index] = HistoryData.Copy(this.Data[index]);
        yClose = this.Data[index].YClose;
      }

      for (; index >= 0; --index) {
        if (yClose != this.Data[index].Close)
          seed *= yClose / this.Data[index].Close;

        result[index] = HistoryData.CopyRight(this.Data[index], seed);

        yClose = this.Data[index].YClose;
      }
    }
    else if (right == 2) {
      var index = 0;
      var seed = 1;
      var close = this.Data[index].Close;
      result[index] = HistoryData.Copy(this.Data[index]);

      for (++index; index < this.Data.length; ++index) {
        if (close != this.Data[index].YClose) break;
        result[index] = HistoryData.Copy(this.Data[index]);
        close = this.Data[index].Close;
      }

      for (; index < this.Data.length; ++index) {
        if (close != this.Data[index].YClose)
          seed *= close / this.Data[index].YClose;

        result[index] = HistoryData.CopyRight(this.Data[index], seed);

        close = this.Data[index].Close;
      }
    }

    return result;
  }

  //叠加数据和主数据拟合,去掉主数据没有日期的数据
  this.GetOverlayData = function (overlayData) {
    var result = [];

    for (var i = 0, j = 0; i < this.Data.length;) {
      var date = this.Data[i].Date;

      if (j >= overlayData.length) {
        result[i] = new HistoryData();
        result[i].Date = date;
        ++i;
        continue;;
      }

      var overlayDate = overlayData[j].Date;

      if (overlayDate == date) {
        result[i] = new HistoryData();
        result[i].Date = overlayData[j].Date;
        result[i].YClose = overlayData[j].YClose;
        result[i].Open = overlayData[j].Open;
        result[i].High = overlayData[j].High;
        result[i].Low = overlayData[j].Low;
        result[i].Close = overlayData[j].Close;
        result[i].Vol = overlayData[j].Vol;
        result[i].Amount = overlayData[j].Amount;
        ++j;
        ++i;
      }
      else if (overlayDate < date) {
        ++j;
      }
      else {
        result[i] = new HistoryData();
        result[i].Date = date;
        ++i;
      }
    }

    return result;
  }


  /*
      技术指标数据方法
  */
  //以主图数据 拟合,返回 SingleData 数组
  this.GetFittingData = function (overlayData) {
    var result = new Array();

    for (var i = 0, j = 0; i < this.Data.length;) {
      var date = this.Data[i].Date;

      if (j >= overlayData.length) {
        result[i] = null;
        ++i;
        continue;;
      }

      var overlayDate = overlayData[j].Date;

      if (overlayDate == date) {
        var item = new SingleData();
        item.Date = overlayData[j].Date;
        item.Value = overlayData[j].Value;
        result[i] = item;
        ++j;
        ++i;
      }
      else if (overlayDate < date) {
        ++j;
      }
      else {
        result[i] = new SingleData();
        result[i].Date = date;
        ++i;
      }
    }

    return result;
  }

  //月线数据拟合
  this.GetFittingMonthData = function (overlayData) {
    var result = new Array();

    var preDate = null;
    for (var i = 0, j = 0; i < this.Data.length;) {
      var date = this.Data[i].Date;

      if (j >= overlayData.length) {
        result[i] = null;
        ++i;
        continue;;
      }

      var overlayDate = overlayData[j].Date;

      if (overlayDate == date) {
        var item = new SingleData();
        item.Date = overlayData[j].Date;
        item.Value = overlayData[j].Value;
        item.Text = overlayData[j].Text;
        result[i] = item;
        ++j;
        ++i;
      }
      else if (preDate != null && preDate < overlayDate && date > overlayDate) {
        var item = new SingleData();
        item.Date = date;
        item.OverlayDate = overlayData[j].Date;
        item.Value = overlayData[j].Value;
        item.Text = overlayData[j].Text;
        result[i] = item;
        ++j;
        ++i;
      }
      else if (overlayDate < date) {
        ++j;
      }
      else {
        result[i] = new SingleData();
        result[i].Date = date;
        ++i;
      }

      preDate = date;
    }

    return result;
  }


  this.GetValue = function () {
    var result = new Array();
    for (var i in this.Data) {
      if (this.Data[i] == null || this.Data[i].Value == null) {
        result[i] = null;
      }
      else {
        // console.log(this.Data[i].Value);
        // console.log(i);
        if (!isNaN(this.Data[i].Value))
          result[i] = this.Data[i].Value;
        else if (this.Data[i].Value instanceof Array)   //支持数组
          result[i] = this.Data[i].Value;
        else
          result[i] = null;
      }
    }

    return result;
  }

  this.GetPeriodSingleData = function (period) {
    var result = new Array();
    var index = 0;
    var startDate = 0;
    var newData = null;
    for (var i in this.Data) {
      var isNewData = false;
      var dayData = this.Data[i];
      if (dayData == null || dayData.Date == null) continue;

      switch (period) {
        case 1: //周线
          var fridayDate = ChartData.GetFirday(dayData.Date);
          if (fridayDate != startDate) {
            isNewData = true;
            startDate = fridayDate;
          }
          break;
        case 2: //月线
          if (parseInt(dayData.Date / 100) != parseInt(startDate / 100)) {
            isNewData = true;
            startDate = dayData.Date;
          }
          break;
        case 3: //年线
          if (parseInt(dayData.Date / 10000) != parseInt(startDate / 10000)) {
            isNewData = true;
            startDate = dayData.Date;
          }
          break;
      }

      if (isNewData) {
        newData = new SingleData();
        newData.Date = dayData.Date;
        newData.Value = dayData.Value;
        result.push(newData);
      }
      else {
        if (newData == null) continue;
        if (dayData.Value == null || isNaN(dayData.Value)) continue;
        if (newData.Value == null || isNaN(newData.Value)) newData.Value = dayData.Value;
      }
    }

    return result;
  }

  /*
      分钟数据方法
      this.GetClose()     每分钟价格
      this.GetVol()       每分钟成交量
  */

  //分钟均线
  this.GetMinuteAvPrice = function () {
    var result = new Array();
    for (var i in this.Data) {
      result[i] = this.Data[i].AvPrice;
    }

    return result;
  }
}

ChartData.GetFirday = function (value) {
  var date = new Date(parseInt(value / 10000), (value / 100 % 100 - 1), value % 100);
  var day = date.getDay();
  if (day == 5) return value;

  var timestamp = date.getTime();
  if (day < 5) {
    var prevTimestamp = (24 * 60 * 60 * 1000) * (5 - day);
    timestamp += prevTimestamp;
  }
  else {
    var prevTimestamp = (24 * 60 * 60 * 1000) * (day - 5);
    timestamp -= prevTimestamp;
  }

  date.setTime(timestamp);
  var fridayDate = date.getFullYear() * 10000 + (date.getMonth() + 1) * 100 + date.getDate();
  var week = date.getDay();
  return fridayDate;

}

function TooltipData()              //提示信息
{
  this.ChartPaint;
  this.Data;
}

function Rect(x, y, width, height) {
  this.Left = x,
    this.Top = y;
  this.Right = x + width;
  this.Bottom = y + height;

  this.IsPointIn = function (x, y) {
    if (x >= this.Left && x <= this.Right && y >= this.Top && y <= this.Bottom) return true;

    return false;
  }
}

//图新画法接口类
function IChartPainting() {
  this.Canvas;                        //画布
  this.ChartBorder;                   //边框信息
  this.ChartFrame;                    //框架画法
  this.Name;                          //名称
  this.Data = new ChartData();          //数据区

  this.NotSupportMessage = null;
  this.MessageFont = g_JSChartResource.Index.NotSupport.Font;
  this.MessageColor = g_JSChartResource.Index.NotSupport.TextColor;

  this.IsDrawFirst = false;             //是否比K线先画
  this.IsShow = true;                   //是否显示

  this.Draw = function () {

  }

  this.DrawNotSupportmessage = function () {
    this.Canvas.font = this.MessageFont;
    this.Canvas.fillStyle = this.MessageColor;

    var left = this.ChartBorder.GetLeft();
    var width = this.ChartBorder.GetWidth();
    var top = this.ChartBorder.GetTopEx();
    var height = this.ChartBorder.GetHeightEx();

    var x = left + width / 2;
    var y = top + height / 2;

    this.Canvas.textAlign = "center";
    this.Canvas.textBaseline = "middle";
    this.Canvas.fillText(this.NotSupportMessage, x, y);
  }

  this.GetTooltipData = function (x, y, tooltip) {
    return false;
  }

  this.GetMaxMin = function () {
    var xPointCount = this.ChartFrame.XPointCount;
    var range = {};
    range.Min = null;
    range.Max = null;

    if (!this.Data || !this.Data.Data) return range;

    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var value = this.Data.Data[i];
      if (value == null || isNaN(value)) continue;

      if (range.Max == null) range.Max = value;
      if (range.Min == null) range.Min = value;

      if (range.Max < value) range.Max = value;
      if (range.Min > value) range.Min = value;
    }

    return range;
  }
}


//缩放因子
var ZOOM_SEED =
  [
    [49, 10], [46, 9], [43, 8],
    [41, 7.5], [39, 7], [37, 6],
    [31, 5.5], [27, 5], [23, 4.5],
    [21, 4], [18, 3.5], [16, 3],
    [13, 2.5], [11, 2], [8, 1.5],
    [6, 1], [3, 0.6], [2.2, 0.5],
    //太多了卡,
    //[1.1,0.3],
    //[0.9,0.2],	[0.7,0.15],
    //[0.6,0.12],	[0.5,0.1],	[0.4,0.08],
    //[0.3,0.06],	[0.2,0.04],	[0.1,0.02]
  ];

//K线画法
function ChartKLine() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.UpColor = g_JSChartResource.UpBarColor;
  this.DownColor = g_JSChartResource.DownBarColor;
  this.UnchagneColor = g_JSChartResource.UnchagneBarColor;          //平盘

  this.IsShowMaxMinPrice = true;                 //是否显示最大最小值
  this.TextFont = g_JSChartResource.KLine.MaxMin.Font;
  this.TextColor = g_JSChartResource.KLine.MaxMin.Color;

  this.InfoData;      //信息地雷 key=日期  value=信息数据
  this.InfoDiv = new Array();

  this.InfoTooltipEvent;  //信息地雷悬停事件

  this.Draw = function () {
    if (this.IsShow == false) return;

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var xOffset = this.ChartBorder.GetLeft() + distanceWidth / 2.0 + 2.0;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    var ptMax = { X: null, Y: null, Value: null, Align: 'left' };
    var ptMin = { X: null, Y: null, Value: null, Align: 'left' };

    this.Canvas.save();

    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j, xOffset += (dataWidth + distanceWidth)) {
      var data = this.Data.Data[i];
      if (data.Open == null || data.High == null || data.Low == null || data.Close == null) continue;

      var left = xOffset;
      var right = xOffset + dataWidth;
      if (left > chartright) break;
      if (right > (chartright + 2)) break;
      var x = left + (right - left) / 2;
      var yLow = this.ChartFrame.GetYFromData(data.Low);
      var yHigh = this.ChartFrame.GetYFromData(data.High);
      var yOpen = this.ChartFrame.GetYFromData(data.Open);
      var yClose = this.ChartFrame.GetYFromData(data.Close);
      var y = yHigh;

      if (ptMax.Value == null || ptMax.Value < data.High)     //求最大值
      {
        ptMax.X = x;
        ptMax.Y = yHigh;
        ptMax.Value = data.High;
        ptMax.Align = j < xPointCount / 2 ? 'left' : 'right';
      }

      if (ptMin.Value == null || ptMin.Value > data.Low)      //求最小值
      {
        ptMin.X = x;
        ptMin.Y = yLow;
        ptMin.Value = data.Low;
        ptMin.Align = j < xPointCount / 2 ? 'left' : 'right';
      }

      if (data.Open < data.Close)       //阳线
      {
        if (dataWidth >= 4) {
          this.Canvas.strokeStyle = this.UpColor;

          if (data.High > data.Close)   //上影线
          {
            this.Canvas.beginPath();
            this.Canvas.moveTo(ToFixedPoint(x), ToFixedPoint(y));
            this.Canvas.lineTo(ToFixedPoint(x), ToFixedPoint(yClose));
            this.Canvas.stroke();
            y = yClose;
          }
          else {
            y = yClose;
          }

          this.Canvas.fillStyle = this.UpColor;
          if (yOpen - y < 1) this.Canvas.fillRect(ToFixedRect(left), ToFixedRect(y), ToFixedRect(dataWidth), 1);    //高度小于1,统一使用高度1
          else this.Canvas.fillRect(ToFixedRect(left), ToFixedRect(y), ToFixedRect(dataWidth), ToFixedRect(yOpen - y));

          if (data.Open > data.Low) {
            this.Canvas.beginPath();
            this.Canvas.moveTo(ToFixedPoint(x), ToFixedPoint(y));
            this.Canvas.lineTo(ToFixedPoint(x), ToFixedPoint(yLow));
            this.Canvas.stroke();
          }
        }
        else {
          this.Canvas.beginPath();
          this.Canvas.strokeStyle = this.UpColor;
          this.Canvas.moveTo(ToFixedPoint(x), yHigh);
          this.Canvas.lineTo(ToFixedPoint(x), yLow);
          this.Canvas.stroke();
        }
      }
      else if (data.Open > data.Close)  //阴线
      {
        if (dataWidth >= 4) {
          this.Canvas.strokeStyle = this.DownColor;

          if (data.High > data.Close)   //上影线
          {
            this.Canvas.beginPath();
            this.Canvas.moveTo(ToFixedPoint(x), ToFixedPoint(y));
            this.Canvas.lineTo(ToFixedPoint(x), ToFixedPoint(yOpen));
            this.Canvas.stroke();
            y = yOpen;
          }
          else {
            y = yOpen
          }

          this.Canvas.fillStyle = this.DownColor;
          if (yClose - y < 1) this.Canvas.fillRect(ToFixedRect(left), ToFixedRect(y), ToFixedRect(dataWidth), 1);    //高度小于1,统一使用高度1
          else this.Canvas.fillRect(ToFixedRect(left), ToFixedRect(y), ToFixedRect(dataWidth), ToFixedRect(yClose - y));

          if (data.Open > data.Low) //下影线
          {
            this.Canvas.beginPath();
            this.Canvas.moveTo(ToFixedPoint(x), ToFixedPoint(y));
            this.Canvas.lineTo(ToFixedPoint(x), ToFixedPoint(yLow));
            this.Canvas.stroke();
          }
        }
        else {
          this.Canvas.beginPath();
          this.Canvas.strokeStyle = this.DownColor;
          this.Canvas.moveTo(ToFixedPoint(x), yHigh);
          this.Canvas.lineTo(ToFixedPoint(x), yLow);
          this.Canvas.stroke();
        }
      }
      else // 平线
      {
        if (dataWidth >= 4) {
          this.Canvas.strokeStyle = this.UnchagneColor;
          this.Canvas.beginPath();
          if (data.High > data.Close)   //上影线
          {
            this.Canvas.moveTo(ToFixedPoint(x), y);
            this.Canvas.lineTo(ToFixedPoint(x), yOpen);
            y = yOpen;
          }
          else {
            y = yOpen;
          }

          this.Canvas.moveTo(ToFixedPoint(left), ToFixedPoint(y));
          this.Canvas.lineTo(ToFixedPoint(right), ToFixedPoint(y));

          if (data.Open > data.Low) //下影线
          {
            this.Canvas.moveTo(ToFixedPoint(x), ToFixedPoint(y));
            this.Canvas.lineTo(ToFixedPoint(x), ToFixedPoint(yLow));
          }

          this.Canvas.stroke();
        }
        else {
          this.Canvas.beginPath();
          this.Canvas.strokeStyle = this.UnchagneColor;
          this.Canvas.moveTo(ToFixedPoint(x), yHigh);
          this.Canvas.lineTo(ToFixedPoint(x), yLow);
          this.Canvas.stroke();
        }
      }

      if (this.Data.DataType == 0) {
        var infoItem = { Xleft: left, XRight: right, YMax: yHigh, YMin: yLow, DayData: data, Index: j };
        this.DrawInfoDiv(infoItem);
      }
    }

    this.Canvas.restore();

    if (this.IsShowMaxMinPrice) this.DrawMaxMinPrice(ptMax, ptMin);
  }

  this.DrawMaxMinPrice = function (ptMax, ptMin) {
    if (ptMax.X == null || ptMax.Y == null || ptMax.Value == null) return;
    if (ptMin.X == null || ptMin.Y == null || ptMin.Value == null) return;

    this.Canvas.font = this.TextFont;
    this.Canvas.fillStyle = this.TextColor;
    this.Canvas.textAlign = ptMax.Align;
    this.Canvas.textBaseline = 'bottom';
    var left = ptMax.X;
    this.Canvas.fillText(ptMax.Value.toFixed(2), left, ptMax.Y);

    this.Canvas.textAlign = ptMin.Align;
    this.Canvas.textBaseline = 'top';
    var left = ptMin.X;
    this.Canvas.fillText(ptMin.Value.toFixed(2), left, ptMin.Y);
  }

  this.ClearInfoDiv = function () {
    if (this.InfoDiv.length <= 0) return;

    for (var i in this.InfoDiv) {
      var item = this.InfoDiv[i];
      var div = document.getElementById(item.id);
      this.ChartBorder.UIElement.parentNode.removeChild(div);
    }

    this.InfoDiv = [];
  }

  //画某一天的信息地雷
  this.DrawInfoDiv = function (item) {
    if (!this.InfoData || this.InfoData.length <= 0) return;

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;

    var infoData = this.InfoData.get(item.DayData.Date.toString());
    if (!infoData || infoData.Data.length <= 0) return;

    var divInfo = document.createElement("div");
    divInfo.className = 'kline-info';
    divInfo.id = Guid();
    var iconWidth = Math.abs(item.Xleft - item.XRight);
    if (iconWidth > 16) {
      iconWidth = 16;
      item.Xleft = item.Xleft + (Math.abs(item.Xleft - item.XRight) - iconWidth) / 2;
    }

    var text = '', title = '';
    var mapImage = new Map();
    for (var i in infoData.Data) {
      var infoItem = infoData.Data[i];
      var iconSrc = JSKLineInfoMap.GetIconUrl(infoItem.InfoType);
      var imageInfo = mapImage.get(infoItem.InfoType);
      if (!imageInfo) {
        divInfo.innerHTML += "<img src='" + iconSrc + "'" + " infotype='" + infoItem.InfoType + "' />";
        mapImage.set(infoItem.InfoType, new Array(infoItem));
      }
      else {
        imageInfo.push(infoItem);
      }
      title += '\n' + infoItem.Title;
    }

    //divInfo.innerHTML=text;
    var scrollPos = GetScrollPosition();
    var left = item.Xleft + this.ChartBorder.UIElement.getBoundingClientRect().left + scrollPos.Left;
    var top = item.YMax + this.ChartBorder.UIElement.getBoundingClientRect().top + scrollPos.Top - 5;

    divInfo.style.left = left + "px";
    divInfo.style.top = top - (mapImage.size * 16) + "px";
    //divInfo.title=title;
    this.ChartBorder.UIElement.parentNode.appendChild(divInfo);

    if (this.InfoTooltipEvent && this.InfoTooltipEvent.length >= 2) {
      if (typeof (this.InfoTooltipEvent[0]) == 'function') {
        var chart = this.ChartBorder.UIElement.JSChartContainer;
        var self = this;
        mapImage.forEach(function (item, key, data) {
          //绑定鼠标悬浮消息
          $("#" + divInfo.id + " img[infotype='" + key + "']").mouseover(
            {
              Chart: chart,    //图形类
              InfoType: key,   //信息地雷类型
              InfoList: item,  //信息数据列表
            },
            self.InfoTooltipEvent[0]);
        });
      }

      if (typeof (this.InfoTooltipEvent[1]) == 'function') {
        var chart = this.ChartBorder.UIElement.JSChartContainer;
        var self = this;
        mapImage.forEach(function (item, key, data) {
          //绑定鼠标离开
          $("#" + divInfo.id + " img[infotype='" + key + "']").mouseleave(
            {
              Chart: chart,    //图形类
            },
            self.InfoTooltipEvent[1]);
        });
      }
    }

    this.InfoDiv.push(divInfo);
  }

  this.GetTooltipData = function (x, y, tooltip) {
    for (var i in this.TooltipRect) {
      var rect = this.TooltipRect[i][1];
      this.Canvas.beginPath();
      this.Canvas.rect(rect.X, rect.Y, rect.Width, rect.Height);
      if (this.Canvas.isPointInPath(x, y)) {
        var index = this.TooltipRect[i][0];
        tooltip.Data = this.Data.Data[index];
        tooltip.ChartPaint = this;
        return true;
      }
    }
    return false;
  }

  //计算当天显示数据的最大最小值
  this.GetMaxMin = function () {
    var xPointCount = this.ChartFrame.XPointCount;
    var range = {};
    range.Max = null;
    range.Min = null;

    if (this.IsShow == false) return range;

    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var data = this.Data.Data[i];
      if (data.Open == null || data.High == null || data.Low == null || data.Close == null) continue;

      if (range.Max == null) range.Max = data.High;
      if (range.Min == null) range.Min = data.Low;

      if (range.Max < data.High) range.Max = data.High;
      if (range.Min > data.Low) range.Min = data.Low;
    }

    return range;
  }
}

/*
    K线画法 只有线段
*/
function ChartKLine2() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.UpColor = g_JSChartResource.UpBarColor;
  this.DownColor = g_JSChartResource.DownBarColor;
  this.UnchagneColor = g_JSChartResource.UnchagneBarColor;      //平盘

  this.Draw = function () {
    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var xOffset = this.ChartBorder.GetLeft() + distanceWidth / 2.0 + 2.0;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j, xOffset += (dataWidth + distanceWidth)) {
      var data = this.Data.Data[i];
      if (data.Open == null || data.High == null || data.Low == null || data.Close == null) continue;

      var left = xOffset;
      var right = xOffset + dataWidth;
      if (right > chartright) break;
      var x = left + (right - left) / 2;
      var yLow = this.ChartFrame.GetYFromData(data.Low);
      var yHigh = this.ChartFrame.GetYFromData(data.High);
      var yOpen = this.ChartFrame.GetYFromData(data.Open);
      var yClose = this.ChartFrame.GetYFromData(data.Close);
      var y = yHigh;

      if (data.Open < data.Close)       //阳线
      {
        this.Canvas.beginPath();
        this.Canvas.moveTo(ToFixedPoint(x), yHigh);
        this.Canvas.lineTo(ToFixedPoint(x), yLow);

        this.Canvas.moveTo(left, ToFixedPoint(yOpen));
        this.Canvas.lineTo(x, ToFixedPoint(yOpen));

        this.Canvas.moveTo(x, ToFixedPoint(yClose));
        this.Canvas.lineTo(right, ToFixedPoint(yClose));

        this.Canvas.strokeStyle = this.UpColor;
        this.Canvas.stroke();
      }
      else if (data.Open > data.Close)  //阴线
      {
        this.Canvas.beginPath();
        this.Canvas.moveTo(ToFixedPoint(x), yHigh);
        this.Canvas.lineTo(ToFixedPoint(x), yLow);

        this.Canvas.moveTo(left, ToFixedPoint(yOpen));
        this.Canvas.lineTo(x, ToFixedPoint(yOpen));

        this.Canvas.moveTo(x, ToFixedPoint(yClose));
        this.Canvas.lineTo(right, ToFixedPoint(yClose));

        this.Canvas.strokeStyle = this.DownColor;
        this.Canvas.stroke();
      }
      else // 平线
      {
        this.Canvas.beginPath();
        this.Canvas.moveTo(ToFixedPoint(x), yHigh);
        this.Canvas.lineTo(ToFixedPoint(x), yLow);

        this.Canvas.moveTo(left, ToFixedPoint(yOpen));
        this.Canvas.lineTo(right, ToFixedPoint(yClose));

        this.Canvas.strokeStyle = this.UnchagneColor;
        this.Canvas.stroke();
      }

    }
  }

  //计算当天显示数据的最大最小值
  this.GetMaxMin = function () {
    var xPointCount = this.ChartFrame.XPointCount;
    var range = {};
    range.Max = null;
    range.Min = null;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var data = this.Data.Data[i];
      if (data.Open == null || data.High == null || data.Low == null || data.Close == null) continue;

      if (range.Max == null) range.Max = data.High;
      if (range.Min == null) range.Min = data.Low;

      if (range.Max < data.High) range.Max = data.High;
      if (range.Min > data.Low) range.Min = data.Low;
    }

    return range;
  }
}

//K线叠加
function ChartOverlayKLine() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Color = "rgb(65,105,225)";
  this.MainData;                  //主图K线数据
  this.SourceData;                //叠加的原始数据
  this.Name = "ChartOverlayKLine";
  this.Title;

  this.Draw = function () {
    if (!this.MainData || !this.Data) return;

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var xOffset = this.ChartBorder.GetLeft() + distanceWidth / 2.0 + 2.0;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    this.TooltipRect = [];
    var isFristDraw = true;

    var firstOpen = null; //主线数据第1个收盘价
    for (var i = this.Data.DataOffset, j = 0; i < this.MainData.Data.length && j < xPointCount; ++i, ++j) {
      var data = this.MainData.Data[i];
      if (data.Open == null || data.High == null || data.Low == null || data.Close == null) continue;
      firstOpen = data.Close;
      break;
    }

    if (firstOpen == null) return;

    var firstOverlayOpen = null;

    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j, xOffset += (dataWidth + distanceWidth)) {
      var data = this.Data.Data[i];
      if (!data || data.Open == null || data.High == null || data.Low == null || data.Close == null) continue;

      if (firstOverlayOpen == null) firstOverlayOpen = data.Open;

      if (isFristDraw) {
        this.Canvas.strokeStyle = this.Color;
        this.Canvas.fillStyle = this.Color;
        this.Canvas.beginPath();
        isFristDraw = false;
      }

      var left = xOffset;
      var right = xOffset + dataWidth;
      if (right > chartright) break;
      var x = left + (right - left) / 2;
      var yLow = this.ChartFrame.GetYFromData(data.Low / firstOverlayOpen * firstOpen);
      var yHigh = this.ChartFrame.GetYFromData(data.High / firstOverlayOpen * firstOpen);
      var yOpen = this.ChartFrame.GetYFromData(data.Open / firstOverlayOpen * firstOpen);
      var yClose = this.ChartFrame.GetYFromData(data.Close / firstOverlayOpen * firstOpen);
      var y = yHigh;

      if (data.Open < data.Close)       //阳线
      {
        if (dataWidth >= 4) {
          if (data.High > data.Close)   //上影线
          {
            this.Canvas.moveTo(ToFixedPoint(x), ToFixedPoint(y));
            this.Canvas.lineTo(ToFixedPoint(x), ToFixedPoint(yClose));
            y = yClose;
          }
          else {
            y = yClose;
          }

          this.Canvas.fillStyle = this.Color;
          if (yOpen - y < 1) this.Canvas.fillRect(ToFixedRect(left), ToFixedRect(y), ToFixedRect(dataWidth), 1);
          else this.Canvas.fillRect(ToFixedRect(left), ToFixedRect(y), ToFixedRect(dataWidth), ToFixedRect(yOpen - y));

          if (data.Open > data.Low) {
            this.Canvas.moveTo(ToFixedPoint(x), ToFixedPoint(y));
            this.Canvas.lineTo(ToFixedPoint(x), ToFixedPoint(yLow));
          }
        }
        else {
          this.Canvas.moveTo(ToFixedPoint(x), yLow);
          this.Canvas.lineTo(ToFixedPoint(x), yHigh);
        }
      }
      else if (data.Open > data.Close)  //阴线
      {
        this.Canvas.strokeStyle = this.Color;
        if (data.High > data.Close)   //上影线
        {
          this.Canvas.moveTo(ToFixedPoint(x), ToFixedPoint(y));
          this.Canvas.lineTo(ToFixedPoint(x), ToFixedPoint(yOpen));
          y = yOpen;
        }
        else {
          y = yOpen
        }

        this.Canvas.fillStyle = this.Color;
        if (yOpen - y < 1) this.Canvas.fillRect(ToFixedRect(left), ToFixedRect(y), ToFixedRect(dataWidth), 1);
        else this.Canvas.fillRect(ToFixedRect(left), ToFixedRect(y), ToFixedRect(dataWidth), ToFixedRect(yClose - y));

        if (data.Open > data.Low) //下影线
        {
          this.Canvas.moveTo(ToFixedPoint(x), ToFixedPoint(y));
          this.Canvas.lineTo(ToFixedPoint(x), ToFixedPoint(yLow));
        }
      }
      else // 平线
      {
        this.Canvas.strokeStyle = this.Color;
        this.Canvas.beginPath();
        if (data.High > data.Close)   //上影线
        {
          this.Canvas.moveTo(ToFixedPoint(x), ToFixedPoint(y));
          this.Canvas.lineTo(ToFixedPoint(x), ToFixedPoint(yOpen));

          y = yOpen;
        }
        else {
          y = yOpen;
        }

        this.Canvas.moveTo(ToFixedPoint(left), ToFixedPoint(y));
        this.Canvas.lineTo(ToFixedPoint(right), ToFixedPoint(y));

        if (data.Open > data.Low) //下影线
        {
          this.Canvas.moveTo(ToFixedPoint(x), ToFixedPoint(y));
          this.Canvas.lineTo(ToFixedPoint(x), ToFixedPoint(yLow));
        }
      }

      //添加tooltip区域
      {
        var yTop = Math.min(yLow, yHigh, yOpen, yClose);
        var yBottom = Math.max(yLow, yHigh, yOpen, yClose);
        var rect = new Rect(left, yTop, dataWidth, yBottom - yTop);
        //this.Canvas.fillStyle="rgb(0,0,100)";
        //this.Canvas.fillRect(rect.X,rect.Y,rect.Width,rect.Height);
        this.TooltipRect.push([i, rect]);    //[0]数据索引 [1]数据区域
      }
    }

    if (isFristDraw == false) this.Canvas.stroke();
  }

  this.GetMaxMin = function () {
    var xPointCount = this.ChartFrame.XPointCount;
    var range = {};
    range.Max = null;
    range.Min = null;

    if (!this.MainData || !this.Data) return range;

    var firstOpen = null; //主线数据第1个收盘价
    for (var i = this.Data.DataOffset, j = 0; i < this.MainData.Data.length && j < xPointCount; ++i, ++j) {
      var data = this.MainData.Data[i];
      if (data.Open == null || data.High == null || data.Low == null || data.Close == null) continue;
      firstOpen = data.Close;
      break;
    }

    if (firstOpen == null) return range;

    var firstOverlayOpen = null;
    var high, low;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var data = this.Data.Data[i];
      if (!data || data.Open == null || data.High == null || data.Low == null || data.Close == null) continue;
      if (firstOverlayOpen == null) firstOverlayOpen = data.Open;

      high = data.High / firstOverlayOpen * firstOpen;
      low = data.Low / firstOverlayOpen * firstOpen;
      if (range.Max == null) range.Max = high;
      if (range.Min == null) range.Min = low;

      if (range.Max < high) range.Max = high;
      if (range.Min > low) range.Min = low;
    }

    return range;
  }

  this.GetTooltipData = function (x, y, tooltip) {
    for (var i in this.TooltipRect) {
      var rect = this.TooltipRect[i][1];
      this.Canvas.beginPath();
      this.Canvas.rect(rect.X, rect.Y, rect.Width, rect.Height);
      if (this.Canvas.isPointInPath(x, y)) {
        var index = this.TooltipRect[i][0];
        tooltip.Data = this.Data.Data[index];
        tooltip.ChartPaint = this;
        return true;
      }
    }
    return false;
  }
}

//历史成交量柱子
function ChartKVolumeBar() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.UpColor = g_JSChartResource.UpBarColor;
  this.DownColor = g_JSChartResource.DownBarColor;

  this.Draw = function () {
    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var xOffset = this.ChartBorder.GetLeft() + distanceWidth / 2.0 + 2.0;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    var yBottom = this.ChartFrame.GetYFromData(0);

    if (dataWidth >= 4) {
      yBottom = ToFixedRect(yBottom);
      for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j, xOffset += (dataWidth + distanceWidth)) {
        var data = this.Data.Data[i];
        if (data.Vol == null) continue;

        var left = xOffset;
        var right = xOffset + dataWidth;
        if (left > chartright) break;
        if (right > (chartright + 2)) break;

        var y = this.ChartFrame.GetYFromData(data.Vol);

        if (data.Close > data.Open)
          this.Canvas.fillStyle = this.UpColor;
        else
          this.Canvas.fillStyle = this.DownColor;

        //高度调整为整数
        var height = ToFixedRect(yBottom - y);
        y = yBottom - height;
        this.Canvas.fillRect(ToFixedRect(left), y, ToFixedRect(dataWidth), height);
      }
    }
    else    //太细了直接话线
    {
      for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j, xOffset += (dataWidth + distanceWidth)) {
        var data = this.Data.Data[i];
        if (data.Vol == null) continue;

        var left = xOffset;
        var right = xOffset + dataWidth;
        if (right > chartright) break;

        var y = this.ChartFrame.GetYFromData(data.Vol);
        var x = this.ChartFrame.GetXFromIndex(j);

        if (data.Close > data.Open)
          this.Canvas.strokeStyle = this.UpColor;
        else
          this.Canvas.strokeStyle = this.DownColor;

        var x = this.ChartFrame.GetXFromIndex(j);
        this.Canvas.beginPath();
        this.Canvas.moveTo(ToFixedPoint(x), y);
        this.Canvas.lineTo(ToFixedPoint(x), yBottom);
        this.Canvas.stroke();
      }
    }
  }

  this.GetMaxMin = function () {
    var xPointCount = this.ChartFrame.XPointCount;
    var range = {};
    range.Min = 0;
    range.Max = null;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var data = this.Data.Data[i];
      if (range.Max == null) range.Max = data.Vol;

      if (range.Max < data.Vol) range.Max = data.Vol;
    }

    return range;
  }
}

//分钟成交量
function ChartMinuteVolumBar() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Color = "rgb(200,200,200)";

  this.Draw = function () {
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    var yBottom = this.ChartFrame.GetYFromData(0);

    var drawCount = 0;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var vol = this.Data.Data[i];
      if (!vol) continue;

      var y = this.ChartFrame.GetYFromData(vol);
      var x = this.ChartFrame.GetXFromIndex(i);
      if (x > chartright) break;

      if (drawCount == 0) this.Canvas.beginPath();

      this.Canvas.moveTo(ToFixedPoint(x), y);
      this.Canvas.lineTo(ToFixedPoint(x), yBottom);

      ++drawCount;
    }

    if (drawCount > 0) {
      this.Canvas.strokeStyle = this.Color;
      this.Canvas.stroke();
    }
  }

  this.GetMaxMin = function () {
    var xPointCount = this.ChartFrame.XPointCount;
    var range = {};
    range.Min = 0;
    range.Max = null;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var vol = this.Data.Data[i];
      if (range.Max == null) range.Max = vol;

      if (range.Max < vol) range.Max = vol;
    }

    return range;
  }
}


//线段
function ChartLine() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Color = "rgb(255,193,37)"; //线段颜色
  this.LineWidth;               //线段宽度
  this.DrawType = 0;              //画图方式  0=无效数平滑  1=无效数不画断开

  this.Draw = function () {
    if (this.NotSupportMessage) {
      this.DrawNotSupportmessage();
      return;
    }

    if (!this.Data || !this.Data.Data) return;

    switch (this.DrawType) {
      case 0:
        return this.DrawLine();
      case 1:
        return this.DrawStraightLine();
    }
  }

  this.DrawLine = function () {
    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    this.Canvas.save();
    if (this.LineWidth > 0) this.Canvas.lineWidth = this.LineWidth;
    var bFirstPoint = true;
    var drawCount = 0;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var value = this.Data.Data[i];
      if (value == null) continue;

      var x = this.ChartFrame.GetXFromIndex(j);
      var y = this.ChartFrame.GetYFromData(value);

      if (x > chartright) break;

      if (bFirstPoint) {
        this.Canvas.strokeStyle = this.Color;
        this.Canvas.beginPath();
        this.Canvas.moveTo(x, y);
        bFirstPoint = false;
      }
      else {
        this.Canvas.lineTo(x, y);
      }

      ++drawCount;
    }

    if (drawCount > 0) this.Canvas.stroke();
    this.Canvas.restore();
  }

  //无效数不画
  this.DrawStraightLine = function () {
    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    this.Canvas.save();
    if (this.LineWidth > 0) this.Canvas.lineWidth = this.LineWidth;
    this.Canvas.strokeStyle = this.Color;

    var bFirstPoint = true;
    var drawCount = 0;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var value = this.Data.Data[i];
      if (value == null) {
        if (drawCount > 0) this.Canvas.stroke();
        bFirstPoint = true;
        drawCount = 0;
        continue;
      }

      var x = this.ChartFrame.GetXFromIndex(j);
      var y = this.ChartFrame.GetYFromData(value);

      if (x > chartright) break;

      if (bFirstPoint) {
        this.Canvas.beginPath();
        this.Canvas.moveTo(x, y);
        bFirstPoint = false;
      }
      else {
        this.Canvas.lineTo(x, y);
      }

      ++drawCount;
    }

    if (drawCount > 0) this.Canvas.stroke();
    this.Canvas.restore();
  }
}

//POINTDOT 圆点
function ChartPointDot() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Color = "rgb(255,193,37)";   //线段颜色
  this.Radius = 1;                  //点半径

  this.Draw = function () {
    if (!this.IsShow) return;

    if (this.NotSupportMessage) {
      this.DrawNotSupportmessage();
      return;
    }

    if (!this.Data || !this.Data.Data) return;

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    this.Canvas.save();
    this.Canvas.fillStyle = this.Color;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var value = this.Data.Data[i];
      if (value == null) continue;

      var x = this.ChartFrame.GetXFromIndex(j);
      var y = this.ChartFrame.GetYFromData(value);

      if (x > chartright) break;

      this.Canvas.beginPath();
      this.Canvas.arc(x, y, this.Radius, 0, Math.PI * 2, true);
      this.Canvas.closePath();
      this.Canvas.fill();
    }

    this.Canvas.restore();
  }
}

//通达信语法  STICK
function ChartStick() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Color = "rgb(255,193,37)";   //线段颜色
  this.LineWidth;               //线段宽度

  this.DrawLine = function () {
    if (!this.Data || !this.Data.Data) return;

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    this.Canvas.save();
    if (this.LineWidth > 0) this.Canvas.lineWidth = this.LineWidth;
    var bFirstPoint = true;
    var drawCount = 0;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var value = this.Data.Data[i];
      if (value == null) continue;

      var x = this.ChartFrame.GetXFromIndex(j);
      var y = this.ChartFrame.GetYFromData(value);

      if (x > chartright) break;

      if (bFirstPoint) {
        this.Canvas.strokeStyle = this.Color;
        this.Canvas.beginPath();
        this.Canvas.moveTo(x, y);
        bFirstPoint = false;
      }
      else {
        this.Canvas.lineTo(x, y);
      }

      ++drawCount;
    }

    if (drawCount > 0) this.Canvas.stroke();
    this.Canvas.restore();
  }

  this.DrawStick = function () {
    if (!this.Data || !this.Data.Data) return;

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    //取显示数据的最低点
    var minY = null;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var value = this.Data.Data[i];
      if (value == null) continue;

      var x = this.ChartFrame.GetXFromIndex(j);
      var y = this.ChartFrame.GetYFromData(value);

      if (x > chartright) break;

      if (minY == null) minY = y;
      else if (minY < y) minY = y;
    }

    this.Canvas.save();
    this.Canvas.strokeStyle = this.Color;
    if (this.LineWidth) this.Canvas.lineWidth = this.LineWidth;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var value = this.Data.Data[i];
      if (value == null) continue;

      var x = this.ChartFrame.GetXFromIndex(j);
      var y = this.ChartFrame.GetYFromData(value);

      if (x > chartright) break;

      var xFix = parseInt(x.toString()) + 0.5;
      this.Canvas.beginPath();
      this.Canvas.moveTo(xFix, y);
      this.Canvas.lineTo(xFix, minY);
      this.Canvas.stroke();
    }

    this.Canvas.restore();
  }

  this.Draw = function () {
    if (!this.IsShow) return;

    if (this.NotSupportMessage) {
      this.DrawNotSupportmessage();
      return;
    }

    this.DrawStick();
  }
}

//通达信语法 LINESTICK
function ChartLineStick() {
  this.newMethod = ChartStick;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Draw = function () {
    if (!this.IsShow) return;

    if (this.NotSupportMessage) {
      this.DrawNotSupportmessage();
      return;
    }

    this.DrawStick();
    this.DrawLine();
  }
}

//通达信语法 VOLSTICK
function ChartVolStick() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.UpColor = g_JSChartResource.UpBarColor;
  this.DownColor = g_JSChartResource.DownBarColor;
  this.HistoryData;               //历史数据

  this.Draw = function () {
    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var xOffset = this.ChartBorder.GetLeft() + distanceWidth / 2.0 + 2.0;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    var yBottom = this.ChartFrame.GetYFromData(0);

    if (dataWidth >= 4) {
      yBottom = ToFixedRect(yBottom);
      for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j, xOffset += (dataWidth + distanceWidth)) {
        var value = this.Data.Data[i];
        var kItem = this.HistoryData.Data[i];
        if (value == null || kItem == null) continue;

        var left = xOffset;
        var right = xOffset + dataWidth;
        if (right > chartright) break;

        var y = this.ChartFrame.GetYFromData(value);

        if (kItem.Close > kItem.Open)
          this.Canvas.fillStyle = this.UpColor;
        else
          this.Canvas.fillStyle = this.DownColor;

        //高度调整为整数
        var height = ToFixedRect(yBottom - y);
        y = yBottom - height;
        this.Canvas.fillRect(ToFixedRect(left), y, ToFixedRect(dataWidth), height);
      }
    }
    else    //太细了直接话线
    {
      for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j, xOffset += (dataWidth + distanceWidth)) {
        var value = this.Data.Data[i];
        var kItem = this.HistoryData.Data[i];
        if (value == null || kItem == null) continue;

        var left = xOffset;
        var right = xOffset + dataWidth;
        if (right > chartright) break;

        var y = this.ChartFrame.GetYFromData(value);
        var x = this.ChartFrame.GetXFromIndex(j);

        if (kItem.Close > kItem.Open)
          this.Canvas.strokeStyle = this.UpColor;
        else
          this.Canvas.strokeStyle = this.DownColor;

        var x = this.ChartFrame.GetXFromIndex(j);
        this.Canvas.beginPath();
        this.Canvas.moveTo(ToFixedPoint(x), y);
        this.Canvas.lineTo(ToFixedPoint(x), yBottom);
        this.Canvas.stroke();
      }
    }
  }

  this.GetMaxMin = function () {
    var xPointCount = this.ChartFrame.XPointCount;
    var range = {};
    range.Min = 0;
    range.Max = null;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var value = this.Data.Data[i];
      if (range.Max == null) range.Max = value;

      if (range.Max < value) range.Max = value;
    }

    return range;
  }
}

//线段 多数据(一个X点有多条Y数据)
function ChartLineMultiData() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Color = "rgb(255,193,37)"; //线段颜色

  this.Draw = function () {
    if (this.NotSupportMessage) {
      this.DrawNotSupportmessage();
      return;
    }

    if (!this.Data || !this.Data.Data) return;

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    var bFirstPoint = true;
    var drawCount = 0;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var aryValue = this.Data.Data[i];
      if (aryValue == null) continue;

      var x = this.ChartFrame.GetXFromIndex(j);
      if (x > chartright) break;

      for (var index in aryValue) {
        var value = aryValue[index].Value;

        var y = this.ChartFrame.GetYFromData(value);

        if (bFirstPoint) {
          this.Canvas.strokeStyle = this.Color;
          this.Canvas.beginPath();
          this.Canvas.moveTo(x, y);
          bFirstPoint = false;
        }
        else {
          this.Canvas.lineTo(x, y);
        }

        ++drawCount;
      }
    }

    if (drawCount > 0)
      this.Canvas.stroke();
  }

  this.GetMaxMin = function () {
    var xPointCount = this.ChartFrame.XPointCount;
    var range = {};
    range.Min = null;
    range.Max = null;

    if (!this.Data || !this.Data.Data) return range;

    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var aryValue = this.Data.Data[i];
      if (aryValue == null) continue;

      for (var index in aryValue) {
        var value = aryValue[index].Value;
        if (range.Max == null) range.Max = value;
        if (range.Min == null) range.Min = value;

        if (range.Max < value) range.Max = value;
        if (range.Min > value) range.Min = value;
      }
    }

    return range;
  }
}


function ChartStickLine() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Color = "rgb(255,193,37)";   //线段颜色
  this.LineWidth = 2;                   //线段宽度

  this.Draw = function () {
    if (this.NotSupportMessage) {
      this.DrawNotSupportmessage();
      return;
    }

    if (!this.Data || !this.Data.Data) return;

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    this.Canvas.save();
    var LineWidth = this.LineWidth;
    if (dataWidth <= 4) LineWidth = 1;
    else if (dataWidth < LineWidth) LineWidth = parseInt(dataWidth);
    this.Canvas.strokeStyle = this.Color;
    this.Canvas.lineWidth = LineWidth;

    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var value = this.Data.Data[i];
      if (value == null) continue;

      var price = value.Value;
      var price2 = value.Value2;
      if (price2 == null) price2 = 0;

      var x = this.ChartFrame.GetXFromIndex(j);
      var y = this.ChartFrame.GetYFromData(price);
      var y2 = this.ChartFrame.GetYFromData(price2);

      if (x > chartright) break;

      var xFix = parseInt(x.toString()) + 0.5;
      this.Canvas.beginPath();
      this.Canvas.moveTo(xFix, y);
      this.Canvas.lineTo(xFix, y2);
      this.Canvas.stroke();
    }

    this.Canvas.restore();
  }

  this.GetMaxMin = function () {
    var xPointCount = this.ChartFrame.XPointCount;
    var range = {};
    range.Min = null;
    range.Max = null;

    if (!this.Data || !this.Data.Data) return range;

    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var data = this.Data.Data[i];
      if (data == null) continue;
      var value2 = data.Value2;
      if (value2 == null) value2 = 0;
      if (data == null || isNaN(data.Value) || isNaN(value2)) continue;

      var valueMax = Math.max(data.Value, value2);
      var valueMin = Math.min(data.Value, value2);

      if (range.Max == null) range.Max = valueMax;
      if (range.Min == null) range.Min = valueMin;

      if (range.Max < valueMax) range.Max = valueMax;
      if (range.Min > valueMin) range.Min = valueMin;
    }

    return range;
  }
}

function ChartText() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.TextFont = "14px 微软雅黑";

  this.Draw = function () {
    if (this.NotSupportMessage) {
      this.DrawNotSupportmessage();
      return;
    }

    if (!this.Data || !this.Data.Data) return;

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    for (var i in this.Data.Data) {
      var value = this.Data.Data[i];
      if (value == null) continue;

      var price = value.Value;
      var position = value.Position;

      if (position == 'Left') {
        var x = this.ChartFrame.GetXFromIndex(0);
        var y = this.ChartFrame.GetYFromData(price);

        if (x > chartright) continue;

        this.Canvas.textAlign = 'left';
        this.Canvas.textBaseline = 'middle';
        this.Canvas.fillStyle = value.Color;
        this.Canvas.font = this.TextFont;
        this.Canvas.fillText(value.Message, x, y);
      }

    }

  }

  this.GetMaxMin = function () {
    var xPointCount = this.ChartFrame.XPointCount;
    var range = {};
    range.Min = null;
    range.Max = null;

    if (!this.Data || !this.Data.Data) return range;

    for (var i in this.Data.Data) {
      var data = this.Data.Data[i];
      if (data == null || isNaN(data.Value)) continue;

      var value = data.Value;

      if (range.Max == null) range.Max = value;
      if (range.Min == null) range.Min = value;

      if (range.Max < value) range.Max = value;
      if (range.Min > value) range.Min = value;
    }

    return range;
  }
}

/*
    数组不为null的数据中输出 this.Text文本
*/
function ChartSingleText() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Color = "rgb(255,193,37)";           //线段颜色
  this.TextFont = "14px 微软雅黑";           //线段宽度
  this.Text;

  this.Draw = function () {
    if (!this.IsShow) return;

    if (this.NotSupportMessage) {
      this.DrawNotSupportmessage();
      return;
    }

    if (!this.Data || !this.Data.Data) return;

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var value = this.Data.Data[i];
      if (value == null) continue;

      var x = this.ChartFrame.GetXFromIndex(j);
      var y = this.ChartFrame.GetYFromData(value);

      if (x > chartright) break;

      this.Canvas.textAlign = 'left';
      this.Canvas.textBaseline = 'middle';
      this.Canvas.fillStyle = this.Color;
      this.Canvas.font = this.TextFont;
      this.Canvas.fillText(this.Text, x, y);
    }
  }
}

//直线 水平直线 只有1个数据
function ChartStraightLine() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Color = "rgb(255,193,37)";   //线段颜色

  this.Draw = function () {
    if (!this.Data || !this.Data.Data) return;
    if (this.Data.Data.length != 1) return;

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    var yValue = this.Data.Data[0];
    var y = this.ChartFrame.GetYFromData(yValue);
    var xLeft = this.ChartFrame.GetXFromIndex(0);
    var xRight = this.ChartFrame.GetXFromIndex(xPointCount - 1);

    var yFix = parseInt(y.toString()) + 0.5;
    this.Canvas.beginPath();
    this.Canvas.moveTo(xLeft, yFix);
    this.Canvas.lineTo(xRight, yFix);
    this.Canvas.strokeStyle = this.Color;
    this.Canvas.stroke();
  }

  this.GetMaxMin = function () {
    var xPointCount = this.ChartFrame.XPointCount;
    var range = {};
    range.Min = null;
    range.Max = null;

    if (!this.Data || !this.Data.Data) return range;
    if (this.Data.Data.length != 1) return range;

    range.Min = this.Data.Data[0];
    range.Max = this.Data.Data[0];

    return range;
  }
}

/*  水平面积 只有1个数据
    Data 数据结构 
    Value, Value2  区间最大最小值
    Color=面积的颜色
    Title=标题 TitleColor=标题颜色
*/
function ChartStraightArea() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Color = "rgb(255,193,37)";   //线段颜色
  this.Font = '11px 微软雅黑';

  this.Draw = function () {
    if (this.NotSupportMessage) {
      this.DrawNotSupportmessage();
      return;
    }

    if (!this.Data || !this.Data.Data) return;

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartright = this.ChartBorder.GetRight();
    var bottom = this.ChartBorder.GetBottom();
    var left = this.ChartBorder.GetLeft();
    var xPointCount = this.ChartFrame.XPointCount;

    var xRight = this.ChartFrame.GetXFromIndex(xPointCount - 1);

    //画背景
    for (let i in this.Data.Data) {
      let item = this.Data.Data[i];
      if (item == null || isNaN(item.Value) || isNaN(item.Value2)) continue;
      if (item.Color == null) continue;

      let valueMax = Math.max(item.Value, item.Value2);
      let valueMin = Math.min(item.Value, item.Value2);

      let yTop = this.ChartFrame.GetYFromData(valueMax);
      let yBottom = this.ChartFrame.GetYFromData(valueMin);

      this.Canvas.fillStyle = item.Color;
      this.Canvas.fillRect(ToFixedRect(left), ToFixedRect(yTop), ToFixedRect(xRight - left), ToFixedRect(yBottom - yTop));
    }

    for (let i in this.Data.Data) {
      let item = this.Data.Data[i];
      if (item == null || isNaN(item.Value) || isNaN(item.Value2)) continue;
      if (item.Color == null) continue;

      let valueMax = Math.max(item.Value, item.Value2);
      let valueMin = Math.min(item.Value, item.Value2);

      let yTop = this.ChartFrame.GetYFromData(valueMax);
      let yBottom = this.ChartFrame.GetYFromData(valueMin);

      if (item.Title && item.TitleColor) {
        let x = xRight;
        if (item.Align == 'left') {
          this.Canvas.textAlign = 'left';
          x = left;
        }
        else {
          this.Canvas.textAlign = 'right';
          x = xRight;
        }

        this.Canvas.textBaseline = 'middle';
        this.Canvas.fillStyle = item.TitleColor;
        this.Canvas.font = this.Font;
        let y = yTop + (yBottom - yTop) / 2;
        this.Canvas.fillText(item.Title, x, y);
      }
    }
  }

  this.GetMaxMin = function () {
    var xPointCount = this.ChartFrame.XPointCount;
    var range = {};
    range.Min = null;
    range.Max = null;

    if (!this.Data || !this.Data.Data) return range;

    for (let i in this.Data.Data) {
      let item = this.Data.Data[i];
      if (item == null || isNaN(item.Value) || isNaN(item.Value2)) continue;

      let valueMax = Math.max(item.Value, item.Value2);
      let valueMin = Math.min(item.Value, item.Value2);

      if (range.Max == null) range.Max = valueMax;
      if (range.Min == null) range.Min = valueMin;

      if (range.Max < valueMax) range.Max = valueMax;
      if (range.Min > valueMin) range.Min = valueMin;
    }

    return range;
  }
}

//分钟线
function ChartMinutePriceLine() {
  this.newMethod = ChartLine;   //派生
  this.newMethod();
  delete this.newMethod;

  this.YClose;

  this.Draw = function () {
    if (this.NotSupportMessage) {
      this.DrawNotSupportmessage();
      return;
    }

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    var bFirstPoint = true;
    var drawCount = 0;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var value = this.Data.Data[i];
      if (value == null) continue;

      var x = this.ChartFrame.GetXFromIndex(j);
      var y = this.ChartFrame.GetYFromData(value);

      if (bFirstPoint) {
        this.Canvas.strokeStyle = this.Color;
        this.Canvas.beginPath();
        this.Canvas.moveTo(x, y);
        bFirstPoint = false;
      }
      else {
        this.Canvas.lineTo(x, y);
      }

      ++drawCount;
    }

    if (drawCount > 0)
      this.Canvas.stroke();
  }

  this.GetMaxMin = function () {
    var xPointCount = this.ChartFrame.XPointCount;
    var range = {};
    if (this.YClose == null) return range;

    range.Min = this.YClose;
    range.Max = this.YClose;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var value = this.Data.Data[i];
      if (range.Max == null) range.Max = value;
      if (range.Min == null) range.Min = value;

      if (range.Max < value) range.Max = value;
      if (range.Min > value) range.Min = value;
    }

    if (range.Max == this.YClose && range.Min == this.YClose) {
      range.Max = this.YClose + this.YClose * 0.1;
      range.Min = this.YClose - this.YClose * 0.1;
      return range;
    }

    var distance = Math.max(Math.abs(this.YClose - range.Max), Math.abs(this.YClose - range.Min));
    range.Max = this.YClose + distance;
    range.Min = this.YClose - distance;

    return range;
  }
}

//MACD森林线
function ChartMACD() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.UpColor = g_JSChartResource.UpBarColor;
  this.DownColor = g_JSChartResource.DownBarColor;

  this.Draw = function () {
    if (this.NotSupportMessage) {
      this.DrawNotSupportmessage();
      return;
    }

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;

    var bFirstPoint = true;
    var drawCount = 0;
    var yBottom = this.ChartFrame.GetYFromData(0);
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var value = this.Data.Data[i];
      if (value == null) continue;

      var x = this.ChartFrame.GetXFromIndex(j);
      var y = this.ChartFrame.GetYFromData(value);

      if (x > chartright) break;

      var xFix = parseInt(x.toString()) + 0.5;    //毛边修正
      this.Canvas.beginPath();
      this.Canvas.moveTo(xFix, yBottom);
      this.Canvas.lineTo(xFix, y);

      if (value >= 0) this.Canvas.strokeStyle = this.UpColor;
      else this.Canvas.strokeStyle = this.DownColor;
      this.Canvas.stroke();
      this.Canvas.closePath();
    }
  }
}

//基础图形的XY坐标互换柱子
function ChartXYSubBar() {
  this.newMethod = ChartBar;   //派生
  this.newMethod();
  delete this.newMethod;

  this.BarID = 0;

  this.Draw = function () {
    if (this.NotSupportMessage) {
      this.DrawNotSupportmessage();
      return;
    }

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartTop = this.ChartBorder.GetTopEx();
    var xPointCount = this.ChartFrame.XPointCount;
    var yOffset = this.ChartBorder.GetBottom() - distanceWidth / 2.0 - 2.0;

    var xMiddle = this.ChartFrame.GetXFromIndex(0); //0 刻度

    if (dataWidth >= 4) {
      var barCount = this.ChartFrame.BarCount;
      var subBarWidth = dataWidth;
      var subBarOffset = 0;
      if (barCount > 0)     //多柱子需要把框架柱子宽度的平均分割
      {
        subBarWidth = dataWidth / barCount;
        subBarOffset = subBarWidth * this.BarID;
        //console.log('[ChartXYSubBar::Draw] ', subBarWidth, this.BarID, subBarOffset);
      }

      xMiddle = ToFixedRect(xMiddle);   //调整为整数
      for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j, yOffset -= (dataWidth + distanceWidth)) {
        var value = this.Data.Data[i];
        if (value == null || value == 0) continue;

        var yBottom = yOffset + subBarOffset;
        var yTop = yOffset + subBarOffset - dataWidth;
        if (yBottom < chartTop) break;

        var x = this.ChartFrame.GetXFromIndex(value);

        if (value > 0) {
          this.Canvas.fillStyle = this.UpBarColor;
          let barWidth = ToFixedRect(Math.abs(x - xMiddle));
          let barHeight = subBarWidth;
          if (Math.abs(chartTop - yBottom) < dataWidth) subBarWidth = Math.abs(chartTop - yBottom); //最后一根柱子可能会超出框架
          this.Canvas.fillRect(xMiddle, ToFixedRect(yTop), barWidth, ToFixedRect(barHeight + 0.5));
        }
        else {
          this.Canvas.fillStyle = this.DownBarColor;
          //高度调整为整数
          let barWidth = ToFixedRect(Math.abs(x - xMiddle));
          let barHeight = subBarWidth;
          if (Math.abs(chartTop - yBottom) < subBarWidth) barHeight = Math.abs(chartTop - yBottom); //最后一根柱子可能会超出框架
          this.Canvas.fillRect(xMiddle, ToFixedRect(yTop), -barWidth, ToFixedRect(barHeight + 0.5));
        }


      }
    }
    else    //太细了 直接画柱子
    {
      for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j, yOffset -= (dataWidth + distanceWidth)) {
        var value = this.Data.Data[i];
        if (value == null || value == 0) continue;

        var yBottom = yOffset;
        var yTop = yOffset - dataWidth;
        if (yTop < chartTop) break;

        var x = this.ChartFrame.GetXFromIndex(value);
        var y = this.ChartFrame.GetYFromData(j);

        if (value > 0) this.Canvas.strokeStyle = this.UpBarColor;
        else this.Canvas.strokeStyle = this.DownBarColor;

        this.Canvas.beginPath();
        this.Canvas.moveTo(ToFixedPoint(x), y);
        this.Canvas.lineTo(ToFixedPoint(xMiddle), y);
        this.Canvas.stroke();
      }
    }
  }
}

function ChartSubBar() {
  this.newMethod = ChartBar;   //派生
  this.newMethod();
  delete this.newMethod;

  this.BarID = 0;

  this.Draw = function () {
    if (this.NotSupportMessage) {
      this.DrawNotSupportmessage();
      return;
    }

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;
    var xOffset = this.ChartBorder.GetLeft() + distanceWidth / 2.0 + 2.0;


    var yBottom = this.ChartFrame.GetYFromData(0);
    if (dataWidth >= 4) {
      var barCount = this.ChartFrame.BarCount;
      var subBarWidth = dataWidth;
      var subBarOffset = 0;
      if (barCount > 0)     //多柱子需要把框架柱子宽度的平均分割
      {
        subBarWidth = dataWidth / barCount;
        subBarOffset = subBarWidth * this.BarID;
        //console.log('[ChartSubBar::Draw] ', subBarWidth, this.BarID, subBarOffset);
      }

      yBottom = ToFixedRect(yBottom);   //调整为整数
      for (let i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j, xOffset += (dataWidth + distanceWidth)) {
        var value = this.Data.Data[i];
        if (value == null || value == 0) continue;

        var left = xOffset + subBarOffset
        var right = xOffset + subBarOffset + subBarWidth;
        if (left > chartright) break;

        var x = this.ChartFrame.GetXFromIndex(j);
        var y = this.ChartFrame.GetYFromData(value);

        if (value > 0) {
          this.Canvas.fillStyle = this.UpBarColor;
          //高度调整为整数
          let height = ToFixedRect(Math.abs(yBottom - y));
          let barWidth = subBarWidth;
          if (chartright - left < subBarWidth) barWidth = chartright - left;
          if (yBottom - y > 0) y = yBottom - height;
          else y = yBottom + height;
          this.Canvas.fillRect(ToFixedRect(left), y, ToFixedRect(barWidth), height);
        }
        else {
          this.Canvas.fillStyle = this.DownBarColor;
          //高度调整为整数
          let height = ToFixedRect(Math.abs(yBottom - y));
          let barWidth = subBarWidth;
          if (chartright - left < subBarWidth) barWidth = chartright - left;
          if (yBottom - y > 0) y = yBottom - height;
          else y = yBottom + height;
          this.Canvas.fillRect(ToFixedRect(left), y, ToFixedRect(subBarWidth), -height);
        }
      }
    }
    else    //太细了 直接画柱子
    {
      for (let i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j, xOffset += (dataWidth + distanceWidth)) {
        var value = this.Data.Data[i];
        if (value == null || value == 0) continue;

        var left = xOffset;
        var right = xOffset + dataWidth;
        if (right > chartright) break;

        var x = this.ChartFrame.GetXFromIndex(j);
        var y = this.ChartFrame.GetYFromData(value);

        if (value > 0) this.Canvas.strokeStyle = this.UpBarColor;
        else this.Canvas.strokeStyle = this.DownBarColor;

        this.Canvas.beginPath();
        this.Canvas.moveTo(ToFixedPoint(x), y);
        this.Canvas.lineTo(ToFixedPoint(x), yBottom);
        this.Canvas.stroke();
      }
    }
  }
}

//柱子
function ChartBar() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.UpBarColor = g_JSChartResource.UpBarColor;
  this.DownBarColor = g_JSChartResource.DownBarColor;

  this.Draw = function () {
    if (this.NotSupportMessage) {
      this.DrawNotSupportmessage();
      return;
    }

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var chartright = this.ChartBorder.GetRight();
    var xPointCount = this.ChartFrame.XPointCount;
    var xOffset = this.ChartBorder.GetLeft() + distanceWidth / 2.0 + 2.0;

    var bFirstPoint = true;
    var drawCount = 0;
    var yBottom = this.ChartFrame.GetYFromData(0);
    if (dataWidth >= 4) {
      yBottom = ToFixedRect(yBottom);   //调整为整数
      for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j, xOffset += (dataWidth + distanceWidth)) {
        var value = this.Data.Data[i];
        if (value == null || value == 0) continue;

        var left = xOffset;
        var right = xOffset + dataWidth;
        if (right > chartright) break;

        var x = this.ChartFrame.GetXFromIndex(j);
        var y = this.ChartFrame.GetYFromData(value);


        if (value > 0) {
          this.Canvas.fillStyle = this.UpBarColor;
          //高度调整为整数
          let height = ToFixedRect(Math.abs(yBottom - y));
          if (yBottom - y > 0) y = yBottom - height;
          else y = yBottom + height;
          this.Canvas.fillRect(ToFixedRect(left), y, ToFixedRect(dataWidth), height);
        }
        else {
          this.Canvas.fillStyle = this.DownBarColor;
          //高度调整为整数
          let height = ToFixedRect(Math.abs(yBottom - y));
          if (yBottom - y > 0) y = yBottom - height;
          else y = yBottom + height;
          this.Canvas.fillRect(ToFixedRect(left), y, ToFixedRect(dataWidth), -height);
        }


      }
    }
    else    //太细了 直接画柱子
    {
      for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j, xOffset += (dataWidth + distanceWidth)) {
        var value = this.Data.Data[i];
        if (value == null || value == 0) continue;

        var left = xOffset;
        var right = xOffset + dataWidth;
        if (right > chartright) break;

        var x = this.ChartFrame.GetXFromIndex(j);
        var y = this.ChartFrame.GetYFromData(value);

        if (value > 0) this.Canvas.strokeStyle = this.UpBarColor;
        else this.Canvas.strokeStyle = this.DownBarColor;

        this.Canvas.beginPath();
        this.Canvas.moveTo(ToFixedPoint(x), y);
        this.Canvas.lineTo(ToFixedPoint(x), yBottom);
        this.Canvas.stroke();
      }
    }
  }

  this.GetMaxMin = function () {
    var xPointCount = this.ChartFrame.XPointCount;
    var range = {};
    range.Min = 0;
    range.Max = null;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var value = this.Data.Data[i];
      if (range.Max == null) range.Max = value;
      if (range.Max < value) range.Max = value;
      if (range.Min > value) range.Min = value;
    }

    return range;
  }
}
// 面积图
function ChartBand() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;
  this.IsDrawFirst = true;

  this.FirstColor = g_JSChartResource.Index.LineColor[0];
  this.SecondColor = g_JSChartResource.Index.LineColor[1];

  this.Draw = function () {
    if (this.NotSupportMessage) {
      this.DrawNotSupportmessage();
      return;
    }

    var dataWidth = this.ChartFrame.DataWidth;
    var distanceWidth = this.ChartFrame.DistanceWidth;
    var xPointCount = this.ChartFrame.XPointCount;
    var xOffset = this.ChartBorder.GetLeft() + distanceWidth / 2.0 + 2.0;
    var x = 0;
    var y = 0;
    var y2 = 0;
    var firstlinePoints = [];
    var secondlinePoints = [];
    var lIndex = 0;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j, xOffset += (dataWidth + distanceWidth)) {
      var value = this.Data.Data[i];
      if (value == null || value.Value == null || value.Value2 == null) continue;
      x = this.ChartFrame.GetXFromIndex(j);
      y = this.ChartFrame.GetYFromData(value.Value);
      y2 = this.ChartFrame.GetYFromData(value.Value2);
      firstlinePoints[lIndex] = { x: x, y: y };
      secondlinePoints[lIndex] = { x: x, y: y2 };
      lIndex++;
    }
    if (firstlinePoints.length > 1) {
      this.Canvas.save();
      this.Canvas.beginPath();
      for (var i = 0; i < firstlinePoints.length; ++i) {
        if (i == 0)
          this.Canvas.moveTo(firstlinePoints[i].x, firstlinePoints[i].y);
        else
          this.Canvas.lineTo(firstlinePoints[i].x, firstlinePoints[i].y);
      }
      for (var j = secondlinePoints.length - 1; j >= 0; --j) {
        this.Canvas.lineTo(secondlinePoints[j].x, secondlinePoints[j].y);
      }
      this.Canvas.closePath();
      this.Canvas.clip();
      this.Canvas.beginPath();
      this.Canvas.moveTo(firstlinePoints[0].x, this.ChartBorder.GetBottom());
      for (var i = 0; i < firstlinePoints.length; ++i) {
        this.Canvas.lineTo(firstlinePoints[i].x, firstlinePoints[i].y);
      }
      this.Canvas.lineTo(firstlinePoints[firstlinePoints.length - 1].x, this.ChartBorder.GetBottom());
      this.Canvas.closePath();
      this.Canvas.fillStyle = this.FirstColor;
      this.Canvas.fill();
      this.Canvas.beginPath();
      this.Canvas.moveTo(secondlinePoints[0].x, this.ChartBorder.GetBottom());
      for (var i = 0; i < secondlinePoints.length; ++i) {
        this.Canvas.lineTo(secondlinePoints[i].x, secondlinePoints[i].y);
      }
      this.Canvas.lineTo(secondlinePoints[secondlinePoints.length - 1].x, this.ChartBorder.GetBottom());
      this.Canvas.closePath();
      this.Canvas.fillStyle = this.SecondColor;
      this.Canvas.fill();
      this.Canvas.restore();
    }
  }
  this.GetMaxMin = function () {
    var xPointCount = this.ChartFrame.XPointCount;
    var range = {};
    range.Min = null;
    range.Max = null;
    for (var i = this.Data.DataOffset, j = 0; i < this.Data.Data.length && j < xPointCount; ++i, ++j) {
      var value = this.Data.Data[i];
      if (value == null || value.Value == null || value.Value2 == null) continue;
      var maxData = value.Value > value.Value2 ? value.Value : value.Value2;
      var minData = value.Value < value.Value2 ? value.Value : value.Value2;
      if (range.Max == null)
        range.Max = maxData;
      else if (range.Max < maxData)
        range.Max = maxData;

      if (range.Min == null)
        range.Min = minData;
      else if (range.Min > minData)
        range.Min = minData;
    }

    return range;
  }
}

////////////////////////////////////////////////////////////////////////////////
// 等待提示
function ChartSplashPaint() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Font = g_JSChartResource.DefaultTextFont;            //字体
  this.TextColor = g_JSChartResource.DefaultTextColor;      //文本颜色
  this.IsEnableSplash = false;
  this.SplashTitle = '数据加载中.....';

  this.Draw = function () {
    if (!this.IsEnableSplash) return;

    var xCenter = (this.Frame.ChartBorder.GetLeft() + this.Frame.ChartBorder.GetRight()) / 2;
    var yCenter = (this.Frame.ChartBorder.GetTop() + this.Frame.ChartBorder.GetBottom()) / 2;
    this.Canvas.textAlign = 'center';
    this.Canvas.textBaseline = 'middle';
    this.Canvas.fillStyle = this.TextColor;
    this.Canvas.font = this.Font;
    this.Canvas.fillText(this.SplashTitle, xCenter, yCenter);
  }
}

/*
    饼图
*/
function ChartPie() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Draw = function () {
    if (!this.Data || !this.Data.Data || !(this.Data.Data.length > 0)) return this.DrawEmptyData();

    let left = this.ChartBorder.GetLeft();
    let right = this.ChartBorder.GetRight();
    let top = this.ChartBorder.GetTop();
    let bottom = this.ChartBorder.GetBottom();
    let width = this.ChartBorder.GetWidth();
    let height = this.ChartBorder.GetHeight();

    //圆半径
    let radius = width / 4 * 0.8;
    this.Canvas.save();
    this.Canvas.translate(left + radius, top + height / 2);

    let totalValue = 0;   //求和
    for (let i in this.Data.Data) {
      totalValue += this.Data.Data[i].Value;
    }

    let startAngle = Math.PI * 1.5;
    let start = startAngle;
    let end = startAngle;
    //画饼图
    for (let i in this.Data.Data) {
      let item = this.Data.Data[i];
      let rate = item.Value / totalValue; //占比

      // 绘制扇形
      this.Canvas.beginPath();
      this.Canvas.moveTo(0, 0);

      end += rate * 2 * Math.PI;//终止角度
      this.Canvas.strokeStyle = "white";
      this.Canvas.fillStyle = item.Color;
      this.Canvas.arc(0, 0, radius, start, end);
      this.Canvas.fill();
      this.Canvas.closePath();
      this.Canvas.stroke();

      start += rate * 2 * Math.PI;//起始角度
    }

    //画文字
    this.Canvas.restore();
    let textLeft = left + width / 2 + 5;
    let textTop = top + height / 2 + 20;
    this.Canvas.textBaseline = "bottom";
    this.Canvas.font = "14px 微软雅黑";

    for (let i = 0, j = 0; i < this.Data.Data.length; ++i) {
      let item = this.Data.Data[i];
      if (!item.Text) continue;

      this.Canvas.fillStyle = item.Color;
      this.Canvas.fillRect(textLeft, textTop - 15, 13, 13);

      this.Canvas.fillStyle = 'rgb(102,102,102)';
      this.Canvas.fillText(item.Text, textLeft + 16, textTop);
      textTop += 20;
      if (textTop > top + height / 2 + radius) {
        ++j;
        if (j >= 2) break;

        textTop = top + height / 2 + 20;
        textLeft = right - (width / 4) + 5;
      }
    }
  }

  //空数据
  this.DrawEmptyData = function () {
    console.log('[ChartPie::DrawEmptyData]')

    let left = this.ChartBorder.GetLeft();
    let right = this.ChartBorder.GetRight();
    let top = this.ChartBorder.GetTop();
    let bottom = this.ChartBorder.GetBottom();
    let width = this.ChartBorder.GetWidth();
    let height = this.ChartBorder.GetHeight();

    //圆半径
    let radius = width / 4 * 0.8;
    this.Canvas.save();
    this.Canvas.translate(left + radius, top + height / 2);

    this.Canvas.beginPath();
    this.Canvas.fillStyle = 'rgb(211,211,211)';
    this.Canvas.strokeStyle = "white";
    this.Canvas.arc(0, 0, radius * 0.8, 0, 2 * Math.PI);
    this.Canvas.fill();
    this.Canvas.closePath();
    this.Canvas.stroke();

    this.Canvas.restore();
  }
}


/*
    圆环
*/
function ChartCircle() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.BGColor = 'white';  //背景色
  this.TextHeight = 25;

  //空数据
  this.DrawEmptyData = function () {
    console.log('[ChartCircle::DrawEmptyData]')
  }

  this.Draw = function () {
    if (!this.Data || !this.Data.Data || !(this.Data.Data.length > 0)) return this.DrawEmptyData();

    let left = this.ChartBorder.GetLeft();
    let right = this.ChartBorder.GetRight();
    let top = this.ChartBorder.GetTop();
    let bottom = this.ChartBorder.GetBottom();
    let width = this.ChartBorder.GetWidth();
    let height = this.ChartBorder.GetHeight();

    //圆半径
    let lTextHeight = this.TextHeight;
    let size = width - lTextHeight;
    if (size > height - lTextHeight) size = height - lTextHeight;
    let radius = (size - lTextHeight) / 2;
    this.Canvas.save();
    this.Canvas.translate(left + width / 2, top + height / 2 - lTextHeight / 2);

    let totalValue = 0;   //求和
    for (let i in this.Data.Data) {
      totalValue += this.Data.Data[i].Value;
    }

    let startAngle = Math.PI * 1.5;
    let start = startAngle;
    let end = startAngle;
    //画饼图
    for (let i in this.Data.Data) {
      let item = this.Data.Data[i];
      let rate = item.Value / totalValue; //占比
      //console.log('[ChartPie::Draw]', i, rate, item);

      // 绘制扇形
      this.Canvas.beginPath();
      this.Canvas.moveTo(0, 0);

      end += rate * 2 * Math.PI;//终止角度
      this.Canvas.strokeStyle = "white";
      this.Canvas.fillStyle = item.Color;
      this.Canvas.arc(0, 0, radius, start, end);
      this.Canvas.fill();
      this.Canvas.closePath();
      this.Canvas.stroke();

      start += rate * 2 * Math.PI;//起始角度
    }

    //中心画一个背景色的圆
    this.Canvas.beginPath();
    this.Canvas.fillStyle = this.BGColor;
    this.Canvas.arc(0, 0, radius * 0.5, 0, 2 * Math.PI);
    this.Canvas.fill();
    this.Canvas.closePath();
    this.Canvas.stroke();

    this.Canvas.restore();

    //画文字
    this.Canvas.restore();
    let textLeft = left;
    let textTop = top + height / 2 - lTextHeight / 2 + radius + 5 + 20;
    this.Canvas.textBaseline = "bottom";
    this.Canvas.textAlign = 'left';
    this.Canvas.font = "14px 微软雅黑";
    let textWidth = 0;
    //以圆心左右显示
    for (let i = 0, j = 0; i < this.Data.Data.length; ++i) {
      let item = this.Data.Data[i];
      if (!item.Text) continue;

      this.Canvas.fillStyle = item.Color;

      if (j % 2 == 0) {
        textLeft = left + width / 2 - 10;
        textWidth = this.Canvas.measureText(item.Text).width;
        textLeft = textLeft - textWidth - 16;
        this.Canvas.fillRect(textLeft, textTop - 15, 13, 13);
        this.Canvas.fillStyle = 'rgb(102,102,102)';
        this.Canvas.fillText(item.Text, textLeft + 16, textTop);
      }
      else {
        textLeft = left + width / 2 + 10 + 10;
        this.Canvas.fillRect(textLeft, textTop - 15, 13, 13);
        this.Canvas.fillStyle = 'rgb(102,102,102)';
        this.Canvas.fillText(item.Text, textLeft + 16, textTop);
        textTop += 20;
      }

      if (textTop > bottom) break;

      ++j;
    }
  }
}

/*
    中国地图
*/


function ChartChinaMap() {
  this.newMethod = IChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.ImageData = null;
  this.Left;
  this.Top;
  this.Width;
  this.Height;
  this.ImageWidth;
  this.ImageHeight;

  this.DefaultColor = [217, 222, 239];

  this.Color =
    [
      { Name: '海南', Color: 'rgb(217,222,223)' },
      { Name: '内蒙古', Color: 'rgb(217,222,225)' },
      { Name: '新疆', Color: 'rgb(217,222,226)' },
      { Name: '青海', Color: 'rgb(217,222,227)' },
      { Name: '西藏', Color: 'rgb(217,222,228)' },
      { Name: '云南', Color: 'rgb(217,222,229)' },
      { Name: '黑龙江', Color: 'rgb(217,222,230)' },
      { Name: '吉林', Color: 'rgb(217,222,231)' },
      { Name: '辽宁', Color: 'rgb(217,222,232)' },
      { Name: '河北', Color: 'rgb(217,222,233)' },
      { Name: '山东', Color: 'rgb(217,222,234)' },
      { Name: '江苏', Color: 'rgb(217,222,235)' },
      { Name: '浙江', Color: 'rgb(217,222,236)' },
      { Name: '福建', Color: 'rgb(217,222,237)' },
      { Name: '广东', Color: 'rgb(217,222,238)' },
      { Name: '广西', Color: 'rgb(217,222,239)' },
      { Name: '贵州', Color: 'rgb(217,222,240)' },
      { Name: '湖南', Color: 'rgb(217,222,241)' },
      { Name: '江西', Color: 'rgb(217,222,242)' },
      { Name: '安徽', Color: 'rgb(217,222,243)' },
      { Name: '湖北', Color: 'rgb(217,222,244)' },
      { Name: '重庆', Color: 'rgb(217,222,245)' },
      { Name: '四川', Color: 'rgb(217,222,246)' },
      { Name: '甘肃', Color: 'rgb(217,222,247)' },
      { Name: '陕西', Color: 'rgb(217,222,248)' },
      { Name: '山西', Color: 'rgb(217,222,249)' },
      { Name: '河南', Color: 'rgb(217,222,250)' }
    ];

  this.Draw = function () {
    let left = this.ChartBorder.GetLeft() + 1;
    let right = this.ChartBorder.GetRight() - 1;
    let top = this.ChartBorder.GetTop() + 1;
    let bottom = this.ChartBorder.GetBottom() - 1;
    let width = this.ChartBorder.GetWidth() - 2;
    let height = this.ChartBorder.GetHeight() - 2;

    let imageWidth = CHINA_MAP_IMAGE.width;
    let imageHeight = CHINA_MAP_IMAGE.height;

    let drawImageWidth = imageWidth;
    let drawImageHeight = imageHeight;

    if (height < drawImageHeight || width < drawImageWidth) {
      this.ImageData = null;
      return;
    }

    if (this.Left != left || this.Top != top || this.Width != width || this.Height != height || this.ImageWidth != imageWidth || this.ImageHeight != imageHeight) {
      this.ImageData = null;

      this.ImageWidth = imageWidth;
      this.ImageHeight = imageHeight;
      this.Left = left;
      this.Top = top;
      this.Width = width;
      this.Height = height;

      console.log(imageWidth, imageHeight);
    }

    if (this.ImageData == null) {
      this.Canvas.drawImage(CHINA_MAP_IMAGE, 0, 0, imageWidth, imageHeight, left, top, drawImageWidth, drawImageHeight);
      this.ImageData = this.Canvas.getImageData(left, top, drawImageWidth, drawImageHeight);

      let defaultColorSet = new Set();  //默认颜色填充的色块
      let colorMap = new Map();         //定义颜色填充的色块

      let nameMap = new Map();
      if (this.Data.length > 0) {
        for (let i in this.Data) {
          let item = this.Data[i];
          nameMap.set(item.Name, item.Color)
        }
      }

      console.log(this.Data);
      for (let i in this.Color) {
        let item = this.Color[i];
        if (nameMap.has(item.Name)) {
          colorMap.set(item.Color, nameMap.get(item.Name));
        }
        else {
          defaultColorSet.add(item.Color);
        }
      }

      var color;
      for (let i = 0; i < this.ImageData.data.length; i += 4) {
        color = 'rgb(' + this.ImageData.data[i] + ',' + this.ImageData.data[i + 1] + ',' + this.ImageData.data[i + 2] + ')';

        if (defaultColorSet.has(color)) {
          this.ImageData.data[i] = this.DefaultColor[0];
          this.ImageData.data[i + 1] = this.DefaultColor[1];
          this.ImageData.data[i + 2] = this.DefaultColor[2];
        }
        else if (colorMap.has(color)) {
          let colorValue = colorMap.get(color);
          this.ImageData.data[i] = colorValue[0];
          this.ImageData.data[i + 1] = colorValue[1];
          this.ImageData.data[i + 2] = colorValue[2];
        }
      }
      this.Canvas.clearRect(left, top, drawImageWidth, drawImageHeight);
      this.Canvas.putImageData(this.ImageData, left, top, 0, 0, drawImageWidth, drawImageHeight);
    }
    else {
      this.Canvas.putImageData(this.ImageData, left, top, 0, 0, drawImageWidth, drawImageHeight);
    }
  }
}

/*
    扩展图形
*/

function IExtendChartPainting() {
  this.Canvas;                        //画布
  this.ChartBorder;                   //边框信息
  this.ChartFrame;                    //框架画法
  this.Name;                          //名称
  this.Data = new ChartData();          //数据区

  //上下左右间距
  this.Left = 5;
  this.Right = 5;
  this.Top = 5;
  this.Bottom = 5;

  this.Draw = function () {

  }

}

function StockInfoExtendChartPaint() {
  this.newMethod = IExtendChartPainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Left = 80;
  this.Right = 1;
  this.Top = 1;
  this.Bottom = 1;

  this.BorderColor = g_JSChartResource.FrameBorderPen;

  this.Symbol;
  this.Name;

  this.TitleFont = ["14px 微软雅黑"];

  this.Draw = function () {
    var left = this.ChartBorder.GetRight() + this.Left;
    var right = this.ChartBorder.GetChartWidth() - this.Right;
    var y = this.Top + 18;
    var middle = left + (right - left) / 2;

    if (this.Symbol && this.Name) {
      this.Canvas.font = this.TitleFont[0];

      this.Canvas.textAlign = "right";
      this.Canvas.textBaseline = "bottom";
      this.Canvas.fillText(this.Symbol, middle - 2, y);

      this.Canvas.textAlign = "left";
      this.Canvas.fillText(this.Name, middle + 2, y);
    }
    ;
    this.Canvas.strokeStyle = this.BorderColor;
    this.Canvas.moveTo(left, y);
    this.Canvas.lineTo(right, y);
    this.Canvas.stroke();

    y += 30;

    this.DrawBorder();
  }

  this.DrawBorder = function () {
    var left = this.ChartBorder.GetRight() + this.Left;
    var right = this.ChartBorder.GetChartWidth() - this.Right;
    var top = this.Top;
    var bottom = this.ChartBorder.GetChartHeight() - this.Bottom;

    this.Canvas.strokeStyle = this.BorderColor;
    this.Canvas.strokeRect(left, top, (right - left), (bottom - top));
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
//坐标分割
//
//
////////////////////////////////////////////////////////////////////////////////////////////////////
function IFrameSplitOperator() {
  this.ChartBorder;                   //边框信息
  this.Frame;                         //框架信息
  this.FrameSplitData;                //坐标轴分割方法
  this.SplitCount = 5;                  //刻度个数
  this.StringFormat = 0;                //刻度字符串格式 -1 刻度文字全部不显示 -2 刻度文字右边不显示

  //////////////////////
  // data.Min data.Max data.Interval data.Count
  //
  this.IntegerCoordinateSplit = function (data) {
    var splitItem = this.FrameSplitData.Find(data.Interval);
    if (!splitItem) return false;

    if (data.Interval == splitItem.Interval) return true;

    //调整到整数倍数,不能整除的 +1
    var fixMax = parseInt((data.Max / (splitItem.FixInterval) + 0.5).toFixed(0)) * splitItem.FixInterval;
    var fixMin = parseInt((data.Min / (splitItem.FixInterval) - 0.5).toFixed(0)) * splitItem.FixInterval;
    if (data.Min == 0) fixMin = 0;  //最小值是0 不用调整了.

    var count = 0;
    for (var i = fixMin; (i - fixMax) < 0.00000001; i += splitItem.FixInterval) {
      ++count;
    }

    data.Interval = splitItem.FixInterval;
    data.Max = fixMax;
    data.Min = fixMin;
    data.Count = count;

    return true;
  }
}

//字符串格式化 千分位分割
IFrameSplitOperator.FormatValueThousandsString = function (value, floatPrecision) {
  if (value == null || isNaN(value)) {
    if (floatPrecision > 0) {
      var nullText = '-.';
      for (var i = 0; i < floatPrecision; ++i)
        nullText += '-';
      return nullText;
    }

    return '--';
  }

  var result = '';
  var num = value.toFixed(floatPrecision);
  while (num.length > 3) {
    result = ',' + num.slice(-3) + result;
    num = num.slice(0, num.length - 3);
  }
  if (num) { result = num + result; }
  return result;
}

//数据输出格式化 floatPrecision=小数位数
IFrameSplitOperator.FormatValueString = function (value, floatPrecision) {
  if (value == null || isNaN(value)) {
    if (floatPrecision > 0) {
      var nullText = '-.';
      for (var i = 0; i < floatPrecision; ++i)
        nullText += '-';
      return nullText;
    }

    return '--';
  }

  if (value < 0.00000000001 && value > -0.00000000001) {
    return "0";
  }

  var absValue = Math.abs(value);
  if (absValue < 10000) {
    return value.toFixed(floatPrecision);
  }
  else if (absValue < 100000000) {
    return (value / 10000).toFixed(floatPrecision) + "万";
  }
  else if (absValue < 1000000000000) {
    return (value / 100000000).toFixed(floatPrecision) + "亿";
  }
  else {
    return (value / 1000000000000).toFixed(floatPrecision) + "万亿";
  }

  return TRUE;
}

IFrameSplitOperator.FormatDateString = function (value) {
  var year = parseInt(value / 10000);
  var month = parseInt(value / 100) % 100;
  var day = value % 100;

  return year.toString() + '-' + month.toString() + '-' + day.toString();
}

IFrameSplitOperator.FormatTimeString = function (value) {
  var hour = parseInt(value / 100);
  var minute = value % 100;
  var strHour = hour >= 10 ? hour.toString() : '0' + hour.toString();
  var strMinute = minute >= 10 ? minute.toString() : '0' + minute.toString();

  return strHour + ':' + strMinute;
}

//报告格式化
IFrameSplitOperator.FormatReportDateString = function (value) {
  var year = parseInt(value / 10000);
  var month = parseInt(value / 100) % 100;
  var monthText;
  switch (month) {
    case 3:
      monthText = "一季度报";
      break;
    case 6:
      monthText = "半年报";
      break;
    case 9:
      monthText = "三季度报";
      break;
    case 12:
      monthText = "年报";
      break;
  }

  return year.toString() + monthText;
}

IFrameSplitOperator.FormatDateTimeString = function (value, isShowDate) {
  var aryValue = value.split(' ');
  if (aryValue.length < 2) return "";
  var time = parseInt(aryValue[1]);
  var minute = time % 100;
  var hour = parseInt(time / 100);
  var text = (hour < 10 ? ('0' + hour.toString()) : hour.toString()) + ':' + (minute < 10 ? ('0' + minute.toString()) : minute.toString());

  if (isShowDate == true) {
    var date = parseInt(aryValue[0]);
    var year = parseInt(date / 10000);
    var month = parseInt(date % 10000 / 100);
    var day = date % 100;
    text = year.toString() + '-' + (month < 10 ? ('0' + month.toString()) : month.toString()) + '-' + (day < 10 ? ('0' + day.toString()) : day.toString()) + " " + text;
  }

  return text;
}

function FrameSplitKLinePriceY() {
  this.newMethod = IFrameSplitOperator;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Operator = function () {
    var splitData = {};
    splitData.Max = this.Frame.HorizontalMax;
    splitData.Min = this.Frame.HorizontalMin;
    splitData.Count = this.SplitCount;
    splitData.Interval = (splitData.Max - splitData.Min) / (splitData.Count - 1);
    this.IntegerCoordinateSplit(splitData);

    this.Frame.HorizontalInfo = [];

    for (var i = 0, value = splitData.Min; i < splitData.Count; ++i, value += splitData.Interval) {
      this.Frame.HorizontalInfo[i] = new CoordinateInfo();
      this.Frame.HorizontalInfo[i].Value = value;
      //this.Frame.HorizontalInfo[i].TextColor = "rgb(51,51,51)";

      if (this.StringFormat == 1)   //手机端格式 如果有万,亿单位了 去掉小数
      {
        var floatPrecision = 2;
        if (!isNaN(value) && Math.abs(value) > 1000) floatPrecision = 0;
        this.Frame.HorizontalInfo[i].Message[1] = value.toFixed(floatPrecision);
      }
      else if (this.StringFormat == -1) {

      }
      else {
        this.Frame.HorizontalInfo[i].Message[1] = value.toFixed(2);
      }
      this.Frame.HorizontalInfo[i].Message[0] = this.Frame.HorizontalInfo[i].Message[1];
      //this.Frame.HorizontalInfo[i].Font="14px 微软雅黑";
      //this.Frame.HorizontalInfo[i].TextColor="rgb(100,0,200)";
      //this.Frame.HorizontalInfo[i].LineColor="rgb(220,220,220)";
    }

    this.Frame.HorizontalMax = splitData.Max;
    this.Frame.HorizontalMin = splitData.Min;
  }

}

function FrameSplitY() {
  this.newMethod = IFrameSplitOperator;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Operator = function () {
    var splitData = {};
    splitData.Max = this.Frame.HorizontalMax;
    splitData.Min = this.Frame.HorizontalMin;
    if (this.Frame.YSpecificMaxMin) {
      splitData.Count = this.Frame.YSpecificMaxMin.Count;
      splitData.Interval = (splitData.Max - splitData.Min) / (splitData.Count - 1);
    }
    else {
      splitData.Count = this.SplitCount;
      splitData.Interval = (splitData.Max - splitData.Min) / (splitData.Count - 1);
      this.IntegerCoordinateSplit(splitData);
    }

    this.Frame.HorizontalInfo = [];

    for (var i = 0, value = splitData.Min; i < splitData.Count; ++i, value += splitData.Interval) {
      this.Frame.HorizontalInfo[i] = new CoordinateInfo();
      this.Frame.HorizontalInfo[i].Value = value;
      //this.Frame.HorizontalInfo[i].TextColor="rgb(51,51,51)";

      if (this.StringFormat == 1)   //手机端格式 如果有万,亿单位了 去掉小数
      {
        var floatPrecision = 2;
        if (!isNaN(value) && Math.abs(value) > 1000) floatPrecision = 0;
        this.Frame.HorizontalInfo[i].Message[1] = IFrameSplitOperator.FormatValueString(value, floatPrecision);
      }
      else if (this.StringFormat == -1) //刻度不显示
      {

      }
      else {
        this.Frame.HorizontalInfo[i].Message[1] = IFrameSplitOperator.FormatValueString(value, 2);
      }

      this.Frame.HorizontalInfo[i].Message[0] = this.Frame.HorizontalInfo[i].Message[1];

      if (this.StringFormat == -2)     //刻度右边不显示
        this.Frame.HorizontalInfo[i].Message[1] = null;
      else if (this.StringFormat == -3)
        this.Frame.HorizontalInfo[i].Message[0] = null;

      //this.Frame.HorizontalInfo[i].Font="14px 微软雅黑";
      //this.Frame.HorizontalInfo[i].TextColor="rgb(100,0,200)";
      //this.Frame.HorizontalInfo[i].LineColor="rgb(220,220,220)";
    }

    this.Frame.HorizontalMax = splitData.Max;
    this.Frame.HorizontalMin = splitData.Min;
  }
}

function FrameSplitKLineX() {
  this.newMethod = IFrameSplitOperator;   //派生
  this.newMethod();
  delete this.newMethod;

  this.ShowText = true;                 //是否显示坐标信息
  this.MinDistance = 12;                //刻度间隔

  this.Operator = function () {
    if (this.Frame.Data == null) return;
    this.Frame.VerticalInfo = [];
    var xOffset = this.Frame.Data.DataOffset;
    var xPointCount = this.Frame.XPointCount;

    var lastYear = null, lastMonth = null;

    for (var i = 0, index = xOffset, distance = this.MinDistance; i < xPointCount && index < this.Frame.Data.Data.length; ++i, ++index) {
      var year = parseInt(this.Frame.Data.Data[index].Date / 10000);
      var month = parseInt(this.Frame.Data.Data[index].Date / 100) % 100;

      if ((distance < this.MinDistance && lastYear == year) ||
        (lastYear != null && lastYear == year && lastMonth != null && lastMonth == month)) {
        lastMonth = month;
        ++distance;
        continue;
      }

      var info = new CoordinateInfo();
      info.Value = index - xOffset;
      //info.TextColor = "rgb(51,51,51)";
      var text;
      if (lastYear == null || lastYear != year) {
        text = year.toString();
      }
      else if (lastMonth == null || lastMonth != month) {
        text = month.toString() + "月";
      }

      lastYear = year;
      lastMonth = month;

      if (this.ShowText) {
        info.Message[0] = text;
      }

      this.Frame.VerticalInfo.push(info);
      distance = 0;
    }
  }
}

function FrameSplitMinutePriceY() {
  this.newMethod = IFrameSplitOperator;   //派生
  this.newMethod();
  delete this.newMethod;

  this.YClose;                        //昨收
  this.Data;                          //分钟数据
  this.AverageData;                   //分钟均线数据
  this.SplitCount = 7;

  this.Operator = function () {
    this.Frame.HorizontalInfo = [];
    if (!this.Data) return;

    var max = this.YClose;
    var min = this.YClose;

    for (var i in this.Data.Data) {
      if (max < this.Data.Data[i]) max = this.Data.Data[i];
      if (min > this.Data.Data[i]) min = this.Data.Data[i];
    }

    if (this.AverageData) {
      for (var i in this.AverageData.Data) {
        if (max < this.AverageData.Data[i]) max = this.AverageData.Data[i];
        if (min > this.AverageData.Data[i]) min = this.AverageData.Data[i];
      }
    }

    if (this.YClose == max && this.YClose == min) {
      max = this.YClose + this.YClose * 0.1;
      min = this.YClose - this.YClose * 0.1
    }
    else {
      var distanceValue = Math.max(Math.abs(this.YClose - max), Math.abs(this.YClose - min));
      max = this.YClose + distanceValue;
      min = this.YClose - distanceValue;
    }

    var showCount = this.SplitCount;
    var distance = (max - min) / (showCount - 1);
    for (var i = 0; i < showCount; ++i) {
      var price = min + (distance * i);
      this.Frame.HorizontalInfo[i] = new CoordinateInfo();
      this.Frame.HorizontalInfo[i].Value = price;

      if (i > 0) {
        if (this.StringFormat == 1)   //手机端格式 如果有万,亿单位了 去掉小数
        {
          var floatPrecision = 2;
          if (!isNaN(price) && Math.abs(price) > 1000) floatPrecision = 0;
          this.Frame.HorizontalInfo[i].Message[0] = IFrameSplitOperator.FormatValueString(price, floatPrecision);
        }
        else {
          this.Frame.HorizontalInfo[i].Message[0] = IFrameSplitOperator.FormatValueString(price, 2);
        }
        var per = (price / this.YClose - 1) * 100;
        if (per > 0) this.Frame.HorizontalInfo[i].TextColor = g_JSChartResource.UpTextColor;
        else if (per < 0) this.Frame.HorizontalInfo[i].TextColor = g_JSChartResource.DownTextColor;
        this.Frame.HorizontalInfo[i].Message[1] = IFrameSplitOperator.FormatValueString(per, 2) + '%'; //百分比
      }
    }

    this.Frame.HorizontalMax = max;
    this.Frame.HorizontalMin = min;
  }

}

var SHZE_MINUTE_X_COORDINATE =
  [
    [0, 0, "rgb(200,200,200)", "09:30"],
    [31, 0, "RGB(200,200,200)", "10:00"],
    [61, 0, "RGB(200,200,200)", "10:30"],
    [91, 0, "RGB(200,200,200)", "11:00"],
    [122, 1, "RGB(200,200,200)", "13:00"],
    [152, 0, "RGB(200,200,200)", "13:30"],
    [182, 0, "RGB(200,200,200)", "14:00"],
    [212, 0, "RGB(200,200,200)", "14:30"],
    [242, 1, "RGB(200,200,200)", ""], // 15:00
  ];

function FrameSplitMinuteX() {
  this.newMethod = IFrameSplitOperator;   //派生
  this.newMethod();
  delete this.newMethod;

  this.ShowText = true;                 //是否显示坐标信息

  this.Operator = function () {
    this.Frame.VerticalInfo = [];
    var xPointCount = this.Frame.XPointCount;

    for (var i in SHZE_MINUTE_X_COORDINATE) {
      var info = new CoordinateInfo();
      //info.TextColor = "rgb(51,51,51)";
      info.Value = SHZE_MINUTE_X_COORDINATE[i][0];
      if (this.ShowText)
        info.Message[0] = SHZE_MINUTE_X_COORDINATE[i][3];
      this.Frame.VerticalInfo[i] = info;
    }
  }
}

function FrameSplitXData() {
  this.newMethod = IFrameSplitOperator;   //派生
  this.newMethod();
  delete this.newMethod;

  this.ShowText = true;                 //是否显示坐标信息

  this.Operator = function () {
    if (this.Frame.Data == null || this.Frame.XData == null) return;
    this.Frame.VerticalInfo = [];
    var xOffset = this.Frame.Data.DataOffset;
    var xPointCount = this.Frame.XPointCount;

    for (var i = 0, index = xOffset; i < xPointCount && index < this.Frame.Data.Data.length; ++i, ++index) {
      var info = new CoordinateInfo();
      info.Value = index - xOffset;

      if (this.ShowText)
        info.Message[0] = this.Frame.XData[i];

      this.Frame.VerticalInfo.push(info);
    }
  }
}


///////////////////////////////////////////////////////////////////////////////////////////////////
//十字光标
function ChartCorssCursor() {
  this.Frame;
  this.Canvas;                            //画布
  this.PenColor = g_JSChartResource.CorssCursorPenColor;        //十字线颜色
  this.Font = g_JSChartResource.CorssCursorTextFont;            //字体
  this.TextColor = g_JSChartResource.CorssCursorTextColor;      //文本颜色
  this.TextBGColor = g_JSChartResource.CorssCursorBGColor;      //文本背景色
  this.TextHeight = 20;                     //文本字体高度
  this.LastPoint;

  this.PointX;
  this.PointY;

  this.StringFormatX;
  this.StringFormatY;

  this.IsShowText = true;   //是否显示十字光标刻度
  this.IsShow = true;       //是否显示

  this.Draw = function () {
    if (!this.LastPoint) return;

    var x = this.LastPoint.X;
    var y = this.LastPoint.Y;

    var isInClient = false;
    var rtClient = new Rect(this.Frame.ChartBorder.GetLeft(), this.Frame.ChartBorder.GetTop(), this.Frame.ChartBorder.GetWidth(), this.Frame.ChartBorder.GetHeight());
    isInClient = rtClient.IsPointIn(x, y);
    this.PointY = null;
    this.PointY == null;

    if (!isInClient) return;

    var left = this.Frame.ChartBorder.GetLeft();
    var right = this.Frame.ChartBorder.GetRight();
    var top = this.Frame.ChartBorder.GetTopEx();
    var bottom = this.Frame.ChartBorder.GetBottom();

    this.PointY = [[left, y], [right, y]];
    this.PointX = [[x, top], [x, bottom]];

    //十字线
    this.Canvas.beginPath();
    this.Canvas.save();
    this.Canvas.strokeStyle = this.PenColor;
    this.Canvas.setLineDash([3, 2]);   //虚线
    //this.Canvas.lineWidth=0.5

    this.Canvas.moveTo(left, ToFixedPoint(y));
    this.Canvas.lineTo(right, ToFixedPoint(y));

    if (this.Frame.SubFrame.length > 0) {
      for (var i in this.Frame.SubFrame) {
        var frame = this.Frame.SubFrame[i].Frame;
        top = frame.ChartBorder.GetTopEx();
        bottom = frame.ChartBorder.GetBottom();
        this.Canvas.moveTo(ToFixedPoint(x), top);
        this.Canvas.lineTo(ToFixedPoint(x), bottom);
      }
    }
    else {
      this.Canvas.moveTo(ToFixedPoint(x), top);
      this.Canvas.lineTo(ToFixedPoint(x), bottom);
    }

    this.Canvas.stroke();
    this.Canvas.restore();
    this.Canvas.closePath();

    var xValue = this.Frame.GetXData(x);
    var yValue = this.Frame.GetYData(y);

    this.StringFormatX.Value = xValue;
    this.StringFormatY.Value = yValue;

    if (this.IsShowText && this.StringFormatY.Operator()) {
      var text = this.StringFormatY.Text;
      this.Canvas.font = this.Font;

      this.Canvas.fillStyle = this.TextBGColor;
      var textWidth = this.Canvas.measureText(text).width + 4;    //前后各空2个像素
      this.Canvas.fillRect(right + 2, y - this.TextHeight / 2, textWidth, this.TextHeight);

      this.Canvas.textAlign = "left";
      this.Canvas.textBaseline = "middle";
      this.Canvas.fillStyle = this.TextColor;
      this.Canvas.fillText(text, right + 4, y, textWidth);
    }

    if (this.IsShowText && this.StringFormatX.Operator()) {
      var text = this.StringFormatX.Text;
      this.Canvas.font = this.Font;

      this.Canvas.fillStyle = this.TextBGColor;
      var textWidth = this.Canvas.measureText(text).width + 4;    //前后各空2个像素
      if (x - textWidth / 2 < 3)    //左边位置不够了, 顶着左边画
      {
        this.Canvas.fillRect(x - 1, bottom + 2, textWidth, this.TextHeight);
        this.Canvas.textAlign = "left";
        this.Canvas.textBaseline = "top";
        this.Canvas.fillStyle = this.TextColor;
        this.Canvas.fillText(text, x + 1, bottom + 2, textWidth);
      }
      else if ((right - left) - x < textWidth) {            //右边位置不够用，顶着右边画
        this.Canvas.fillRect(x - textWidth, bottom + 2, textWidth, this.TextHeight);
        this.Canvas.textAlign = "right";
        this.Canvas.textBaseline = "top";
        this.Canvas.fillStyle = this.TextColor;
        this.Canvas.fillText(text, x - 1, bottom + 2, textWidth);
      }
      else {
        this.Canvas.fillRect(x - textWidth / 2, bottom + 2, textWidth, this.TextHeight);
        this.Canvas.textAlign = "center";
        this.Canvas.textBaseline = "top";
        this.Canvas.fillStyle = this.TextColor;
        this.Canvas.fillText(text, x, bottom + 2, textWidth);
      }
    }
  }
}


/////////////////////////////////////////////////////////////////////////////////
//
function IChangeStringFormat() {
  this.Data;
  this.Value;     //数据
  this.Text;      //输出字符串

  this.Operator = function () {
    return false;
  }
}


function HQPriceStringFormat() {
  this.newMethod = IChangeStringFormat;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Operator = function () {
    if (!this.Value) return false;

    this.Text = IFrameSplitOperator.FormatValueString(this.Value, 2);
    return true;
  }
}

function HQDateStringFormat() {
  this.newMethod = IChangeStringFormat;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Operator = function () {
    if (!this.Value) return false;
    if (!this.Data) return false;

    var index = Math.abs(this.Value - 0.5);
    index = parseInt(index.toFixed(0));
    if (this.Data.DataOffset + index >= this.Data.Data.length) return false;

    var date = this.Data.Data[this.Data.DataOffset + index].Date;
    this.Text = IFrameSplitOperator.FormatDateString(date);

    return true;
  }
}

function HQMinuteTimeStringFormat() {
  this.newMethod = IChangeStringFormat;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Operator = function () {
    if (!this.Value) return false;

    var index = Math.abs(this.Value);
    index = parseInt(index.toFixed(0));

    if (index == 0) {
      this.Text = "9:25";
    }
    else if (index < 122) {
      var time = 9 * 60 + 30 + index - 1;
      var minute = time % 60;
      if (minute < 10) this.Text = parseInt(time / 60) + ":" + '0' + minute;
      else this.Text = parseInt(time / 60) + ":" + minute;
    }
    else if (index < 243) {
      var time = 13 * 60 + index - (122);
      var minute = time % 60;
      if (minute < 10) this.Text = parseInt(time / 60) + ":" + '0' + minute;
      else this.Text = parseInt(time / 60) + ":" + minute;
    }
    else {
      this.Text = "15:00";
    }

    return true;
  }
}


//行情tooltip提示信息格式
var WEEK_NAME = ["日", "一", "二", "三", "四", "五", "六"];
function HistoryDataStringFormat() {
  this.newMethod = IChangeStringFormat;   //派生
  this.newMethod();
  delete this.newMethod;

  this.UpColor = g_JSChartResource.UpTextColor;
  this.DownColor = g_JSChartResource.DownTextColor;
  this.UnchagneColor = g_JSChartResource.UnchagneTextColor;

  this.VolColor = g_JSChartResource.DefaultTextColor;
  this.AmountColor = g_JSChartResource.DefaultTextColor;

  this.Operator = function () {
    var data = this.Value.Data;
    if (!data) return false;

    var date = new Date(parseInt(data.Date / 10000), (data.Date / 100 % 100 - 1), data.Date % 100);
    var week = WEEK_NAME[date.getDay()];
    var strText =
      "<span class='tooltip-title'>" + data.Date + "&nbsp&nbsp" + week + "</span>" +
      "<span class='tooltip-con'>开盘:</span>" +
      "<span class='tooltip-num' style='color:" + this.GetColor(data.Open, data.YClose) + ";'>" + data.Open.toFixed(2) + "</span><br/>" +
      "<span class='tooltip-con'>最高:</span>" +
      "<span class='tooltip-num' style='color:" + this.GetColor(data.High, data.YClose) + ";'>" + data.High.toFixed(2) + "</span><br/>" +
      "<span class='tooltip-con'>最低:</span>" +
      "<span class='tooltip-num' style='color:" + this.GetColor(data.Low, data.YClose) + ";'>" + data.Low.toFixed(2) + "</span><br/>" +
      "<span class='tooltip-con'>收盘:</span>" +
      "<span class='tooltip-num' style='color:" + this.GetColor(data.Close, data.YClose) + ";'>" + data.Close.toFixed(2) + "</span><br/>" +
      //"<span style='color:"+this.YClose+";font:微软雅黑;font-size:12px'>&nbsp;前收: "+IFrameSplitOperator.FormatValueString(data.YClose,2)+"</span><br/>"+
      "<span class='tooltip-con'>数量:</span>" +
      "<span class='tooltip-num' style='color:" + this.VolColor + ";'>" + IFrameSplitOperator.FormatValueString(data.Vol, 2) + "</span><br/>" +
      "<span class='tooltip-con'>金额:</span>" +
      "<span class='tooltip-num' style='color:" + this.AmountColor + ";'>" + IFrameSplitOperator.FormatValueString(data.Amount, 2) + "</span><br/>";

    //叠加股票
    if (this.Value.ChartPaint.Name == "Overlay-KLine") {
      var title = "<span style='color:rgb(0,0,0);font:微软雅黑;font-size:12px;text-align:center;display: block;'>" + this.Value.ChartPaint.Title + "</span>";
      strText = title + strText;
    }

    this.Text = strText;
    return true;
  }

  this.GetColor = function (price, yclse) {
    if (price > yclse) return this.UpColor;
    else if (price < yclse) return this.DownColor;
    else return this.UnchagneColor;
  }
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                      标题
//
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function IChartTitlePainting() {
  this.Frame;
  this.Data = new Array();
  this.Canvas;                        //画布
  this.IsDynamic = false;               //是否是动态标题
  this.Position = 0;                    //标题显示位置 0 框架里的标题  1 框架上面
  this.CursorIndex;                   //数据索引
  this.Font = g_JSChartResource.DynamicTitleFont;//"12px 微软雅黑";
  this.Title;                         //固定标题(可以为空)
  this.TitleColor = g_JSChartResource.DefaultTextColor;
}

var PERIOD_NAME = ["日线", "周线", "月线", "年线", "1分", "5分", "15分", "30分", "60分", "", ""];
var RIGHT_NAME = ['不复权', '前复权', '后复权'];

function DynamicKLineTitlePainting() {
  this.newMethod = IChartTitlePainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.IsDynamic = true;
  this.IsShow = true;       //是否显示

  this.UpColor = g_JSChartResource.UpTextColor;
  this.DownColor = g_JSChartResource.DownTextColor;
  this.UnchagneColor = g_JSChartResource.UnchagneTextColor;

  this.VolColor = g_JSChartResource.DefaultTextColor;
  this.AmountColor = g_JSChartResource.DefaultTextColor;

  this.Symbol;
  this.Name;

  this.IsShowName = true;           //是否显示股票名称
  this.IsShowSettingInfo = true;    //是否显示设置信息(周期 复权)

  this.DrawTitle = function () {
    if (!this.IsShowName && !this.IsShowSettingInfo) return;

    var left = this.Frame.ChartBorder.GetLeft();
    var bottom = this.Frame.ChartBorder.GetTop();
    var right = this.Frame.ChartBorder.GetRight();
    if (bottom < 5) return;

    this.Canvas.textAlign = "left";
    this.Canvas.textBaseline = "bottom";
    this.Canvas.font = this.Font;

    if (this.IsShowName && this.Name) {
      this.Canvas.fillStyle = this.UnchagneColor;
      var textWidth = this.Canvas.measureText(this.Name).width + 2;    //后空2个像素
      if (left + textWidth > right) return;
      this.Canvas.fillText(this.Name, left, bottom, textWidth);
      left += textWidth;
    }

    if (this.IsShowSettingInfo && this.Data.Period != null && this.Data.Right != null) {
      this.Canvas.fillStyle = this.UnchagneColor;
      var periodName = PERIOD_NAME[this.Data.Period];
      var rightName = RIGHT_NAME[this.Data.Right];
      var text = "(" + periodName + " " + rightName + ")";
      if (this.Data.Period >= 4) text = "(" + periodName + ")";
      var textWidth = this.Canvas.measureText(text).width + 2;
      if (left + textWidth > right) return;
      this.Canvas.fillText(text, left, bottom, textWidth);
      left += textWidth;
    }
  }

  this.Draw = function () {
    if (!this.IsShow) return;
    if (this.CursorIndex == null || !this.Data) return;
    if (this.Data.length <= 0) return;

    var index = Math.abs(this.CursorIndex - 0.5);
    index = parseInt(index.toFixed(0));
    var dataIndex = this.Data.DataOffset + index;
    if (dataIndex >= this.Data.Data.length) dataIndex = this.Data.Data.length - 1;
    if (dataIndex < 0) return;

    var item = this.Data.Data[dataIndex];

    var left = this.Frame.ChartBorder.GetLeft();
    //var bottom=this.Frame.ChartBorder.GetTop()-this.Frame.ChartBorder.Top/2;
    var bottom = this.Frame.ChartBorder.GetTop();
    var right = this.Frame.ChartBorder.GetRight();
    if (bottom < 5) return;

    this.Canvas.textAlign = "left";
    this.Canvas.textBaseline = "bottom";
    this.Canvas.font = this.Font;

    if (this.IsShowName) {
      this.Canvas.fillStyle = this.UnchagneColor;
      var textWidth = this.Canvas.measureText(this.Name).width + 2;    //后空2个像素
      if (left + textWidth > right) return;
      //this.Canvas.fillText(this.Name,left,bottom,textWidth);
      left += textWidth;
    }

    if (this.IsShowSettingInfo) {
      this.Canvas.fillStyle = this.UnchagneColor;
      var periodName = PERIOD_NAME[this.Data.Period];
      var rightName = RIGHT_NAME[this.Data.Right];
      var text = "(" + periodName + " " + rightName + ")";
      if (item.Time != null) text = "(" + periodName + ")";
      var textWidth = this.Canvas.measureText(text).width + 2;
      if (left + textWidth > right) return;
      //this.Canvas.fillText(text,left,bottom,textWidth);
      left += textWidth;
    }

    this.Canvas.fillStyle = this.UnchagneColor;
    var text = IFrameSplitOperator.FormatDateString(item.Date);
    var textWidth = this.Canvas.measureText(text).width + 2;    //后空2个像素
    if (left + textWidth > right) return;
    this.Canvas.fillText(text, left, bottom, textWidth);
    left += textWidth;

    if (item.Time != null && !isNaN(item.Time) && item.Time > 0) {
      var text = IFrameSplitOperator.FormatTimeString(item.Time);
      var textWidth = this.Canvas.measureText(text).width + 2;    //后空2个像素
      if (left + textWidth > right) return;
      this.Canvas.fillText(text, left, bottom, textWidth);
      left += textWidth;
    }

    this.Canvas.fillStyle = this.GetColor(item.Open, item.YClose);
    var text = "开:" + item.Open.toFixed(2);
    var textWidth = this.Canvas.measureText(text).width + 2;    //后空2个像素
    if (left + textWidth > right) return;
    this.Canvas.fillText(text, left, bottom, textWidth);
    left += textWidth;

    this.Canvas.fillStyle = this.GetColor(item.High, item.YClose);
    var text = "高:" + item.High.toFixed(2);
    var textWidth = this.Canvas.measureText(text).width + 2;    //后空2个像素
    if (left + textWidth > right) return;
    this.Canvas.fillText(text, left, bottom, textWidth);
    left += textWidth;

    this.Canvas.fillStyle = this.GetColor(item.Low, item.YClose);
    var text = "低:" + item.Low.toFixed(2);
    var textWidth = this.Canvas.measureText(text).width + 2;    //后空2个像素
    if (left + textWidth > right) return;
    this.Canvas.fillText(text, left, bottom, textWidth);
    left += textWidth;

    this.Canvas.fillStyle = this.GetColor(item.Close, item.YClose);
    var text = "收:" + item.Close.toFixed(2);
    var textWidth = this.Canvas.measureText(text).width + 2;    //后空2个像素
    if (left + textWidth > right) return;
    this.Canvas.fillText(text, left, bottom, textWidth);
    left += textWidth;

    this.Canvas.fillStyle = this.VolColor;
    var text = "量:" + IFrameSplitOperator.FormatValueString(item.Vol, 2);
    var textWidth = this.Canvas.measureText(text).width + 2;    //后空2个像素
    if (left + textWidth > right) return;
    this.Canvas.fillText(text, left, bottom, textWidth);
    left += textWidth;

    this.Canvas.fillStyle = this.AmountColor;
    var text = "额:" + IFrameSplitOperator.FormatValueString(item.Amount, 2);
    var textWidth = this.Canvas.measureText(text).width + 2;    //后空2个像素
    if (left + textWidth > right) return;
    this.Canvas.fillText(text, left, bottom, textWidth);
    left += textWidth;
  }

  this.GetColor = function (price, yclse) {
    if (price > yclse) return this.UpColor;
    else if (price < yclse) return this.DownColor;
    else return this.UnchagneColor;
  }

}

function DynamicMinuteTitlePainting() {
  this.newMethod = DynamicKLineTitlePainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.YClose;
  this.IsShowDate = false;  //标题是否显示日期
  this.IsShowName = true;   //标题是否显示股票名字

  this.DrawTitle = function () {

  }

  this.Draw = function () {
    if (!this.IsShow) return;
    if (this.CursorIndex == null || !this.Data || !this.Data.Data) return;
    if (this.Data.Data.length <= 0) return;

    //var index=Math.abs(this.CursorIndex-0.5);
    var index = this.CursorIndex;
    index = parseInt(index.toFixed(0));
    var dataIndex = index + this.Data.DataOffset;
    if (dataIndex >= this.Data.Data.length) dataIndex = this.Data.Data.length - 1;

    var item = this.Data.Data[dataIndex];

    var left = this.Frame.ChartBorder.GetLeft();
    var bottom = this.Frame.ChartBorder.GetTop() - this.Frame.ChartBorder.Top / 2;
    //var bottom = this.Frame.ChartBorder.GetTop() - this.Frame.ChartBorder.Top - 15;
    var right = this.Frame.ChartBorder.GetRight();
    if (bottom < 5) return;

    this.Canvas.textAlign = "left";
    this.Canvas.textBaseline = "middle";
    this.Canvas.font = this.Font;

    if (this.IsShowName) {
      this.Canvas.fillStyle = this.UnchagneColor;
      var textWidth = this.Canvas.measureText(this.Name).width + 2;    //后空2个像素
      if (left + textWidth > right) return;
      this.Canvas.fillText(this.Name, left, bottom, textWidth);
      left += textWidth;
    }

    this.Canvas.fillStyle = this.UnchagneColor;
    var text = IFrameSplitOperator.FormatDateTimeString(item.DateTime, this.IsShowDate);
    var textWidth = this.Canvas.measureText(text).width + 2;    //后空2个像素
    if (left + textWidth > right) return;
    this.Canvas.fillText(text, left, bottom, textWidth);
    left += textWidth;

    this.Canvas.fillStyle = this.GetColor(item.Close, this.YClose);
    var text = "价格:" + item.Close.toFixed(2);
    var textWidth = this.Canvas.measureText(text).width + 2;    //后空2个像素
    if (left + textWidth > right) return;
    this.Canvas.fillText(text, left, bottom, textWidth);
    left += textWidth;

    this.Canvas.fillStyle = this.GetColor(item.AvPrice, this.YClose);
    var text = "均价:" + item.AvPrice.toFixed(2);
    var textWidth = this.Canvas.measureText(text).width + 2;    //后空2个像素
    if (left + textWidth > right) return;
    this.Canvas.fillText(text, left, bottom, textWidth);
    left += textWidth;

    this.Canvas.fillStyle = this.VolColor;
    var text = "量:" + IFrameSplitOperator.FormatValueString(item.Vol, 2);
    var textWidth = this.Canvas.measureText(text).width + 2;    //后空2个像素
    if (left + textWidth > right) return;
    this.Canvas.fillText(text, left, bottom, textWidth);
    left += textWidth;

    this.Canvas.fillStyle = this.AmountColor;
    var text = "额:" + IFrameSplitOperator.FormatValueString(item.Amount, 2);
    var textWidth = this.Canvas.measureText(text).width + 2;    //后空2个像素
    if (left + textWidth > right) return;
    this.Canvas.fillText(text, left, bottom, textWidth);
    left += textWidth;
  }
}

//字符串输出格式
var STRING_FORMAT_TYPE =
  {
    DEFAULT: 1,     //默认 2位小数 单位自动转化 (万 亿)
    THOUSANDS: 21,   //千分位分割
  };

function DynamicTitleData(data, name, color) {
  this.Data = data;
  this.Name = name;
  this.Color = color;   //字体颜色
  this.DataType;      //数据类型
  this.StringFormat = STRING_FORMAT_TYPE.DEFAULT;   //字符串格式
  this.FloatPrecision = 2;                          //小数位数
  this.GetTextCallback;                           //自定义数据转文本回调
}

function DynamicChartTitlePainting() {
  this.newMethod = IChartTitlePainting;   //派生
  this.newMethod();
  delete this.newMethod;

  this.IsDynamic = true;
  this.Data = new Array();
  this.Explain;
  this.TitleBG;             //标题背景色
  this.TitleBGHeight = 20;  //标题背景色高度
  this.TitleAlign = 'middle';//对其方式
  this.TitleBottomDistance = 1; //标题靠底部输出的时候 字体和底部的间距

  this.Text = new Array();  //副标题 Text:'文本', Color:'颜色'

  this.FormatValue = function (value, item) {
    if (item.StringFormat == STRING_FORMAT_TYPE.DEFAULT)
      return IFrameSplitOperator.FormatValueString(value, item.FloatPrecision);
    else if (item.StringFormat = STRING_FORMAT_TYPE.THOUSANDS)
      return IFrameSplitOperator.FormatValueThousandsString(value, item.FloatPrecision);
  }

  this.FormatMultiReport = function (data, format) {
    var text = "";
    for (var i in data) {
      var item = data[i];
      let quarter = item.Quarter;
      let year = item.Year;
      let value = item.Value;

      if (text.length > 0) text += ',';

      text += year.toString();
      switch (quarter) {
        case 1:
          text += '一季报 ';
          break;
        case 2:
          text += '半年报 ';
          break;
        case 3:
          text += '三季报 ';
          break;
        case 4:
          text += '年报 ';
          break;
      }

      text += this.FormatValue(value, format);
    }

    return text;
  }

  this.DrawTitle = function () {
    if (this.Frame.ChartBorder.TitleHeight < 5) return;

    let left = this.Frame.ChartBorder.GetLeft() + 1;
    let bottom = this.Frame.ChartBorder.GetTop() + this.Frame.ChartBorder.TitleHeight / 2;    //上下居中显示
    if (this.TitleAlign == 'bottom') bottom = this.Frame.ChartBorder.GetTopEx() - this.TitleBottomDistance;
    let right = this.Frame.ChartBorder.GetRight();

    this.Canvas.textAlign = "left";
    this.Canvas.textBaseline = this.TitleAlign;
    this.Canvas.font = this.Font;

    let textWidth = 10;
    if (this.TitleBG && this.Title) {
      textWidth = this.Canvas.measureText(this.Title).width + 2;
      let height = this.Frame.ChartBorder.TitleHeight;
      let top = this.Frame.ChartBorder.GetTop();
      if (height > 20) {
        top += (height - 20) / 2 + (height - 45) / 2;
        height = 20;
      }

      if (this.TitleAlign == 'bottom')  //底部输出文字
      {
        top = this.Frame.ChartBorder.GetTopEx() - 20;
        if (top < 0) top = 0;
      }

      this.Canvas.fillStyle = this.TitleBG;
      this.Canvas.fillRect(left, top, textWidth, height);
    }

    if (this.Title) {
      this.Canvas.fillStyle = this.TitleColor;
      const metrics = this.Canvas.measureText(this.Title);
      textWidth = metrics.width + 2;
      this.Canvas.fillText(this.Title, left, bottom, textWidth);
      left += textWidth;
    }

    if (this.Text && this.Text.length > 0) {
      for (let i in this.Text) {
        let item = this.Text[i];
        this.Canvas.fillStyle = item.Color;
        textWidth = this.Canvas.measureText(item.Text).width + 2;
        this.Canvas.fillText(item.Text, left, bottom, textWidth);
        left += textWidth;
      }
    }

  }

  this.Draw = function () {
    if (this.CursorIndex == null) return;
    if (!this.Data) return;
    if (this.Frame.ChartBorder.TitleHeight < 5) return;

    var left = this.Frame.ChartBorder.GetLeft() + 1;
    var bottom = this.Frame.ChartBorder.GetTop() + this.Frame.ChartBorder.TitleHeight / 2;    //上下居中显示
    if (this.TitleAlign == 'bottom') bottom = this.Frame.ChartBorder.GetTopEx() - this.TitleBottomDistance;
    var right = this.Frame.ChartBorder.GetRight();

    this.Canvas.textAlign = "left";
    this.Canvas.textBaseline = this.TitleAlign;
    this.Canvas.font = this.Font;

    if (this.Title) {
      this.Canvas.fillStyle = this.TitleColor;
      let textWidth = this.Canvas.measureText(this.Title).width + 2;
      //this.Canvas.fillText(this.Title,left,bottom,textWidth);
      left += textWidth;
    }

    if (this.Text && this.Text.length > 0) {
      for (let i in this.Text) {
        let item = this.Text[i];
        this.Canvas.fillStyle = item.Color;
        let textWidth = this.Canvas.measureText(item.Text).width + 2;
        //this.Canvas.fillText(item.Text, left, bottom, textWidth);
        left += textWidth;
      }
    }

    for (var i in this.Data) {
      var item = this.Data[i];
      if (!item || !item.Data || !item.Data.Data) continue;

      if (item.Data.Data.length <= 0) continue;

      var value = null;
      var valueText = null;
      if (item.DataType == "StraightLine")  //直线只有1个数据
      {
        value = item.Data.Data[0];
        valueText = this.FormatValue(value, item);
      }
      else {
        var index = Math.abs(this.CursorIndex - 0.5);
        index = parseInt(index.toFixed(0));
        if (item.Data.DataOffset + index >= item.Data.Data.length) continue;

        value = item.Data.Data[item.Data.DataOffset + index];
        if (value == null) continue;

        if (item.DataType == "HistoryData-Vol") {
          value = value.Vol;
          valueText = this.FormatValue(value, item);
        }
        else if (item.DataType == "MultiReport") {
          valueText = this.FormatMultiReport(value, item);
        }
        else {
          if (item.GetTextCallback) valueText = item.GetTextCallback(value, item);
          else valueText = this.FormatValue(value, item);
        }
      }

      this.Canvas.fillStyle = item.Color;

      var text = item.Name + ":" + valueText;
      var textWidth = this.Canvas.measureText(text).width + 2;    //后空2个像素
      this.Canvas.fillText(text, left, bottom, textWidth);
      left += textWidth;
    }

    if (this.Explain)   //说明信息
    {
      this.Canvas.fillStyle = this.TitleColor;
      var text = "说明:" + this.Explain;
      var textWidth = this.Canvas.measureText(text).width + 2;
      if (left + textWidth < right) {
        this.Canvas.fillText(text, left, bottom, textWidth);
        left += textWidth;
      }
    }
  }
}


/*
    画图工具
*/
function IChartDrawPicture() {
  this.Frame;
  this.Canvas;
  this.Point = new Array()                      //画图的点
  this.Value = new Array();                     //XValue,YValue
  this.PointCount = 2;                          //画点的个数
  this.Status = 0;                              //0 开始画 1 完成第1个点  2 完成第2个点    10 完成 20 移动
  this.MovePointIndex = null;                        //移动哪个点 0-10 对应Point索引  100 整体移动

  this.LineColor = g_JSChartResource.DrawPicture.LineColor[0];                            //线段颜色
  this.PointColor = g_JSChartResource.DrawPicture.PointColor[0];

  this.Draw = function () {

  }

  //Point => Value
  this.PointToValue = function () {
    if (!this.Frame) return false;
    var data = this.Frame.Data;
    if (!data) return false;

    for (var i in this.Point) {
      var item = this.Point[i];
      var xValue = parseInt(this.Frame.GetXData(item.X)) + data.DataOffset;
      var yValue = this.Frame.GetYData(item.Y);

      this.Value[i] = {};
      this.Value[i].XValue = xValue;
      this.Value[i].YValue = yValue;
    }

    return true;
  }

  this.IsPointIn = function (x, y) {
    return false;
  }

  //Value => Point
  this.ValueToPoint = function () {
    if (!this.Frame) return false;
    var data = this.Frame.Data;
    if (!data) return false;

    this.Point = [];
    for (var i in this.Value) {
      var item = this.Value[i];
      var pt = new Point();
      pt.X = this.Frame.GetXFromIndex(item.XValue - data.DataOffset);
      pt.Y = this.Frame.GetYFromData(item.YValue);
      this.Point[i] = pt;
    }
  }

  //xStep,yStep 移动的偏移量
  this.Move = function (xStep, yStep) {
    if (this.Status != 20) return fasle;
    if (!this.Frame) return false;
    var data = this.Frame.Data;
    if (!data) return false;

    if (this.MovePointIndex == 100)    //整体移动
    {
      for (var i in this.Point) {
        this.Point[i].X += xStep;
        this.Point[i].Y += yStep;
      }
    }
    else if (this.MovePointIndex == 0 || this.MovePointIndex == 1) {
      this.Point[this.MovePointIndex].X += xStep;
      this.Point[this.MovePointIndex].Y += yStep;
    }
  }

  this.ClipFrame = function () {
    var left = this.Frame.ChartBorder.GetLeft();
    var top = this.Frame.ChartBorder.GetTopEx();
    var width = this.Frame.ChartBorder.GetWidth();
    var height = this.Frame.ChartBorder.GetHeightEx();

    this.Canvas.save();
    this.Canvas.beginPath();
    this.Canvas.rect(left, top, width, height);
    this.Canvas.clip();
  }

  //计算需要画的点的坐标
  this.CalculateDrawPoint = function () {
    if (this.Status < 2) return null;
    if (!this.Point.length || !this.Frame) return null;

    var drawPoint = new Array();
    if (this.Status == 10) {
      var data = this.Frame.Data;
      if (!data) return null;

      for (var i in this.Value) {
        var item = this.Value[i];
        var pt = new Point();
        pt.X = this.Frame.GetXFromIndex(item.XValue - data.DataOffset);
        pt.Y = this.Frame.GetYFromData(item.YValue);
        drawPoint.push(pt);
      }
    }
    else {
      drawPoint = this.Point;
    }

    return drawPoint;
  }

  this.DrawPoint = function (aryPoint) {
    if (!aryPoint || aryPoint.length <= 0) return;

    //画点
    this.ClipFrame();
    for (var i in aryPoint) {
      var item = aryPoint[i];

      this.Canvas.beginPath();
      this.Canvas.arc(item.X, item.Y, 5, 0, 360, false);
      this.Canvas.fillStyle = this.PointColor;      //填充颜色
      this.Canvas.fill();                         //画实心圆
      this.Canvas.closePath();
    }

    this.Canvas.restore();
  }
}

/*
    画图工具-线段
*/

function ChartDrawPictureLine() {
  this.newMethod = IChartDrawPicture;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Draw = function () {
    var drawPoint = this.CalculateDrawPoint();
    if (!drawPoint) return;

    this.ClipFrame();

    for (var i in drawPoint) {
      var item = drawPoint[i];
      if (i == 0) {
        this.Canvas.beginPath();
        this.Canvas.moveTo(item.X, item.Y);
      }
      else {
        this.Canvas.lineTo(item.X, item.Y);
      }

    }

    this.Canvas.strokeStyle = this.LineColor;
    this.Canvas.stroke();
    this.Canvas.closePath();
    this.Canvas.restore();

    //画点
    this.DrawPoint(drawPoint);
  }


  //0-10 鼠标对应的点索引   100=鼠标在正个图形上  -1 鼠标不在图形上
  this.IsPointIn = function (x, y) {
    if (!this.Frame || this.Status != 10) return -1;

    var data = this.Frame.Data;
    if (!data) return -1;

    //是否在点上
    var aryPoint = new Array();
    for (var i in this.Value) {
      var item = this.Value[i];
      var pt = new Point();
      pt.X = this.Frame.GetXFromIndex(item.XValue - data.DataOffset);
      pt.Y = this.Frame.GetYFromData(item.YValue);

      this.Canvas.beginPath();
      this.Canvas.arc(pt.X, pt.Y, 5, 0, 360);
      //console.log('['+i+']'+'x='+x+' y='+y+' dataX='+pt.X+" dataY="+pt.Y);
      if (this.Canvas.isPointInPath(x, y))
        return i;

      aryPoint.push(pt);
    }

    //是否在线段上
    this.Canvas.beginPath();
    this.Canvas.moveTo(aryPoint[0].X, aryPoint[0].Y + 5);
    this.Canvas.lineTo(aryPoint[0].X, aryPoint[0].Y - 5);
    this.Canvas.lineTo(aryPoint[1].X, aryPoint[1].Y - 5);
    this.Canvas.lineTo(aryPoint[1].X, aryPoint[1].Y + 5);
    this.Canvas.closePath();
    if (this.Canvas.isPointInPath(x, y))
      return 100;

    return -1;
  }
}

/*
    画图工具-射线
*/
function ChartDrawPictureHaflLine() {
  this.newMethod = IChartDrawPicture;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Draw = function () {
    var drawPoint = this.CalculateDrawPoint();
    if (!drawPoint || drawPoint.length != 2) return;

    this.ClipFrame();

    this.Canvas.beginPath();
    this.Canvas.moveTo(drawPoint[0].X, drawPoint[0].Y);
    this.Canvas.lineTo(drawPoint[1].X, drawPoint[1].Y);

    var endPoint = this.CalculateEndPoint(drawPoint);
    this.Canvas.lineTo(endPoint.X, endPoint.Y);

    this.Canvas.strokeStyle = this.LineColor;
    this.Canvas.stroke();
    this.Canvas.closePath();
    this.Canvas.restore();

    //画点
    this.DrawPoint(drawPoint);
  }

  this.CalculateEndPoint = function (aryPoint) {
    var left = this.Frame.ChartBorder.GetLeft();
    var right = this.Frame.ChartBorder.GetRight();

    var a = aryPoint[1].X - aryPoint[0].X;
    var b = aryPoint[1].Y - aryPoint[0].Y;

    if (a > 0) {
      var a1 = right - aryPoint[0].X;
      var b1 = a1 * b / a;
      var y = b1 + aryPoint[0].Y;

      var pt = new Point();
      pt.X = right;
      pt.Y = y;
      return pt;
    }
    else {
      var a1 = aryPoint[0].X - left;
      var b1 = a1 * b / Math.abs(a);
      var y = b1 + aryPoint[0].Y;

      var pt = new Point();
      pt.X = left;
      pt.Y = y;
      return pt;
    }
  }


  //0-10 鼠标对应的点索引   100=鼠标在正个图形上  -1 鼠标不在图形上
  this.IsPointIn = function (x, y) {
    if (!this.Frame || this.Status != 10) return -1;

    var data = this.Frame.Data;
    if (!data) return -1;

    //是否在点上
    var aryPoint = new Array();
    for (var i in this.Value) {
      var item = this.Value[i];
      var pt = new Point();
      pt.X = this.Frame.GetXFromIndex(item.XValue - data.DataOffset);
      pt.Y = this.Frame.GetYFromData(item.YValue);

      this.Canvas.beginPath();
      this.Canvas.arc(pt.X, pt.Y, 5, 0, 360);
      //console.log('['+i+']'+'x='+x+' y='+y+' dataX='+pt.X+" dataY="+pt.Y);
      if (this.Canvas.isPointInPath(x, y))
        return i;

      aryPoint.push(pt);
    }

    //是否在线段上
    this.Canvas.beginPath();
    this.Canvas.moveTo(aryPoint[0].X, aryPoint[0].Y + 5);
    this.Canvas.lineTo(aryPoint[0].X, aryPoint[0].Y - 5);
    this.Canvas.lineTo(aryPoint[1].X, aryPoint[1].Y - 5);
    this.Canvas.lineTo(aryPoint[1].X, aryPoint[1].Y + 5);
    this.Canvas.closePath();
    if (this.Canvas.isPointInPath(x, y))
      return 100;

    return -1;
  }
}

/*
    画图工具-矩形
*/
function ChartDrawPictureRect() {
  this.newMethod = IChartDrawPicture;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Draw = function () {
    var drawPoint = this.CalculateDrawPoint();
    if (!drawPoint || drawPoint.length != 2) return;

    this.ClipFrame();

    this.Canvas.beginPath();
    this.Canvas.rect(drawPoint[0].X, drawPoint[0].Y, drawPoint[1].X - drawPoint[0].X, drawPoint[1].Y - drawPoint[0].Y);

    this.Canvas.strokeStyle = this.LineColor;
    this.Canvas.stroke();
    this.Canvas.closePath();
    this.Canvas.restore();

    //画点
    this.DrawPoint(drawPoint);
  }

  //0-10 鼠标对应的点索引   100=鼠标在正个图形上  -1 鼠标不在图形上
  this.IsPointIn = function (x, y) {
    if (!this.Frame || this.Status != 10) return -1;

    var data = this.Frame.Data;
    if (!data) return -1;

    //是否在点上
    var aryPoint = new Array();
    for (var i in this.Value) {
      var item = this.Value[i];
      var pt = new Point();
      pt.X = this.Frame.GetXFromIndex(item.XValue - data.DataOffset);
      pt.Y = this.Frame.GetYFromData(item.YValue);

      this.Canvas.beginPath();
      this.Canvas.arc(pt.X, pt.Y, 5, 0, 360);
      //console.log('['+i+']'+'x='+x+' y='+y+' dataX='+pt.X+" dataY="+pt.Y);
      if (this.Canvas.isPointInPath(x, y))
        return i;

      aryPoint.push(pt);
    }

    //是否在矩形边框上
    var linePoint = [{ X: aryPoint[0].X, Y: aryPoint[0].Y }, { X: aryPoint[1].X, Y: aryPoint[0].Y }];
    if (this.IsPointInLine(linePoint, x, y))
      return 100;

    linePoint = [{ X: aryPoint[1].X, Y: aryPoint[0].Y }, { X: aryPoint[1].X, Y: aryPoint[1].Y }];
    if (this.IsPointInLine2(linePoint, x, y))
      return 100;

    linePoint = [{ X: aryPoint[1].X, Y: aryPoint[1].Y }, { X: aryPoint[0].X, Y: aryPoint[1].Y }];
    if (this.IsPointInLine(linePoint, x, y))
      return 100;

    linePoint = [{ X: aryPoint[0].X, Y: aryPoint[1].Y }, { X: aryPoint[0].X, Y: aryPoint[0].Y }];
    if (this.IsPointInLine2(linePoint, x, y))
      return 100;

    return -1;
  }

  //点是否在线段上 水平线段
  this.IsPointInLine = function (aryPoint, x, y) {
    this.Canvas.beginPath();
    this.Canvas.moveTo(aryPoint[0].X, aryPoint[0].Y + 5);
    this.Canvas.lineTo(aryPoint[0].X, aryPoint[0].Y - 5);
    this.Canvas.lineTo(aryPoint[1].X, aryPoint[1].Y - 5);
    this.Canvas.lineTo(aryPoint[1].X, aryPoint[1].Y + 5);
    this.Canvas.closePath();
    if (this.Canvas.isPointInPath(x, y))
      return true;
  }

  //垂直线段
  this.IsPointInLine2 = function (aryPoint, x, y) {
    this.Canvas.beginPath();
    this.Canvas.moveTo(aryPoint[0].X - 5, aryPoint[0].Y);
    this.Canvas.lineTo(aryPoint[0].X + 5, aryPoint[0].Y);
    this.Canvas.lineTo(aryPoint[1].X + 5, aryPoint[1].Y);
    this.Canvas.lineTo(aryPoint[1].X - 5, aryPoint[1].Y);
    this.Canvas.closePath();
    if (this.Canvas.isPointInPath(x, y))
      return true;
  }
}

/*
    画图工具-弧形
*/
function ChartDrawPictureArc() {
  this.newMethod = IChartDrawPicture;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Draw = function () {
    var drawPoint = this.CalculateDrawPoint();
    if (!drawPoint || drawPoint.length != 2) return;

    this.ClipFrame();

    //this.Canvas.beginPath();
    //this.Canvas.rect(drawPoint[0].X,drawPoint[0].Y,drawPoint[1].X-drawPoint[0].X,drawPoint[1].Y-drawPoint[0].Y);
    if (drawPoint[0].X < drawPoint[1].X && drawPoint[0].Y > drawPoint[1].Y) // 第一象限
    {
      var a = drawPoint[1].X - drawPoint[0].X;
      var b = drawPoint[0].Y - drawPoint[1].Y;
      var step = (a > b) ? 1 / a : 1 / b;
      var xcenter = drawPoint[0].X;
      var ycenter = drawPoint[1].Y;
      this.Canvas.beginPath();
      this.Canvas.moveTo(drawPoint[0].X, drawPoint[0].Y);
      for (var i = 1.5 * Math.PI; i < 2 * Math.PI; i += step) {
        this.Canvas.lineTo(xcenter + a * Math.cos(i), ycenter + b * Math.sin(i) * -1);
      }
      for (var j = 0; j <= 0.5 * Math.PI; j += step) {
        this.Canvas.lineTo(xcenter + a * Math.cos(j), ycenter + b * Math.sin(j) * -1);
      }
    }
    else if (drawPoint[0].X > drawPoint[1].X && drawPoint[0].Y > drawPoint[1].Y) // 第二象限
    {
      var a = drawPoint[0].X - drawPoint[1].X;
      var b = drawPoint[0].Y - drawPoint[1].Y;
      var step = (a > b) ? 1 / a : 1 / b;
      var xcenter = drawPoint[1].X;
      var ycenter = drawPoint[0].Y;
      this.Canvas.beginPath();
      this.Canvas.moveTo(drawPoint[0].X, drawPoint[0].Y);
      for (var i = 0; i <= Math.PI; i += step) {
        this.Canvas.lineTo(xcenter + a * Math.cos(i), ycenter + b * Math.sin(i) * -1);
      }
    }
    else if (drawPoint[0].X > drawPoint[1].X && drawPoint[0].Y < drawPoint[1].Y) // 第三象限
    {
      var a = drawPoint[0].X - drawPoint[1].X;
      var b = drawPoint[1].Y - drawPoint[0].Y;
      var step = (a > b) ? 1 / a : 1 / b;
      var xcenter = drawPoint[0].X;
      var ycenter = drawPoint[1].Y;
      this.Canvas.beginPath();
      this.Canvas.moveTo(drawPoint[0].X, drawPoint[0].Y);
      for (var i = 0.5 * Math.PI; i <= 1.5 * Math.PI; i += step) {
        this.Canvas.lineTo(xcenter + a * Math.cos(i), ycenter + b * Math.sin(i) * -1);
      }
    }
    else if (drawPoint[0].X < drawPoint[1].X && drawPoint[0].Y < drawPoint[1].Y) // 第四象限
    {
      var a = drawPoint[1].X - drawPoint[0].X;
      var b = drawPoint[1].Y - drawPoint[0].Y;
      var step = (a > b) ? 1 / a : 1 / b;
      var xcenter = drawPoint[1].X;
      var ycenter = drawPoint[0].Y;
      this.Canvas.beginPath();
      this.Canvas.moveTo(drawPoint[0].X, drawPoint[0].Y);
      for (var i = Math.PI; i <= 2 * Math.PI; i += step) {
        this.Canvas.lineTo(xcenter + a * Math.cos(i), ycenter + b * Math.sin(i) * -1);
      }
    }


    this.Canvas.strokeStyle = this.LineColor;
    this.Canvas.stroke();
    //this.Canvas.closePath();
    this.Canvas.restore();

    //画点
    this.DrawPoint(drawPoint);
  }

  //0-10 鼠标对应的点索引   100=鼠标在正个图形上  -1 鼠标不在图形上
  this.IsPointIn = function (x, y) {
    if (!this.Frame || this.Status != 10) return -1;

    var data = this.Frame.Data;
    if (!data) return -1;

    //是否在点上
    var aryPoint = new Array();
    for (var i in this.Value) {
      var item = this.Value[i];
      var pt = new Point();
      pt.X = this.Frame.GetXFromIndex(item.XValue - data.DataOffset);
      pt.Y = this.Frame.GetYFromData(item.YValue);

      this.Canvas.beginPath();
      this.Canvas.arc(pt.X, pt.Y, 5, 0, 360);
      //console.log('['+i+']'+'x='+x+' y='+y+' dataX='+pt.X+" dataY="+pt.Y);
      if (this.Canvas.isPointInPath(x, y))
        return i;

      aryPoint.push(pt);
    }

    //是否在弧线上
    var ArcPoint = [{ X: aryPoint[0].X, Y: aryPoint[0].Y }, { X: aryPoint[1].X, Y: aryPoint[1].Y }];
    if (this.IsPointInArc(ArcPoint, x, y))
      return 100;

    return -1;
  }
  this.IsPointInArc = function (aryPoint, x, y) {
    if (aryPoint.length != 2)
      return false;
    if (aryPoint[0].X < aryPoint[1].X && aryPoint[0].Y > aryPoint[1].Y) // 第一象限
    {
      var a = aryPoint[1].X - aryPoint[0].X;
      var b = aryPoint[0].Y - aryPoint[1].Y;
      var step = (a > b) ? 1 / a : 1 / b;
      var ainer = a * 0.8;
      var biner = b * 0.8;
      var stepiner = (ainer > biner) ? 1 / ainer : 1 / biner;
      var xcenter = aryPoint[0].X;
      var ycenter = aryPoint[1].Y;
      this.Canvas.beginPath();
      this.Canvas.moveTo(aryPoint[0].X, aryPoint[0].Y);
      for (var i = 1.5 * Math.PI; i < 2 * Math.PI; i += step) {
        this.Canvas.lineTo(xcenter + a * Math.cos(i), ycenter + b * Math.sin(i) * -1);
      }
      for (var j = 0; j <= 0.5 * Math.PI; j += step) {
        this.Canvas.lineTo(xcenter + a * Math.cos(j), ycenter + b * Math.sin(j) * -1);
      }
      for (var k = 0.5 * Math.PI; k >= 0; k -= stepiner) {
        this.Canvas.lineTo(xcenter + ainer * Math.cos(k), ycenter + biner * Math.sin(j) * -1);
      }
      for (var l = 2 * Math.PI; l >= 1.5 * Math.PI; l -= stepiner) {
        this.Canvas.lineTo(xcenter + ainer * Math.cos(l), ycenter + biner * Math.sin(l) * -1);
      }
      this.Canvas.closePath();
    }
    else if (aryPoint[0].X > aryPoint[1].X && aryPoint[0].Y > aryPoint[1].Y) // 第二象限
    {
      var a = aryPoint[0].X - aryPoint[1].X;
      var b = aryPoint[0].Y - aryPoint[1].Y;
      var step = (a > b) ? 1 / a : 1 / b;
      var ainer = a * 0.8;
      var biner = b * 0.8;
      var stepiner = (ainer > biner) ? 1 / ainer : 1 / biner;
      var xcenter = aryPoint[1].X;
      var ycenter = aryPoint[0].Y;
      this.Canvas.beginPath();
      this.Canvas.moveTo(aryPoint[0].X, aryPoint[0].Y);
      for (var i = 0; i <= Math.PI; i += step) {
        this.Canvas.lineTo(xcenter + a * Math.cos(i), ycenter + b * Math.sin(i) * -1);
      }
      for (var j = Math.PI; j >= 0; j -= stepiner) {
        this.Canvas.lineTo(xcenter + ainer * Math.cos(j), ycenter + biner * Math.sin(j) * -1);
      }
      this.Canvas.closePath();
    }
    else if (aryPoint[0].X > aryPoint[1].X && aryPoint[0].Y < aryPoint[1].Y) // 第三象限
    {
      var a = aryPoint[0].X - aryPoint[1].X;
      var b = aryPoint[1].Y - aryPoint[0].Y;
      var step = (a > b) ? 1 / a : 1 / b;
      var ainer = a * 0.8;
      var biner = b * 0.8;
      var stepiner = (ainer > biner) ? 1 / ainer : 1 / biner;
      var xcenter = aryPoint[0].X;
      var ycenter = aryPoint[1].Y;
      this.Canvas.beginPath();
      this.Canvas.moveTo(aryPoint[0].X, aryPoint[0].Y);
      for (var i = 0.5 * Math.PI; i <= 1.5 * Math.PI; i += step) {
        this.Canvas.lineTo(xcenter + a * Math.cos(i), ycenter + b * Math.sin(i) * -1);
      }
      for (var j = 1.5 * Math.PI; j >= 0.5 * Math.PI; j -= stepiner) {
        this.Canvas.lineTo(xcenter + ainer * Math.cos(j), ycenter + biner * Math.sin(j) * -1);
      }
      this.Canvas.closePath();
    }
    else if (aryPoint[0].X < aryPoint[1].X && aryPoint[0].Y < aryPoint[1].Y) // 第四象限
    {
      var a = aryPoint[1].X - aryPoint[0].X;
      var b = aryPoint[1].Y - aryPoint[0].Y;
      var step = (a > b) ? 1 / a : 1 / b;
      var ainer = a * 0.8;
      var biner = b * 0.8;
      var stepiner = (ainer > biner) ? 1 / ainer : 1 / biner;
      var xcenter = aryPoint[1].X;
      var ycenter = aryPoint[0].Y;
      this.Canvas.beginPath();
      this.Canvas.moveTo(aryPoint[0].X, aryPoint[0].Y);
      for (var i = Math.PI; i <= 2 * Math.PI; i += step) {
        this.Canvas.lineTo(xcenter + a * Math.cos(i), ycenter + b * Math.sin(i) * -1);
      }
      for (var j = 2 * Math.PI; j >= Math.PI; j -= stepiner) {
        this.Canvas.lineTo(xcenter + ainer * Math.cos(j), ycenter + biner * Math.sin(j) * -1);
      }
      this.Canvas.closePath();
    }
    if (this.Canvas.isPointInPath(x, y))
      return true;
    else
      return false;

  }

}


/////////////////////////////////////////////////////////////////////////////////////////////////////////
//  数据分割
//  [0]=Start起始 [1]=End结束 [2]=FixInterval修正的间隔 [3]=Increase
//
function SplitData() {
  this.Data = [
    [0.000001, 0.000002, 0.000001, 0.0000001],
    [0.000002, 0.000004, 0.000002, 0.0000002],
    [0.000004, 0.000005, 0.000004, 0.0000001],
    [0.000005, 0.00001, 0.000005, 0.0000005],

    [0.00001, 0.00002, 0.00001, 0.000001],
    [0.00002, 0.00004, 0.00002, 0.000002],
    [0.00004, 0.00005, 0.00004, 0.000001],
    [0.00005, 0.0001, 0.00005, 0.000005],

    [0.0001, 0.0002, 0.0001, 0.00001],
    [0.0002, 0.0004, 0.0002, 0.00002],
    [0.0004, 0.0005, 0.0004, 0.00001],
    [0.0005, 0.001, 0.0005, 0.00005],

    [0.001, 0.002, 0.001, 0.0001],
    [0.002, 0.004, 0.002, 0.0002],
    [0.004, 0.005, 0.004, 0.0001],
    [0.005, 0.01, 0.005, 0.0005],

    [0.01, 0.02, 0.01, 0.001],
    [0.02, 0.04, 0.02, 0.002],
    [0.04, 0.05, 0.04, 0.001],
    [0.05, 0.1, 0.05, 0.005],

    [0.1, 0.2, 0.1, 0.01],
    [0.2, 0.4, 0.2, 0.02],
    [0.4, 0.5, 0.4, 0.01],
    [0.5, 1, 0.5, 0.05],

    [1, 2, 1, 0.05],
    [2, 4, 2, 0.05],
    [4, 5, 4, 0.05],
    [5, 10, 5, 0.05],

    [10, 12, 10, 2],
    [20, 40, 20, 5],
    [40, 50, 40, 2],
    [50, 100, 50, 10],

    [100, 200, 100, 10],
    [200, 400, 200, 20],
    [400, 500, 400, 10],
    [500, 1000, 500, 50],

    [1000, 2000, 1000, 50],
    [2000, 4000, 2000, 50],
    [4000, 5000, 4000, 50],
    [5000, 10000, 5000, 100],

    [10000, 20000, 10000, 1000],
    [20000, 40000, 20000, 2000],
    [40000, 50000, 40000, 1000],
    [50000, 100000, 50000, 5000],

    [100000, 200000, 100000, 10000],
    [200000, 400000, 200000, 20000],
    [400000, 500000, 400000, 10000],
    [500000, 1000000, 500000, 50000],

    [1000000, 2000000, 1000000, 100000],
    [2000000, 4000000, 2000000, 200000],
    [4000000, 5000000, 4000000, 100000],
    [5000000, 10000000, 5000000, 500000],

    [10000000, 20000000, 10000000, 1000000],
    [20000000, 40000000, 20000000, 2000000],
    [40000000, 50000000, 40000000, 1000000],
    [50000000, 100000000, 50000000, 5000000],

    [100000000, 200000000, 100000000, 10000000],
    [200000000, 400000000, 200000000, 20000000],
    [400000000, 500000000, 400000000, 10000000],
    [500000000, 1000000000, 500000000, 50000000],

    [1000000000, 2000000000, 1000000000, 100000000],
    [2000000000, 4000000000, 2000000000, 200000000],
    [4000000000, 5000000000, 4000000000, 100000000],
    [5000000000, 10000000000, 5000000000, 500000000],
  ];

  this.Find = function (interval) {
    for (var i in this.Data) {
      var item = this.Data[i];
      if (interval > item[0] && interval <= item[1]) {
        var result = {};
        result.FixInterval = item[2];
        result.Increase = item[3];
        return result;
      }
    }

    return null;
  }
}

function PriceSplitData() {
  this.newMethod = SplitData;   //派生
  this.newMethod();
  delete this.newMethod;

  this.Data = [
    [0.000001, 0.000002, 0.000001, 0.0000001],
    [0.000002, 0.000004, 0.000002, 0.0000002],
    [0.000004, 0.000005, 0.000004, 0.0000001],
    [0.000005, 0.00001, 0.000005, 0.0000005],

    [0.00001, 0.00002, 0.00001, 0.000001],
    [0.00002, 0.00004, 0.00002, 0.000002],
    [0.00004, 0.00005, 0.00004, 0.000001],
    [0.00005, 0.0001, 0.00005, 0.000005],

    [0.0001, 0.0002, 0.0001, 0.00001],
    [0.0002, 0.0004, 0.0002, 0.00002],
    [0.0004, 0.0005, 0.0004, 0.00001],
    [0.0005, 0.001, 0.0005, 0.00005],

    [0.001, 0.002, 0.001, 0.0001],
    [0.002, 0.004, 0.002, 0.0002],
    [0.004, 0.005, 0.004, 0.0001],
    [0.005, 0.01, 0.005, 0.0005],

    [0.01, 0.02, 0.01, 0.001],
    [0.02, 0.04, 0.02, 0.002],
    [0.04, 0.05, 0.04, 0.001],
    [0.05, 0.1, 0.05, 0.005],

    [0.1, 0.2, 0.1, 0.01],
    [0.2, 0.4, 0.2, 0.02],
    [0.4, 0.5, 0.2, 0.01],
    [0.5, 0.8, 0.2, 0.05],
    [0.8, 1, 0.5, 0.05],

    [1, 2, 1, 0.05],
    [2, 4, 2, 0.05],
    [4, 5, 4, 0.05],
    [5, 10, 5, 0.05],

    [10, 12, 10, 2],
    [20, 40, 20, 5],
    [40, 50, 40, 2],
    [50, 100, 50, 10],

    [100, 200, 100, 10],
    [200, 400, 200, 20],
    [400, 500, 400, 10],
    [500, 1000, 500, 50],

    [1000, 2000, 1000, 50],
    [2000, 4000, 2000, 50],
    [4000, 5000, 4000, 50],
    [5000, 10000, 5000, 100],

    [10000, 20000, 10000, 1000],
    [20000, 40000, 20000, 2000],
    [40000, 50000, 40000, 1000],
    [50000, 100000, 50000, 5000],

    [100000, 200000, 100000, 10000],
    [200000, 400000, 200000, 20000],
    [400000, 500000, 400000, 10000],
    [500000, 1000000, 500000, 50000],

    [1000000, 2000000, 1000000, 100000],
    [2000000, 4000000, 2000000, 200000],
    [4000000, 5000000, 4000000, 100000],
    [5000000, 10000000, 5000000, 500000],

    [10000000, 20000000, 10000000, 1000000],
    [20000000, 40000000, 20000000, 2000000],
    [40000000, 50000000, 40000000, 1000000],
    [50000000, 100000000, 50000000, 5000000],

    [100000000, 200000000, 100000000, 10000000],
    [200000000, 400000000, 200000000, 20000000],
    [400000000, 500000000, 400000000, 10000000],
    [500000000, 1000000000, 500000000, 50000000],

    [1000000000, 2000000000, 1000000000, 100000000],
    [2000000000, 4000000000, 2000000000, 200000000],
    [4000000000, 5000000000, 4000000000, 100000000],
    [5000000000, 10000000000, 5000000000, 500000000],
  ];
}

/////////////////////////////////////////////////////////////////////////////
//   全局配置颜色
//
//
function JSChartResource() {
  this.TooltipBGColor = "rgb(255, 255, 255)"; //背景色
  this.TooltipAlpha = 0.92;                  //透明度

  this.SelectRectBGColor = "rgba(1,130,212,0.06)"; //背景色
  //   this.SelectRectAlpha=0.06;                  //透明度

  this.UpBarColor = "rgb(238,21,21)";
  this.DownBarColor = "rgb(25,158,0)";
  this.UnchagneBarColor = "rgb(0,0,0)";

  this.Minute = {};
  this.Minute.VolBarColor = "rgb(238,127,9)";
  this.Minute.PriceColor = "rgb(50,171,205)";
  this.Minute.AvPriceColor = "rgb(238,127,9)";

  this.DefaultTextColor = "rgb(43,54,69)";
  this.DefaultTextFont = '14px 微软雅黑';

  this.DynamicTitleFont = '12px 微软雅黑'; //指标动态标题字体


  this.UpTextColor = "rgb(238,21,21)";
  this.DownTextColor = "rgb(25,158,0)";
  this.UnchagneTextColor = "rgb(0,0,0)";

  this.FrameBorderPen = "rgb(225,236,242)";
  this.FrameSplitPen = "rgb(225,236,242)";          //分割线
  this.FrameSplitTextColor = "rgb(51,51,51)";     //刻度文字颜色
  this.FrameSplitTextFont = "12px 微软雅黑";        //坐标刻度文字字体
  //this.FrameSplitTextFont = "14px PingFang-SC-Bold";//坐标刻度文字字体
  this.FrameTitleBGColor = "rgb(246,251,253)";      //标题栏背景色

  this.CorssCursorBGColor = "rgb(43,54,69)";            //十字光标背景
  this.CorssCursorTextColor = "rgb(255,255,255)";
  this.CorssCursorTextFont = "14px 微软雅黑";
  this.CorssCursorPenColor = "rgb(130,130,130)";           //十字光标线段颜色

  this.Domain = "https://opensource.zealink.com";               //API域名
  this.CacheDomain = "https://opensourcecache.zealink.com";     //缓存域名

  this.KLine = {
    MaxMin: { Font: '12px 微软雅黑', Color: 'rgb(111,111,111)' },   //K线最大最小值显示
    Info:  //信息地雷
      {
        Investor:
          {
            ApiUrl: 'https://opensource.zealink.com/API/NewsInteract', //互动易
            Icon: 'https://opensourcecache.zealink.com/cache/test/investor.png',
          },
        Announcement:                                           //公告
          {
            ApiUrl: 'https://opensource.zealink.com/API/ReportList',
            Icon: 'https://opensourcecache.zealink.com/cache/test/announcement.png',
            IconQuarter: 'https://opensourcecache.zealink.com/cache/test/announcement2.png',  //季报
          },
        Pforecast:  //业绩预告
          {
            ApiUrl: 'https://opensource.zealink.com/API/StockHistoryDay',
            Icon: 'https://opensourcecache.zealink.com/cache/test/pforecast.png',
          },
        Research:   //调研
          {
            ApiUrl: 'https://opensource.zealink.com/API/InvestorRelationsList',
            Icon: 'https://opensourcecache.zealink.com/cache/test/research.png',
          },
        BlockTrading:   //大宗交易
          {
            ApiUrl: 'https://opensource.zealink.com/API/StockHistoryDay',
            Icon: 'https://opensourcecache.zealink.com/cache/test/blocktrading.png',
          },
        TradeDetail:    //龙虎榜
          {
            ApiUrl: 'https://opensource.zealink.com/API/StockHistoryDay',
            Icon: 'https://opensourcecache.zealink.com/cache/test/tradedetail.png',
          }

      }
  };

  this.Index = {};
  //指标线段颜色
  this.Index.LineColor =
    [
      "rgb(255,189,09)",
      "rgb(22,198,255)",
      "rgb(174,35,161)",
      "rgb(236,105,65)",
      "rgb(68,114,196)",
      "rgb(229,0,79)",
      "rgb(0,128,255)",
      "rgb(252,96,154)",
      "rgb(42,230,215)",
      "rgb(24,71,178)",

    ];

  //历史数据api
  this.Index.StockHistoryDayApiUrl = "https://opensource.zealink.com/API/StockHistoryDay";
  //市场多空
  this.Index.MarketLongShortApiUrl = "https://opensource.zealink.com/API/FactorTiming";
  //市场关注度
  this.Index.MarketAttentionApiUrl = "https://opensource.zealink.com/API/MarketAttention";
  //行业,指数热度
  this.Index.MarketHeatApiUrl = "https://opensource.zealink.com/API/MarketHeat"
  //自定义指数热度
  this.Index.CustomIndexHeatApiUrl = "https://opensource.zealink.com/API/QuadrantCalculate";

  //指标不支持信息
  this.Index.NotSupport = { Font: "14px 微软雅黑", TextColor: "rgb(52,52,52)" };

  //画图工具
  this.DrawPicture = {};
  this.DrawPicture.LineColor =
    [
      "rgb(30,144,255)",
    ];

  this.DrawPicture.PointColor =
    [
      "rgb(105,105,105)",
    ];



}

var g_JSChartResource = new JSChartResource();



/*
    指标列表 指标信息都在这里,不够后面再加字段
*/
function JSIndexMap() {

}

JSIndexMap.Get = function (id) {
  var indexMap = new Map(
    [
      //主图指标
      ["均线", { IsMainIndex: true, Create: function () { return new CloseMAIndex() } }],
      ["BOLL", { IsMainIndex: true, Create: function () { return new BOLLIndex() }, Name: '布林线' }],
      ["BBI", { IsMainIndex: true, Create: function () { return new BBIIndex() }, Name: '多空指标' }],
      ["DKX", { IsMainIndex: true, Create: function () { return new DKXIndex() }, Name: '多空线' }],
      ["MIKE", { IsMainIndex: true, Create: function () { return new MIKEIndex() }, Name: '麦克支撑压力' }],
      ["PBX", { IsMainIndex: true, Create: function () { return new PBXIndex() }, Name: '瀑布线' }],
      ["ENE", { IsMainIndex: true, Create: function () { return new ENEIndex() }, Name: '轨道线' }],
      ["飞龙四式", { IsMainIndex: true, Create: function () { return new DragonFourIndex }, Name: '飞龙四式' }],



      ["MACD", { IsMainIndex: false, Create: function () { return new MACDIndex() }, Name: '平滑异同平均' }],
      ["KDJ", { IsMainIndex: false, Create: function () { return new KDJIndex() }, Name: '随机指标' }],
      ["VOL", { IsMainIndex: false, Create: function () { return new VolumeIndex() }, Name: '成交量' }],
      ["RSI", { IsMainIndex: false, Create: function () { return new RSIIndex() }, Name: '相对强弱指标' }],
      ["BRAR", { IsMainIndex: false, Create: function () { return new BRARIndex() }, Name: '情绪指标' }],
      ["WR", { IsMainIndex: false, Create: function () { return new WRIndex() }, Name: '威廉指标' }],
      ["BIAS", { IsMainIndex: false, Create: function () { return new BIASIndex() }, Name: '乖离率' }],
      ["OBV", { IsMainIndex: false, Create: function () { return new OBVIndex() }, Name: '累积能量线' }],
      ["DMI", { IsMainIndex: false, Create: function () { return new DMIIndex() }, Name: '趋向指标' }],
      ["CR", { IsMainIndex: false, Create: function () { return new CRIndex() }, Name: '带状能量线' }],
      ["PSY", { IsMainIndex: false, Create: function () { return new PSYIndex() }, Name: '心理线' }],
      ["CCI", { IsMainIndex: false, Create: function () { return new CCIIndex() }, Name: '商品路径指标' }],
      ["DMA", { IsMainIndex: false, Create: function () { return new DMAIndex() }, Name: '平均差' }],
      ["TRIX", { IsMainIndex: false, Create: function () { return new TRIXIndex() }, Name: '三重指数平均线' }],
      ["VR", { IsMainIndex: false, Create: function () { return new VRIndex() }, Name: '成交量变异率' }],
      ["EMV", { IsMainIndex: false, Create: function () { return new EMVIndex() }, Name: '简易波动指标' }],
      ["ROC", { IsMainIndex: false, Create: function () { return new ROCIndex() }, Name: '变动率指标' }],
      ["MIM", { IsMainIndex: false, Create: function () { return new MTMIndex() }, Name: "动量线" }],
      ["FSL", { IsMainIndex: false, Create: function () { return new FSLIndex() }, Name: '分水岭' }],
      ["CYR", { IsMainIndex: false, Create: function () { return new CYRIndex() }, Name: '市场强弱' }],
      ["MASS", { IsMainIndex: false, Create: function () { return new MASSIndex() }, Name: '梅斯线' }],
      ["WAD", { IsMainIndex: false, Create: function () { return new WADIndex() }, Name: '威廉多空力度线' }],
      ["CHO", { IsMainIndex: false, Create: function () { return new CHOIndex() }, Name: '济坚指数' }],
      ["ADTM", { IsMainIndex: false, Create: function () { return new ADTMIndex() }, Name: '动态买卖气指标' }],
      ["HSL", { IsMainIndex: false, Create: function () { return new HSLIndex() }, Name: '换手率' }],
      ["BIAS36", { IsMainIndex: false, Create: function () { return new BIAS36Index() }, Name: '三六乖离' }],
      ["BIAS_QL", { IsMainIndex: false, Create: function () { return new BIAS_QLIndex() }, Name: '乖离率-传统版' }],
      ["DPO", { IsMainIndex: false, Create: function () { return new DPOIndex() }, Name: "区间震荡线" }],
      ["OSC", { IsMainIndex: false, Create: function () { return new OSCIndex() }, Name: '变动速率线' }],
      ["BOLL副图", { IsMainIndex: false, Create: function () { return new BOLL2Index() }, Name: '布林线' }],
      ["ART", { IsMainIndex: false, Create: function () { return new ARTIndex() }, Name: '真实波幅' }],
      ["NVI", { IsMainIndex: false, Create: function () { return new NVIIndex() }, Name: '负成交量' }],
      ["PVI", { IsMainIndex: false, Create: function () { return new PVIIndex() }, Name: '正成交量' }],
      ["UOS", { IsMainIndex: false, Create: function () { return new UOSIndex() }, Name: '终极指标' }],
      ["CYW", { IsMainIndex: false, Create: function () { return new CYWIndex() }, Name: '主力控盘' }],
      ["LON", { IsMainIndex: false, Create: function () { return new LonIndex() }, Name: '钱龙长线' }],
      ["飞龙四式-附图", { IsMainIndex: false, Create: function () { return new DragonFourFigureIndex() }, Name: '飞龙四式-附图' }],

      //公司自己的指标
      ["市场多空", { IsMainIndex: false, Create: function () { return new MarketLongShortIndex() } }],
      ["市场择时", { IsMainIndex: false, Create: function () { return new MarketTimingIndex() } }],
      ["融资占比", { IsMainIndex: false, Create: function () { return new MarginRateIndex() } }],
      ["市场关注度", { IsMainIndex: false, Create: function () { return new MarketAttentionIndex() } }],
      ["指数热度", { IsMainIndex: false, Create: function () { return new MarketHeatIndex() } }],
      ["自定义指数热度", { IsMainIndex: false, Create: function () { return new CustonIndexHeatIndex() }, Name: '自定义指数热度' }],
      ["财务粉饰", { IsMainIndex: false, Create: function () { return new BenfordIndex() } }],

      //能图指标
      ["能图-趋势", { IsMainIndex: false, Create: function () { return new LighterIndex1() }, Name: '大盘/个股趋势' }],
      ["能图-位置研判", { IsMainIndex: false, Create: function () { return new LighterIndex2() }, Name: '位置研判' }],
      ["能图-点位研判", { IsMainIndex: false, Create: function () { return new LighterIndex3() }, Name: '点位研判' }],
      ["能图-资金分析", { IsMainIndex: false, Create: function () { return new LighterIndex4() }, Name: '资金分析' }],
      ["能图-市场关注度", { IsMainIndex: false, Create: function () { return new LighterIndex5() }, Name: '市场关注度' }]

    ]
  );

  return indexMap.get(id);
}

////////////////////////////////////////////////////////////////////////////////////////////////
//      指标计算方法
//
//
//

function HQIndexFormula() {

}

//指数平均数指标 EMA(close,10)
HQIndexFormula.EMA = function (data, dayCount) {
  var result = [];

  var offset = 0;
  if (offset >= data.length) return result;

  //取首个有效数据
  for (; offset < data.length; ++offset) {
    if (data[offset] != null && !isNaN(data[offset]))
      break;
  }

  var p1Index = offset;
  var p2Index = offset + 1;

  result[p1Index] = data[p1Index];
  for (var i = offset + 1; i < data.length; ++i, ++p1Index, ++p2Index) {
    result[p2Index] = ((2 * data[p2Index] + (dayCount - 1) * result[p1Index])) / (dayCount + 1);
  }

  return result;
}

HQIndexFormula.SMA = function (data, n, m) {
  var result = [];

  var i = 0;
  var lastData = null;
  for (; i < data.length; ++i) {
    if (data[i] == null || isNaN(data[i])) continue;
    lastData = data[i];
    result[i] = lastData; //第一天的数据
    break;
  }

  for (++i; i < data.length; ++i) {
    result[i] = (m * data[i] + (n - m) * lastData) / n;
    lastData = result[i];
  }

  return result;
}


/*
    求动态移动平均.
    用法: DMA(X,A),求X的动态移动平均.
    算法: 若Y=DMA(X,A)则 Y=A*X+(1-A)*Y',其中Y'表示上一周期Y值,A必须小于1.
    例如:DMA(CLOSE,VOL/CAPITAL)表示求以换手率作平滑因子的平均价
*/
HQIndexFormula.DMA = function (data, data2) {
  var result = [];
  if (data.length < 0 || data.length != data2.length) return result;

  var index = 0;
  for (; index < data.length; ++index) {
    if (data[index] != null && !isNaN(data[index]) && data2[index] != null && !isNaN(data2[index])) {
      result[index] = data[index];
      break;
    }
  }

  for (index = index + 1; index < data.length; ++index) {
    if (data[index] == null || data2[index] == null)
      result[index] = null;
    else {
      if (data[index] < 1)
        result[index] = (data2[index] * data[index]) + (1 - data2[index]) * result[index - 1];
      else
        result[index] = data[index];
    }
  }

  return result;
}


HQIndexFormula.HHV = function (data, n) {
  var result = [];
  if (n > data.length) return result;

  var max = -10000;
  for (var i = n, j = 0; i < data.length; ++i, ++j) {
    if (i < n + max) {
      max = data[i] < data[max] ? max : i;
    }
    else {
      for (j = (max = i - n + 1) + 1; j <= i; ++j) {
        if (data[j] > data[max])
          max = j;
      }
    }

    result[i] = data[max];
  }

  return result;
}

HQIndexFormula.LLV = function (data, n) {
  var result = [];
  if (n > data.length) return result;

  var min = -10000;

  for (var i = n; i < data.length; ++i, ++j) {
    if (i < n + min) {
      min = data[i] > data[min] ? min : i;
    }
    else {
      for (var j = (min = i - n + 1) + 1; j <= i; ++j) {
        if (data[j] < data[min])
          min = j;
      }
    }
    result[i] = data[min];
  }

  return result;
}

HQIndexFormula.REF = function (data, n) {
  var result = [];

  if (data.length <= 0) return result;
  if (n >= data.length) return result;

  result = data.slice(0, data.length - n);

  for (var i = 0; i < n; ++i)
    result.unshift(null);

  return result;
}

HQIndexFormula.REFDATE = function (data, n) {
  var result = [];

  if (data.length <= 0) return result;

  //暂时写死取最后一个
  n = data.length - 1;
  for (var i in data) {
    result[i] = data[n];
  }

  return result;
}



HQIndexFormula.SUM = function (data, n) {
  var result = [];

  if (n == 0) {
    result[0] = data[0];

    for (var i = 1; i < data.length; ++i) {
      result[i] = result[i - 1] + data[i];
    }
  }
  else {

    for (var i = n - 1, j = 0; i < data.length; ++i, ++j) {
      for (var k = 0; k < n; ++k) {
        if (k == 0) result[i] = data[k + j];
        else result[i] += data[k + j];
      }
    }
  }

  return result;
}

//两个数组相减
HQIndexFormula.ARRAY_SUBTRACT = function (data, data2) {
  var result = [];
  var IsNumber = typeof (data2) == "number";
  if (IsNumber) {
    for (var i in data) {
      if (data[i] == null || isNaN(data[i]))
        result[i] = null;
      else
        result[i] = data[i] - data2;
    }
  }
  else {
    var count = Math.max(data.length, data2.length)

    for (var i = 0; i < count; ++i) {
      if (i < data.length && i < data2.length) {
        if (data[i] == null || data2[i] == null) result[i] = null;
        else result[i] = data[i] - data2[i];
      }
      else
        result[i] = null;
    }
  }

  return result;
}

//数组 data>data2比较 返回 0/1 数组
HQIndexFormula.ARRAY_GT = function (data, data2) {
  var result = [];
  var IsNumber = typeof (data2) == "number";
  if (IsNumber) {
    for (var i in data) {
      result[i] = (data[i] > data2 ? 1 : 0);
    }
  }
  else {
    var count = Math.max(data.length, data2.length)

    for (var i = 0; i < count; ++i) {
      if (i < data.length && i < data2.length)
        result[i] = data[i] > data2[i] ? 1 : 0;
      else
        result[i] = null;
    }
  }

  return result;
}

//数组 data>=data2比较 返回 0/1 数组
HQIndexFormula.ARRAY_GTE = function (data, data2) {
  var result = [];
  var IsNumber = typeof (data2) == "number";
  if (IsNumber) {
    for (var i in data) {
      result[i] = (data[i] >= data2 ? 1 : 0);
    }
  }
  else {
    var count = Math.max(data.length, data2.length)

    for (var i = 0; i < count; ++i) {
      if (i < data.length && i < data2.length)
        result[i] = data[i] >= data2[i] ? 1 : 0;
      else
        result[i] = null;
    }
  }

  return result;
}

//数组 data<data2比较 返回 0/1 数组
HQIndexFormula.ARRAY_LT = function (data, data2) {
  var result = [];
  var IsNumber = typeof (data2) == "number";
  if (IsNumber) {
    for (var i in data) {
      result[i] = (data[i] < data2 ? 1 : 0);
    }
  }
  else {
    var count = Math.max(data.length, data2.length)

    for (var i = 0; i < count; ++i) {
      if (i < data.length && i < data2.length)
        result[i] = data[i] < data2[i] ? 1 : 0;
      else
        result[i] = null;
    }
  }

  return result;
}

//数组 data<=data2比较 返回 0/1 数组
HQIndexFormula.ARRAY_LTE = function (data, data2) {
  var result = [];
  var IsNumber = typeof (data2) == "number";
  if (IsNumber) {
    for (var i in data) {
      result[i] = (data[i] <= data2 ? 1 : 0);
    }
  }
  else {
    var count = Math.max(data.length, data2.length)

    for (var i = 0; i < count; ++i) {
      if (i < data.length && i < data2.length)
        result[i] = data[i] <= data2[i] ? 1 : 0;
      else
        result[i] = null;
    }
  }

  return result;
}

//数组 data==data2比较 返回 0/1 数组
HQIndexFormula.ARRAY_EQ = function (data, data2) {
  var result = [];
  var IsNumber = typeof (data2) == "number";
  if (IsNumber) {
    for (var i in data) {
      result[i] = (data[i] == data2 ? 1 : 0);
    }
  }
  else {
    var count = Math.max(data.length, data2.length)

    for (var i = 0; i < count; ++i) {
      if (i < data.length && i < data2.length)
        result[i] = (data[i] == data2[i] ? 1 : 0);
      else
        result[i] = null;
    }
  }

  return result;
}

HQIndexFormula.ARRAY_IF = function (data, trueData, falseData) {
  var result = [];
  var IsNumber = [typeof (trueData) == "number", typeof (falseData) == "number"];
  for (var i in data) {
    if (data[i]) {
      if (IsNumber[0]) result[i] = trueData;
      else result[i] = trueData[i];
    }
    else {
      if (IsNumber[1]) result[i] = falseData;
      else result[i] = falseData[i];
    }
  }

  return result;
}

HQIndexFormula.ARRAY_AND = function (data, data2) {
  var result = [];
  var IsNumber = typeof (trueData) == "number";
  if (IsNumber) {
    for (var i in data) {
      result[i] = (data[i] && data2 ? 1 : 0);
    }
  }
  else {
    var count = Math.max(data.length, data2.length)

    for (var i = 0; i < count; ++i) {
      if (i < data.length && i < data2.length)
        result[i] = (data[i] && data2[i] ? 1 : 0);
      else
        result[i] = 0;
    }
  }

  return result;
}
HQIndexFormula.ARRAY_OR = function (data, data2) {
  var result = [];
  var IsNumber = typeof (data2) == "number";
  if (IsNumber) {
    for (var i in data) {
      result[i] = (data[i] || data2 ? 1 : 0);
    }
  }
  else {
    var count = Math.max(data.length, data2.length)

    for (var i = 0; i < count; ++i) {
      if (i < data.length && data[i]) {
        result[i] = 1;
        continue;
      }
      if (i < data2.length && data2[i]) {
        result[i] = 1;
        continue;
      }
      result[i] = 0;
    }
  }

  return result;
}
//数组相乘
//支持多个参数累乘 如:HQIndexFormula.ARRAY_MULTIPLY(data,data2,data3,data3) =data*data2*data3*data4
HQIndexFormula.ARRAY_MULTIPLY = function (data, data2) {
  if (arguments.length == 2) {
    var result = [];
    var IsNumber = typeof (data2) == "number";
    if (IsNumber) {
      for (var i in data) {
        if (data[i] == null || isNaN(data[i]))
          result[i] = null;
        else
          result[i] = data[i] * data2;
      }
    }
    else {
      var count = Math.max(data.length, data2.length);
      for (var i = 0; i < count; ++i) {
        if (i < data.length && i < data2.length)
          result[i] = data[i] * data2[i];
        else
          result[i] = null;
      }
    }

    return result;
  }

  var result = HQIndexFormula.ARRAY_MULTIPLY(arguments[0], arguments[1]);

  for (var i = 2; i < arguments.length; ++i) {
    result = HQIndexFormula.ARRAY_MULTIPLY(result, arguments[i]);
  }

  return result;
}

//数组相除
HQIndexFormula.ARRAY_DIVIDE = function (data, data2) {
  var result = [];
  var IsNumber = typeof (data2) == "number";
  if (IsNumber) {
    for (var i in data) {
      result[i] = data[i] / data2;
    }
  }
  else {
    var count = Math.max(data.length, data2.length);
    for (var i = 0; i < count; ++i) {
      if (i < data.length && i < data2.length) {
        if (data[i] == null || data2[i] == null || isNaN(data[i]) || isNaN(data2[i]))
          result[i] = null;
        else if (data2[i] == 0)
          result[i] = null;
        else
          result[i] = data[i] / data2[i];
      }
      else
        result[i] = null;
    }
  }

  return result;
}

//数组相加
//支持多个参数累加 如:HQIndexFormula.ARRAY_ADD(data,data2,data3,data3) =data+data2+data3+data4
HQIndexFormula.ARRAY_ADD = function (data, data2) {
  if (arguments.length == 2) {
    var result = [];
    var IsNumber = typeof (data2) == "number";
    if (IsNumber) {
      for (var i in data) {
        result[i] = data[i] + data2;
      }
    }
    else {
      var count = Math.max(data.length, data2.length);
      for (var i = 0; i < count; ++i) {
        if (i < data.length && i < data2.length) {
          if (data[i] == null || data2[i] == null || isNaN(data[i]) || isNaN(data2[i])) result[i] = null
          else result[i] = data[i] + data2[i];
        }
        else {
          result[i] = null;
        }
      }
    }

    return result;
  }

  var result = HQIndexFormula.ARRAY_ADD(arguments[0], arguments[1]);

  for (var i = 2; i < arguments.length; ++i) {
    result = HQIndexFormula.ARRAY_ADD(result, arguments[i]);
  }

  return result;
}

HQIndexFormula.MAX = function (data, data2) {
  var result = [];
  var IsNumber = typeof (data2) == "number";
  if (IsNumber) {
    for (var i in data) {
      if (data[i] == null) result[i] = null;
      else result[i] = Math.max(data[i], data2);
    }
  }
  else {
    var count = Math.max(data.length, data2.length);
    for (var i = 0; i < count; ++i) {
      if (i < data.length && i < data2.length) {
        if (data[i] == null || data2[i] == null) result[i] = null;
        else result[i] = Math.max(data[i], data2[i]);
      }
      else
        result[i] = null;
    }
  }

  return result;
}

HQIndexFormula.MIN = function (data, data2) {
  var result = [];
  var IsNumber = typeof (data2) == "number";
  if (IsNumber) {
    for (var i in data) {
      if (data[i] == null) result[i] = null;
      else result[i] = Math.min(data[i], data2);
    }
  }
  else {
    var count = Math.max(data.length, data2.length);
    for (var i = 0; i < count; ++i) {
      if (i < data.length && i < data2.length) {
        if (data[i] == null || data2[i] == null) result[i] = null;
        else result[i] = Math.min(data[i], data2[i]);
      }
      else
        result[i] = null;
    }
  }

  return result;
}


HQIndexFormula.ABS = function (data) {
  var result = [];
  for (var i in data) {
    if (data[i] == null) result[i] = null;
    else result[i] = Math.abs(data[i]);
  }

  return result;
}


HQIndexFormula.MA = function (data, dayCount) {
  var result = [];

  for (var i = 0, len = data.length; i < len; i++) {
    if (i < dayCount) {
      result[i] = null;
      continue;
    }

    var sum = 0;
    for (var j = 0; j < dayCount; j++) {
      sum += data[i - j];
    }
    result[i] = sum / dayCount;
  }
  return result;
}

/*
    加权移动平均
    返回加权移动平均
    用法:EXPMA(X,M):X的M日加权移动平均
    EXPMA[i]=buffer[i]*para+(1-para)*EXPMA[i-1] para=2/(1+__para)
*/
HQIndexFormula.EXPMA = function (data, dayCount) {
  var result = [];
  if (dayCount >= data.length) return result;

  var i = dayCount;
  for (; i < data.length; ++i) //获取第1个有效数据
  {
    if (data[i] != null) {
      result[i] = data[i];
      break;
    }
  }

  for (i = i + 1; i < data.length; ++i) {
    if (result[i - 1] != null && data[i] != null)
      result[i] = (2 * data[i] + (dayCount - 1) * result[i - 1]) / (dayCount + 1);
    else if (result[i - 1] != null)
      result[i] = result[i - 1];
  }

  return result;
}

//加权平滑平均,MEMA[i]=SMA[i]*para+(1-para)*SMA[i-1] para=2/(1+__para)
HQIndexFormula.EXPMEMA = function (data, dayCount) {
  var result = [];
  if (dayCount >= data.length) return result;

  var index = 0;
  for (; index < data.length; ++index) {
    if (data[index] && !isNaN(data[index])) break;
  }

  var sum = 0;
  for (var i = 0; index < data.length && i < dayCount; ++i, ++index) {
    if (data[index] && !isNaN(data[index]))
      sum += data[index];
    else
      sum += data[index - 1];
  }

  result[index - 1] = sum / dayCount;
  for (; index < data.length; ++index) {
    if (result[index - 1] != null && data[index] != null)
      result[index] = (2 * data[index] + (dayCount - 1) * result[index - 1]) / (dayCount + 1);
    else if (result[index - 1] != null)
      result[index] = result[index - 1];
  }

  return result;
}


HQIndexFormula.STD = function (data, n) {
  var result = [];

  var total = 0;
  var averageData = []; //平均值
  for (var i = n - 1; i < data.length; ++i) {
    total = 0;
    for (var j = 0; j < n; ++j) {
      total += data[i - j];
    }

    averageData[i] = total / n;
  }

  for (var i = n - 1; i < data.length; ++i) {
    total = 0;
    for (var j = 0; j < n; ++j) {
      total += Math.pow((data[i - j] - averageData[i]), 2);
    }

    result[i] = Math.sqrt(total / n);
  }


  return result;
}

//平均绝对方差
HQIndexFormula.AVEDEV = function (data, n) {
  var result = [];

  var total = 0;
  var averageData = []; //平均值
  for (var i = n - 1; i < data.length; ++i) {
    total = 0;
    for (var j = 0; j < n; ++j) {
      total += data[i - j];
    }

    averageData[i] = total / n;
  }

  for (var i = n - 1; i < data.length; ++i) {
    total = 0;
    for (var j = 0; j < n; ++j) {
      total += Math.abs(data[i - j] - averageData[i]);
    }

    result[i] = total / n;
  }


  return result;
}

HQIndexFormula.COUNT = function (data, n) {
  var result = [];


  for (var i = n - 1; i < data.length; ++i) {
    var count = 0;
    for (var j = 0; j < n; ++j) {
      if (data[i - j])++count;
    }

    result[i] = count;
  }

  return result;
}

//上穿
HQIndexFormula.CROSS = function (data, data2) {
  var result = [];
  if (data.length != data2.length) return result = [];

  var index = 0;
  for (; index < data.length; ++index) {
    if (data[index] != null && !isNaN(data[index]) && data2[index] != null && isNaN(data2[index]))
      break;
  }

  for (++index; index < data.length; ++index) {
    result[index] = (data[index] > data2[index] && data[index - 1] < data2[index - 1]) ? 1 : 0;
  }

  return result;
}

//累乘
HQIndexFormula.MULAR = function (data, n) {
  var result = [];
  if (data.length < n) return result;

  var index = n;
  for (; index < data.length; ++index) {
    if (data[index] != null && !isNaN(data[index])) {
      result[index] = data[index];
      break;
    }
  }

  for (++index; index < data.length; ++index) {
    result[index] = result[index - 1] * data[index];
  }

  return result;
}


HQIndexFormula.STICKLINE = function (data, price1, price2) {
  var result = [];
  if (data.length <= 0) return result;

  var IsNumber = typeof (price1) == "number";
  var IsNumber2 = typeof (price2) == "number";

  for (var i in data) {
    result[i] = null;
    if (isNaN(data[i])) continue;
    if (!data[i]) continue;

    if (IsNumber && IsNumber2) {
      result[i] = { Value: price1, Value2: price2 };
    }
    else if (IsNumber && !IsNumber2) {
      if (isNaN(price2[i])) continue;
      result[i] = { Value: price1, Value2: price2[i] };
    }
    else if (!IsNumber && IsNumber2) {
      if (isNaN(price1[i])) continue;
      result[i] = { Value: price1[i], Value2: price2 };
    }
    else {
      if (isNaN(price1[i]) || isNaN(price2[i])) continue;
      result[i] = { Value: price1[i], Value2: price2[i] };
    }
  }

  return result;
}

/////////////////////////////////////////////////////////////////////////////////////////////
//  K线图 控件
//  this.ChartPaint[0] K线画法 这个不要修改
//
//
function KLineChartContainer(uielement) {
  var _self = this;
  this.newMethod = JSChartContainer;   //派生
  this.newMethod(uielement);
  delete this.newMethod;

  this.WindowIndex = new Array();
  this.Symbol;
  this.Name;
  this.Period = 0;                      //周期 0=日线 1=周线 2=月线 3=年线 4=1分钟 5=5分钟 6=15分钟 7=30分钟 8=60分钟
  this.Right = 0;                       //复权 0 不复权 1 前复权 2 后复权
  this.SourceData;                    //原始的历史数据
  this.MaxReqeustDataCount = 3000;      //数据个数
  this.MaxRequestMinuteDayCount = 5;    //分钟数据请求的天数
  this.PageSize = 200;                  //每页数据个数
  this.SplashTitle = '下载历史数据';

  //this.KLineApiUrl="http://opensource.zealink.com/API/KLine2";                    //历史K线api地址
  this.KLineApiUrl = g_JSChartResource.Domain + "/API/KLine2";                        //历史K线api地址
  this.MinuteKLineApiUrl = g_JSChartResource.Domain + '/API/KLine3';                  //历史分钟数据
  this.RealtimeApiUrl = g_JSChartResource.Domain + "/API/Stock";                      //实时行情api地址
  this.KLineMatchUrl = g_JSChartResource.Domain + "/API/KLineMatch";                  //形态匹配

  this.MinuteDialog;  //双击历史K线 弹出分钟走势图

  //创建
  //windowCount 窗口个数
  this.Create = function (windowCount) {
    this.UIElement.JSChartContainer = this;

    //创建十字光标
    this.ChartCorssCursor = new ChartCorssCursor();
    this.ChartCorssCursor.Canvas = this.Canvas;
    this.ChartCorssCursor.StringFormatX = new HQDateStringFormat();
    this.ChartCorssCursor.StringFormatY = new HQPriceStringFormat();

    //创建等待提示
    this.ChartSplashPaint = new ChartSplashPaint();
    this.ChartSplashPaint.Canvas = this.Canvas;
    this.ChartSplashPaint.SplashTitle = this.SplashTitle;

    //创建框架容器
    this.Frame = new HQTradeFrame();
    this.Frame.ChartBorder = new ChartBorder();
    this.Frame.ChartBorder.UIElement = this.UIElement;
    this.Frame.ChartBorder.Top = 30;
    this.Frame.ChartBorder.Left = 5;
    this.Frame.ChartBorder.Bottom = 20;
    this.Frame.Canvas = this.Canvas;
    this.ChartCorssCursor.Frame = this.Frame; //十字光标绑定框架
    this.ChartSplashPaint.Frame = this.Frame;

    this.CreateChildWindow(windowCount);
    this.CreateMainKLine();

    //子窗口动态标题
    for (var i in this.Frame.SubFrame) {
      var titlePaint = new DynamicChartTitlePainting();
      titlePaint.Frame = this.Frame.SubFrame[i].Frame;
      titlePaint.Canvas = this.Canvas;

      this.TitlePaint.push(titlePaint);
    }
  }

  //创建子窗口
  this.CreateChildWindow = function (windowCount) {
    for (var i = 0; i < windowCount; ++i) {
      var border = new ChartBorder();
      border.UIElement = this.UIElement;

      var frame = new KLineFrame();
      frame.Canvas = this.Canvas;
      frame.ChartBorder = border;
      frame.Identify = i;                   //窗口序号

      frame.HorizontalMax = 20;
      frame.HorizontalMin = 10;

      if (i == 0) {
        frame.YSplitOperator = new FrameSplitKLinePriceY();
        frame.YSplitOperator.FrameSplitData = this.FrameSplitData.get('price');
      }
      else {
        frame.YSplitOperator = new FrameSplitY();
        frame.YSplitOperator.FrameSplitData = this.FrameSplitData.get('double');
      }

      frame.YSplitOperator.Frame = frame;
      frame.YSplitOperator.ChartBorder = border;
      frame.XSplitOperator = new FrameSplitKLineX();
      frame.XSplitOperator.Frame = frame;
      frame.XSplitOperator.ChartBorder = border;

      if (i != windowCount - 1) frame.XSplitOperator.ShowText = false;

      for (var j = frame.HorizontalMin; j <= frame.HorizontalMax; j += 1) {
        frame.HorizontalInfo[j] = new CoordinateInfo();
        frame.HorizontalInfo[j].Value = j;
        if (i == 0 && j == frame.HorizontalMin) continue;

        frame.HorizontalInfo[j].Message[1] = j.toString();
        frame.HorizontalInfo[j].Font = "14px 微软雅黑";
      }

      var subFrame = new SubFrameItem();
      subFrame.Frame = frame;
      if (i == 0)
        subFrame.Height = 20;
      else
        subFrame.Height = 10;

      this.Frame.SubFrame[i] = subFrame;
    }
  }

  //创建主图K线画法
  this.CreateMainKLine = function () {
    var kline = new ChartKLine();
    kline.Canvas = this.Canvas;
    kline.ChartBorder = this.Frame.SubFrame[0].Frame.ChartBorder;
    kline.ChartFrame = this.Frame.SubFrame[0].Frame;
    kline.Name = "Main-KLine";

    this.ChartPaint[0] = kline;

    this.TitlePaint[0] = new DynamicKLineTitlePainting();
    this.TitlePaint[0].Frame = this.Frame.SubFrame[0].Frame;
    this.TitlePaint[0].Canvas = this.Canvas;

    //主图叠加画法
    var paint = new ChartOverlayKLine();
    paint.Canvas = this.Canvas;
    paint.ChartBorder = this.Frame.SubFrame[0].Frame.ChartBorder;
    paint.ChartFrame = this.Frame.SubFrame[0].Frame;
    paint.Name = "Overlay-KLine";
    this.OverlayChartPaint[0] = paint;

  }

  //绑定主图K线数据
  this.BindMainData = function (hisData, showCount) {
    this.ChartPaint[0].Data = hisData;
    for (var i in this.Frame.SubFrame) {
      var item = this.Frame.SubFrame[i].Frame;
      item.XPointCount = showCount + 5;
      item.Data = this.ChartPaint[0].Data;
    }

    this.TitlePaint[0].Data = this.ChartPaint[0].Data;                    //动态标题
    this.TitlePaint[0].Symbol = this.Symbol;
    this.TitlePaint[0].Name = this.Name;

    this.ChartCorssCursor.StringFormatX.Data = this.ChartPaint[0].Data;   //十字光标
    this.Frame.Data = this.ChartPaint[0].Data;

    this.OverlayChartPaint[0].MainData = this.ChartPaint[0].Data;         //K线叠加

    var dataOffset = hisData.Data.length - showCount;
    if (dataOffset < 0) dataOffset = 0;
    this.ChartPaint[0].Data.DataOffset = dataOffset;

    this.CursorIndex = showCount;
    if (this.CursorIndex + dataOffset >= hisData.Data.length) this.CursorIndex = dataOffset;
  }

  //创建指定窗口指标
  this.CreateWindowIndex = function (windowIndex) {
    this.WindowIndex[windowIndex].Create(this, windowIndex);
  }

  this.BindIndexData = function (windowIndex, hisData) {
    if (!this.WindowIndex[windowIndex]) return;
    if (typeof (this.WindowIndex[windowIndex].RequestData) == "function")  //数据需要另外下载的.
    {
      this.WindowIndex[windowIndex].RequestData(this, windowIndex, hisData);
      return;
    }
    if (typeof (this.WindowIndex[windowIndex].ExecuteScript) == 'function')    //脚本指标
    {
      this.WindowIndex[windowIndex].ExecuteScript(this, windowIndex, hisData);
      return;
    }

    this.WindowIndex[windowIndex].BindData(this, windowIndex, hisData);
  }

  //获取子窗口的所有画法
  this.GetChartPaint = function (windowIndex) {
    var paint = new Array();
    for (var i in this.ChartPaint) {
      if (i == 0) continue; //第1个K线数据除外

      var item = this.ChartPaint[i];
      if (item.ChartFrame == this.Frame.SubFrame[windowIndex].Frame)
        paint.push(item);
    }

    return paint;
  }

  this.RequestHistoryData = function () {
    var self = this;
    this.ChartSplashPaint.IsEnableSplash = true;
    wx.request({
      url: this.KLineApiUrl,
      data:
        {
          "field": [
            "name",
            "symbol",
            "yclose",
            "open",
            "price",
            "high",
            "low",
            "vol"
          ],
          "symbol": self.Symbol,
          "start": -1,
          "count": self.MaxReqeustDataCount
        },
      method: 'POST',
      dataType: 'json',
      success: function (data) {
        self.ChartSplashPaint.IsEnableSplash = false;
        self.RecvHistroyData(data);
      }
    });
  }

  this.RecvHistroyData = function (recvData) {
    var data = recvData.data;
    var aryDayData = KLineChartContainer.JsonDataToHistoryData(data);

    //原始数据
    var sourceData = new ChartData();
    sourceData.Data = aryDayData;
    sourceData.DataType = 0;      //0=日线数据 1=分钟数据

    //显示的数据
    var bindData = new ChartData();
    bindData.Data = aryDayData;
    bindData.Right = this.Right;
    bindData.Period = this.Period;
    bindData.DataType = 0;

    if (bindData.Right > 0)    //复权
    {
      var rightData = bindData.GetRightDate(bindData.Right);
      bindData.Data = rightData;
    }

    if (bindData.Period > 0 && bindData.Period <= 3)   //周期数据
    {
      var periodData = sourceData.GetPeriodData(bindData.Period);
      bindData.Data = periodData;
    }

    //绑定数据
    this.SourceData = sourceData;
    this.Symbol = data.symbol;
    this.Name = data.name;
    this.BindMainData(bindData, this.PageSize);

    for (var i = 0; i < this.Frame.SubFrame.length; ++i) {
      this.BindIndexData(i, bindData);
    }
    //this.BindIndexData(0,hisData);
    //this.BindIndexData(1,hisData);
    //this.BindIndexData(2,hisData);

    //刷新画图
    this.UpdataDataoffset();           //更新数据偏移
    this.UpdatePointByCursorIndex();   //更新十字光标位子
    this.UpdateFrameMaxMin();          //调整坐标最大 最小值
    this.Frame.SetSizeChage(true);
    this.Draw();
  }

  this.ReqeustHistoryMinuteData = function () {
    var self = this;
    this.ChartSplashPaint.IsEnableSplash = true;
    wx.request({
      url: this.MinuteKLineApiUrl,
      data:
        {
          "field": [
            "name",
            "symbol",
            "yclose",
            "open",
            "price",
            "high",
            "low",
            "vol"
          ],
          "symbol": self.Symbol,
          "start": -1,
          "count": self.MaxRequestMinuteDayCount
        },
      method: 'POST',
      dataType: "json",
      success: function (data) {
        self.ChartSplashPaint.IsEnableSplash = false;
        self.RecvMinuteHistroyData(data);
      }
    });
  }


  this.RecvMinuteHistroyData = function (recvData) {
    var data = recvData.data;
    var aryDayData = KLineChartContainer.JsonDataToMinuteHistoryData(data);

    //原始数据
    var sourceData = new ChartData();
    sourceData.Data = aryDayData;
    sourceData.DataType = 1;      //0=日线数据 1=分钟数据

    //显示的数据
    var bindData = new ChartData();
    bindData.Data = aryDayData;
    bindData.Right = this.Right;
    bindData.Period = this.Period;
    bindData.DataType = 1;

    if (bindData.Period >= 5)   //周期数据
    {
      var periodData = sourceData.GetPeriodData(bindData.Period);
      bindData.Data = periodData;
    }

    //绑定数据
    this.SourceData = sourceData;
    this.Symbol = data.symbol;
    this.Name = data.name;
    this.BindMainData(bindData, this.PageSize);

    for (var i = 0; i < this.Frame.SubFrame.length; ++i) {
      this.BindIndexData(i, bindData);
    }
    //this.BindIndexData(0,hisData);
    //this.BindIndexData(1,hisData);
    //this.BindIndexData(2,hisData);

    //刷新画图
    this.UpdataDataoffset();           //更新数据偏移
    this.UpdatePointByCursorIndex();   //更新十字光标位子
    this.UpdateFrameMaxMin();          //调整坐标最大 最小值
    this.Frame.SetSizeChage(true);
    this.Draw();
  }

  //请求实时行情数据
  this.ReqeustRealtimeData = function () {
    var self = this;

    $.ajax({
      url: this.RealtimeApiUrl,
      data:
        {
          "field": [
            "name",
            "symbol",
            "yclose",
            "open",
            "price",
            "high",
            "low",
            "vol",
            "amount",
            "date",
            "time"
          ],
          "symbol": [self.Symbol],
          "start": -1
        },
      type: "post",
      dataType: "json",
      async: true,
      success: function (data) {
        self.RecvRealtimeData(data);
      }
    });
  }

  this.RecvRealtimeData = function (data) {
    var realtimeData = KLineChartContainer.JsonDataToRealtimeData(data);
    if (this.Symbol == data.symbol) {
      if (this.SourceData.Data[this.SourceData.Data.length - 1].Date == realtimeData.Date)    //实时行情数据更新
      {
        var item = this.SourceData.Data[this.SourceData.Data.length - 1];
        item.Close = realtimeData.Close;
        item.High = realtimeData.High;
        item.Low = realtimeData.Low;
        item.Vol = realtimeData.Vol;
        item.Amount = realtimeData.Amount;
      }
    }
  }

  //周期切换
  this.ChangePeriod = function (period) {
    if (this.Period == period) return;

    var isDataTypeChange = false;
    switch (period) {
      case 0:     //日线
      case 1:     //周
      case 2:     //月
      case 3:     //年
        if (this.SourceData.DataType != 0) isDataTypeChange = true;
        break;
      case 4:     //1分钟
      case 5:     //5分钟
      case 6:     //15分钟
      case 7:     //30分钟
      case 8:     //60分钟
        if (this.SourceData.DataType != 1) isDataTypeChange = true;
        break;
    }

    this.Period = period;
    if (isDataTypeChange == false) {
      this.Updata();
      return;
    }

    if (this.Period <= 3) {
      this.RequestHistoryData();                  //请求日线数据
      this.ReqeustKLineInfoData();
    }
    else {
      this.ReqeustHistoryMinuteData();            //请求分钟数据
    }
  }

  //复权切换
  this.ChangeRight = function (right) {
    if (IsIndexSymbol(this.Symbol)) return; //指数没有复权

    if (right < 0 || right > 2) return;

    if (this.Right == right) return;

    this.Right = right;

    this.Updata();
  }

  //删除某一个窗口的指标
  this.DeleteIndexPaint = function (windowIndex) {
    let paint = new Array();  //踢出当前窗口的指标画法
    for (let i in this.ChartPaint) {
      let item = this.ChartPaint[i];

      if (i == 0 || item.ChartFrame != this.Frame.SubFrame[windowIndex].Frame)
        paint.push(item);
    }

    //清空指定最大最小值
    this.Frame.SubFrame[windowIndex].Frame.YSpecificMaxMin = null;
    this.Frame.SubFrame[windowIndex].Frame.IsLocked = false;          //解除上锁

    this.ChartPaint = paint;

    //清空东条标题
    var titleIndex = windowIndex + 1;
    this.TitlePaint[titleIndex].Data = [];
    this.TitlePaint[titleIndex].Title = null;
  }

  //切换成 脚本指标
  this.ChangeScriptIndex = function (windowIndex, indexData) {
    this.DeleteIndexPaint(windowIndex);
    this.WindowIndex[windowIndex] = new ScriptIndex(indexData.Name, indexData.Script, indexData.Args);    //脚本执行

    var bindData = this.ChartPaint[0].Data;
    this.BindIndexData(windowIndex, bindData);   //执行脚本

    this.UpdataDataoffset();           //更新数据偏移
    this.UpdateFrameMaxMin();          //调整坐标最大 最小值
    this.Draw();
  }

  //切换指标 指定切换窗口指标
  this.ChangeIndex = function (windowIndex, indexName) {
    var indexItem = JSIndexMap.Get(indexName);
    if (!indexItem) return;

    //主图指标
    if (indexItem.IsMainIndex) {
      if (windowIndex > 0) windowIndex = 0;  //主图指标只能在主图显示
    }
    else {
      if (windowIndex == 0) windowIndex = 1;  //幅图指标,不能再主图显示
    }

    var paint = new Array();  //踢出当前窗口的指标画法
    for (var i in this.ChartPaint) {
      var item = this.ChartPaint[i];

      if (i == 0 || item.ChartFrame != this.Frame.SubFrame[windowIndex].Frame)
        paint.push(item);
    }

    //清空指定最大最小值
    this.Frame.SubFrame[windowIndex].Frame.YSpecificMaxMin = null;

    this.ChartPaint = paint;

    //清空东条标题
    var titleIndex = windowIndex + 1;
    this.TitlePaint[titleIndex].Data = [];
    this.TitlePaint[titleIndex].Title = null;

    this.WindowIndex[windowIndex] = indexItem.Create();
    this.CreateWindowIndex(windowIndex);

    var bindData = this.ChartPaint[0].Data;
    this.BindIndexData(windowIndex, bindData);

    this.UpdataDataoffset();           //更新数据偏移
    this.UpdateFrameMaxMin();          //调整坐标最大 最小值
    this.Draw();
  }

  this.Updata = function () {
    if (!this.SourceData) return;

    var bindData = new ChartData();
    bindData.Data = this.SourceData.Data;
    bindData.Period = this.Period;
    bindData.Right = this.Right;

    if (bindData.Right > 0 && bindData.Period <= 3)    //复权(日线数据才复权)
    {
      var rightData = bindData.GetRightDate(bindData.Right);
      bindData.Data = rightData;
    }

    if (bindData.Period > 0 && bindData.Period != 4)   //周期数据 (0= 日线,4=1分钟线 不需要处理))   //周期数据
    {
      var periodData = bindData.GetPeriodData(bindData.Period);
      bindData.Data = periodData;
    }

    //绑定数据
    this.BindMainData(bindData, this.PageSize);

    for (var i = 0; i < this.Frame.SubFrame.length; ++i) {
      this.BindIndexData(i, bindData);
    }

    //叠加数据周期调整
    if (this.OverlayChartPaint[0].SourceData) {
      var bindData = new ChartData();
      bindData.Data = this.OverlayChartPaint[0].SourceData.Data;
      bindData.Period = this.Period;
      bindData.Right = this.Right;

      if (bindData.Right > 0 && !IsIndexSymbol(this.OverlayChartPaint[0].Symbol))       //复权数据
      {
        var rightData = bindData.GetRightDate(bindData.Right);
        bindData.Data = rightData;
      }

      var aryOverlayData = this.SourceData.GetOverlayData(bindData.Data);      //和主图数据拟合以后的数据
      bindData.Data = aryOverlayData;

      if (bindData.Period > 0)   //周期数据
      {
        var periodData = bindData.GetPeriodData(bindData.Period);
        bindData.Data = periodData;
      }

      this.OverlayChartPaint[0].Data = bindData;
    }

    //刷新画图
    this.UpdataDataoffset();           //更新数据偏移
    this.UpdatePointByCursorIndex();   //更新十字光标位子
    this.UpdateFrameMaxMin();          //调整坐标最大 最小值
    this.Frame.SetSizeChage(true);
    this.Draw();
  }

  //切换股票代码
  this.ChangeSymbol = function (symbol) {
    this.Symbol = symbol;
    if (IsIndexSymbol(symbol)) this.Right = 0;    //指数没有复权

    if (this.Period <= 3) {
      this.RequestHistoryData();                  //请求日线数据
      this.ReqeustKLineInfoData();
    }
    else {
      this.ReqeustHistoryMinuteData();            //请求分钟数据
    }
  }

  this.ReqeustKLineInfoData = function () {
    if (this.ChartPaint.length > 0) {
      var klinePaint = this.ChartPaint[0];
      klinePaint.InfoData = new Map();
    }

    //信息地雷信息
    for (var i in this.ChartInfo) {
      this.ChartInfo[i].RequestData(this);
    }
  }

  //设置K线信息地雷
  this.SetKLineInfo = function (aryInfo, bUpdate) {
    for (var i in aryInfo) {
      var infoItem = JSKLineInfoMap.Get(aryInfo[i]);
      if (!infoItem) continue;
      var item = infoItem.Create();
      item.MaxReqeustDataCount = this.MaxReqeustDataCount;
      this.ChartInfo.push(item);
    }

    if (bUpdate == true) this.ReqeustKLineInfoData();
  }

  //叠加股票
  this.OverlaySymbol = function (symbol) {
    var self = this;
    if (!this.OverlayChartPaint[0].MainData) return false;

    this.OverlayChartPaint[0].Symbol = symbol;

    //请求数据
    wx.request({
      url: this.KLineApiUrl,
      data:
        {
          "field": [
            "name",
            "symbol",
            "yclose",
            "open",
            "price",
            "high"
          ],
          "symbol": symbol,
          "start": -1,
          "count": this.MaxReqeustDataCount
        },
      method: 'POST',
      dataType: "json",
      async: true,
      success: function (data) {
        self.RecvOverlayHistoryData(data);
      }
    });

    return true;
  }

  this.RecvOverlayHistoryData = function (recvData) {
    var data = recvData.data;
    var aryDayData = KLineChartContainer.JsonDataToHistoryData(data);

    //原始叠加数据
    var sourceData = new ChartData();
    sourceData.Data = aryDayData;

    var bindData = new ChartData();
    bindData.Data = aryDayData;
    bindData.Period = this.Period;
    bindData.Right = this.Right;

    if (bindData.Right > 0 && !IsIndexSymbol(data.symbol))    //复权数据 ,指数没有复权)
    {
      var rightData = bindData.GetRightDate(bindData.Right);
      bindData.Data = rightData;
    }

    var aryOverlayData = this.SourceData.GetOverlayData(bindData.Data);      //和主图数据拟合以后的数据
    bindData.Data = aryOverlayData;

    if (bindData.Period > 0)   //周期数据
    {
      var periodData = bindData.GetPeriodData(bindData.Period);
      bindData.Data = periodData;
    }

    this.OverlayChartPaint[0].Data = bindData;
    this.OverlayChartPaint[0].SourceData = sourceData;
    this.OverlayChartPaint[0].Title = data.name;
    this.OverlayChartPaint[0].Symbol = data.symbol;

    this.UpdataDataoffset();           //更新数据偏移
    this.UpdateFrameMaxMin();          //调整坐标最大 最小值
    this.Frame.SetSizeChage(true);
    this.Draw();

  }

  //取消叠加股票
  this.ClearOverlaySymbol = function () {
    this.OverlayChartPaint[0].Symbol = null;
    this.OverlayChartPaint[0].Data = null;
    this.OverlayChartPaint[0].SourceData = null;
    this.OverlayChartPaint[0].TooltipRect = [];

    this.UpdateFrameMaxMin();
    this.Draw();
  }

  //创建画图工具
  this.CreateChartDrawPicture = function (name) {
    var drawPicture = null;
    switch (name) {
      case "线段":
        drawPicture = new ChartDrawPictureLine();
        break;
      case "射线":
        drawPicture = new ChartDrawPictureHaflLine();
        break;
      case "矩形":
        drawPicture = new ChartDrawPictureRect();
        break;
      case "圆弧线":
        drawPicture = new ChartDrawPictureArc();
        break;

      default:
        return false;
    }

    drawPicture.Canvas = this.Canvas;
    drawPicture.Status = 0;
    this.CurrentChartDrawPicture = drawPicture;
    return true;
  }

  this.SetChartDrawPictureFirstPoint = function (x, y) {
    var drawPicture = this.CurrentChartDrawPicture;
    if (!drawPicture) return false;
    if (!this.Frame.SubFrame || this.Frame.SubFrame.length <= 0) return false;

    for (var i in this.Frame.SubFrame) {
      var frame = this.Frame.SubFrame[i].Frame;
      var left = frame.ChartBorder.GetLeft();
      var top = frame.ChartBorder.GetTopEx();
      var height = frame.ChartBorder.GetHeight();
      var width = frame.ChartBorder.GetWidth();

      this.Canvas.rect(left, top, width, height);
      if (this.Canvas.isPointInPath(x, y)) {
        drawPicture.Frame = frame;
        break;
      }
    }

    if (!drawPicture.Frame) return false;

    drawPicture.Point[0] = new Point();
    drawPicture.Point[0].X = x - this.UIElement.getBoundingClientRect().left;
    drawPicture.Point[0].Y = y - this.UIElement.getBoundingClientRect().top;
    drawPicture.Status = 1;   //第1个点完成
  }

  this.SetChartDrawPictureSecondPoint = function (x, y) {
    var drawPicture = this.CurrentChartDrawPicture;
    if (!drawPicture) return false;

    drawPicture.Point[1] = new Point();
    drawPicture.Point[1].X = x - this.UIElement.getBoundingClientRect().left;
    drawPicture.Point[1].Y = y - this.UIElement.getBoundingClientRect().top;

    drawPicture.Status = 2;   //设置第2个点
  }

  //xStep,yStep 移动的偏移量
  this.MoveChartDrawPicture = function (xStep, yStep) {
    var drawPicture = this.CurrentChartDrawPicture;
    if (!drawPicture) return false;

    //console.log("xStep="+xStep+" yStep="+yStep);
    drawPicture.Move(xStep, yStep);

    return true;
  }

  this.FinishChartDrawPicturePoint = function () {
    var drawPicture = this.CurrentChartDrawPicture;
    if (!drawPicture) return false;
    if (drawPicture.PointCount != drawPicture.Point.length) return false;

    drawPicture.Status = 10;  //完成
    drawPicture.PointToValue();

    this.ChartDrawPicture.push(drawPicture);
    this.CurrentChartDrawPicture = null;

    return true;
  }

  this.FinishMoveChartDrawPicture = function () {
    var drawPicture = this.CurrentChartDrawPicture;
    if (!drawPicture) return false;
    if (drawPicture.PointCount != drawPicture.Point.length) return false;

    drawPicture.Status = 10;  //完成
    drawPicture.PointToValue();

    this.CurrentChartDrawPicture = null;
    return true;
  }

  //清空所有的画线工具
  this.ClearChartDrawPicture = function (drawPicture) {
    if (!drawPicture) {
      this.ChartDrawPicture = [];
      this.Draw();
    }
    else {
      for (var i in this.ChartDrawPicture) {
        if (this.ChartDrawPicture[i] == drawPicture) {
          this.ChartDrawPicture.splice(i, 1);
          this.Draw();
        }
      }
    }
  }

  //形态匹配
  // scopeData.Plate 板块范围 scopeData.Symbol 股票范围
  this.RequestKLineMatch = function (selectRectData, scopeData, fun) {
    var _self = this;

    var aryDate = new Array();
    var aryValue = new Array();

    for (var i = selectRectData.Start; i < selectRectData.End && i < selectRectData.Data.Data.length; ++i) {
      aryDate.push(selectRectData.Data.Data[i].Date);
      aryValue.push(selectRectData.Data.Data[i].Close);
    }

    //请求数据
    $.ajax({
      url: this.KLineMatchUrl,
      data:
        {
          "userid": "guest",
          "plate": scopeData.Plate,
          "period": this.Period,
          "right": this.Right,
          "dayregion": 365,
          "minsimilar": scopeData.Minsimilar,
          "sampledate": aryDate,
          "samplevalue": aryValue
        },
      type: "post",
      dataType: "json",
      async: true,
      success: function (data) {
        if ($.type(fun) == "function") {
          // console.log(data);
          fun(data);
        }
      }
    });
  }

  //更新信息地雷
  this.UpdataChartInfo = function () {
    //TODO: 根据K线数据日期来做map, 不在K线上的合并到下一个k线日期里面
    var mapInfoData = new Map();
    for (var i in this.ChartInfo) {
      var infoData = this.ChartInfo[i].Data;
      for (var j in infoData) {
        var item = infoData[j];
        if (mapInfoData.has(item.Date.toString())) {
          mapInfoData.get(item.Date.toString()).Data.push(item);
        }
        else {

          mapInfoData.set(item.Date.toString(), { Data: new Array(item) });
        }
      }
    }

    var klinePaint = this.ChartPaint[0];
    klinePaint.InfoData = mapInfoData;
  }

  //更新窗口指标
  this.UpdateWindowIndex = function (index) {
    var bindData = new ChartData();
    bindData.Data = this.SourceData.Data;
    bindData.Period = this.Period;
    bindData.Right = this.Right;

    if (bindData.Right > 0)    //复权
    {
      var rightData = bindData.GetRightDate(bindData.Right);
      bindData.Data = rightData;
    }

    if (bindData.Period > 0)   //周期数据
    {
      var periodData = bindData.GetPeriodData(bindData.Period);
      bindData.Data = periodData;
    }

    this.WindowIndex[index].BindData(this, index, bindData);

    this.UpdataDataoffset();           //更新数据偏移
    this.UpdateFrameMaxMin();          //调整坐标最大 最小值
    this.Draw();
  }

  //修改参数指标
  this.ChangeWindowIndexParam = function (index) {
    this.WindowIndex[index].Index[0].Param += 1;
    this.WindowIndex[index].Index[1].Param += 1;

    this.UpdateWindowIndex(index);
  }


  this.OnDoubleClick = function (x, y, e) {
    if (!this.MinuteDialog) return;

    var tooltip = new TooltipData();
    for (var i in this.ChartPaint) {
      var item = this.ChartPaint[i];
      if (item.GetTooltipData(x, y, tooltip)) {
        break;
      }
    }

    if (!tooltip.Data) return;

    e.data = { Chart: this, Tooltip: tooltip };

    this.MinuteDialog.DoModal(e);
  }

  this.GetMaxPageSize = function () {
    let width = this.Frame.ChartBorder.GetWidth();
    let barWidth = (ZOOM_SEED[ZOOM_SEED.length - 1][0] + ZOOM_SEED[ZOOM_SEED.length - 1][1]);
    return parseInt(width / barWidth) - 8;
  }

}

//API 返回数据 转化为array[]
KLineChartContainer.JsonDataToHistoryData = function (data) {
  var list = data.data;
  var aryDayData = new Array();
  if (!list) return aryDayData;

  var date = 0, yclose = 1, open = 2, high = 3, low = 4, close = 5, vol = 6, amount = 7;
  for (var i = 0; i < list.length; ++i) {
    var item = new HistoryData();

    item.Date = list[i][date];
    item.Open = list[i][open];
    item.YClose = list[i][yclose];
    item.Close = list[i][close];
    item.High = list[i][high];
    item.Low = list[i][low];
    item.Vol = list[i][vol] / 100;    //原始单位股
    item.Amount = list[i][amount];

    if (isNaN(item.Open) || item.Open <= 0) continue; //停牌的数据剔除

    aryDayData.push(item);
  }

  return aryDayData;
}

KLineChartContainer.JsonDataToRealtimeData = function (data) {
  var item = new HistoryData();
  item.Date = data.stock[0].date;
  item.Open = data.stock[0].open;
  item.YClose = data.stock[0].yclose;
  item.High = data.stock[0].high;
  item.Low = data.stock[0].low;
  item.Vol = data.stock[0].vol / 100; //原始单位股
  item.Amount = data.stock[0].amount;
}

//API 返回数据 转化为array[]
KLineChartContainer.JsonDataToMinuteHistoryData = function (data) {
  var list = data.data;
  var aryDayData = new Array();
  var date = 0, yclose = 1, open = 2, high = 3, low = 4, close = 5, vol = 6, amount = 7, time = 8;
  for (var i = 0; i < list.length; ++i) {
    var item = new HistoryData();

    item.Date = list[i][date];
    item.Open = list[i][open];
    item.YClose = list[i][yclose];
    item.Close = list[i][close];
    item.High = list[i][high];
    item.Low = list[i][low];
    item.Vol = list[i][vol] / 100;    //原始单位股
    item.Amount = list[i][amount];
    item.Time = list[i][time];

    aryDayData.push(item);
  }

  // 无效数据处理
  for (var i = 0; i < aryDayData.length; ++i) {
    var minData = aryDayData[i];
    if (minData == null) coninue;
    if (isNaN(minData.Open) || minData.Open <= 0 || isNaN(minData.High) || minData.High <= 0 || isNaN(minData.Low) || minData.Low <= 0
      || isNaN(minData.Close) || minData.Close <= 0 || isNaN(minData.YClose) || minData.YClose <= 0) {
      if (i == 0) {
        if (minData.YClose > 0) {
          minData.Open = minData.YClose;
          minData.High = minData.YClose;
          minData.Low = minData.YClose;
          minData.Close = minData.YClose;
        }
      }
      else // 用前一个有效数据填充
      {
        for (var j = i - 1; j >= 0; --j) {
          var minData2 = aryDayData[j];
          if (minData2 == null) coninue;
          if (minData2.Open > 0 && minData2.High > 0 && minData2.Low > 0 && minData2.Close > 0) {
            if (minData.YClose <= 0) minData.YClose = minData2.Close;
            minData.Open = minData2.Open;
            minData.High = minData2.High;
            minData.Low = minData2.Low;
            minData.Close = minData2.Close;
            break;
          }
        }
      }
    }
  }

  return aryDayData;
}


///////////////////////////////////////////////////////////////////////////////////////////
//  走势图
//
function MinuteChartContainer(uielement) {
  this.newMethod = JSChartContainer;   //派生
  this.newMethod(uielement);
  delete this.newMethod;

  this.WindowIndex = new Array();
  this.Symbol;
  this.Name;
  this.SourceData;                          //原始的历史数据
  this.IsAutoUpate = false;                   //是否自动更新行情数据
  this.TradeDate = 0;                         //行情交易日期
  this.SplashTitle = '下载分钟数据';
  this.MinuteApiUrl = g_JSChartResource.Domain + "/API/Stock";

  //创建
  //windowCount 窗口个数
  this.Create = function (windowCount) {
    this.UIElement.JSChartContainer = this;

    //创建十字光标
    this.ChartCorssCursor = new ChartCorssCursor();
    this.ChartCorssCursor.Canvas = this.Canvas;
    this.ChartCorssCursor.StringFormatX = new HQMinuteTimeStringFormat();
    this.ChartCorssCursor.StringFormatY = new HQPriceStringFormat();

    //创建等待提示
    this.ChartSplashPaint = new ChartSplashPaint();
    this.ChartSplashPaint.Canvas = this.Canvas;
    this.ChartSplashPaint.SplashTitle = this.SplashTitle;

    //创建框架容器
    this.Frame = new HQTradeFrame();
    this.Frame.ChartBorder = new ChartBorder();
    this.Frame.ChartBorder.UIElement = this.UIElement;
    this.Frame.ChartBorder.Top = 25;
    this.Frame.ChartBorder.Left = 50;
    this.Frame.ChartBorder.Bottom = 20;
    this.Frame.Canvas = this.Canvas;
    this.ChartCorssCursor.Frame = this.Frame; //十字光标绑定框架
    this.ChartSplashPaint.Frame = this.Frame;

    this.CreateChildWindow(windowCount);
    this.CreateMainKLine();

    //子窗口动态标题
    for (var i in this.Frame.SubFrame) {
      var titlePaint = new DynamicChartTitlePainting();
      titlePaint.Frame = this.Frame.SubFrame[i].Frame;
      titlePaint.Canvas = this.Canvas;

      this.TitlePaint.push(titlePaint);
    }
  }

  //创建子窗口
  this.CreateChildWindow = function (windowCount) {
    for (var i = 0; i < windowCount; ++i) {
      var border = new ChartBorder();
      border.UIElement = this.UIElement;

      var frame = new MinuteFrame();
      frame.Canvas = this.Canvas;
      frame.ChartBorder = border;
      if (i < 2) frame.ChartBorder.TitleHeight = 0;
      frame.XPointCount = 243;

      var DEFAULT_HORIZONTAL = [9, 8, 7, 6, 5, 4, 3, 2, 1];
      frame.HorizontalMax = DEFAULT_HORIZONTAL[0];
      frame.HorizontalMin = DEFAULT_HORIZONTAL[DEFAULT_HORIZONTAL.length - 1];

      if (i == 0) {
        frame.YSplitOperator = new FrameSplitMinutePriceY();
        frame.YSplitOperator.FrameSplitData = this.FrameSplitData.get('price');
      }
      else {
        frame.YSplitOperator = new FrameSplitY();
        frame.YSplitOperator.FrameSplitData = this.FrameSplitData.get('double');
      }

      frame.YSplitOperator.Frame = frame;
      frame.YSplitOperator.ChartBorder = border;
      frame.XSplitOperator = new FrameSplitMinuteX();
      frame.XSplitOperator.Frame = frame;
      frame.XSplitOperator.ChartBorder = border;
      if (i != windowCount - 1) frame.XSplitOperator.ShowText = false;
      frame.XSplitOperator.Operator();

      for (var j in DEFAULT_HORIZONTAL) {
        frame.HorizontalInfo[j] = new CoordinateInfo();
        frame.HorizontalInfo[j].Value = DEFAULT_HORIZONTAL[j];
        if (i == 0 && j == frame.HorizontalMin) continue;

        frame.HorizontalInfo[j].Message[1] = DEFAULT_HORIZONTAL[j].toString();
        frame.HorizontalInfo[j].Font = "14px 微软雅黑";
      }

      var subFrame = new SubFrameItem();
      subFrame.Frame = frame;
      if (i == 0)
        subFrame.Height = 20;
      else
        subFrame.Height = 10;

      this.Frame.SubFrame[i] = subFrame;
    }
  }

  this.CreateStockInfo = function () {
    this.ExtendChartPaint[0] = new StockInfoExtendChartPaint();
    this.ExtendChartPaint[0].Canvas = this.Canvas;
    this.ExtendChartPaint[0].ChartBorder = this.Frame.ChartBorder;
    this.ExtendChartPaint[0].ChartFrame = this.Frame;

    this.Frame.ChartBorder.Right = 300;
  }

  //创建主图K线画法
  this.CreateMainKLine = function () {
    //分钟线
    var minuteLine = new ChartMinutePriceLine();
    minuteLine.Canvas = this.Canvas;
    minuteLine.ChartBorder = this.Frame.SubFrame[0].Frame.ChartBorder;
    minuteLine.ChartFrame = this.Frame.SubFrame[0].Frame;
    minuteLine.Name = "Minute-Line";
    minuteLine.Color = g_JSChartResource.Minute.PriceColor;

    this.ChartPaint[0] = minuteLine;

    //分钟线均线
    var averageLine = new ChartLine();
    averageLine.Canvas = this.Canvas;
    averageLine.ChartBorder = this.Frame.SubFrame[0].Frame.ChartBorder;
    averageLine.ChartFrame = this.Frame.SubFrame[0].Frame;
    averageLine.Name = "Minute-Average-Line";
    averageLine.Color = g_JSChartResource.Minute.AvPriceColor;
    this.ChartPaint[1] = averageLine;

    var averageLine = new ChartMinuteVolumBar();
    averageLine.Color = g_JSChartResource.Minute.VolBarColor;
    averageLine.Canvas = this.Canvas;
    averageLine.ChartBorder = this.Frame.SubFrame[1].Frame.ChartBorder;
    averageLine.ChartFrame = this.Frame.SubFrame[1].Frame;
    averageLine.Name = "Minute-Vol-Bar";
    this.ChartPaint[2] = averageLine;


    this.TitlePaint[0] = new DynamicMinuteTitlePainting();
    this.TitlePaint[0].Frame = this.Frame.SubFrame[0].Frame;
    this.TitlePaint[0].Canvas = this.Canvas;

    /*
    //主图叠加画法
    var paint=new ChartOverlayKLine();
    paint.Canvas=this.Canvas;
    paint.ChartBorder=this.Frame.SubFrame[0].Frame.ChartBorder;
    paint.ChartFrame=this.Frame.SubFrame[0].Frame;
    paint.Name="Overlay-KLine";
    this.OverlayChartPaint[0]=paint;
    */

  }

  //切换股票代码
  this.ChangeSymbol = function (symbol) {
    this.Symbol = symbol;
    this.ChartSplashPaint.IsEnableSplash = true;
    this.RequestData();
  }

  this.RequestData = function () {
    this.RequestMinuteData();               //请求数据
  }

  //请求分钟数据
  this.RequestMinuteData = function () {
    var self = this;

    wx.request({
      url: this.MinuteApiUrl,
      data:
        {
          "field": [
            "name",
            "symbol",
            "yclose",
            "open",
            "price",
            "high",
            "low",
            "vol",
            "amount",
            "date",
            "minute",
            "time",
            "minutecount",
          ],
          "symbol": [this.Symbol],
          "start": -1
        },
      method: "post",
      dataType: "json",
      success: function (data) {
        self.ChartSplashPaint.IsEnableSplash = false;
        self.RecvMinuteData(data);
      }
    });
  }

  this.RecvMinuteData = function (data) {
    var aryMinuteData = MinuteChartContainer.JsonDataToMinuteData(data.data);

    //原始数据
    var sourceData = new ChartData();
    sourceData.Data = aryMinuteData;

    this.TradeDate = data.data.stock[0].date;

    this.SourceData = sourceData;
    this.Symbol = data.data.stock[0].symbol;
    this.Name = data.data.stock[0].name;

    this.BindMainData(sourceData, data.data.stock[0].yclose);

    if (this.Frame.SubFrame.length > 2) {
      var bindData = new ChartData();
      bindData.Data = aryMinuteData;
      for (var i = 2; i < this.Frame.SubFrame.length; ++i) {
        this.BindIndexData(i, bindData);
      }
    }

    this.UpdateFrameMaxMin();          //调整坐标最大 最小值
    this.Frame.SetSizeChage(true);
    this.Draw();

    this.AutoUpdata();
  }

  //数据自动更新
  this.AutoUpdata = function () {
    var _self = this;

    if (!this.IsAutoUpate) return;

    //9:30 - 15:40 非周6，日 每隔30秒更新一次 this.RequestMinuteData();
    var nowDate = new Date(),
      day = nowDate.getDay(),
      time = nowDate.getHours() * 100 + nowDate.getMinutes();

    if (day == 6 || day == 0) return;

    if (time > 1540) return;

    if (time < 930) {
      setTimeout(function () {
        _self.AutoUpdata();
      }, 30000);
    } else {
      setTimeout(function () {
        _self.RequestMinuteData();
      }, 30000);
    }
  }

  this.Stop = function () {
    this.IsAutoUpate = false;
  }

  this.BindIndexData = function (windowIndex, hisData) {
    if (!this.WindowIndex[windowIndex]) return;
    this.WindowIndex[windowIndex].BindData(this, windowIndex, hisData);
  }

  //绑定分钟数据
  this.BindMainData = function (minuteData, yClose) {
    //分钟数据
    var bindData = new ChartData();
    bindData.Data = minuteData.GetClose();
    this.ChartPaint[0].Data = bindData;
    this.ChartPaint[0].YClose = yClose;
    this.ChartPaint[0].NotSupportMessage = null;

    this.Frame.SubFrame[0].Frame.YSplitOperator.YClose = yClose;
    this.Frame.SubFrame[0].Frame.YSplitOperator.Data = bindData;

    //均线
    bindData = new ChartData();
    bindData.Data = minuteData.GetMinuteAvPrice();
    this.ChartPaint[1].Data = bindData;

    this.Frame.SubFrame[0].Frame.YSplitOperator.AverageData = bindData;

    //成交量
    bindData = new ChartData();
    bindData.Data = minuteData.GetVol();
    this.ChartPaint[2].Data = bindData;

    this.TitlePaint[0].Data = this.SourceData;                    //动态标题
    this.TitlePaint[0].Symbol = this.Symbol;
    this.TitlePaint[0].Name = this.Name;
    this.TitlePaint[0].YClose = yClose;

    if (this.ExtendChartPaint[0]) {
      this.ExtendChartPaint[0].Symbol = this.Symbol;
      this.ExtendChartPaint[0].Name = this.Name;
    }

    /*
    this.ChartCorssCursor.StringFormatX.Data=this.ChartPaint[0].Data;   //十字光标
    this.Frame.Data=this.ChartPaint[0].Data;

    this.OverlayChartPaint[0].MainData=this.ChartPaint[0].Data;         //K线叠加

    var dataOffset=hisData.Data.length-showCount;
    if (dataOffset<0) dataOffset=0;
    this.ChartPaint[0].Data.DataOffset=dataOffset;

    this.CursorIndex=showCount;
    if (this.CursorIndex+dataOffset>=hisData.Data.length) this.CursorIndex=dataOffset;
    */
  }

  //获取子窗口的所有画法
  this.GetChartPaint = function (windowIndex) {
    var paint = new Array();
    for (var i in this.ChartPaint) {
      if (i < 3) continue; //分钟 均线 成交量 3个线不能改

      var item = this.ChartPaint[i];
      if (item.ChartFrame == this.Frame.SubFrame[windowIndex].Frame)
        paint.push(item);
    }

    return paint;
  }

  //创建指定窗口指标
  this.CreateWindowIndex = function (windowIndex) {
    this.WindowIndex[windowIndex].Create(this, windowIndex);
  }
}

//API 返回数据 转化为array[]
MinuteChartContainer.JsonDataToMinuteData = function (data) {
  var aryMinuteData = new Array();
  for (var i in data.stock[0].minute) {
    var jsData = data.stock[0].minute[i];
    var item = new MinuteData();

    item.Close = jsData.price;
    item.Open = jsData.open;
    item.High = jsData.high;
    item.Low = jsData.low;
    item.Vol = jsData.vol / 100; //原始单位股
    item.Amount = jsData.amount;
    item.Increate = jsData.increate;
    item.Risefall = jsData.risefall;
    item.AvPrice = jsData.avprice;

    if (i == 0)      //第1个数据 写死9：25
    {
      item.DateTime = data.stock[0].date.toString() + " 0925";
      if (item.Close <= 0) //第1分钟 没数据就用开盘价
      {
        item.Close = data.stock[0].open;
        item.High = item.Low = data.stock[0].open;
        item.AvPrice = data.stock[0].open;
        console.log('[MinuteChartContainer::JsonDataToMinuteData] first minute data is empty.', data.stock[0].symbol, jsData);
      }
    }
    else
      item.DateTime = data.stock[0].date.toString() + " " + jsData.time.toString();


    aryMinuteData[i] = item;
  }

  return aryMinuteData;
}

/*
    历史分钟走势图
*/
function HistoryMinuteChartContainer(uielement) {
  this.newMethod = MinuteChartContainer;   //派生
  this.newMethod(uielement);
  delete this.newMethod;

  this.HistoryMinuteApiUrl = "https://opensourcecache.zealink.com/cache/minuteday/day/";


  //创建主图K线画法
  this.CreateMainKLine = function () {
    //分钟线
    var minuteLine = new ChartMinutePriceLine();
    minuteLine.Canvas = this.Canvas;
    minuteLine.ChartBorder = this.Frame.SubFrame[0].Frame.ChartBorder;
    minuteLine.ChartFrame = this.Frame.SubFrame[0].Frame;
    minuteLine.Name = "Minute-Line";
    minuteLine.Color = g_JSChartResource.Minute.PriceColor;

    this.ChartPaint[0] = minuteLine;

    //分钟线均线
    var averageLine = new ChartLine();
    averageLine.Canvas = this.Canvas;
    averageLine.ChartBorder = this.Frame.SubFrame[0].Frame.ChartBorder;
    averageLine.ChartFrame = this.Frame.SubFrame[0].Frame;
    averageLine.Name = "Minute-Average-Line";
    averageLine.Color = g_JSChartResource.Minute.AvPriceColor;
    this.ChartPaint[1] = averageLine;

    var averageLine = new ChartMinuteVolumBar();
    averageLine.Color = g_JSChartResource.Minute.VolBarColor;
    averageLine.Canvas = this.Canvas;
    averageLine.ChartBorder = this.Frame.SubFrame[1].Frame.ChartBorder;
    averageLine.ChartFrame = this.Frame.SubFrame[1].Frame;
    averageLine.Name = "Minute-Vol-Bar";
    this.ChartPaint[2] = averageLine;


    this.TitlePaint[0] = new DynamicMinuteTitlePainting();
    this.TitlePaint[0].Frame = this.Frame.SubFrame[0].Frame;
    this.TitlePaint[0].Canvas = this.Canvas;
    this.TitlePaint[0].IsShowDate = true;

    /*
    //主图叠加画法
    var paint=new ChartOverlayKLine();
    paint.Canvas=this.Canvas;
    paint.ChartBorder=this.Frame.SubFrame[0].Frame.ChartBorder;
    paint.ChartFrame=this.Frame.SubFrame[0].Frame;
    paint.Name="Overlay-KLine";
    this.OverlayChartPaint[0]=paint;
    */

  }

  this.RequestData = function () {
    var date = new Date();
    var nowDate = date.getFullYear() * 10000 + (date.getMonth() + 1) * 100 + date.getDate();
    if (nowDate == this.TradeDate) this.RequestMinuteData();
    else this.RequestHistoryMinuteData();
  }

  //请求分钟数据
  this.RequestHistoryMinuteData = function () {
    var _self = this;
    var url = this.HistoryMinuteApiUrl + this.TradeDate.toString() + "/" + this.Symbol + ".json";

    $.ajax({
      url: url,
      type: "get",
      dataType: "json",
      async: true,
      success: function (data) {
        _self.RecvHistoryMinuteData(data);
      },
      error: function (reqeust) {
        _self.RecvHistoryMinuteError(reqeust);
      }
    });
  }

  this.RecvHistoryMinuteError = function (reqeust) {
    if (reqeust.status != 404) return;

    var sourceData = new ChartData();
    this.SourceData = sourceData;

    for (var i in this.ChartPaint) {
      this.ChartPaint[i].Data = sourceData;
      if (i == 0) this.ChartPaint[i].NotSupportMessage = '没有权限访问!';
    }

    this.TitlePaint[0].Data = this.SourceData;                    //动态标题
    this.TitlePaint[0].Symbol = this.Symbol;
    this.TitlePaint[0].Name = null;

    this.Draw();
  }

  this.RecvHistoryMinuteData = function (data) {
    var aryMinuteData = HistoryMinuteChartContainer.JsonDataToMinuteData(data);

    //原始数据
    var sourceData = new ChartData();
    sourceData.Data = aryMinuteData;

    this.TradeDate = data.date;

    this.SourceData = sourceData;
    this.Symbol = data.symbol;
    this.Name = data.name;

    this.BindMainData(sourceData, data.day.yclose);

    if (this.Frame.SubFrame.length > 2) {
      var bindData = new ChartData();
      bindData.Data = aryMinuteData;
      for (var i = 2; i < this.Frame.SubFrame.length; ++i) {
        this.BindIndexData(i, bindData);
      }
    }

    this.UpdateFrameMaxMin();          //调整坐标最大 最小值
    this.Frame.SetSizeChage(true);
    this.Draw();

    //this.AutoUpdata();
  }

}

//API 返回数据 转化为array[]
HistoryMinuteChartContainer.JsonDataToMinuteData = function (data) {
  var aryMinuteData = new Array();
  for (var i in data.minute.time) {
    var item = new MinuteData();

    if (data.minute.price[i] <= 0 && i > 0) //当前这一分钟价格为空,使用上一分钟的数据
    {
      item.Close = aryMinuteData[i - 1].Close;
      item.Open = aryMinuteData[i - 1].Close;
      item.High = item.Close;
      item.Low = item.Close;
      item.Vol = data.minute.vol[i] / 100; //原始单位股
      item.Amount = data.minute.amount[i];
      item.DateTime = data.date.toString() + " " + data.minute.time[i].toString();
      //item.Increate=jsData.increate;
      //item.Risefall=jsData.risefall;
      item.AvPrice = aryMinuteData[i - 1].AvPrice;
    }
    else {
      item.Close = data.minute.price[i];
      item.Open = data.minute.open[i];
      item.High = data.minute.high[i];
      item.Low = data.minute.low[i];
      item.Vol = data.minute.vol[i] / 100; //原始单位股
      item.Amount = data.minute.amount[i];
      item.DateTime = data.date.toString() + " " + data.minute.time[i].toString();
      //item.Increate=jsData.increate;
      //item.Risefall=jsData.risefall;
      item.AvPrice = data.minute.avprice[i];
    }

    aryMinuteData[i] = item;
  }

  return aryMinuteData;
}

/////////////////////////////////////////////////////////////////////////////
//  自定义指数
//
function CustomKLineChartContainer(uielement) {
  this.newMethod = KLineChartContainer;   //派生
  this.newMethod(uielement);
  delete this.newMethod;

  this.ChangeRight = null;  //没有复权设置
  this.SplashTitle = '计算指数数据';

  this.CustomKLineApiUrl = g_JSChartResource.Domain + "/API/IndexCalculate";  //自定义指数计算地址
  this.CustomStock;   //成分
  this.QueryDate = { Start: 20180101, End: 20180627 };     //计算时间区间

  this.RequestHistoryData = function () {
    var self = this;
    this.ChartSplashPaint.IsEnableSplash = true;
    this.Draw();
    wx.request({
      url: this.CustomKLineApiUrl,
      data:
        {
          "stock": self.CustomStock,
          "Name": self.Symbol,
          "date": { "startdate": self.QueryDate.Start, "enddate": self.QueryDate.End }
        },
      method: 'POST',
      dataType: "json",
      async: true,
      success: function (data) {
        self.ChartSplashPaint.IsEnableSplash = false;
        self.RecvHistroyData(data);
      }
    });
  }

  this.RecvHistroyData = function (recvData) {
    var data = recvData.data;
    var aryDayData = KLineChartContainer.JsonDataToHistoryData(data);

    //原始数据
    var sourceData = new ChartData();
    sourceData.Data = aryDayData;
    sourceData.DataType = 0;      //0=日线数据 1=分钟数据

    //显示的数据
    var bindData = new ChartData();
    bindData.Data = aryDayData;
    bindData.Right = 0;   //指数没有复权
    bindData.Period = this.Period;
    bindData.DataType = 0;

    if (bindData.Period > 0 && bindData.Period <= 3)   //周期数据
    {
      var periodData = sourceData.GetPeriodData(bindData.Period);
      bindData.Data = periodData;
    }

    //绑定数据
    this.SourceData = sourceData;
    this.Name = data.name;
    this.BindMainData(bindData, this.PageSize);

    for (var i = 0; i < this.Frame.SubFrame.length; ++i) {
      this.BindIndexData(i, bindData);
    }
    //this.BindIndexData(0,hisData);
    //this.BindIndexData(1,hisData);
    //this.BindIndexData(2,hisData);

    //刷新画图
    this.UpdataDataoffset();           //更新数据偏移
    this.UpdatePointByCursorIndex();   //更新十字光标位子
    this.UpdateFrameMaxMin();          //调整坐标最大 最小值
    this.Frame.SetSizeChage(true);
    this.Draw();

    if (typeof (this.UpdateUICallback) == 'function') this.UpdateUICallback('RecvHistroyData', this);
  }

}

////////////////////////////////////////////////////////////////////////////////
//  简单的图形框架
//
function SimlpleChartContainer(uielement) {
  this.newMethod = JSChartContainer;   //派生
  this.newMethod(uielement);
  delete this.newMethod;

  this.WindowIndex = new Array();
  this.MainDataControl;    //主数据类(对外的接口类)
  this.SubDataControl = new Array();
  this.FrameType = 0;       //框架类型

  this.YSplitCount = 3;

  //创建
  this.Create = function () {
    this.UIElement.JSChartContainer = this;

    //创建十字光标
    //this.ChartCorssCursor=new ChartCorssCursor();
    //this.ChartCorssCursor.Canvas=this.Canvas;
    //this.ChartCorssCursor.StringFormatX=new HQDateStringFormat();
    //this.ChartCorssCursor.StringFormatY=new HQPriceStringFormat();

    //创建等待提示
    this.ChartSplashPaint = new ChartSplashPaint();
    this.ChartSplashPaint.Canvas = this.Canvas;

    //创建框架容器
    if (this.FrameType == 1) this.Frame = new Rotate90SimpleChartFrame();
    else this.Frame = new SimpleChartFrame();
    this.Frame.ChartBorder = new ChartBorder();
    this.Frame.ChartBorder.UIElement = this.UIElement;
    this.Frame.ChartBorder.Top = 30;
    this.Frame.ChartBorder.Left = 5;
    this.Frame.ChartBorder.Bottom = 20;
    this.Frame.Canvas = this.Canvas;
    if (this.ChartCorssCursor) this.ChartCorssCursor.Frame = this.Frame; //十字光标绑定框架
    this.ChartSplashPaint.Frame = this.Frame;

    this.CreateMainChart();

  }

  this.SetMainDataConotrl = function (dataControl) {
    if (!dataControl) return;

    this.MainDataControl = dataControl;
    this.ChartPaint = []; //图形
    this.Frame.BarCount = 0;

    let yStringFormat = this.Frame.YSplitOperator.StringFormat;//保存配置

    this.CreateMainChart();
    this.Frame.YSplitOperator.StringFormat = yStringFormat;//还原配置
    this.Draw();
    this.RequestData();
  }

  //创建主数据画法
  this.CreateMainChart = function () {
    if (!this.MainDataControl) return;

    let barIndex = 0;
    for (let i in this.MainDataControl.DataType) {
      let item = this.MainDataControl.DataType[i];
      if (item.Type == "BAR") {
        let chartItem;
        if (this.FrameType == 1) chartItem = new ChartXYSubBar();
        else chartItem = new ChartSubBar();

        chartItem.BarID = barIndex;
        chartItem.Canvas = this.Canvas;
        chartItem.ChartBorder = this.Frame.ChartBorder;
        chartItem.ChartFrame = this.Frame;
        chartItem.Name = item.Name;
        if (item.Color) chartItem.UpBarColor = item.Color;
        if (item.Color2) chartItem.DownBarColor = item.Color2;

        this.ChartPaint.push(chartItem);
        ++this.Frame.BarCount;
        ++barIndex;
      }
      else if (item.Type == "LINE") {
        let chartItem = new ChartLine();
        chartItem.Canvas = this.Canvas;
        chartItem.ChartBorder = this.Frame.ChartBorder;
        chartItem.ChartFrame = this.Frame;
        chartItem.Name = item.Name;
        if (item.Color) chartItem.Color = item.Color;

        this.ChartPaint.push(chartItem);
      }
    }

    this.Frame.YSplitOperator = new FrameSplitY();
    this.Frame.YSplitOperator.SplitCount = this.YSplitCount;
    this.Frame.YSplitOperator.FrameSplitData = this.FrameSplitData.get('double');
    this.Frame.YSplitOperator.Frame = this.Frame;
    this.Frame.YSplitOperator.ChartBorder = this.Frame.ChartBorder;

    this.Frame.XSplitOperator = new FrameSplitXData();
    this.Frame.XSplitOperator.Frame = this.Frame;
    this.Frame.XSplitOperator.ChartBorder = this.Frame.ChartBorder;


    // this.TitlePaint[0]=new DynamicKLineTitlePainting();
    // this.TitlePaint[0].Frame=this.Frame.SubFrame[0].Frame;
    // this.TitlePaint[0].Canvas=this.Canvas;
  }

  this.RequestData = function () {
    if (!this.MainDataControl) return;

    this.MainDataControl.JSChartContainer = this;
    this.MainDataControl.RequestData();
  }

  this.UpdateMainData = function (dataControl) {
    let lCount = 0;
    for (let i in dataControl.Data) {
      let itemData = new ChartData();
      itemData.Data = dataControl.Data[i];
      this.ChartPaint[i].Data = itemData;
      if (lCount < itemData.Data.length) lCount = itemData.Data.length;
    }

    this.Frame.XPointCount = lCount;
    this.Frame.Data = this.ChartPaint[0].Data;
    this.Frame.XData = dataControl.XData;

    this.UpdateFrameMaxMin();               //调整坐标最大 最小值
    this.Frame.SetSizeChage(true);
    this.Draw();
  }

}

////////////////////////////////////////////////////////////////////////////////
//  饼图图形框架
//
function PieChartContainer(uielement) {
  this.Radius;    //半径
  this.newMethod = JSChartContainer;   //派生
  this.newMethod(uielement);
  delete this.newMethod;

  this.MainDataControl;    //主数据类(对外的接口类)

  //鼠标移动
  this.OnMouseMove = function (x, y, e) {

  }

  //创建
  this.Create = function () {
    this.UIElement.JSChartContainer = this;

    //创建等待提示
    this.ChartSplashPaint = new ChartSplashPaint();
    this.ChartSplashPaint.Canvas = this.Canvas;

    //创建框架容器
    this.Frame = new NoneFrame();
    this.Frame.ChartBorder = new ChartBorder();
    this.Frame.ChartBorder.UIElement = this.UIElement;
    this.Frame.ChartBorder.Top = 30;
    this.Frame.ChartBorder.Left = 5;
    this.Frame.ChartBorder.Bottom = 20;
    this.Frame.Canvas = this.Canvas;

    this.ChartSplashPaint.Frame = this.Frame;
    this.CreateMainChart();
  }

  this.SetMainDataConotrl = function (dataControl) {
    if (!dataControl) return;

    this.MainDataControl = dataControl;
    this.ChartPaint = []; //图形

    this.CreateMainChart();
    this.Draw();
    this.RequestData();
  }

  //创建主数据画法
  this.CreateMainChart = function () {
    if (!this.MainDataControl) return;

    for (let i in this.MainDataControl.DataType) {
      let item = this.MainDataControl.DataType[i];
      if (item.Type == "PIE") {
        var chartItem = new ChartPie();
        chartItem.Canvas = this.Canvas;
        chartItem.ChartBorder = this.Frame.ChartBorder;
        chartItem.ChartFrame = this.Frame;
        chartItem.Name = item.Name;

        this.ChartPaint.push(chartItem);
      }
      else if (item.Type == 'CIRCLE') {
        var chartItem = new ChartCircle();
        chartItem.Canvas = this.Canvas;
        chartItem.ChartBorder = this.Frame.ChartBorder;
        chartItem.ChartFrame = this.Frame;
        chartItem.Name = item.Name;

        this.ChartPaint.push(chartItem);
      }
    }

    // this.TitlePaint[0]=new DynamicKLineTitlePainting();
    // this.TitlePaint[0].Frame=this.Frame.SubFrame[0].Frame;
    // this.TitlePaint[0].Canvas=this.Canvas;
  }

  this.RequestData = function () {
    if (!this.MainDataControl) return;

    this.MainDataControl.JSChartContainer = this;
    this.MainDataControl.RequestData();
  }

  this.UpdateMainData = function (dataControl) {
    for (let i in dataControl.Data) {
      let itemData = new ChartData();
      itemData.Data = dataControl.Data[i];
      this.ChartPaint[i].Data = itemData;
    }
    this.Frame.SetSizeChage(true);
    this.Draw();
  }

}

//地图
function MapChartContainer(uielement) {
  this.newMethod = JSChartContainer;   //派生
  this.newMethod(uielement);
  delete this.newMethod;

  this.MainDataControl;    //主数据类(对外的接口类)

  //鼠标移动
  this.OnMouseMove = function (x, y, e) {

  }

  //创建
  this.Create = function () {
    this.UIElement.JSChartContainer = this;

    //创建等待提示
    this.ChartSplashPaint = new ChartSplashPaint();
    this.ChartSplashPaint.Canvas = this.Canvas;

    //创建框架容器
    this.Frame = new NoneFrame();
    this.Frame.ChartBorder = new ChartBorder();
    this.Frame.ChartBorder.UIElement = this.UIElement;
    this.Frame.ChartBorder.Top = 30;
    this.Frame.ChartBorder.Left = 5;
    this.Frame.ChartBorder.Bottom = 20;
    this.Frame.Canvas = this.Canvas;

    this.ChartSplashPaint.Frame = this.Frame;
    this.CreateMainChart();
  }

  this.SetMainDataConotrl = function (dataControl) {
    if (!dataControl) return;

    this.MainDataControl = dataControl;
    this.ChartPaint = []; //图形

    this.CreateMainChart();
    this.Draw();
    this.RequestData();
  }

  //创建主数据画法
  this.CreateMainChart = function () {
    if (!this.MainDataControl) return;

    let chartItem = new ChartChinaMap();
    chartItem.Canvas = this.Canvas;
    chartItem.ChartBorder = this.Frame.ChartBorder;
    chartItem.ChartFrame = this.Frame;
    chartItem.Name = this.MainDataControl.DataType[0].Name;

    if (this.Radius) chartItem.Radius = this.Radius;

    this.ChartPaint.push(chartItem);

    // this.TitlePaint[0]=new DynamicKLineTitlePainting();
    // this.TitlePaint[0].Frame=this.Frame.SubFrame[0].Frame;
    // this.TitlePaint[0].Canvas=this.Canvas;
  }

  this.RequestData = function () {
    if (!this.MainDataControl) return;

    this.MainDataControl.JSChartContainer = this;
    this.MainDataControl.RequestData();
  }

  this.UpdateMainData = function (dataControl) {
    this.ChartPaint[0].Data = dataControl.Data[0];

    this.Frame.SetSizeChage(true);
    this.Draw();
  }
}

//////////////////////////////////////////////////////////
//
//  指标信息
//
function IndexInfo(name, param) {
  this.Name = name;                 //名字
  this.Param = param;               //参数
  this.LineColor;                 //线段颜色
  this.ReqeustData = null;          //数据请求
}

function BaseIndex(name) {
  this.Index;               //指标阐述
  this.Name = name;           //指标名字
  this.UpdateUICallback;    //数据到达回调

  //默认创建都是线段
  this.Create = function (hqChart, windowIndex) {
    for (var i in this.Index) {
      if (!this.Index[i].Name) continue;

      var maLine = new ChartLine();
      maLine.Canvas = hqChart.Canvas;
      maLine.Name = this.Name + '-' + i.toString();
      maLine.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
      maLine.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;
      maLine.Color = this.Index[i].LineColor;

      hqChart.ChartPaint.push(maLine);
    }
  }

  //指标不支持 周期/复权/股票等
  this.NotSupport = function (hqChart, windowIndex, message) {
    var paint = hqChart.GetChartPaint(windowIndex);
    for (var i in paint) {
      paint[i].Data.Data = [];    //清空数据
      if (i == 0) paint[i].NotSupportMessage = message;
    }
  }

  //格式化指标名字+参数
  //格式:指标名(参数1,参数2,参数3,...)
  this.FormatIndexTitle = function () {
    var title = this.Name;
    var param = null;

    for (var i in this.Index) {
      var item = this.Index[i];
      if (item.Param == null) continue;

      if (param)
        param += ',' + item.Param.toString();
      else
        param = item.Param.toString();
    }

    if (param) {
      title += '(' + param + ')';
    }

    return title;
  }

  this.InvokeUpdateUICallback = function (paint) {
    if (typeof (this.UpdateUICallback) != 'function') return;

    let indexData = new Array();
    for (let i in paint) {
      indexData.push({ Name: this.Index[i].Name, Data: paint[i].Data });
    }

    this.UpdateUICallback(indexData);
  }

}

//////////////////////////////////////////////////////////////////////////////////////
//  MA(5,10,20)
//
//
function CloseMAIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('MA');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("MA", 5),
    new IndexInfo("MA", 10),
    new IndexInfo("MA", 20)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[2];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      var maData = hisData.GetCloseMA(this.Index[i].Param);
      paint[i].Data.Data = maData;
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name + this.Index[i].Param.toString(), this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    //hqChart.TitlePaint[titleIndex].TitleAlign='bottom';

    return true;
  }
}

///////////////////////////////////////////////////////////////////////////////////////////
//  成交量指标 VOL(5,10)
//
function VolumeIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('VOL');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("VOL", 5),
    new IndexInfo("VOLMA", 10),
    new IndexInfo("VOLMA", null)
  );

  this.Index[0].LineColor = g_JSChartResource.DefaultTextColor;
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[1];

  this.Create = function (hqChart, windowIndex) {
    for (var i in this.Index) {
      var paint = null;
      if (i == 0) {
        paint = new ChartKVolumeBar();
      }
      else {
        paint = new ChartLine();
        paint.Color = this.Index[i].LineColor;
      }

      paint.Canvas = hqChart.Canvas;
      paint.Name = this.Name + '-' + i.toString();
      paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
      paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;

      hqChart.ChartPaint.push(paint);
    }
  }

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    paint[0].Data = hisData;
    paint[1].Data.Data = hisData.GetVolMA(this.Index[0].Param);
    paint[2].Data.Data = hisData.GetVolMA(this.Index[1].Param);

    var titleIndex = windowIndex + 1;
    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
      if (i == 0) hqChart.TitlePaint[titleIndex].Data[i].DataType = "HistoryData-Vol";
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();

    return true;
  }
}


////////////////////////////////////////////////////////////////////////////////////////////////////
//  MACD
//
function MACDIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('MACD');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("DIF", 12),
    new IndexInfo("DEA", 26),
    new IndexInfo("MACD", 9)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.DefaultTextColor;

  this.Create = function (hqChart, windowIndex) {
    for (var i in this.Index) {
      var paint = null;
      if (i == 2) {
        paint = new ChartMACD();
      }
      else {
        paint = new ChartLine();
        paint.Color = this.Index[i].LineColor;
      }

      paint.Canvas = hqChart.Canvas;
      paint.Name = this.Name + "-" + i.toString();
      paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
      paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;

      hqChart.ChartPaint.push(paint);
    }
  }

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var closeEMA12 = HQIndexFormula.EMA(closeData, this.Index[0].Param);
    var closeEMA26 = HQIndexFormula.EMA(closeData, this.Index[1].Param);

    var data1 = [];
    for (var i in closeEMA12) {
      data1[i] = closeEMA12[i] - closeEMA26[i];
    }

    var data2 = HQIndexFormula.EMA(data1, this.Index[2].Param);

    var data3 = [];
    for (var i in data1) {
      data3[i] = (data1[i] - data2[i]) * 2;
    }

    paint[0].Data.Data = data1;
    paint[1].Data.Data = data2;
    paint[2].Data.Data = data3;

    var titleIndex = windowIndex + 1;
    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "MACD(" + this.Index[0].Param + "," + this.Index[1].Param + "," + this.Index[2].Param + ")";

    return true;
  }
}


/*
  KDJ
        RSV:=(CLOSE-LLV(LOW,N))/(HHV(HIGH,N)-LLV(LOW,N))*100;
        K:SMA(RSV,M1,1);
        D:SMA(K,M2,1);
        J:3*K-2*D;
*/
function KDJIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('KDJ');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("K", 9),
    new IndexInfo("D", 3),
    new IndexInfo("J", 3)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[2];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var highData = hisData.GetHigh();
    var lowData = hisData.GetLow();

    //RSV:=(CLOSE-LLV(LOW,N))/(HHV(HIGH,N)-LLV(LOW,N))*100;
    var RSVData = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.ARRAY_SUBTRACT(closeData, HQIndexFormula.LLV(lowData, this.Index[0].Param)),
        HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.HHV(highData, this.Index[0].Param), HQIndexFormula.LLV(lowData, this.Index[0].Param))
      ),
      100);

    //K:SMA(RSV,M1,1);
    var KData = HQIndexFormula.SMA(RSVData, this.Index[1].Param, 1);

    //D:SMA(K,M2,1);
    var DData = HQIndexFormula.SMA(KData, this.Index[2].Param, 1);

    //J:3*K-2*D;
    var JData = HQIndexFormula.ARRAY_SUBTRACT(
      HQIndexFormula.ARRAY_MULTIPLY(KData, 3),
      HQIndexFormula.ARRAY_MULTIPLY(DData, 2)
    );

    paint[0].Data.Data = KData;
    paint[1].Data.Data = DData;
    paint[2].Data.Data = JData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    RSI 相对强弱指标
    LC:=REF(CLOSE,1);
    RSI1:SMA(MAX(CLOSE-LC,0),N1,1)/SMA(ABS(CLOSE-LC),N1,1)*100;
    RSI2:SMA(MAX(CLOSE-LC,0),N2,1)/SMA(ABS(CLOSE-LC),N2,1)*100;
    RSI3:SMA(MAX(CLOSE-LC,0),N3,1)/SMA(ABS(CLOSE-LC),N3,1)*100;
*/

function RSIIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('RSI');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("RSI1", 6),
    new IndexInfo("RSI2", 12),
    new IndexInfo("RSI3", 24)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[2];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var closeData2 = HQIndexFormula.REF(closeData, 1);
    var closeMax = HQIndexFormula.MAX(HQIndexFormula.ARRAY_SUBTRACT(closeData, closeData2), 0);
    var closeAbs = HQIndexFormula.ABS(HQIndexFormula.ARRAY_SUBTRACT(closeData, closeData2));

    for (var i in paint) {
      var data1 = HQIndexFormula.SMA(closeMax, this.Index[i].Param, 1);
      var data2 = HQIndexFormula.SMA(closeAbs, this.Index[i].Param, 1);
      paint[i].Data.Data = HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.ARRAY_DIVIDE(data1, data2), 100);
    }

    //设置动态标题
    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "RSI(" + this.Index[0].Param + "," + this.Index[1].Param + "," + this.Index[2].Param + ")";

    return true;
  }
}


/*
    BRAR 情绪指标
    BR:SUM(MAX(0,HIGH-REF(CLOSE,1)),N)/SUM(MAX(0,REF(CLOSE,1)-LOW),N)*100;
    AR:SUM(HIGH-OPEN,N)/SUM(OPEN-LOW,N)*100;
*/
function BRARIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('BRAR');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("BR", 26),
    new IndexInfo("AR", null)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];


  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var close1Data = HQIndexFormula.REF(closeData, 1);
    var highData = hisData.GetHigh();
    var lowData = hisData.GetLow();
    var openData = hisData.GetOpen();

    //BR:SUM(MAX(0,HIGH-REF(CLOSE,1)),N)/SUM(MAX(0,REF(CLOSE,1)-LOW),N)*100;
    var tempData = HQIndexFormula.SUM(HQIndexFormula.MAX(HQIndexFormula.ARRAY_SUBTRACT(highData, close1Data), 0), this.Index[0].Param);
    var tempData2 = HQIndexFormula.SUM(HQIndexFormula.MAX(HQIndexFormula.ARRAY_SUBTRACT(close1Data, lowData), 0), this.Index[0].Param);
    var tempData3 = [];
    for (var i in tempData2) {
      tempData3[i] = tempData[i] / tempData2[i] * 100;
    }

    paint[0].Data.Data = tempData3;

    //SUM(HIGH-OPEN,N)/SUM(OPEN-LOW,N)*100;
    tempData = HQIndexFormula.SUM(HQIndexFormula.ARRAY_SUBTRACT(highData, openData), this.Index[0].Param);
    tempData2 = HQIndexFormula.SUM(HQIndexFormula.ARRAY_SUBTRACT(openData, lowData), this.Index[0].Param);
    tempData3 = [];
    for (var i in tempData2) {
      tempData3[i] = tempData[i] / tempData2[i] * 100;
    }
    paint[1].Data.Data = tempData3;


    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "BRAR(" + this.Index[0].Param + ")";
    return true;
  }
}

/*
    WR 威廉指标
    WR1:100*(HHV(HIGH,N)-CLOSE)/(HHV(HIGH,N)-LLV(LOW,N));
    WR2:100*(HHV(HIGH,N1)-CLOSE)/(HHV(HIGH,N1)-LLV(LOW,N1));
*/
function WRIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('WR');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("WR1", 10),
    new IndexInfo("WR2", 6)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var highData = hisData.GetHigh();
    var lowData = hisData.GetLow();

    //WR1:100*(HHV(HIGH,N)-CLOSE)/(HHV(HIGH,N)-LLV(LOW,N));
    var tempData = HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.HHV(highData, this.Index[0].Param), closeData);
    var tempData2 = HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.HHV(highData, this.Index[0].Param), HQIndexFormula.LLV(lowData, this.Index[0].Param));
    var tempData3 = HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.ARRAY_DIVIDE(tempData, tempData2), 100);

    paint[0].Data.Data = tempData3;

    //WR2:100*(HHV(HIGH,N1)-CLOSE)/(HHV(HIGH,N1)-LLV(LOW,N1));
    var tempData = HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.HHV(highData, this.Index[1].Param), closeData);
    var tempData2 = HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.HHV(highData, this.Index[1].Param), HQIndexFormula.LLV(lowData, this.Index[1].Param));
    var tempData3 = HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.ARRAY_DIVIDE(tempData, tempData2), 100);
    paint[1].Data.Data = tempData3;


    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "WR(" + this.Index[0].Param + "," + this.Index[1].Param + ")";
    return true;
  }
}


/*
    OBV 累积能量线
    VA:=IF(CLOSE>REF(CLOSE,1),VOL,-VOL);
    OBV:SUM(IF(CLOSE=REF(CLOSE,1),0,VA),0);
    MAOBV:MA(OBV,M);
*/
function OBVIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('OBV');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("OBV", 30),
    new IndexInfo("MAOBV", null)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var close1Data = HQIndexFormula.REF(closeData, 1);
    var volData = hisData.GetVol();
    var vol2Data = HQIndexFormula.ARRAY_MULTIPLY(volData, -1); //负数成交量

    //VA:=IF(CLOSE>REF(CLOSE,1),VOL,-VOL);
    var tempData = HQIndexFormula.ARRAY_IF(HQIndexFormula.ARRAY_GT(closeData, close1Data), volData, vol2Data);

    //OBV:SUM(IF(CLOSE=REF(CLOSE,1),0,VA),0);
    var tempData2 = HQIndexFormula.SUM(HQIndexFormula.ARRAY_IF(HQIndexFormula.ARRAY_EQ(closeData, close1Data), 0, tempData), 0);
    paint[0].Data.Data = tempData2;

    //MAOBV:MA(OBV,M);
    var tempData3 = HQIndexFormula.MA(tempData2, this.Index[0].Param);

    paint[1].Data.Data = tempData3;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 3;
      hqChart.TitlePaint[titleIndex].Data[i].StringFormat = STRING_FORMAT_TYPE.THOUSANDS;
    }

    hqChart.TitlePaint[titleIndex].Title = "OBV(" + this.Index[0].Param + ")";
    return true;
  }
}


/*
    BIAS 乖离率
    BIAS1 :(CLOSE-MA(CLOSE,N1))/MA(CLOSE,N1)*100;
    BIAS2 :(CLOSE-MA(CLOSE,N2))/MA(CLOSE,N2)*100;
    BIAS3 :(CLOSE-MA(CLOSE,N3))/MA(CLOSE,N3)*100;
*/
function BIASIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('OBV');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("BIAS1", 6),
    new IndexInfo("BIAS2", 12),
    new IndexInfo("BIAS3", 24)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[2];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();

    for (var i in this.Index) {
      var closeMAdata = HQIndexFormula.MA(closeData, this.Index[i].Param);
      var data = HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.ARRAY_DIVIDE(HQIndexFormula.ARRAY_SUBTRACT(closeData, closeMAdata), closeMAdata), 100);
      paint[i].Data.Data = data;
    }

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "BIAS(" + this.Index[0].Param + ',' + this.Index[1].Param + ',' + this.Index[2].Param + ")";
    return true;
  }
}

/*
    DMI 趋向指标
    MTR:EXPMEMA(MAX(MAX(HIGH-LOW,ABS(HIGH-REF(CLOSE,1))),ABS(REF(CLOSE,1)-LOW)),N);
    HD :=HIGH-REF(HIGH,1);
    LD :=REF(LOW,1)-LOW;
    DMP:=EXPMEMA(IF(HD>0&&HD>LD,HD,0),N);
    DMM:=EXPMEMA(IF(LD>0&&LD>HD,LD,0),N);
    PDI: DMP*100/MTR;
    MDI: DMM*100/MTR;
    ADX: EXPMEMA(ABS(MDI-PDI)/(MDI+PDI)*100,MM);
    ADXR:EXPMEMA(ADX,MM);
*/
function DMIIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('DMI');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("PDI", 14),
    new IndexInfo("MDI", 6),
    new IndexInfo("ADX", null),
    new IndexInfo("ADXR", null)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[2];
  this.Index[3].LineColor = g_JSChartResource.Index.LineColor[3];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var highData = hisData.GetHigh();
    var lowData = hisData.GetLow();

    // MTR:EXPMEMA(MAX(MAX(HIGH-LOW,ABS(HIGH-REF(CLOSE,1))),ABS(REF(CLOSE,1)-LOW)),N);
    var MTRData = HQIndexFormula.MA(
      HQIndexFormula.MAX(
        HQIndexFormula.MAX(
          HQIndexFormula.ARRAY_SUBTRACT(highData, lowData),
          HQIndexFormula.ABS(HQIndexFormula.ARRAY_SUBTRACT(highData, HQIndexFormula.REF(closeData, 1)))),
        HQIndexFormula.ABS(HQIndexFormula.ARRAY_SUBTRACT(lowData, HQIndexFormula.REF(closeData, 1)))),
      this.Index[0].Param);

    //HD := HIGH-REF(HIGH,1);
    var HDData = HQIndexFormula.ARRAY_SUBTRACT(highData, HQIndexFormula.REF(highData, 1));
    //LD := REF(LOW,1)-LOW;
    var LDData = HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.REF(lowData, 1), lowData);
    //DMP:=EXPMEMA(IF(HD>0&&HD>LD,HD,0),N);
    var DMPData = HQIndexFormula.MA(
      HQIndexFormula.ARRAY_IF(
        HQIndexFormula.ARRAY_AND(HQIndexFormula.ARRAY_GT(HDData, 0), HQIndexFormula.ARRAY_GT(HDData, LDData))
        , HDData, 0)
      , this.Index[0].Param);
    //DMM:=EXPMEMA(IF(LD>0&&LD>HD,LD,0),N);
    var DMMData = HQIndexFormula.MA(
      HQIndexFormula.ARRAY_IF(
        HQIndexFormula.ARRAY_AND(HQIndexFormula.ARRAY_GT(LDData, 0), HQIndexFormula.ARRAY_GT(LDData, HDData))
        , LDData, 0)
      , this.Index[0].Param);

    //PDI: DMP*100/MTR;
    var PDIData = HQIndexFormula.ARRAY_DIVIDE(HQIndexFormula.ARRAY_MULTIPLY(DMPData, 100), MTRData);
    //MDI: DMM*100/MTR;
    var MDIData = HQIndexFormula.ARRAY_DIVIDE(HQIndexFormula.ARRAY_MULTIPLY(DMMData, 100), MTRData);
    //ADX: EXPMEMA(ABS(MDI-PDI)/(MDI+PDI)*100,MM);
    var ADXData = HQIndexFormula.MA(
      HQIndexFormula.ARRAY_MULTIPLY(
        HQIndexFormula.ARRAY_DIVIDE(
          HQIndexFormula.ABS(HQIndexFormula.ARRAY_SUBTRACT(MDIData, PDIData)), HQIndexFormula.ARRAY_ADD(MDIData, PDIData)
        ), 100),
      this.Index[1].Param);
    //ADXR:EXPMEMA(ADX,MM);
    var ADXRData = HQIndexFormula.MA(ADXData, this.Index[1].Param);

    paint[0].Data.Data = PDIData;
    paint[1].Data.Data = MDIData;
    paint[2].Data.Data = ADXData;
    paint[3].Data.Data = ADXRData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "DMI(" + this.Index[0].Param + ',' + this.Index[1].Param + ")";
    return true;
  }
}

/*
    CR 带状能量线
    MID:=REF(HIGH+LOW,1)/2;
    CR:SUM(MAX(0,HIGH-MID),N)/SUM(MAX(0,MID-LOW),N)*100;
    MA1:REF(MA(CR,M1),M1/2.5+1);
    MA2:REF(MA(CR,M2),M2/2.5+1);
    MA3:REF(MA(CR,M3),M3/2.5+1);
    MA4:REF(MA(CR,M4),M4/2.5+1);
*/
function CRIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('CR');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("CR", 26),
    new IndexInfo("MA1", 10),
    new IndexInfo("MA2", 20),
    new IndexInfo("MA3", 40),
    new IndexInfo("MA4", 62)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[2];
  this.Index[3].LineColor = g_JSChartResource.Index.LineColor[3];
  this.Index[4].LineColor = g_JSChartResource.Index.LineColor[4];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var highData = hisData.GetHigh();
    var lowData = hisData.GetLow();

    //MID:=REF(HIGH+LOW,1)/2;
    var MDIData = HQIndexFormula.ARRAY_DIVIDE(HQIndexFormula.REF(HQIndexFormula.ARRAY_ADD(highData, lowData), 1), 2);
    //CR:SUM(MAX(0,HIGH-MID),N)/SUM(MAX(0,MID-LOW),N)*100;
    var CRData = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.SUM(
          HQIndexFormula.MAX(HQIndexFormula.ARRAY_SUBTRACT(highData, MDIData), 0), this.Index[0].Param),
        HQIndexFormula.SUM(
          HQIndexFormula.MAX(HQIndexFormula.ARRAY_SUBTRACT(MDIData, lowData), 0), this.Index[0].Param))
      , 100);
    //MA1:REF(MA(CR,M1),M1/2.5+1);
    var MA1Data = HQIndexFormula.REF(HQIndexFormula.MA(CRData, this.Index[1].Param), parseInt(this.Index[1].Param / 2.5 + 1));
    //MA2:REF(MA(CR,M2),M2/2.5+1);
    var MA2Data = HQIndexFormula.REF(HQIndexFormula.MA(CRData, this.Index[2].Param), parseInt(this.Index[2].Param / 2.5 + 1));
    //MA3:REF(MA(CR,M3),M3/2.5+1);
    var MA3Data = HQIndexFormula.REF(HQIndexFormula.MA(CRData, this.Index[3].Param), parseInt(this.Index[3].Param / 2.5 + 1));
    //MA4:REF(MA(CR,M4),M4/2.5+1);
    var MA4Data = HQIndexFormula.REF(HQIndexFormula.MA(CRData, this.Index[4].Param), parseInt(this.Index[4].Param / 2.5 + 1));


    paint[0].Data.Data = CRData;
    paint[1].Data.Data = MA1Data;
    paint[2].Data.Data = MA2Data;
    paint[3].Data.Data = MA3Data;
    paint[4].Data.Data = MA4Data;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "CR(" + this.Index[0].Param + ',' + this.Index[1].Param + ',' + this.Index[2].Param + ")";
    return true;
  }
}


/*
    BOLL 布林线 (主线数据)
    BOLL:MA(CLOSE,N);
    UPPER:BOLL+M*STD(CLOSE,N);
    LOWER:BOLL-M*STD(CLOSE,N);
*/
function BOLLIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('BOLL');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("BOLL", 20),
    new IndexInfo("UPPER", 2),
    new IndexInfo("LOWER", null)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[2];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();

    //BOLL:MA(CLOSE,N);
    var BOLLData = HQIndexFormula.MA(closeData, this.Index[0].Param);
    //UPPER:BOLL+M*STD(CLOSE,N);
    var UPPERData = HQIndexFormula.ARRAY_ADD(
      BOLLData,
      HQIndexFormula.ARRAY_MULTIPLY(
        HQIndexFormula.STD(closeData, this.Index[0].Param),
        this.Index[1].Param)
    );
    //LOWER:BOLL-M*STD(CLOSE,N);
    var LOWERData = HQIndexFormula.ARRAY_SUBTRACT(
      BOLLData,
      HQIndexFormula.ARRAY_MULTIPLY(
        HQIndexFormula.STD(closeData, this.Index[0].Param),
        this.Index[1].Param)
    );

    paint[0].Data.Data = BOLLData;
    paint[1].Data.Data = UPPERData;
    paint[2].Data.Data = LOWERData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "BOLL(" + this.Index[0].Param + ',' + this.Index[1].Param + ")";
    return true;
  }
}

/*
    BOLL 布林线 (附图)
    BOLL:MA(CLOSE,N);
    UPPER:BOLL+M*STD(CLOSE,N);
    LOWER:BOLL-M*STD(CLOSE,N);
*/
function BOLL2Index() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('BOLL');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("BOLL", 20),
    new IndexInfo("UPPER", 2),
    new IndexInfo("LOWER", null)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[2];

  this.Create = function (hqChart, windowIndex) {
    var paint = new ChartKLine2();
    paint.Name = this.Name + "-KLine2";
    paint.Canvas = hqChart.Canvas;
    paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
    paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;
    hqChart.ChartPaint.push(paint);

    for (var i in this.Index) {
      var paint = null;
      paint = new ChartLine();
      paint.Color = this.Index[i].LineColor;
      paint.Canvas = hqChart.Canvas;
      paint.Name = this.Name + "-" + i.toString();
      paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
      paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;

      hqChart.ChartPaint.push(paint);
    }
  }

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != 4) return false;

    var closeData = hisData.GetClose();

    //BOLL:MA(CLOSE,N);
    var BOLLData = HQIndexFormula.MA(closeData, this.Index[0].Param);
    //UPPER:BOLL+M*STD(CLOSE,N);
    var UPPERData = HQIndexFormula.ARRAY_ADD(
      BOLLData,
      HQIndexFormula.ARRAY_MULTIPLY(
        HQIndexFormula.STD(closeData, this.Index[0].Param),
        this.Index[1].Param)
    );
    //LOWER:BOLL-M*STD(CLOSE,N);
    var LOWERData = HQIndexFormula.ARRAY_SUBTRACT(
      BOLLData,
      HQIndexFormula.ARRAY_MULTIPLY(
        HQIndexFormula.STD(closeData, this.Index[0].Param),
        this.Index[1].Param)
    );

    paint[0].Data = hisData;
    paint[1].Data.Data = BOLLData;
    paint[2].Data.Data = UPPERData;
    paint[3].Data.Data = LOWERData;

    var titleIndex = windowIndex + 1;
    var aryPaint = [paint[1], paint[2], paint[3]];

    for (var i in aryPaint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(aryPaint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();

    return true;
  }
}

/*
    PSY 心理线
    PSY:COUNT(CLOSE>REF(CLOSE,1),N)/N*100;
    PSYMA:MA(PSY,M);
*/
function PSYIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('PSY');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("PSY", 12),
    new IndexInfo("PSYMA", 6)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var close1Data = HQIndexFormula.REF(closeData, 1);


    var test1 = HQIndexFormula.COUNT(
      HQIndexFormula.ARRAY_GT(closeData, close1Data),
      this.Index[0].Param);
    var test2 = HQIndexFormula.ARRAY_GT(closeData, close1Data);


    //PSY:COUNT(CLOSE>REF(CLOSE,1),N)/N*100;
    var PSYData = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.COUNT(
          HQIndexFormula.ARRAY_GT(closeData, HQIndexFormula.REF(closeData, 1)),
          this.Index[0].Param),
        this.Index[0].Param),
      100);

    //PSYMA:MA(PSY,M);
    var PSYMAData = HQIndexFormula.MA(PSYData, this.Index[1].Param);

    paint[0].Data.Data = PSYData;
    paint[1].Data.Data = PSYMAData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "PSY(" + this.Index[0].Param + ',' + this.Index[1].Param + ")";
    return true;
  }
}

/*
    CCI 商品路径指标
    TYP:=(HIGH+LOW+CLOSE)/3;
    CCI:(TYP-MA(TYP,N))/(0.015*AVEDEV(TYP,N));
*/
function CCIIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('CCI');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("CCI", 14)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var highData = hisData.GetHigh();
    var lowData = hisData.GetLow();

    //TYP:=(HIGH+LOW+CLOSE)/3;
    var TYPData = HQIndexFormula.ARRAY_DIVIDE(
      HQIndexFormula.ARRAY_ADD(HQIndexFormula.ARRAY_ADD(highData, lowData), closeData), 3);

    //CCI:(TYP-MA(TYP,N))/(0.015*AVEDEV(TYP,N));
    var CCIData = HQIndexFormula.ARRAY_DIVIDE(
      HQIndexFormula.ARRAY_SUBTRACT(TYPData, HQIndexFormula.MA(TYPData, this.Index[0].Param)),
      HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.AVEDEV(TYPData, this.Index[0].Param), 0.015)
    );

    paint[0].Data.Data = CCIData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "CCI(" + this.Index[0].Param + ")";
    return true;
  }
}


/*
    DMA 平均差
    DIF:MA(CLOSE,N1)-MA(CLOSE,N2);
    DIFMA:MA(DIF,M);
*/
function DMAIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('DMA');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("DIF", 10),
    new IndexInfo("DIFMA", 50),
    new IndexInfo(null, 10)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != 2) return false;

    var closeData = hisData.GetClose();

    //DIF:MA(CLOSE,N1)-MA(CLOSE,N2);
    var DIFData = HQIndexFormula.ARRAY_SUBTRACT(
      HQIndexFormula.MA(closeData, this.Index[0].Param),
      HQIndexFormula.MA(closeData, this.Index[1].Param)
    );

    //DIFMA:MA(DIF,M);
    var DIFMAData = HQIndexFormula.MA(DIFData, this.Index[2].Param);

    paint[0].Data.Data = DIFData;
    paint[1].Data.Data = DIFMAData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "DMA(" + this.Index[0].Param + ',' + this.Index[1].Param + ',' + this.Index[2].Param + ")";
    return true;
  }
}

/*
    TRIX 三重指数平均线
    MTR:=EMA(EMA(EMA(CLOSE,N),N),N);
    TRIX:(MTR-REF(MTR,1))/REF(MTR,1)*100;
    MATRIX:MA(TRIX,M) ;
*/
function TRIXIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('TRIX');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("TRIX", 12),
    new IndexInfo("MATRIX", 9)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();

    //MTR:=EMA(EMA(EMA(CLOSE,N),N),N);
    var MTRData = HQIndexFormula.EMA(
      HQIndexFormula.EMA(
        HQIndexFormula.EMA(closeData, this.Index[0].Param),
        this.Index[0].Param),
      this.Index[0].Param);

    //TRIX:(MTR-REF(MTR,1))/REF(MTR,1)*100;
    var TRIXData = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.ARRAY_SUBTRACT(MTRData, HQIndexFormula.REF(MTRData, 1)),
        HQIndexFormula.REF(MTRData, 1)),
      100
    );

    //MATRIX:MA(TRIX,M) ;
    var MATRIXData = HQIndexFormula.MA(TRIXData, this.Index[1].Param);

    paint[0].Data.Data = TRIXData;
    paint[1].Data.Data = MATRIXData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "TRIX(" + this.Index[0].Param + ',' + this.Index[1].Param + ")";
    return true;
  }
}

/*
    VR 成交量变异率
    TH:=SUM(IF(CLOSE>REF(CLOSE,1),VOL,0),N);
    TL:=SUM(IF(CLOSE<REF(CLOSE,1),VOL,0),N);
    TQ:=SUM(IF(CLOSE=REF(CLOSE,1),VOL,0),N);
    VR:100*(TH*2+TQ)/(TL*2+TQ);
    MAVR:MA(VR,M);
*/
function VRIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('VR');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("VR", 26),
    new IndexInfo("MAVR", 6)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var volData = hisData.GetVol();
    //TH:=SUM(IF(CLOSE>REF(CLOSE,1),VOL,0),N);
    var THData = HQIndexFormula.SUM(
      HQIndexFormula.ARRAY_IF(
        HQIndexFormula.ARRAY_GT(closeData, HQIndexFormula.REF(closeData, 1)), volData, 0), this.Index[0].Param);

    //TL:=SUM(IF(CLOSE<REF(CLOSE,1),VOL,0),N);
    var TLData = HQIndexFormula.SUM(
      HQIndexFormula.ARRAY_IF(
        HQIndexFormula.ARRAY_LT(closeData, HQIndexFormula.REF(closeData, 1)), volData, 0), this.Index[0].Param);

    //TQ:=SUM(IF(CLOSE=REF(CLOSE,1),VOL,0),N);
    var TQData = HQIndexFormula.SUM(
      HQIndexFormula.ARRAY_IF(
        HQIndexFormula.ARRAY_EQ(closeData, HQIndexFormula.REF(closeData, 1)), volData, 0), this.Index[0].Param);


    //VR:100*(TH*2+TQ)/(TL*2+TQ);
    var VRData = HQIndexFormula.ARRAY_DIVIDE(
      HQIndexFormula.ARRAY_MULTIPLY(
        HQIndexFormula.ARRAY_ADD(HQIndexFormula.ARRAY_MULTIPLY(THData, 2), TQData)
        , 100),
      HQIndexFormula.ARRAY_ADD(HQIndexFormula.ARRAY_MULTIPLY(TLData, 2), TQData));


    //MAVR:MA(VR,M);
    var MAVRData = HQIndexFormula.MA(VRData, this.Index[1].Param);

    paint[0].Data.Data = VRData;
    paint[1].Data.Data = MAVRData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "VR(" + this.Index[0].Param + ',' + this.Index[1].Param + ")";
    return true;
  }
}

/*
    EMV 简易波动指标
    VOLUME:=MA(VOL,N)/VOL;
    MID:=100*(HIGH+LOW-REF(HIGH+LOW,1))/(HIGH+LOW);
    EMV:MA(MID*VOLUME*(HIGH-LOW)/MA(HIGH-LOW,N),N);
    MAEMV:MA(EMV,M);
*/
function EMVIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('EMV');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("EMV", 14),
    new IndexInfo("MAEMV", 9)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var highData = hisData.GetHigh();
    var lowData = hisData.GetLow();
    var volData = hisData.GetVol();

    //HIGH-LOW
    var highSublowData = HQIndexFormula.ARRAY_SUBTRACT(highData, lowData);
    //HIGH+LOW
    var highAddlowData = HQIndexFormula.ARRAY_ADD(highData, lowData);


    //VOLUME:=MA(VOL,N)/VOL;
    var VOLUMEData = HQIndexFormula.ARRAY_DIVIDE(HQIndexFormula.MA(volData, this.Index[0].Param), volData);
    //MID:=100*(HIGH+LOW-REF(HIGH+LOW,1))/(HIGH+LOW);
    var MIDData = HQIndexFormula.ARRAY_DIVIDE(
      HQIndexFormula.ARRAY_MULTIPLY(
        HQIndexFormula.ARRAY_SUBTRACT(highAddlowData, HQIndexFormula.REF(highAddlowData, 1))
        , 100),
      highAddlowData
    );

    //EMV:MA(MID*VOLUME*(HIGH-LOW)/MA(HIGH-LOW,N),N);
    var EMVData = HQIndexFormula.MA(
      HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.ARRAY_MULTIPLY(MIDData, VOLUMEData), highSublowData),
        HQIndexFormula.MA(highSublowData, this.Index[0].Param)
      ),
      this.Index[0].Param);

    //MAEMV:MA(EMV,M);
    var MAEMVData = HQIndexFormula.MA(EMVData, this.Index[1].Param)

    paint[0].Data.Data = EMVData;
    paint[1].Data.Data = MAEMVData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "EMV(" + this.Index[0].Param + ',' + this.Index[1].Param + ")";
    return true;
  }
}


/*
    ROC 变动率指标
    ROC:100*(CLOSE-REF(CLOSE,N))/REF(CLOSE,N);
    MAROC:MA(ROC,M);
*/
function ROCIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('ROC');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("ROC", 12),
    new IndexInfo("MAROC", 6)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();

    //ROC:100*(CLOSE-REF(CLOSE,N))/REF(CLOSE,N);
    var ROCData = HQIndexFormula.ARRAY_DIVIDE(
      HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.ARRAY_SUBTRACT(closeData, HQIndexFormula.REF(closeData, this.Index[0].Param)), 100),
      HQIndexFormula.REF(closeData, this.Index[0].Param)
    );

    //MAROC:MA(ROC,M);
    var MAROCData = HQIndexFormula.MA(ROCData, this.Index[1].Param);

    paint[0].Data.Data = ROCData;
    paint[1].Data.Data = MAROCData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "EMV(" + this.Index[0].Param + ',' + this.Index[1].Param + ")";
    return true;
  }
}


/*
    MTM 动量线
    MTM:CLOSE-REF(CLOSE,N);
    MTMMA:MA(MTM,M);
*/
function MTMIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('MTM');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("MTM", 12),
    new IndexInfo("MTMMA", 6)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();

    //MTM:CLOSE-REF(CLOSE,N);
    var MTMData = HQIndexFormula.ARRAY_SUBTRACT(closeData, HQIndexFormula.REF(closeData, this.Index[0].Param));
    //MTMMA:MA(MTM,M);
    var MTMMAData = HQIndexFormula.MA(MTMData, this.Index[1].Param);

    paint[0].Data.Data = MTMData;
    paint[1].Data.Data = MTMMAData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "MTM(" + this.Index[0].Param + ',' + this.Index[1].Param + ")";
    return true;
  }
}


/*
    FSL 分水岭
    SWL:(EMA(CLOSE,5)*7+EMA(CLOSE,10)*3)/10;
    SWS:DMA(EMA(CLOSE,12),MAX(1,100*(SUM(VOL,5)/(3*CAPITAL))));
*/
function FSLIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('FSL');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("SWL", null),
    new IndexInfo("SWS", null)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.FlowEquity;    //流通股本

  //请求数据
  this.RequestData = function (hqChart, windowIndex, hisData) {
    var self = this;
    var param =
      {
        HQChart: hqChart,
        WindowIndex: windowIndex,
        HistoryData: hisData
      };

    this.FlowEquity = [];

    //请求数据
    $.ajax({
      url: g_JSChartResource.Index.StockHistoryDayApiUrl,
      data:
        {
          "field": ["name", "date", "symbol", "folwequity"],
          "symbol": [param.HQChart.Symbol],
        },
      type: "post",
      dataType: "json",
      async: true,
      success: function (recvData) {
        self.RecvData(recvData, param);
      }
    });

    return true;
  }

  this.RecvData = function (recvData, param) {
    this.FlowEquity = [];

    if (recvData.stock.length < 0) return;

    var aryData = new Array();
    for (var i in recvData.stock[0].stockday) {
      var item = recvData.stock[0].stockday[i];
      var indexData = new SingleData();
      indexData.Date = item.date;
      indexData.Value = item.folwequity;
      aryData.push(indexData);
    }

    var aryFlowEquity = param.HistoryData.GetFittingData(aryData);

    var bindData = new ChartData();
    bindData.Data = aryFlowEquity;
    bindData.Period = param.HQChart.Period;   //周期
    bindData.Right = param.HQChart.Right;     //复权

    if (bindData.Period > 0)   //周期数据
    {
      var periodData = bindData.GetPeriodSingleData(bindData.Period);
      bindData.Data = periodData;
    }

    this.FlowEquity = bindData.GetValue();
    this.BindData(param.HQChart, param.WindowIndex, param.HistoryData);

    param.HQChart.UpdataDataoffset();           //更新数据偏移
    param.HQChart.UpdateFrameMaxMin();          //调整坐标最大 最小值
    param.HQChart.Draw();
  }


  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var volData = hisData.GetVol();

    //SWL:(EMA(CLOSE,5)*7+EMA(CLOSE,10)*3)/10;
    var SWLData = HQIndexFormula.ARRAY_DIVIDE(
      HQIndexFormula.ARRAY_ADD(
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.EMA(closeData, 5), 7),
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.EMA(closeData, 10), 3)
      ),
      10);


    //SWS:DMA(EMA(CLOSE,12),MAX(1,100*(SUM(VOL,5)/(3*CAPITAL))));
    var volSumData = HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.SUM(volData, 5), 100);
    var tempData = HQIndexFormula.ARRAY_MULTIPLY(this.FlowEquity, 3);
    var MaxData = HQIndexFormula.MAX(
      HQIndexFormula.ARRAY_DIVIDE(volSumData, tempData),
      1);
    var EmaData = HQIndexFormula.EMA(closeData, 12);

    var SWSData = HQIndexFormula.DMA(EmaData, MaxData);

    paint[0].Data.Data = SWLData;
    paint[1].Data.Data = SWSData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    CYR 市场强弱
    DIVE:=0.01*EXPMA(AMOUNT,N)/EXPMA(VOL,N);
    CYR:(DIVE/REF(DIVE,1)-1)*100;
    MACYR:MA(CYR,M);
*/
function CYRIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('CYR');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("CYR", 13),
    new IndexInfo("MACYR", 5)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var volData = hisData.GetVol();
    var amountData = hisData.GetAmount();

    //DIVE:=0.01*EXPMA(AMOUNT,N)/EXPMA(VOL,N);
    var DIVEData = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.EXPMA(amountData, this.Index[0].Param),
        HQIndexFormula.EXPMA(volData, this.Index[0].Param)),
      0.01);
    //CYR:(DIVE/REF(DIVE,1)-1)*100;
    var CRYData = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_SUBTRACT(
        HQIndexFormula.ARRAY_DIVIDE(DIVEData, HQIndexFormula.REF(DIVEData, 1)),
        1),
      100);
    //MACYR:MA(CYR,M);
    var MACYRData = HQIndexFormula.MA(CRYData, this.Index[1].Param);


    paint[0].Data.Data = CRYData;
    paint[1].Data.Data = MACYRData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = "CYR(" + this.Index[0].Param + ',' + this.Index[1].Param + ")";
    return true;
  }
}

/*
    MASS 梅斯线
    MASS:SUM(MA(HIGH-LOW,N1)/MA(MA(HIGH-LOW,N1),N1),N2);
    MAMASS:MA(MASS,M);
*/
function MASSIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('MASS');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("MASS", 9),
    new IndexInfo("MAMASS", 25),
    new IndexInfo(null, 6)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != 2) return false;

    var highData = hisData.GetHigh();
    var lowData = hisData.GetLow();

    //MASS:SUM(MA(HIGH-LOW,N1)/MA(MA(HIGH-LOW,N1),N1),N2);
    var MASSData = HQIndexFormula.SUM(
      HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.MA(HQIndexFormula.ARRAY_SUBTRACT(highData, lowData), this.Index[0].Param),
        HQIndexFormula.MA(HQIndexFormula.MA(HQIndexFormula.ARRAY_SUBTRACT(highData, lowData), this.Index[0].Param), this.Index[0].Param)
      ),
      this.Index[1].Param
    );

    //MAMASS:MA(MASS,M)
    var MAMASS = HQIndexFormula.MA(MASSData, this.Index[2].Param);

    paint[0].Data.Data = MASSData;
    paint[1].Data.Data = MAMASS;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    WAD 威廉多空力度线
    MIDA:=CLOSE-MIN(REF(CLOSE,1),LOW);
    MIDB:=IF(CLOSE<REF(CLOSE,1),CLOSE-MAX(REF(CLOSE,1),HIGH),0);
    WAD:SUM(IF(CLOSE>REF(CLOSE,1),MIDA,MIDB),0);
    MAWAD:MA(WAD,M);
*/
function WADIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('WAD');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("WAD", 30),
    new IndexInfo("MAWAD", null)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != 2) return false;

    var closeData = hisData.GetClose();
    var lowData = hisData.GetLow();
    var highData = hisData.GetHigh();
    var close1Data = HQIndexFormula.REF(closeData, 1);

    //MIDA:=CLOSE-MIN(REF(CLOSE,1),LOW);
    var MIDAData = HQIndexFormula.ARRAY_SUBTRACT(closeData, HQIndexFormula.MIN(close1Data, lowData));

    //MIDB:=IF(CLOSE<REF(CLOSE,1),CLOSE-MAX(REF(CLOSE,1),HIGH),0);
    var MIDBData = HQIndexFormula.ARRAY_IF(
      HQIndexFormula.ARRAY_LT(closeData, close1Data),
      HQIndexFormula.ARRAY_SUBTRACT(closeData, HQIndexFormula.MAX(close1Data, highData)),
      0);

    //WAD:SUM(IF(CLOSE>REF(CLOSE,1),MIDA,MIDB),0);
    var WADData = HQIndexFormula.SUM(
      HQIndexFormula.ARRAY_IF(
        HQIndexFormula.ARRAY_GT(closeData, close1Data),
        MIDAData,
        MIDBData
      ),
      0);

    //MAWAD:MA(WAD,M);
    var MAWADData = HQIndexFormula.MA(WADData, this.Index[0].Param);

    paint[0].Data.Data = WADData;
    paint[1].Data.Data = MAWADData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    CHO 济坚指数
    MID:=SUM(VOL*(2*CLOSE-HIGH-LOW)/(HIGH+LOW),0);
    CHO:MA(MID,N1)-MA(MID,N2);
    MACHO:MA(CHO,M);
*/
function CHOIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('CHO');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("CHO", 10),
    new IndexInfo("MACHO", 20),
    new IndexInfo(null, 6)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != 2) return false;

    var closeData = hisData.GetClose();
    var lowData = hisData.GetLow();
    var highData = hisData.GetHigh();
    var volData = hisData.GetVol();

    //MID:=SUM(VOL*(2*CLOSE-HIGH-LOW)/(HIGH+LOW),0);
    var MIDData = HQIndexFormula.SUM(
      HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.ARRAY_MULTIPLY(
          volData,
          HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.ARRAY_MULTIPLY(closeData, 2), highData), lowData)
        ),
        HQIndexFormula.ARRAY_ADD(highData, lowData)),
      0)
    //CHO:MA(MID,N1)-MA(MID,N2);
    var CHOData = HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.MA(MIDData, this.Index[0].Param), HQIndexFormula.MA(MIDData, this.Index[1].Param));

    //MACHO:MA(CHO,M);
    var MACHOData = HQIndexFormula.MA(CHOData, this.Index[2].Param);



    paint[0].Data.Data = CHOData;
    paint[1].Data.Data = MACHOData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    ADTM 动态买卖气指标
    DTM:=IF(OPEN<=REF(OPEN,1),0,MAX((HIGH-OPEN),(OPEN-REF(OPEN,1))));
    DBM:=IF(OPEN>=REF(OPEN,1),0,MAX((OPEN-LOW),(OPEN-REF(OPEN,1))));
    STM:=SUM(DTM,N);
    SBM:=SUM(DBM,N);
    ADTM:IF(STM>SBM,(STM-SBM)/STM,IF(STM=SBM,0,(STM-SBM)/SBM));
    MAADTM:MA(ADTM,M);
*/
function ADTMIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('ADTM');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("ADTM", 23),
    new IndexInfo("MAADTM", 8)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != 2) return false;

    var closeData = hisData.GetClose();
    var openData = hisData.GetOpen();
    var openRef1Data = HQIndexFormula.REF(openData, 1);
    var lowData = hisData.GetLow();
    var highData = hisData.GetHigh();

    //DTM:=IF(OPEN<=REF(OPEN,1),0,MAX((HIGH-OPEN),(OPEN-REF(OPEN,1))));
    var DTMData = HQIndexFormula.ARRAY_IF(
      HQIndexFormula.ARRAY_LTE(openData, openRef1Data),
      0,
      HQIndexFormula.MAX(HQIndexFormula.ARRAY_SUBTRACT(highData, openData), HQIndexFormula.ARRAY_SUBTRACT(openData, openRef1Data))
    );

    //DBM:=IF(OPEN>=REF(OPEN,1),0,MAX((OPEN-LOW),(OPEN-REF(OPEN,1))));
    var DBMData = HQIndexFormula.ARRAY_IF(
      HQIndexFormula.ARRAY_GTE(openData, openRef1Data),
      0,
      HQIndexFormula.MAX(HQIndexFormula.ARRAY_SUBTRACT(openData, lowData), HQIndexFormula.ARRAY_SUBTRACT(openData, openRef1Data))
    );

    //STM:=SUM(DTM,N);
    var STMData = HQIndexFormula.SUM(DTMData, this.Index[0].Param);

    //SBM:=SUM(DBM,N);
    var SBMData = HQIndexFormula.SUM(DBMData, this.Index[0].Param);

    //ADTM:IF(STM>SBM,(STM-SBM)/STM,IF(STM=SBM,0,(STM-SBM)/SBM));
    var ADTMData = HQIndexFormula.ARRAY_IF(
      HQIndexFormula.ARRAY_GT(STMData, SBMData),
      HQIndexFormula.ARRAY_DIVIDE(HQIndexFormula.ARRAY_SUBTRACT(STMData, SBMData), STMData),
      HQIndexFormula.ARRAY_IF(
        HQIndexFormula.ARRAY_EQ(STMData, SBMData),
        0,
        HQIndexFormula.ARRAY_DIVIDE(HQIndexFormula.ARRAY_SUBTRACT(STMData, SBMData), SBMData)
      )
    );

    //MAADTM:MA(ADTM,M);
    var MAADTMData = HQIndexFormula.MA(ADTMData, this.Index[1].Param);

    paint[0].Data.Data = ADTMData;
    paint[1].Data.Data = MAADTMData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    BBI 多空指标
    BBI:(MA(CLOSE,M1)+MA(CLOSE,M2)+MA(CLOSE,M3)+MA(CLOSE,M4))/4;
*/
function BBIIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('BBI');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("BBI", 3),
    new IndexInfo(null, 6),
    new IndexInfo(null, 12),
    new IndexInfo(null, 24)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != 1) return false;

    var closeData = hisData.GetClose();

    //BBI:(MA(CLOSE,M1)+MA(CLOSE,M2)+MA(CLOSE,M3)+MA(CLOSE,M4))/4;
    var BBIData = HQIndexFormula.ARRAY_DIVIDE(
      HQIndexFormula.ARRAY_ADD(HQIndexFormula.MA(closeData, this.Index[3].Param),
        HQIndexFormula.ARRAY_ADD(HQIndexFormula.MA(closeData, this.Index[2].Param),
          HQIndexFormula.ARRAY_ADD(HQIndexFormula.MA(closeData, this.Index[0].Param), HQIndexFormula.MA(closeData, this.Index[1].Param)))),
      4);

    paint[0].Data.Data = BBIData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    HSL 换手率
    HSL:100*VOL/CAPITAL;
    MA1:MA(HSL,M1);
    MA2:MA(HSL,M2);
*/
function HSLIndex() {
  this.newMethod = FSLIndex;   //派生
  this.newMethod('HSL');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("HSL", 5),
    new IndexInfo("MA1", 10),
    new IndexInfo("MA2", null)
  );

  this.Name = "HSL";
  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[2];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var volData = hisData.GetVol();

    //HSL:100*VOL/CAPITAL;
    var HSLData = HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.ARRAY_DIVIDE(volData, this.FlowEquity), 100);

    //MA1:MA(HSL,M1);
    var MA1Data = HQIndexFormula.MA(HSLData, this.Index[0].Param);
    //MA2:MA(HSL,M2);
    var MA2Data = HQIndexFormula.MA(HSLData, this.Index[1].Param);


    paint[0].Data.Data = HSLData;
    paint[1].Data.Data = MA1Data;
    paint[2].Data.Data = MA2Data;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 3;
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    BIAS36 三六乖离
    BIAS36:MA(CLOSE,3)-MA(CLOSE,6);
    BIAS612:MA(CLOSE,6)-MA(CLOSE,12);
    MABIAS:MA(BIAS36,M);
*/
function BIAS36Index() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('BIAS36');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("BIAS36", 6),
    new IndexInfo('BIAS612', null),
    new IndexInfo('MABIAS', null)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[2];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();

    //BIAS36:MA(CLOSE,3)-MA(CLOSE,6);
    var BIAS36Data = HQIndexFormula.ARRAY_SUBTRACT(
      HQIndexFormula.MA(closeData, 3),
      HQIndexFormula.MA(closeData, 6)
    );

    //BIAS612:MA(CLOSE,6)-MA(CLOSE,12);
    var BIAS612Data = HQIndexFormula.ARRAY_SUBTRACT(
      HQIndexFormula.MA(closeData, 6),
      HQIndexFormula.MA(closeData, 12)
    );

    //MABIAS:MA(BIAS36,M);
    var MABIASData = HQIndexFormula.MA(BIAS36Data, this.Index[0].Param);


    paint[0].Data.Data = BIAS36Data;
    paint[1].Data.Data = BIAS612Data;
    paint[2].Data.Data = MABIASData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 3;
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    BIAS_QL 乖离率-传统版
    BIAS :(CLOSE-MA(CLOSE,N))/MA(CLOSE,N)*100;
    BIASMA :MA(BIAS,M);
*/
function BIAS_QLIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('BIAS_QL');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("BIAS", 6),
    new IndexInfo('BIASMA', 6)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();

    //BIAS :(CLOSE-MA(CLOSE,N))/MA(CLOSE,N)*100;
    var BIASData = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.ARRAY_SUBTRACT(closeData, HQIndexFormula.MA(closeData, this.Index[0].Param)),
        HQIndexFormula.MA(closeData, this.Index[0].Param)),
      100);


    //BIASMA :MA(BIAS,M);
    var BIASMAData = HQIndexFormula.MA(BIASData, this.Index[1].Param);

    paint[0].Data.Data = BIASData;
    paint[1].Data.Data = BIASMAData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 3;
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    DKX 多空线
    MID:=(3*CLOSE+LOW+OPEN+HIGH)/6;
    DKX:(20*MID+19*REF(MID,1)+18*REF(MID,2)+17*REF(MID,3)+
    16*REF(MID,4)+15*REF(MID,5)+14*REF(MID,6)+
    13*REF(MID,7)+12*REF(MID,8)+11*REF(MID,9)+
    10*REF(MID,10)+9*REF(MID,11)+8*REF(MID,12)+
    7*REF(MID,13)+6*REF(MID,14)+5*REF(MID,15)+
    4*REF(MID,16)+3*REF(MID,17)+2*REF(MID,18)+REF(MID,20))/210;
    MADKX:MA(DKX,M);
*/
function DKXIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('DKX');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("DKX", 10),
    new IndexInfo('MADKX', null)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var lowData = hisData.GetClose();
    var highData = hisData.GetHigh();
    var openData = hisData.GetOpen();

    //MID:=(3*CLOSE+LOW+OPEN+HIGH)/6;
    var MIDData = HQIndexFormula.ARRAY_DIVIDE(
      HQIndexFormula.ARRAY_ADD(
        HQIndexFormula.ARRAY_ADD(HQIndexFormula.ARRAY_MULTIPLY(closeData, 3), lowData),
        HQIndexFormula.ARRAY_ADD(openData, highData)
      ),
      6
    );


    //DKX:(20*MID+19*REF(MID,1)+18*REF(MID,2)+17*REF(MID,3)+
    //16*REF(MID,4)+15*REF(MID,5)+14*REF(MID,6)+
    //13*REF(MID,7)+12*REF(MID,8)+11*REF(MID,9)+
    //10*REF(MID,10)+9*REF(MID,11)+8*REF(MID,12)+
    //7*REF(MID,13)+6*REF(MID,14)+5*REF(MID,15)+
    //4*REF(MID,16)+3*REF(MID,17)+2*REF(MID,18)+REF(MID,20))/210;
    var DKXData1 = HQIndexFormula.ARRAY_ADD(
      HQIndexFormula.ARRAY_ADD(
        HQIndexFormula.ARRAY_MULTIPLY(MIDData, 20),
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 1), 19)
      ),
      HQIndexFormula.ARRAY_ADD(
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 2), 18),
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 3), 17)
      )
    );

    var DKXData2 = HQIndexFormula.ARRAY_ADD(
      HQIndexFormula.ARRAY_ADD(
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 4), 16),
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 5), 15)
      ),
      HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 6), 14)
    );

    var DKXData3 = HQIndexFormula.ARRAY_ADD(
      HQIndexFormula.ARRAY_ADD(
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 7), 13),
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 8), 12)
      ),
      HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 9), 11)
    );

    var DKXData4 = HQIndexFormula.ARRAY_ADD(
      HQIndexFormula.ARRAY_ADD(
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 10), 10),
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 11), 9)
      ),
      HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 12), 8)
    );

    var DKXData5 = HQIndexFormula.ARRAY_ADD(
      HQIndexFormula.ARRAY_ADD(
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 13), 7),
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 14), 6)
      ),
      HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 15), 5)
    );

    var DKXData6 = HQIndexFormula.ARRAY_ADD(
      HQIndexFormula.ARRAY_ADD(
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 16), 4),
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 17), 3)
      ),
      HQIndexFormula.ARRAY_ADD(
        HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(MIDData, 18), 2),
        HQIndexFormula.REF(MIDData, 20))
    );

    var DKXData = HQIndexFormula.ARRAY_DIVIDE(
      HQIndexFormula.ARRAY_ADD(
        HQIndexFormula.ARRAY_ADD(DKXData1, DKXData2),
        HQIndexFormula.ARRAY_ADD(
          HQIndexFormula.ARRAY_ADD(DKXData3, DKXData4),
          HQIndexFormula.ARRAY_ADD(DKXData5, DKXData6)
        )
      ),
      210);

    //MADKX:MA(DKX,M);
    var MADKXData = HQIndexFormula.MA(DKXData, this.Index[0].Param);

    paint[0].Data.Data = DKXData;
    paint[1].Data.Data = MADKXData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    DPO 区间震荡线
    DPO:CLOSE-REF(MA(CLOSE,N),N/2+1);
    MADPO:MA(DPO,M);
*/
function DPOIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('DPO');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("DPO", 20),
    new IndexInfo('MADPO', 6)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();

    //DPO:CLOSE-REF(MA(CLOSE,N),N/2+1);
    var DPOData = HQIndexFormula.ARRAY_SUBTRACT(
      closeData,
      HQIndexFormula.REF(
        HQIndexFormula.MA(closeData, this.Index[0].Param),
        parseInt(this.Index[0].Param / 2 + 1))
    );

    //MADPO:MA(DPO,M);
    var MADPOData = HQIndexFormula.MA(DPOData, this.Index[1].Param);

    paint[0].Data.Data = DPOData;
    paint[1].Data.Data = MADPOData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 3;
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    OSC 变动速率线
    OSC:100*(CLOSE-MA(CLOSE,N));
    MAOSC:EXPMEMA(OSC,M);
*/
function OSCIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('OSC');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("OSC", 20),
    new IndexInfo('MAOSC', 6)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();

    //OSC:100*(CLOSE-MA(CLOSE,N));
    var OSCData = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_SUBTRACT(closeData, HQIndexFormula.MA(closeData, this.Index[0].Param)),
      100
    );

    //MAOSC:EXPMEMA(OSC,M)
    var MAOSCData = HQIndexFormula.EXPMEMA(OSCData, this.Index[1].Param);

    paint[0].Data.Data = OSCData;
    paint[1].Data.Data = MAOSCData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 3;
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    ART 真实波幅
    MTR:MAX(MAX((HIGH-LOW),ABS(REF(CLOSE,1)-HIGH)),ABS(REF(CLOSE,1)-LOW));
    ATR:MA(MTR,N);
*/
function ARTIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('ART');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("MTR", 14),
    new IndexInfo('ATR', null)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var highData = hisData.GetHigh();
    var lowData = hisData.GetLow();

    //MTR:MAX(MAX((HIGH-LOW),ABS(REF(CLOSE,1)-HIGH)),ABS(REF(CLOSE,1)-LOW));
    var MTRData = HQIndexFormula.MAX(
      HQIndexFormula.MAX(
        HQIndexFormula.ARRAY_SUBTRACT(highData, lowData),
        HQIndexFormula.ABS(HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.REF(closeData, 1), highData))),
      HQIndexFormula.ABS(HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.REF(closeData, 1), lowData))
    );

    //ATR:MA(MTR,N);
    var ATRData = HQIndexFormula.MA(MTRData, this.Index[0].Param);

    paint[0].Data.Data = MTRData;
    paint[1].Data.Data = ATRData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    NVI 负成交量
    NVI:100*MULAR(if(v<ref(v,1),c/ref(c,1),1),0);
    MANVI:MA(NVI,N);
*/
function NVIIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('NVI');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("NVI", 72),
    new IndexInfo('MANVI', null)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var volData = hisData.GetVol();

    //NVI:100*MULAR(if(v<ref(v,1),c/ref(c,1),1),0);
    var NVIData = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.MULAR(
        HQIndexFormula.ARRAY_IF(
          HQIndexFormula.ARRAY_LT(volData, HQIndexFormula.REF(volData, 1)),
          HQIndexFormula.ARRAY_DIVIDE(closeData, HQIndexFormula.REF(closeData, 1)),
          1),
        0
      ),
      100
    );

    //MANVI:MA(NVI,N);
    var MANVIData = HQIndexFormula.MA(NVIData, this.Index[0].Param);

    paint[0].Data.Data = NVIData;
    paint[1].Data.Data = MANVIData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 3;
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    UOS 终极指标
    TH:=MAX(HIGH,REF(CLOSE,1));
    TL:=MIN(LOW,REF(CLOSE,1));
    ACC1:=SUM(CLOSE-TL,N1)/SUM(TH-TL,N1);
    ACC2:=SUM(CLOSE-TL,N2)/SUM(TH-TL,N2);
    ACC3:=SUM(CLOSE-TL,N3)/SUM(TH-TL,N3);
    UOS:(ACC1*N2*N3+ACC2*N1*N3+ACC3*N1*N2)*100/(N1*N2+N1*N3+N2*N3);
    MAUOS:EXPMEMA(UOS,M);
*/
function UOSIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('UOS');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("UOS", 7),
    new IndexInfo('MAUOS', 14),
    new IndexInfo(null, 28),
    new IndexInfo(null, 6)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != 2) return false;

    var closeData = hisData.GetClose();
    var highData = hisData.GetHigh();
    var lowData = hisData.GetLow();

    //TH:=MAX(HIGH,REF(CLOSE,1));
    var THData = HQIndexFormula.MAX(highData, HQIndexFormula.REF(closeData, 1));
    //TL:=MIN(LOW,REF(CLOSE,1));
    var TLData = HQIndexFormula.MIN(lowData, HQIndexFormula.REF(closeData, 1));

    //ACC1:=SUM(CLOSE-TL,N1)/SUM(TH-TL,N1);
    var ACC1Data = HQIndexFormula.ARRAY_DIVIDE(
      HQIndexFormula.SUM(HQIndexFormula.ARRAY_SUBTRACT(closeData, TLData), this.Index[0].Param),
      HQIndexFormula.SUM(HQIndexFormula.ARRAY_SUBTRACT(THData, TLData), this.Index[0].Param)
    );
    //ACC2:=SUM(CLOSE-TL,N2)/SUM(TH-TL,N2);
    var ACC2Data = HQIndexFormula.ARRAY_DIVIDE(
      HQIndexFormula.SUM(HQIndexFormula.ARRAY_SUBTRACT(closeData, TLData), this.Index[1].Param),
      HQIndexFormula.SUM(HQIndexFormula.ARRAY_SUBTRACT(THData, TLData), this.Index[1].Param)
    );
    //ACC3:=SUM(CLOSE-TL,N3)/SUM(TH-TL,N3);
    var ACC3Data = HQIndexFormula.ARRAY_DIVIDE(
      HQIndexFormula.SUM(HQIndexFormula.ARRAY_SUBTRACT(closeData, TLData), this.Index[2].Param),
      HQIndexFormula.SUM(HQIndexFormula.ARRAY_SUBTRACT(THData, TLData), this.Index[2].Param)
    );

    //UOS:(ACC1*N2*N3+ACC2*N1*N3+ACC3*N1*N2)*100/(N1*N2+N1*N3+N2*N3);
    var UOSData = HQIndexFormula.ARRAY_DIVIDE(
      HQIndexFormula.ARRAY_MULTIPLY(
        HQIndexFormula.ARRAY_ADD(
          HQIndexFormula.ARRAY_MULTIPLY(ACC1Data, (this.Index[1].Param * this.Index[2].Param)),
          HQIndexFormula.ARRAY_MULTIPLY(ACC2Data, (this.Index[0].Param * this.Index[2].Param)),
          HQIndexFormula.ARRAY_MULTIPLY(ACC2Data, (this.Index[0].Param * this.Index[1].Param))
        ),
        100),
      (this.Index[0].Param * this.Index[1].Param + this.Index[0].Param * this.Index[2].Param + this.Index[1].Param * this.Index[2].Param)
    );

    //MAUOS:EXPMEMA(UOS,M);
    var MAUOSData = HQIndexFormula.EXPMEMA(UOSData, this.Index[3].Param);

    paint[0].Data.Data = UOSData;
    paint[1].Data.Data = MAUOSData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 3;
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}


/*
    MIKE 麦克支撑压力
    HLC:=REF(MA((HIGH+LOW+CLOSE)/3,N),1);
    HV:=EMA(HHV(HIGH,N),3);
    LV:=EMA(LLV(LOW,N),3);
    STOR:EMA(2*HV-LV,3);
    MIDR:EMA(HLC+HV-LV,3);
    WEKR:EMA(HLC*2-LV,3);
    WEKS:EMA(HLC*2-HV,3);
    MIDS:EMA(HLC-HV+LV,3);
    STOS:EMA(2*LV-HV,3);
*/
function MIKEIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('MIKE');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("STOR", 10),
    new IndexInfo('MIDR', null),
    new IndexInfo("WEKR", null),
    new IndexInfo('WEKS', null),
    new IndexInfo('MIDS', null),
    new IndexInfo('STOS', null)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[2];
  this.Index[3].LineColor = g_JSChartResource.Index.LineColor[3];
  this.Index[4].LineColor = g_JSChartResource.Index.LineColor[4];
  this.Index[5].LineColor = g_JSChartResource.Index.LineColor[5];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var highData = hisData.GetHigh();
    var lowData = hisData.GetLow();

    //HLC:=REF(MA((HIGH+LOW+CLOSE)/3,N),1);
    var HLCData = HQIndexFormula.REF(
      HQIndexFormula.MA(
        HQIndexFormula.ARRAY_DIVIDE(HQIndexFormula.ARRAY_ADD(highData, lowData, closeData), 3),
        this.Index[0].Param),
      1);
    //HV:=EMA(HHV(HIGH,N),3);
    var HVData = HQIndexFormula.EMA(HQIndexFormula.HHV(highData, this.Index[0].Param), 3);
    //LV:=EMA(LLV(LOW,N),3);
    var LVData = HQIndexFormula.EMA(HQIndexFormula.LLV(lowData, this.Index[0].Param), 3);
    //STOR:EMA(2*HV-LV,3);
    var STORData = HQIndexFormula.EMA(HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.ARRAY_MULTIPLY(HVData, 2), LVData), 3);
    //MIDR:EMA(HLC+HV-LV,3);
    var MIDRData = HQIndexFormula.EMA(HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.ARRAY_ADD(HLCData, HVData), LVData), 3);
    //WEKR:EMA(HLC*2-LV,3);
    var WEKRData = HQIndexFormula.EMA(HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.ARRAY_MULTIPLY(HLCData, 2), LVData), 3);
    //WEKS:EMA(HLC*2-HV,3);
    var WEKSData = HQIndexFormula.EMA(HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.ARRAY_MULTIPLY(HLCData, 2), HVData), 3);
    //MIDS:EMA(HLC-HV+LV,3);
    var MIDSDaa = HQIndexFormula.EMA(HQIndexFormula.ARRAY_ADD(HQIndexFormula.ARRAY_SUBTRACT(HLCData, HVData), LVData), 3);
    //STOS:EMA(2*LV-HV,3);
    var STOSData = HQIndexFormula.EMA(HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.ARRAY_MULTIPLY(LVData, 2), HVData), 3);

    paint[0].Data.Data = STORData;
    paint[1].Data.Data = MIDRData;
    paint[2].Data.Data = WEKRData;
    paint[3].Data.Data = WEKSData;
    paint[4].Data.Data = MIDSDaa;
    paint[5].Data.Data = STOSData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    PVI 正成交量
    NVI:100*MULAR(if(v>ref(v,1),c/ref(c,1),1),0);
    MANVI:MA(NVI,N);
*/
function PVIIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('PVI');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("NVI", 72),
    new IndexInfo('MANVI', null)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var volData = hisData.GetVol();

    //NVI:100*MULAR(if(v>ref(v,1),c/ref(c,1),1),0);
    var NVIData = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.MULAR(
        HQIndexFormula.ARRAY_IF(
          HQIndexFormula.ARRAY_GT(volData, HQIndexFormula.REF(volData, 1)),
          HQIndexFormula.ARRAY_DIVIDE(closeData, HQIndexFormula.REF(closeData, 1)),
          1),
        0
      ),
      100
    );

    //MANVI:MA(NVI,N);
    var MANVIData = HQIndexFormula.MA(NVIData, this.Index[0].Param);

    paint[0].Data.Data = NVIData;
    paint[1].Data.Data = MANVIData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 3;
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    PBX 瀑布线
    PBX1:(EXPMA(CLOSE,M1)+MA(CLOSE,M1*2)+MA(CLOSE,M1*4))/3;
    PBX2:(EXPMA(CLOSE,M2)+MA(CLOSE,M2*2)+MA(CLOSE,M2*4))/3;
    PBX3:(EXPMA(CLOSE,M3)+MA(CLOSE,M3*2)+MA(CLOSE,M3*4))/3;
    PBX4:(EXPMA(CLOSE,M4)+MA(CLOSE,M4*2)+MA(CLOSE,M4*4))/3;
    PBX5:(EXPMA(CLOSE,M5)+MA(CLOSE,M5*2)+MA(CLOSE,M5*4))/3;
    PBX6:(EXPMA(CLOSE,M6)+MA(CLOSE,M6*2)+MA(CLOSE,M6*4))/3;
*/
function PBXIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('PBX');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("PBX1", 4),
    new IndexInfo('PBX2', 9),
    new IndexInfo('PBX3', 9),
    new IndexInfo('PBX4', 13),
    new IndexInfo('PBX5', 18),
    new IndexInfo('PBX6', 24)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[2];
  this.Index[3].LineColor = g_JSChartResource.Index.LineColor[3];
  this.Index[4].LineColor = g_JSChartResource.Index.LineColor[4];
  this.Index[5].LineColor = g_JSChartResource.Index.LineColor[5];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();

    for (var i in this.Index) {
      var param = this.Index[i].Param;

      //PBX1:(EXPMA(CLOSE,M1)+MA(CLOSE,M1*2)+MA(CLOSE,M1*4))/3;
      var Data = HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.ARRAY_ADD(HQIndexFormula.EXPMA(closeData, param), HQIndexFormula.MA(closeData, param * 2), HQIndexFormula.MA(closeData, param * 4)),
        3);

      paint[i].Data.Data = Data;
    }


    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 3;
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    ENE 轨道线
    UPPER:(1+M1/100)*MA(CLOSE,N);
    LOWER:(1-M2/100)*MA(CLOSE,N);
    ENE:(UPPER+LOWER)/2;
*/
function ENEIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('ENE');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("UPPER", 25),
    new IndexInfo('LOWER', 6),
    new IndexInfo('ENE', 6)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[2];

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();

    //UPPER:(1+M1/100)*MA(CLOSE,N);
    var UPPERData = HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.MA(closeData, this.Index[0].Param), (1 + this.Index[1].Param / 100));
    //LOWER:(1-M2/100)*MA(CLOSE,N);
    var LOWERData = HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.MA(closeData, this.Index[0].Param), (1 - this.Index[1].Param / 100));
    //ENE:(UPPER+LOWER)/2;
    var ENEData = HQIndexFormula.ARRAY_DIVIDE(HQIndexFormula.ARRAY_ADD(UPPERData, LOWERData), 2);

    paint[0].Data.Data = UPPERData;
    paint[1].Data.Data = LOWERData;
    paint[2].Data.Data = ENEData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 3;
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
    CYW 主力控盘
    VAR1:=CLOSE-LOW;
    VAR2:=HIGH-LOW;
    VAR3:=CLOSE-HIGH;
    VAR4:=IF(CLOSE>=0,(VAR1/VAR2+VAR3/VAR2)*VOL,(VAR3/VAR2+VAR1/VAR2)*VOL);
    CYW: SUM(VAR4,10)/10000, COLORSTICK;
*/
function CYWIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('CYW');
  delete this.newMethod;

  this.Create = function (hqChart, windowIndex) {
    var paint = new ChartMACD();
    paint.Canvas = hqChart.Canvas;
    paint.Name = this.Name;
    paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
    paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;
    hqChart.ChartPaint.push(paint);
  }

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != 1) return false;

    var closeData = hisData.GetClose();
    var highData = hisData.GetHigh();
    var lowData = hisData.GetLow();
    var volData = hisData.GetVol();

    //VAR1:=CLOSE-LOW;
    var VAR1Data = HQIndexFormula.ARRAY_SUBTRACT(closeData, lowData);
    //VAR2:=HIGH-LOW;
    var VAR2Data = HQIndexFormula.ARRAY_SUBTRACT(highData, lowData);
    //VAR3:=CLOSE-HIGH;
    var VAR3Data = HQIndexFormula.ARRAY_SUBTRACT(closeData, highData);
    //VAR4:=IF(CLOSE>=0,(VAR1/VAR2+VAR3/VAR2)*VOL,(VAR3/VAR2+VAR1/VAR2)*VOL);
    var VAR4Data = HQIndexFormula.ARRAY_IF(
      HQIndexFormula.ARRAY_GTE(closeData, 0),
      HQIndexFormula.ARRAY_MULTIPLY(
        HQIndexFormula.ARRAY_ADD(
          HQIndexFormula.ARRAY_DIVIDE(VAR1Data, VAR2Data),
          HQIndexFormula.ARRAY_DIVIDE(VAR3Data, VAR2Data)),
        volData),
      HQIndexFormula.ARRAY_MULTIPLY(
        HQIndexFormula.ARRAY_ADD(
          HQIndexFormula.ARRAY_DIVIDE(VAR3Data, VAR2Data),
          HQIndexFormula.ARRAY_DIVIDE(VAR1Data, VAR2Data)),
        volData)
    );
    //CYW: SUM(VAR4,10)/10000, COLORSTICK;
    var CYWData = HQIndexFormula.ARRAY_DIVIDE(HQIndexFormula.SUM(VAR4Data, 10), 10000);


    paint[0].Data.Data = CYWData;

    var titleIndex = windowIndex + 1;
    hqChart.TitlePaint[titleIndex].Data[0] = new DynamicTitleData(paint[0].Data, "CYW", g_JSChartResource.DefaultTextColor);

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();

    return true;
  }
}

/*
    NDB 脑电波
    HH:=IF(C/REF(C,1)>1.098 AND L>REF(H,1),2*C-REF(C,1)-H,2*C-H-L);
    V1:=BARSCOUNT(C)-1;
    V2:=2*REF(C,V1)-REF(H,V1)-REF(L,V1);
    DK:SUM(HH,0)+V2;
    MDK5:MA(DK,P1);
    MDK10:MA(DK,P2);
*/








//市场多空
function MarketLongShortIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('Long-Short');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("市场多空指标", null),
    new IndexInfo("多头区域", null),
    new IndexInfo("空头区域", null)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.UpBarColor;
  this.Index[2].LineColor = g_JSChartResource.DownBarColor;

  this.LongShortData; //多空数据

  this.Create = function (hqChart, windowIndex) {
    for (var i in this.Index) {
      var paint = null;
      if (i == 0)
        paint = new ChartLine();
      else
        paint = new ChartStraightLine();

      paint.Color = this.Index[i].LineColor;
      paint.Canvas = hqChart.Canvas;
      paint.Name = this.Name + "-" + i.toString();
      paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
      paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;

      hqChart.ChartPaint.push(paint);
    }
  }

  //请求数据
  this.RequestData = function (hqChart, windowIndex, hisData) {
    var self = this;
    var param =
      {
        HQChart: hqChart,
        WindowIndex: windowIndex,
        HistoryData: hisData
      };

    this.LongShortData = [];

    if (param.HQChart.Period > 0)   //周期数据
    {
      this.NotSupport(param.HQChart, param.WindowIndex, "不支持周期切换");
      param.HQChart.Draw();
      return false;
    }

    //请求数据
    $.ajax({
      url: g_JSChartResource.Index.MarketLongShortApiUrl,
      data:
        {

        },
      type: "post",
      dataType: "json",
      async: true,
      success: function (recvData) {
        self.RecvData(recvData, param);
      }
    });

    return true;
  }

  this.RecvData = function (recvData, param) {
    if (recvData.data.length <= 0) return;

    var aryData = new Array();
    for (var i in recvData.data) {
      var item = recvData.data[i];
      var indexData = new SingleData();
      indexData.Date = item[0];
      indexData.Value = item[1];
      aryData.push(indexData);
    }

    var aryFittingData = param.HistoryData.GetFittingData(aryData);

    var bindData = new ChartData();
    bindData.Data = aryFittingData;
    bindData.Period = param.HQChart.Period;   //周期
    bindData.Right = param.HQChart.Right;     //复权

    this.LongShortData = bindData.GetValue();
    this.BindData(param.HQChart, param.WindowIndex, param.HistoryData);

    param.HQChart.UpdataDataoffset();           //更新数据偏移
    param.HQChart.UpdateFrameMaxMin();          //调整坐标最大 最小值
    param.HQChart.Draw();
  }


  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    //paint[0].Data.Data=SWLData;
    paint[0].Data.Data = this.LongShortData;
    paint[0].NotSupportMessage = null;
    paint[1].Data.Data[0] = 8;
    paint[2].Data.Data[0] = 1;

    //指定[0,9]
    hqChart.Frame.SubFrame[windowIndex].Frame.YSpecificMaxMin = { Max: 9, Min: 0, Count: 3 };

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
      if (i > 0) hqChart.TitlePaint[titleIndex].Data[i].DataType = "StraightLine";
    }

    return true;
  }

}

//市场择时
function MarketTimingIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('Market-Timing');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("因子择时", null)
  );

  this.TimingData; //择时数据
  this.TitleColor = g_JSChartResource.FrameSplitTextColor

  this.Create = function (hqChart, windowIndex) {
    for (var i in this.Index) {
      var paint = new ChartMACD();
      paint.Canvas = hqChart.Canvas;
      paint.Name = this.Name + "-" + i.toString();
      paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
      paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;

      hqChart.ChartPaint.push(paint);
    }
  }

  //请求数据
  this.RequestData = function (hqChart, windowIndex, hisData) {
    var self = this;
    var param =
      {
        HQChart: hqChart,
        WindowIndex: windowIndex,
        HistoryData: hisData
      };

    this.LongShortData = [];

    if (param.HQChart.Period > 0)   //周期数据
    {
      this.NotSupport(param.HQChart, param.WindowIndex, "不支持周期切换");
      param.HQChart.Draw();
      return false;
    }

    //请求数据
    $.ajax({
      url: g_JSChartResource.Index.MarketLongShortApiUrl,
      data:
        {

        },
      type: "post",
      dataType: "json",
      async: true,
      success: function (recvData) {
        self.RecvData(recvData, param);
      }
    });

    return true;
  }

  this.RecvData = function (recvData, param) {
    if (recvData.data.length <= 0) return;

    var aryData = new Array();
    for (var i in recvData.data) {
      var item = recvData.data[i];
      var indexData = new SingleData();
      indexData.Date = item[0];
      indexData.Value = item[2];
      aryData.push(indexData);
    }

    var aryFittingData = param.HistoryData.GetFittingData(aryData);

    var bindData = new ChartData();
    bindData.Data = aryFittingData;
    bindData.Period = param.HQChart.Period;   //周期
    bindData.Right = param.HQChart.Right;     //复权

    this.TimingData = bindData.GetValue();
    this.BindData(param.HQChart, param.WindowIndex, param.HistoryData);

    param.HQChart.UpdataDataoffset();           //更新数据偏移
    param.HQChart.UpdateFrameMaxMin();          //调整坐标最大 最小值
    param.HQChart.Draw();
  }


  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    //paint[0].Data.Data=SWLData;
    paint[0].Data.Data = this.TimingData;
    paint[0].NotSupportMessage = null;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.TitleColor);
      hqChart.TitlePaint[titleIndex].Data[i].StringFormat = STRING_FORMAT_TYPE.THOUSANDS;
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 0;
    }

    return true;
  }
}

//融资占比
function MarginRateIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('融资占比');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("融资占比(%)", null)
  );

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];

  this.MarginRate;    //融资占比

  //请求数据
  this.RequestData = function (hqChart, windowIndex, hisData) {
    var self = this;
    var param =
      {
        HQChart: hqChart,
        WindowIndex: windowIndex,
        HistoryData: hisData
      };

    this.MarginRate = [];

    if (param.HQChart.Period > 0)   //周期数据
    {
      this.NotSupport(param.HQChart, param.WindowIndex, "不支持周期切换");
      param.HQChart.Draw();
      return false;
    }

    //请求数据
    wx.request({
      url: g_JSChartResource.Index.StockHistoryDayApiUrl,
      data:
        {
          "field": ["name", "date", "symbol", " margin.rate"],
          "condition":
            [
              { "item": ["margin.rate", "double", "gte", "0.000001"] }
            ],
          "orderfield": "date",
          "symbol": [param.HQChart.Symbol],
        },
      method: 'POST',
      dataType: "json",
      async: true,
      success: function (recvData) {
        self.RecvData(recvData, param);
      }
    });

    return true;
  }

  this.RecvData = function (recvData, param) {
    this.MarginRate = [];
    let data = recvData.data;
    if (data.stock.length <= 0) return;

    var aryData = new Array();
    for (var i in data.stock[0].stockday) {
      var item = data.stock[0].stockday[i];
      var indexData = new SingleData();
      indexData.Date = item.date;
      indexData.Value = item.margin.rate;
      aryData.push(indexData);
    }

    var aryMarginRate = param.HistoryData.GetFittingData(aryData);

    var bindData = new ChartData();
    bindData.Data = aryMarginRate;
    bindData.Period = param.HQChart.Period;   //周期
    bindData.Right = param.HQChart.Right;     //复权

    if (bindData.Period > 0)   //周期数据
    {
      var periodData = bindData.GetPeriodSingleData(bindData.Period);
      bindData.Data = periodData;
    }

    this.MarginRate = bindData.GetValue();
    this.BindData(param.HQChart, param.WindowIndex, param.HistoryData);

    param.HQChart.UpdataDataoffset();           //更新数据偏移
    param.HQChart.UpdateFrameMaxMin();          //调整坐标最大 最小值
    param.HQChart.Draw();
  }


  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    paint[0].Data.Data = this.MarginRate;
    paint[0].NotSupportMessage = null;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}



//市场关注度
function MarketAttentionIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('市场关注度');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("市场关注度指数", null)
  );

  this.Data; //关注度数据
  this.TitleColor = g_JSChartResource.FrameSplitTextColor;
  this.ApiUrl = g_JSChartResource.Index.MarketAttentionApiUrl;

  this.Create = function (hqChart, windowIndex) {
    for (var i in this.Index) {
      var paint = new ChartBar();   //柱子
      paint.Canvas = hqChart.Canvas;
      paint.Name = this.Name + "-" + i.toString();
      paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
      paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;
      paint.UpBarColor = paint.DownBarColor = 'rgb(243,152,0)';

      hqChart.ChartPaint.push(paint);
    }
  }

  //调整框架
  this.SetFrame = function (hqChart, windowIndex, hisData) {
    hqChart.Frame.SubFrame[windowIndex].Frame.YSpecificMaxMin = { Max: 6, Min: 0, Count: 3 };
  }

  //请求数据
  this.RequestData = function (hqChart, windowIndex, hisData) {
    var self = this;
    var param =
      {
        HQChart: hqChart,
        WindowIndex: windowIndex,
        HistoryData: hisData
      };

    this.Data = [];

    if (param.HQChart.Period > 0)   //周期数据
    {
      this.NotSupport(param.HQChart, param.WindowIndex, "不支持周期切换");
      param.HQChart.Draw();
      return false;
    }

    //请求数据
    wx.request({
      url: this.ApiUrl,
      data:
        {
          "symbol": param.HQChart.Symbol,
          "startdate": 20100101,
        },
      method: 'POST',
      dataType: "json",
      success: function (recvData) {
        self.RecvData(recvData.data, param);
      }
    });

    return true;
  }

  this.RecvData = function (recvData, param) {
    if (recvData.date.length < 0) return;

    var aryData = new Array();
    for (var i in recvData.date) {
      var indexData = new SingleData();
      indexData.Date = recvData.date[i];
      indexData.Value = recvData.value[i];
      aryData.push(indexData);
    }

    var aryFittingData = param.HistoryData.GetFittingData(aryData);

    var bindData = new ChartData();
    bindData.Data = aryFittingData;
    bindData.Period = param.HQChart.Period;   //周期
    bindData.Right = param.HQChart.Right;     //复权

    this.Data = bindData.GetValue();
    this.BindData(param.HQChart, param.WindowIndex, param.HistoryData);
    this.SetFrame(param.HQChart, param.WindowIndex, param.HistoryData);

    param.HQChart.UpdataDataoffset();           //更新数据偏移
    param.HQChart.UpdateFrameMaxMin();          //调整坐标最大 最小值
    param.HQChart.Draw();
  }


  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    //paint[0].Data.Data=SWLData;
    paint[0].Data.Data = this.Data;
    paint[0].NotSupportMessage = null;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.TitleColor);
      hqChart.TitlePaint[titleIndex].Data[i].StringFormat = STRING_FORMAT_TYPE.THOUSANDS;
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 0;
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}


/*
    行业,指数热度
*/
function MarketHeatIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('指数/行业热度');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("热度指数", 5),
    new IndexInfo('MA', 10),
    new IndexInfo('MA', null)
  );

  this.Data; //关注度数据

  this.ApiUrl = g_JSChartResource.Index.MarketHeatApiUrl;

  this.Index[0].LineColor = g_JSChartResource.FrameSplitTextColor;
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[1];

  this.Create = function (hqChart, windowIndex) {
    for (var i in this.Index) {
      var paint = null;
      if (i == 0) {
        paint = new ChartMACD();   //柱子
      }
      else {
        paint = new ChartLine();
        paint.Color = this.Index[i].LineColor;
      }

      paint.Canvas = hqChart.Canvas;
      paint.Name = this.Name + "-" + i.toString();
      paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
      paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;

      hqChart.ChartPaint.push(paint);
    }
  }

  //请求数据
  this.RequestData = function (hqChart, windowIndex, hisData) {
    var self = this;
    var param =
      {
        HQChart: hqChart,
        WindowIndex: windowIndex,
        HistoryData: hisData
      };

    this.Data = [];

    if (param.HQChart.Period > 0)   //周期数据
    {
      this.NotSupport(param.HQChart, param.WindowIndex, "不支持周期切换");
      param.HQChart.Draw();
      return false;
    }

    //请求数据
    wx.request({
      url: this.ApiUrl,
      data:
        {
          "symbol": param.HQChart.Symbol,
          "startdate": 20100101,
        },
      method: 'POST',
      dataType: "json",
      success: function (recvData) {
        self.RecvData(recvData.data, param);
      }
    });

    return true;
  }

  this.RecvData = function (recvData, param) {
    if (recvData.date.length < 0) return;

    var aryData = new Array();
    for (var i in recvData.date) {
      var indexData = new SingleData();
      indexData.Date = recvData.date[i];
      indexData.Value = recvData.value[i];
      aryData.push(indexData);
    }

    var aryFittingData = param.HistoryData.GetFittingData(aryData);

    var bindData = new ChartData();
    bindData.Data = aryFittingData;
    bindData.Period = param.HQChart.Period;   //周期
    bindData.Right = param.HQChart.Right;     //复权

    this.Data = bindData.GetValue();
    this.BindData(param.HQChart, param.WindowIndex, param.HistoryData);

    param.HQChart.UpdataDataoffset();           //更新数据偏移
    param.HQChart.UpdateFrameMaxMin();          //调整坐标最大 最小值
    param.HQChart.Draw();
  }


  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    paint[0].Data.Data = this.Data;
    paint[0].NotSupportMessage = null;

    var MA = HQIndexFormula.MA(this.Data, this.Index[0].Param);
    paint[1].Data.Data = MA;

    var MA2 = HQIndexFormula.MA(this.Data, this.Index[1].Param);
    paint[2].Data.Data = MA2;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      var name = "";    //显示的名字特殊处理
      if (i == 0)
        name = hqChart.Name + this.Index[i].Name;
      else
        name = "MA" + this.Index[i - 1].Param;

      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, name, this.Index[i].LineColor);
      hqChart.TitlePaint[titleIndex].Data[i].StringFormat = STRING_FORMAT_TYPE.DEFAULT;
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 2;
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();

    return true;
  }

}

//自定义指数热度
function CustonIndexHeatIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('Market-Heat');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo('区域', 3),
    new IndexInfo("热度指数", 10),
    new IndexInfo('MA', 5),
    new IndexInfo('MA', 10)
  );

  this.Data; //热度数据

  this.ApiUrl = g_JSChartResource.Index.CustomIndexHeatApiUrl;

  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.Index.LineColor[2];
  this.Index[3].LineColor = g_JSChartResource.Index.LineColor[3];

  this.Create = function (hqChart, windowIndex) {
    for (var i in this.Index) {
      var paint = null;
      if (i == 0) {
        paint = new ChartStraightArea();
      }
      else {
        paint = new ChartLine();
        paint.Color = this.Index[i].LineColor;
      }

      paint.Canvas = hqChart.Canvas;
      paint.Name = this.Name + "-" + i.toString();
      paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
      paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;

      hqChart.ChartPaint.push(paint);
    }
  }

  //请求数据
  this.RequestData = function (hqChart, windowIndex, hisData) {
    var self = this;
    var param =
      {
        HQChart: hqChart,
        WindowIndex: windowIndex,
        HistoryData: hisData
      };

    this.Data = [];

    if (param.HQChart.Period > 0)   //周期数据
    {
      this.NotSupport(param.HQChart, param.WindowIndex, "不支持周期切换");
      param.HQChart.Draw();
      return false;
    }

    //请求数据
    wx.request({
      url: this.ApiUrl,
      data:
        {
          "stock": param.HQChart.CustomStock,
          "date": { "startdate": param.HQChart.QueryDate.Start, "enddate": param.HQChart.QueryDate.End },
          "day": [this.Index[0].Param, this.Index[1].Param],
        },
      method: 'POST',
      dataType: "json",
      success: function (recvData) {
        self.RecvData(recvData, param);
      }
    });

    return true;
  }

  this.RecvData = function (recvData, param) {
    let data = recvData.data;
    if (data.data == null || data.data.length < 0) return;

    //console.log(recvData.data);
    let aryData = new Array();
    for (let i in data.data) {
      let item = data.data[i];
      let indexData = new SingleData();
      indexData.Date = item[0];
      indexData.Value = item[1];
      aryData.push(indexData);
    }

    var aryFittingData = param.HistoryData.GetFittingData(aryData);

    var bindData = new ChartData();
    bindData.Data = aryFittingData;
    bindData.Period = param.HQChart.Period;   //周期
    bindData.Right = param.HQChart.Right;     //复权

    this.Data = bindData.GetValue();
    this.BindData(param.HQChart, param.WindowIndex, param.HistoryData);

    param.HQChart.UpdataDataoffset();           //更新数据偏移
    param.HQChart.UpdateFrameMaxMin();          //调整坐标最大 最小值
    param.HQChart.Draw();
  }


  this.BindData = function (hqChart, windowIndex, hisData) {
    let paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    paint[0].NotSupportMessage = null;

    paint[0].Data.Data =
      [
        { Value: 0, Value2: 0.2, Color: 'rgb(46,139,87)', Title: '较差区', TitleColor: 'rgb(245,255 ,250)' },
        { Value: 0.19, Value2: 0.4, Color: 'rgb(255,140,0)', Title: '变热区', TitleColor: 'rgb(245,255 ,250)' },
        { Value: 0.39, Value2: 0.8, Color: 'rgb(255,106,106)', Title: '较好区', TitleColor: 'rgb(245,255 ,250)' },
        { Value: 0.79, Value2: 1, Color: 'rgb(255,69,0)', Title: '过热区', TitleColor: 'rgb(245,255 ,250)' }
      ];

    paint[1].Data.Data = this.Data;

    let MA = HQIndexFormula.MA(this.Data, this.Index[2].Param);
    paint[2].Data.Data = MA;

    let MA2 = HQIndexFormula.MA(this.Data, this.Index[3].Param);
    paint[3].Data.Data = MA2;

    //指定框架最大最小[0,1]
    hqChart.Frame.SubFrame[windowIndex].Frame.YSpecificMaxMin = { Max: 1, Min: 0, Count: 3 };

    let titleIndex = windowIndex + 1;

    for (let i = 1; i < paint.length; ++i) {
      let name = this.Index[i].Name;    //显示的名字特殊处理
      if (name == 'MA') name = "MA" + this.Index[i].Param;

      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, name, this.Index[i].LineColor);
      hqChart.TitlePaint[titleIndex].Data[i].StringFormat = STRING_FORMAT_TYPE.DEFAULT;
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 2;
    }


    hqChart.TitlePaint[titleIndex].Title = '热度' + '(' + this.Index[0].Param + ',' + this.Index[1].Param + ',' + this.Index[2].Param + ',' + this.Index[3].Param + ')';

    return true;
  }

}

/*
    本福特系数(财务粉饰)
*/
function BenfordIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('财务风险');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo('区域', null),
    new IndexInfo("系数", null),
  );

  this.Data; //财务数据

  this.ApiUrl = g_JSChartResource.Index.StockHistoryDayApiUrl;

  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = 'rgb(105,105,105)';

  this.Create = function (hqChart, windowIndex) {
    for (var i in this.Index) {
      var paint = null;
      if (i == 0)
        paint = new ChartStraightArea();
      else if (i == 1)
        paint = new ChartLineMultiData();

      if (paint) {
        paint.Color = this.Index[i].LineColor;
        paint.Canvas = hqChart.Canvas;
        paint.Name = this.Name + "-" + i.toString();
        paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
        paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;

        hqChart.ChartPaint.push(paint);
      }
    }
  }

  //请求数据
  this.RequestData = function (hqChart, windowIndex, hisData) {
    var self = this;
    var param =
      {
        HQChart: hqChart,
        WindowIndex: windowIndex,
        HistoryData: hisData
      };

    this.Data = [];

    if (param.HQChart.Period != 2)   //周期数据
    {
      this.NotSupport(param.HQChart, param.WindowIndex, "只支持月线");
      param.HQChart.Draw();
      return false;
    }

    var aryField = ["finance.benford", "announcement2.quarter", "announcement1.quarter", "announcement3.quarter", "announcement4.quarter"];
    var aryCondition =
      [
        { item: ["date", "int32", "gte", "20130101"] },
        {
          item: ["announcement1.year", "int32", "gte", 0,
            "announcement2.year", "int32", "gte", 0,
            "announcement3.year", "int32", "gte", 0,
            "announcement4.year", "int32", "gte", 0,
            "or"]
        }
      ];
    //请求数据
    wx.request({
      url: this.ApiUrl,
      data:
        {
          "symbol": [param.HQChart.Symbol],
          "field": aryField,
          "condition": aryCondition
        },
      method: 'POST',
      dataType: "json",
      success: function (recvData) {
        self.RecvData(recvData, param);
      }
    });

    return true;
  }

  this.JsonDataToMapSingleData = function (recvData) {
    var stockData = recvData.stock[0].stockday;
    var mapData = new Map();
    for (var i in stockData) {
      var item = stockData[i];
      var indexData = new SingleData();
      indexData.Date = item.date;
      indexData.Value = new Array();
      if (item.finance1 != null && item.announcement1 != null) {
        let year = item.announcement1.year;
        let quarter = item.announcement1.quarter;
        let value = item.finance1.benford;
        indexData.Value.push({ Year: year, Quarter: quarter, Value: value });
      }
      if (item.finance2 != null && item.announcement2 != null) {
        let year = item.announcement2.year;
        let quarter = item.announcement2.quarter;
        let value = item.finance2.benford;
        indexData.Value.push({ Year: year, Quarter: quarter, Value: value });
      }
      if (item.finance3 != null && item.announcement3 != null) {
        let year = item.announcement3.year;
        let quarter = item.announcement3.quarter;
        let value = item.finance3.benford;
        indexData.Value.push({ Year: year, Quarter: quarter, Value: value });
      }
      if (item.finance4 != null && item.announcement4 != null) {
        let year = item.announcement4.year;
        let quarter = item.announcement4.quarter;
        let value = item.finance4.benford;
        indexData.Value.push({ Year: year, Quarter: quarter, Value: value });
      }

      mapData.set(indexData.Date, indexData);
    }

    var aryData = new Array();
    for (var item of mapData) {
      aryData.push(item[1]);
    }

    return aryData;
  }

  this.RecvData = function (recvData, param) {
    console.log(recvData);
    if (recvData.data.stock == null || recvData.data.stock.length <= 0) return;

    var aryData = this.JsonDataToMapSingleData(recvData.data);
    var aryFittingData = param.HistoryData.GetFittingMonthData(aryData);

    var bindData = new ChartData();
    bindData.Data = aryFittingData;
    bindData.Period = param.HQChart.Period;   //周期
    bindData.Right = param.HQChart.Right;     //复权

    this.Data = bindData.GetValue();
    this.BindData(param.HQChart, param.WindowIndex, param.HistoryData);

    param.HQChart.UpdataDataoffset();           //更新数据偏移
    param.HQChart.UpdateFrameMaxMin();          //调整坐标最大 最小值
    param.HQChart.Draw();
  }


  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    paint[0].NotSupportMessage = null;

    paint[0].Data.Data =
      [
        { Value: 0, Value2: 0.2, Color: 'rgb(50,205,50)', Title: '安全区', TitleColor: 'rgb(245,255 ,250)' },
        { Value: 0.2, Value2: 0.4, Color: 'rgb(255,140,0)', Title: '预警区', TitleColor: 'rgb(245,255 ,250)' },
        { Value: 0.4, Value2: 1, Color: 'rgb(255,106,106)', Title: '警示区', TitleColor: 'rgb(245,255 ,250)' }
      ];

    paint[1].Data.Data = this.Data;

    //指定框架最大最小[0,1]
    hqChart.Frame.SubFrame[windowIndex].Frame.YSpecificMaxMin = { Max: 1, Min: 0, Count: 3 };

    var titleIndex = windowIndex + 1;

    hqChart.TitlePaint[titleIndex].Data[1] = new DynamicTitleData(paint[1].Data, this.Index[1].Name, this.Index[1].LineColor);
    hqChart.TitlePaint[titleIndex].Data[1].DataType = "MultiReport";

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();

    return true;
  }
}


///////////////////////////////////////////////////////////////////////
//  能图指标
//

/*
    大盘趋势函数
    个股趋势函数

    上线:=SMA(C,6.5,1);
    下线:=SMA(C,13.5,1);
    STICKLINE(上线>下线 , 上线,下线 ,2, 0),COLORRED,LINETHICK2;
    STICKLINE(下线>上线,上线,下线,2,0),COLORBLUE,LINETHICK2;
*/

function LighterIndex1() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('Lighter-Trend');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("STICKLINE", null),
    new IndexInfo('STICKLINE', null)
  );

  this.Index[0].LineColor = 'rgb(255,0,0)';
  this.Index[1].LineColor = 'rgb(0,0,255)';

  this.Create = function (hqChart, windowIndex) {
    for (var i in this.Index) {
      var paint = new ChartStickLine();
      paint.Canvas = hqChart.Canvas;
      paint.Name = this.Name;
      paint.Name = this.Name + '-' + i.toString();
      paint.Color = this.Index[i].LineColor;
      paint.LineWidth = 2;
      paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
      paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;
      hqChart.ChartPaint.push(paint);
    }
  }

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != 2) return false;

    var closeData = hisData.GetClose();
    var upData = HQIndexFormula.SMA(closeData, 6.5, 1);
    var downData = HQIndexFormula.SMA(closeData, 13.5, 1);

    var stickLine = HQIndexFormula.STICKLINE(HQIndexFormula.ARRAY_GT(upData, downData), upData, downData);;
    var stickLine2 = HQIndexFormula.STICKLINE(HQIndexFormula.ARRAY_GT(downData, upData), upData, downData);;

    paint[0].Data.Data = stickLine;
    paint[1].Data.Data = stickLine2;

    var titleIndex = windowIndex + 1;
    hqChart.TitlePaint[titleIndex].Title = "大盘/个股 趋势函数";

    return true;
  }
}

/*
    位置研判函数
    N:=34;M:=3;
    28,COLORFFFFFF;
    STICKLINE(C>0,0,2,5,0),COLOR00008A;
    STICKLINE(C>0,2,5,5,0),COLOR85008A;
    STICKLINE(C>0,5,10,5,0),COLOR657600;
    STICKLINE(C>0,10,21.5,5,0),COLOR690079;
    STICKLINE(C>0,21.5,23,5,0),COLOR79B715;
    STICKLINE(C>0,23,28,5,0),COLOR00008A;
    VAR1:=EMA(100*(CLOSE-LLV(LOW,N))/(HHV(HIGH,N)-LLV(LOW,N)),M)/4,COLORFFFF00,LINETHICK2;

    财貌双拳:VAR1,COLORFFFF00,LINETHICK2;
    DRAWTEXT(CURRBARSCOUNT=128,1,'底部区域'),COLOR00FFFF;
    DRAWTEXT(CURRBARSCOUNT=128,3.5,'介入区域'),COLOR00FFFF;
    DRAWTEXT(CURRBARSCOUNT=128,7.5,'稳健区域'),COLOR00FFFF;
    DRAWTEXT(CURRBARSCOUNT=128,16,'高位区域'),COLOR00FFFF;
    DRAWTEXT(CURRBARSCOUNT=128,22,'风险区域'),COLOR0000FF;
    DRAWTEXT(CURRBARSCOUNT=128,25.5,'顶部区域'),COLORFF00FF;
*/

function LighterIndex2() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('位置研判');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("区域", 34),
    new IndexInfo('位置研判', 3),
  );

  this.Index[0].LineColor = 'rgb(0,0,138)';
  this.Index[1].LineColor = 'rgb(246,46,47)';

  this.Create = function (hqChart, windowIndex) {
    for (var i in this.Index) {
      var paint = null;
      if (i == 0) {
        paint = new ChartStraightArea();
      }
      else {
        paint = new ChartLine();
        paint.Color = this.Index[i].LineColor;
      }

      paint.Canvas = hqChart.Canvas;
      paint.Name = this.Name;
      paint.Name = this.Name + '-' + i.toString();
      paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
      paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;
      hqChart.ChartPaint.push(paint);
    }
  }

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var highData = hisData.GetHigh();
    var lowData = hisData.GetLow();

    paint[0].NotSupportMessage = null;

    paint[0].Data.Data =
      [
        { Value: 0, Value2: 2, Color: 'rgb(230,238 ,247)', Title: '底部区域', TitleColor: 'rgb(0,0 ,0)', Align: 'left' },
        { Value: 1.9, Value2: 5, Color: 'rgb(255,255 ,255)', Title: '介入区域', TitleColor: 'rgb(0,0 ,0)', Align: 'left' },
        { Value: 5, Value2: 10, Color: 'rgb(230,238 ,247)', Title: '稳健区域', TitleColor: 'rgb(0,0 ,0)', Align: 'left' },
        { Value: 10, Value2: 21.5, Color: 'rgb(255,255 ,255)', Title: '高位区域', TitleColor: 'rgb(0,0 ,0)', Align: 'left' },
        { Value: 21.4, Value2: 23.5, Color: 'rgb(230,238 ,247)', Title: '风险区域', TitleColor: 'rgb(0,0 ,0)', Align: 'left' },
        { Value: 23, Value2: 28, Color: 'rgb(255,255 ,255)', Title: '顶部区域', TitleColor: 'rgb(0,0 ,0)', Align: 'left' }
      ];

    //VAR1:=EMA(100*(CLOSE-LLV(LOW,N))/(HHV(HIGH,N)-LLV(LOW,N)),M)/4
    var lineData = HQIndexFormula.ARRAY_DIVIDE(
      HQIndexFormula.EMA(
        HQIndexFormula.ARRAY_MULTIPLY(
          HQIndexFormula.ARRAY_DIVIDE(
            HQIndexFormula.ARRAY_SUBTRACT(closeData, HQIndexFormula.LLV(lowData, this.Index[0].Param)),
            HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.HHV(highData, this.Index[0].Param), HQIndexFormula.LLV(lowData, this.Index[0].Param))
          ),
          100),
        this.Index[1].Param),
      4
    );

    paint[1].Data.Data = lineData;

    var titleIndex = windowIndex + 1;
    //hqChart.TitlePaint[titleIndex].Data[0] = new DynamicTitleData(paint[1].Data, '目前处于',paint[1].Color);
    //hqChart.TitlePaint[titleIndex].Data[0].GetTextCallback = this.GetTextCallback;

    hqChart.TitlePaint[titleIndex].Title = '位置研判';
    hqChart.TitlePaint[titleIndex].TitleBG = 'rgb(242,242,242)';
    hqChart.TitlePaint[titleIndex].TitleAlign = 'bottom';
    hqChart.TitlePaint[titleIndex].TitleBottomDistance = 2; //底部间距设置为2

    if (lineData.length > 0) {
      let value = lineData[lineData.length - 1];
      let text = this.GetTextCallback(value);
      hqChart.TitlePaint[titleIndex].Text = [];
      hqChart.TitlePaint[titleIndex].Text[0] = { Text: ' 目前处于:', Color: 'rgb(0,0,0)' };
      hqChart.TitlePaint[titleIndex].Text[1] = text;
    }

    this.InvokeUpdateUICallback(paint);

    return true;
  }

  this.GetTextCallback = function (value) {
    if (value >= 0 && value <= 2) return { Text: '底部区域', Color: 'rgb(255,69,0)' };
    else if (value >= 2 && value <= 5) return { Text: '介入区域', Color: 'rgb(255,69,0)' };
    else if (value >= 5 && value <= 10) return { Text: '稳健区域', Color: 'rgb(255,69,0)' };
    else if (value >= 10 && value <= 21.5) return { Text: '高位区域', Color: 'rgb(255,69,0)' };
    else if (value >= 21.5 && value <= 23.5) return { Text: '风险区域', Color: 'rgb(255,69,0)' };
    else return { Text: '顶部区域', Color: 'rgb(255,69,0)' };
  }
}


/*
    点位研判函数

    HJ_1:=REF(LOW,1);
    HJ_2:=SMA(ABS(LOW-HJ_1),13,1)/SMA(MAX(LOW-HJ_1,0),13,1)*100;
    HJ_3:=EMA(IF(CLOSE*1.2,HJ_2*13,HJ_2/13),13);
    HJ_4:=LLV(LOW,34);
    HJ_5:=HHV(HJ_3,34);
    HJ_6:=IF(LLV(LOW,56),1,0);
    HJ_7:=EMA(IF(LOW<=HJ_4,(HJ_3+HJ_5*2)/2,0),3)/618*HJ_6;
    HJ_8:=HJ_7>REF(HJ_7,1);
    HJ_9:=REF(LLV(LOW,100),3);
    HJ_10:=REFDATE(HJ_9,DATE);
    HJ_11:=LOW=HJ_10;
    HJ_12:=HJ_8 AND HJ_11;
    HJ_13:=HJ_12>REF(HJ_12,1);
    启动买点:HJ_13>REF(HJ_13,1),COLORRED,LINETHICK1;
*/
function LighterIndex3() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('点位研判函数');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("启动买点", null)
  );

  this.Index[0].LineColor = 'rgb(255,0,0)';

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var highData = hisData.GetHigh();
    var lowData = hisData.GetLow();

    //HJ_1:=REF(LOW,1);
    var hj_1 = HQIndexFormula.REF(lowData, 1);

    //HJ_2:=SMA(ABS(LOW-HJ_1),13,1)/SMA(MAX(LOW-HJ_1,0),13,1)*100;
    var hj_2 = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.SMA(HQIndexFormula.ABS(HQIndexFormula.ARRAY_SUBTRACT(lowData, hj_1)), 13, 1),
        HQIndexFormula.SMA(HQIndexFormula.MAX(HQIndexFormula.ARRAY_SUBTRACT(lowData, hj_1), 0), 13, 1)
      ),
      100
    );

    //HJ_3:=EMA(IF(CLOSE*1.2,HJ_2*13,HJ_2/13),13);
    var hj_3 = HQIndexFormula.EMA(
      HQIndexFormula.ARRAY_IF(HQIndexFormula.ARRAY_MULTIPLY(closeData, 1.2), HQIndexFormula.ARRAY_MULTIPLY(hj_2, 13), HQIndexFormula.ARRAY_DIVIDE(hj_2, 13)),
      13
    );

    //HJ_4:=LLV(LOW,34);
    var hj_4 = HQIndexFormula.LLV(lowData, 34);

    //HJ_5:=HHV(HJ_3,34);
    var hj_5 = HQIndexFormula.HHV(hj_3, 34);

    //HJ_6:=IF(LLV(LOW,56),1,0);
    var hj_6 = HQIndexFormula.ARRAY_IF(HQIndexFormula.LLV(lowData, 56), 1, 0);

    //HJ_7:=EMA(IF(LOW<=HJ_4,(HJ_3+HJ_5*2)/2,0),3)/618*HJ_6;
    //hj_7_temp=(HJ_3+HJ_5*2)/2,0)  太长了 这部分单独算下
    var hj_7_temp = HQIndexFormula.ARRAY_DIVIDE(HQIndexFormula.ARRAY_ADD(hj_3, HQIndexFormula.ARRAY_MULTIPLY(hj_5, 2)), 2);

    var hj_7 = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.EMA(
          HQIndexFormula.ARRAY_IF(HQIndexFormula.ARRAY_LTE(lowData, hj_4), hj_7_temp, 0),
          3
        ),
        618
      ),
      hj_6
    );

    //HJ_8:=HJ_7>REF(HJ_7,1);
    var hj_8 = HQIndexFormula.ARRAY_GT(hj_7, HQIndexFormula.REF(hj_7, 1));

    //HJ_9:=REF(LLV(LOW,100),3);
    var hj_9 = HQIndexFormula.REF(HQIndexFormula.LLV(lowData, 100), 3);

    //HJ_10:=REFDATE(HJ_9,DATE); 用当日的数据 产生数组
    var hj_10 = HQIndexFormula.REFDATE(hj_9, -1);

    //HJ_11:=LOW=HJ_10;
    var hj_11 = HQIndexFormula.ARRAY_EQ(lowData, hj_10);

    //HJ_12:=HJ_8 AND HJ_11;
    var hj_12 = HQIndexFormula.ARRAY_AND(hj_8, hj_11);

    var buyData = null;
    paint[0].Data.Data = hj_12;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();

    return true;
  }
}

/*
能图-资金分析
M:=55;
N:=34;
LC:=REF(CLOSE,1);
RSI:=((SMA(MAX((CLOSE - LC),0),3,1) / SMA(ABS((CLOSE - LC)),3,1)) * 100);
FF:=EMA(CLOSE,3);
MA15:=EMA(CLOSE,21); DRAWTEXT(CROSS(85,RSI),75,'▼'),COLORGREEN;
VAR1:=IF(YEAR>=2038 AND MONTH>=1,0,1);
VAR2:=REF(LOW,1)*VAR1;
VAR3:=SMA(ABS(LOW-VAR2),3,1)/SMA(MAX(LOW-VAR2,0),3,1)*100*VAR1;
VAR4:=EMA(IF(CLOSE*1.3,VAR3*10,VAR3/10),3)*VAR1;
VAR5:=LLV(LOW,30)*VAR1;
VAR6:=HHV(VAR4,30)*VAR1;
VAR7:=IF(MA(CLOSE,58),1,0)*VAR1;
VAR8:=EMA(IF(LOW<=VAR5,(VAR4+VAR6*2)/2,0),3)/618*VAR7*VAR1;
吸筹A:IF(VAR8>100,100,VAR8)*VAR1,COLORRED;
吸筹B:STICKLINE(吸筹A>-150,0,吸筹A,8,0),COLORRED;

散户线: 100*(HHV(HIGH,M)-CLOSE)/(HHV(HIGH,M)-LLV(LOW,M)),COLORFFFF00,LINETHICK2;
RSV:=(CLOSE-LLV(LOW,N))/(HHV(HIGH,N)-LLV(LOW,N))*100;
K:=SMA(RSV,3,1);
D:=SMA(K,3,1);
J:=3*K-2*D;
主力线:EMA(J,5),COLORFF00FF,LINETHICK2;
DRAWICON(CROSS(主力线,散户线),主力线,1);
DRAWICON(CROSS(散户线,主力线),主力线,2);
*/

function LighterIndex4() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('资金分析');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("吸筹", 55),
    new IndexInfo("散户线", 34),
    new IndexInfo("主力线", null),
    new IndexInfo("吸筹B", null),
  );

  this.Index[0].LineColor = 'rgb(251,47,59)';
  this.Index[1].LineColor = 'rgb(170,137,189)';
  this.Index[2].LineColor = 'rgb(243,152,0)';
  this.Index[3].LineColor = 'rgb(251,47,59)';

  this.Create = function (hqChart, windowIndex) {
    for (var i in this.Index) {
      var paint = null;
      switch (this.Index[i].Name) {
        case '吸筹':
        case '散户线':
        case '主力线':
          paint = new ChartLine();
          paint.Color = this.Index[i].LineColor;
          break;
        case '吸筹B':
          paint = new ChartStickLine();
          paint.Color = this.Index[i].LineColor;
          paint.LineWidth = 8;
          break;
      }

      paint.Canvas = hqChart.Canvas;
      paint.Name = this.Name;
      paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
      paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;
      hqChart.ChartPaint.push(paint);
    }
  }

  this.BindData = function (hqChart, windowIndex, hisData) {
    let paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    let closeData = hisData.GetClose();
    let highData = hisData.GetHigh();
    let lowData = hisData.GetLow();
    let yearData = hisData.GetYear();
    let monthData = hisData.GetMonth();

    //LC:=REF(CLOSE,1);
    let LC = HQIndexFormula.REF(closeData, 1);

    //RSI:=((SMA(MAX((CLOSE - LC),0),3,1) / SMA(ABS((CLOSE - LC)),3,1)) * 100);
    let RSI = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_DIVIDE(HQIndexFormula.SMA(HQIndexFormula.MAX(HQIndexFormula.ARRAY_SUBTRACT(closeData, LC), 0), 3, 1),
        HQIndexFormula.SMA(HQIndexFormula.ABS(HQIndexFormula.ARRAY_SUBTRACT(closeData, LC)), 3, 1)),
      100);

    //FF:=EMA(CLOSE,3);
    let FF = HQIndexFormula.EMA(closeData, 3);
    //MA15:=EMA(CLOSE,21);
    let MA15 = HQIndexFormula.EMA(closeData, 21);
    //VAR1:=IF(YEAR>=2038 AND MONTH>=1,0,1);
    let VAR1 = HQIndexFormula.ARRAY_IF(HQIndexFormula.ARRAY_ADD(
      HQIndexFormula.ARRAY_GTE(yearData, 2038), HQIndexFormula.ARRAY_LTE(monthData, 1)),
      0, 1);
    //VAR2:=REF(LOW,1)*VAR1;
    let VAR2 = HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(lowData, 1), VAR1);
    //VAR3:=SMA(ABS(LOW-VAR2),3,1)/SMA(MAX(LOW-VAR2,0),3,1)*100*VAR1;
    let VAR3 = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.SMA(HQIndexFormula.ABS(HQIndexFormula.ARRAY_SUBTRACT(lowData, VAR2)), 3, 1),
        HQIndexFormula.SMA(HQIndexFormula.MAX(HQIndexFormula.ARRAY_SUBTRACT(lowData, VAR2), 0), 3, 1)),
      100, VAR1);
    //VAR4:=EMA(IF(CLOSE*1.3,VAR3*10,VAR3/10),3)*VAR1;
    let VAR4 = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.EMA(HQIndexFormula.ARRAY_IF(
        HQIndexFormula.ARRAY_MULTIPLY(closeData, 1.3),
        HQIndexFormula.ARRAY_MULTIPLY(VAR3, 10),
        HQIndexFormula.ARRAY_DIVIDE(VAR3, 10)), 3),
      VAR1);
    //VAR5:=LLV(LOW,30)*VAR1;
    let VAR5 = HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.LLV(lowData, 30), VAR1);
    //VAR6:=HHV(VAR4,30)*VAR1;
    let VAR6 = HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.HHV(VAR4, 30), VAR1);
    //VAR7:=IF(MA(CLOSE,58),1,0)*VAR1;
    let VAR7 = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_IF(HQIndexFormula.MA(closeData, 58), 1, 0),
      VAR1);
    //VAR8:=EMA(IF(LOW<=VAR5,(VAR4+VAR6*2)/2,0),3)/618*VAR7*VAR1;
    let VAR8 = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.EMA(
          HQIndexFormula.ARRAY_IF(
            HQIndexFormula.ARRAY_LTE(lowData, VAR5),
            HQIndexFormula.ARRAY_DIVIDE(HQIndexFormula.ARRAY_ADD(HQIndexFormula.ARRAY_MULTIPLY(VAR6, 2), VAR4), 2),
            0),
          3),
        618),
      VAR7, VAR1);

    //吸筹A:IF(VAR8>100,100,VAR8)*VAR1,COLORRED;
    let XiChouA = HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.ARRAY_IF(HQIndexFormula.ARRAY_GT(VAR8, 100), 100, VAR8), VAR1);
    //吸筹B:STICKLINE(吸筹A>-150,0,吸筹A,8,0),COLORRED;
    let XiChouB = HQIndexFormula.STICKLINE(HQIndexFormula.ARRAY_GT(XiChouA, -150), 0, XiChouA, 0);

    //散户线: 100*(HHV(HIGH,M)-CLOSE)/(HHV(HIGH,M)-LLV(LOW,M)),COLORFFFF00,LINETHICK2;
    let SanHuXian = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.HHV(highData, this.Index[0].Param), closeData),
        HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.HHV(highData, this.Index[0].Param), HQIndexFormula.LLV(lowData, this.Index[0].Param)))
      , 100);


    //RSV:=(CLOSE-LLV(LOW,N))/(HHV(HIGH,N)-LLV(LOW,N))*100;
    let RSV = HQIndexFormula.ARRAY_MULTIPLY(
      HQIndexFormula.ARRAY_DIVIDE(
        HQIndexFormula.ARRAY_SUBTRACT(closeData, HQIndexFormula.LLV(lowData, this.Index[1].Param)),
        HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.HHV(highData, this.Index[1].Param), HQIndexFormula.LLV(lowData, this.Index[1].Param)))
      , 100);
    //K:=SMA(RSV,3,1);
    let K = HQIndexFormula.SMA(RSV, 3, 1);
    //D:=SMA(K,3,1);
    let D = HQIndexFormula.SMA(K, 3, 1);
    //J:=3*K-2*D;
    let J = HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.ARRAY_MULTIPLY(K, 3), HQIndexFormula.ARRAY_MULTIPLY(D, 2));
    //主力线:EMA(J,5),COLORFF00FF,LINETHICK2;
    let ZhuLiXian = HQIndexFormula.EMA(J, 5);

    paint[0].Data.Data = XiChouA;
    paint[1].Data.Data = SanHuXian;
    paint[2].Data.Data = ZhuLiXian;
    paint[3].Data.Data = XiChouB;

    let titleIndex = windowIndex + 1;

    for (let i in paint) {
      if (i >= 3) break;
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }


    // if (XiChouA.length > 0) {
    //   let value = XiChouA[XiChouA.length - 1];
    //   // let text = this.GetTextCallback(value);
    //   console.log("valueoooooo", value)
    //   hqChart.TitlePaint[titleIndex].Text = [];
    //   hqChart.TitlePaint[titleIndex].Text[0] = { Text: ' 吸筹:', Color: 'rgb(251,47,59)' };
    //   hqChart.TitlePaint[titleIndex].Text[1] = { Text: value, Color: 'rgb(251,47,59)' };
    // }



    // hqChart.TitlePaint[titleIndex].Title = this.Name;

    this.InvokeUpdateUICallback(paint);

    return true;
  }
}


/*
    能图-市场关注度
*/

function LighterIndex5() {
  this.newMethod = MarketAttentionIndex;   //派生
  this.newMethod();
  delete this.newMethod;

  /*
      this.Index = new Array(
          new IndexInfo('0-2', null),
          new IndexInfo('3-4', null),
          new IndexInfo('5', null),
      );
  
      //线段颜色 找UI要
      this.Index[0].LineColor = 'rgb(0,0,138)';
      this.Index[1].LineColor = 'rgb(246,46,47)';
      this.Index[2].LineColor = 'rgb(246,46,47)';
  
  
      this.Create = function (hqChart, windowIndex) 
      {
          for (var i in this.Index) 
          {
              var paint = new ChartBar();   //柱子
              paint.Canvas = hqChart.Canvas;
              paint.Name = this.Name + "-" + i.toString();
              paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
              paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;
              paint.UpBarColor = paint.DownBarColor = 'rgb(243,152,0)';
  
              hqChart.ChartPaint.push(paint);
          }
      }
  */

  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    //TODO: 把this.Data 根据 [0-2] ,(2-4] (4-5] 拆成3个数组 赋值给画法 paint[0] - paint[1]

    //paint[0].Data.Data=SWLData;
    paint[0].Data.Data = this.Data;
    paint[0].NotSupportMessage = null;

    //把0的数据都换成0.1 这样柱子可以画出来
    for (let i in this.Data) {
      var item = this.Data[i];
      if (item == 0) this.Data[i] = 0.1;
    }

    var titleIndex = windowIndex + 1;

    for (let i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.TitleColor);
      hqChart.TitlePaint[titleIndex].Data[i].StringFormat = STRING_FORMAT_TYPE.THOUSANDS;
      hqChart.TitlePaint[titleIndex].Data[i].FloatPrecision = 0;
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }
}

/*
钱龙长线
LC := REF(CLOSE,1);
VID := SUM(VOL,2)/(((HHV(HIGH,2)-LLV(LOW,2)))*100);
RC := (CLOSE-LC)*VID;
LONG := SUM(RC,0);
DIFF := SMA(LONG,10,1);
DEA := SMA(LONG,20,1);
LON : DIFF-DEA;
LONMA : MA(LON,10);
LONT : LON, COLORSTICK;
*/
function LonIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('LON');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo("LON", null),
    new IndexInfo("LONMA", 10),
    new IndexInfo("LONT", null)
  );
  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.DefaultTextColor;
  this.Create = function (hqChart, windowIndex) {
    for (var i in this.Index) {
      var paint = null;
      if (this.Index[i].Name == 'LONT') {
        paint = new ChartMACD();
        paint.Color = this.Index[i].LineColor;
      }
      else {
        paint = new ChartLine();
        paint.Color = this.Index[i].LineColor;
        paint.LineWidth = 1;
      }

      paint.Canvas = hqChart.Canvas;
      paint.Name = this.Name;
      paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
      paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;
      hqChart.ChartPaint.push(paint);
    }
  }
  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != 3) return false;

    var closeData = hisData.GetClose();
    var highData = hisData.GetHigh();
    var lowData = hisData.GetLow();
    var volData = hisData.GetVol();
    var lcData = HQIndexFormula.REF(closeData, 1);
    var vidData2 = HQIndexFormula.ARRAY_SUBTRACT(HQIndexFormula.HHV(highData, 2), HQIndexFormula.LLV(lowData, 2));
    var vidData3 = HQIndexFormula.ARRAY_MULTIPLY(vidData2, 100);
    var vidData = HQIndexFormula.ARRAY_DIVIDE(HQIndexFormula.SUM(volData, 2), vidData3);
    var rcData = HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.ARRAY_SUBTRACT(closeData, lcData), vidData);
    var longData = HQIndexFormula.SUM(rcData, 0);
    var diffData = HQIndexFormula.SMA(longData, 10, 1);
    var deaData = HQIndexFormula.SMA(longData, 20, 1);
    var lonData = HQIndexFormula.ARRAY_SUBTRACT(diffData, deaData);
    var lonmaData = HQIndexFormula.MA(lonData, 10);
    var lontData = lonData;

    paint[0].Data.Data = lonData;
    paint[1].Data.Data = lonmaData;
    paint[2].Data.Data = lontData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }


}
/*   飞龙四式
蜻蜓点水:=EMA(CLOSE,5),COLORGRAY;
魔界:=EMA(CLOSE,10),colorgreen;
水:=EMA(CLOSE,50),colorwhite;
生命线:MA(CLOSE,60),COLORBLUE,LINETHICK2;
DRAWBAND(魔界,RGB(250,250,250),水,RGB(250,250,0));
DRAWBAND(蜻蜓点水,RGB(128,138,135),魔界,RGB(0,0,255));
*/
function DragonFourIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('飞龙四式');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo(null, null),
    new IndexInfo(null, null),
    new IndexInfo("生命线", null)
  );
  this.Index[0].LineColor = g_JSChartResource.Index.LineColor[0];
  this.Index[1].LineColor = g_JSChartResource.Index.LineColor[1];
  this.Index[2].LineColor = g_JSChartResource.DefaultTextColor;
  this.Create = function (hqChart, windowIndex) {
    for (var i in this.Index) {
      var paint = null;
      if (this.Index[i].Name == '生命线') {
        paint = new ChartLine();
        paint.Color = this.Index[i].LineColor;
        paint.LineWidth = 1;
      }
      else {
        paint = new ChartBand();
        if (i == 0) {
          paint.FirstColor = g_JSChartResource.Index.LineColor[0];
          paint.SecondColor = g_JSChartResource.Index.LineColor[1];
        }
        else {
          paint.FirstColor = g_JSChartResource.Index.LineColor[2];
          paint.SecondColor = g_JSChartResource.Index.LineColor[3];
        }
      }

      paint.Canvas = hqChart.Canvas;
      paint.Name = this.Name;
      paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
      paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;
      hqChart.ChartPaint.push(paint);
    }
  }
  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;

    var closeData = hisData.GetClose();
    var qddsData = HQIndexFormula.MA(closeData, 5);
    var mjData = HQIndexFormula.MA(closeData, 10);
    var waterData = HQIndexFormula.MA(closeData, 50);
    var smxData = HQIndexFormula.MA(closeData, 60);

    var mjsData = [];
    for (var i = 0; i < mjData.length && i < waterData.length; ++i) {
      mjsData[i] = { Value: mjData[i], Value2: waterData[i] };
    }
    var qddsmjData = [];
    for (var i = 0; i < qddsData.length && i < mjData.length; ++i) {
      qddsmjData[i] = { Value: qddsData[i], Value2: mjData[i] };
    }
    paint[0].Data.Data = mjsData;
    paint[1].Data.Data = qddsmjData;
    paint[2].Data.Data = smxData;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }


}
/*
倍:VOL>=REF(V,1)*1.90 AND C>REF(C,1),COLORYELLOW;
低:VOL<REF(LLV(VOL,13),1),COLORGREEN;
地:VOL<REF(LLV(VOL,100),1),COLORMAGENTA; 
平:ABS(VOL-HHV(REF(VOL,1),5))/HHV(REF(VOL,1),5)<=0.03 OR ABS(VOL-REF(VOL,1))/REF(VOL,1)<=0.03,NODRAW,COLORWHITE;
倍缩:VOL<=REF(V,1)*0.5,COLORFF8000;
梯量:COUNT(V>REF(V,1),3)=3 AND COUNT(C>O,3)=3,COLORBROWN;
缩量涨:COUNT(C>REF(C,1),2)=2 AND COUNT(V<REF(V,1),2)=2,COLORBLUE;

STICKLINE(C>=REF(C,1),V,0,2,0),COLORRED;
STICKLINE(C<REF(C,1),V,0,2,0),COLORGREEN;

STICKLINE(倍,0,V,2,0),COLORYELLOW;
STICKLINE(低,0,V,2,0),COLORGREEN;
STICKLINE(地,0,V,2,0),COLORLIMAGENTA;
STICKLINE(平,0,V,2,0),COLORWHITE;
STICKLINE(倍缩,0,V,2,0),COLORFF8000;
STICKLINE(梯量,0,V,2,0),COLORBROWN;
STICKLINE(缩量涨,0,V,2,0),COLORBLUE;
*/
function DragonFourFigureIndex() {
  this.newMethod = BaseIndex;   //派生
  this.newMethod('飞龙四式-附图');
  delete this.newMethod;

  this.Index = new Array(
    new IndexInfo('倍', null),
    new IndexInfo('低', null),
    new IndexInfo('地', null),
    new IndexInfo('平', null),
    new IndexInfo('倍缩', null),
    new IndexInfo('梯量', null),
    new IndexInfo('缩量涨', null),
    new IndexInfo(null, null),
    new IndexInfo(null, null),
    new IndexInfo(null, null),
    new IndexInfo(null, null),
    new IndexInfo(null, null),
    new IndexInfo(null, null),
    new IndexInfo(null, null),
    new IndexInfo(null, null),
    new IndexInfo(null, null)
  );
  for (var i in this.Index) {
    if (i < 7)
      this.Index[i].LineColor = g_JSChartResource.Index.LineColor[i];
    else if (i == 7)
      this.Index[i].LineColor = g_JSChartResource.UpBarColor;
    else if (i == 8)
      this.Index[i].LineColor = g_JSChartResource.DownBarColor;
    else
      this.Index[i].LineColor = g_JSChartResource.Index.LineColor[i - 9];
  }

  this.Create = function (hqChart, windowIndex) {
    for (var i in this.Index) {
      var paint = null;
      if (i < 7) {
        paint = new ChartLine();
        paint.Color = this.Index[i].LineColor;
        paint.LineWidth = 1;
        if (this.Index[i].Name == '平')
          paint.IsShow = false;
      }
      else {
        paint = new ChartStickLine();
        paint.Color = this.Index[i].LineColor;
        paint.LineWidth = 2;
      }

      paint.Canvas = hqChart.Canvas;
      paint.Name = this.Name;
      paint.ChartBorder = hqChart.Frame.SubFrame[windowIndex].Frame.ChartBorder;
      paint.ChartFrame = hqChart.Frame.SubFrame[windowIndex].Frame;
      hqChart.ChartPaint.push(paint);
    }
  }
  this.BindData = function (hqChart, windowIndex, hisData) {
    var paint = hqChart.GetChartPaint(windowIndex);

    if (paint.length != this.Index.length) return false;
    var dataVol = hisData.GetVol();
    var dataClose = hisData.GetClose();
    var dataOpen = hisData.GetOpen();
    //倍:VOL>=REF(V,1)*1.90 AND C>REF(C,1),COLORYELLOW;
    var data1 = HQIndexFormula.REF(dataVol, 1);
    var data2 = HQIndexFormula.ARRAY_MULTIPLY(data1, 1.90);
    var data3 = HQIndexFormula.ARRAY_GTE(dataVol, data2);
    var data4 = HQIndexFormula.REF(dataClose, 1);
    var data5 = HQIndexFormula.ARRAY_GT(dataClose, data4);
    var dataBei = HQIndexFormula.ARRAY_AND(data3, data5);
    paint[0].Data.Data = dataBei;
    var dataBeiStick = HQIndexFormula.STICKLINE(dataBei, 0, dataVol);
    paint[9].Data.Data = dataBeiStick;
    //低:VOL<REF(LLV(VOL,13),1),COLORGREEN;
    var data6 = HQIndexFormula.LLV(dataVol, 13);
    var data7 = HQIndexFormula.REF(data6, 1);
    var dataDi = HQIndexFormula.ARRAY_LT(dataVol, data7);
    paint[1].Data.Data = dataDi;
    var dataDiStick = HQIndexFormula.STICKLINE(dataDi, 0, dataVol);
    paint[10].Data.Data = dataDiStick;
    //地:VOL<REF(LLV(VOL,100),1),COLORMAGENTA; 
    var data8 = HQIndexFormula.LLV(dataVol, 100);
    var data9 = HQIndexFormula.REF(data8, 1);
    var dataDi2 = HQIndexFormula.ARRAY_LT(dataVol, data9);
    paint[2].Data.Data = dataDi2;
    var dataDiStick2 = HQIndexFormula.STICKLINE(dataDi2, 0, dataVol);
    paint[11].Data.Data = dataDiStick2;
    //平:ABS(VOL-HHV(REF(VOL,1),5))/HHV(REF(VOL,1),5)<=0.03 OR ABS(VOL-REF(VOL,1))/REF(VOL,1)<=0.03,NODRAW,COLORWHITE;
    var data10 = HQIndexFormula.ABS(HQIndexFormula.ARRAY_SUBTRACT(dataVol, HQIndexFormula.HHV(HQIndexFormula.REF(dataVol, 1), 5)));
    var data11 = HQIndexFormula.HHV(HQIndexFormula.REF(dataVol, 1), 5);
    var data12 = HQIndexFormula.ARRAY_LTE(HQIndexFormula.ARRAY_DIVIDE(data10, data11), 0.03);
    var data13 = HQIndexFormula.ABS(HQIndexFormula.ARRAY_SUBTRACT(dataVol, HQIndexFormula.REF(dataVol, 1)));
    var data14 = HQIndexFormula.ARRAY_LTE(HQIndexFormula.ARRAY_DIVIDE(data13, HQIndexFormula.REF(dataVol, 1)), 0.03);
    var dataPin = HQIndexFormula.ARRAY_OR(data12, data14);
    paint[3].Data.Data = dataPin;
    var dataPinStick = HQIndexFormula.STICKLINE(dataPin, 0, dataVol);
    paint[12].Data.Data = dataPinStick;
    //倍缩:VOL<=REF(V,1)*0.5,COLORFF8000;
    var dataBeiSuo = HQIndexFormula.ARRAY_LTE(dataVol, HQIndexFormula.ARRAY_MULTIPLY(HQIndexFormula.REF(dataVol, 1), 0.5));
    paint[4].Data.Data = dataBeiSuo;
    var dataBeiSuoStick = HQIndexFormula.STICKLINE(dataBeiSuo, 0, dataVol);
    paint[13].Data.Data = dataBeiSuoStick;
    //梯量:COUNT(V>REF(V,1),3)=3 AND COUNT(C>O,3)=3,COLORBROWN;
    var data15 = HQIndexFormula.COUNT(HQIndexFormula.ARRAY_GT(dataVol, HQIndexFormula.REF(dataVol, 1)), 3);
    var data16 = HQIndexFormula.COUNT(HQIndexFormula.ARRAY_GT(dataClose, dataOpen), 3);
    var dataTiLiang = HQIndexFormula.ARRAY_AND(HQIndexFormula.ARRAY_EQ(data15, 3), HQIndexFormula.ARRAY_EQ(data16, 3));
    paint[5].Data.Data = dataTiLiang;
    var dataTiLiangStick = HQIndexFormula.STICKLINE(dataTiLiang, 0, dataVol);
    paint[14].Data.Data = dataTiLiangStick;
    //缩量涨:COUNT(C>REF(C,1),2)=2 AND COUNT(V<REF(V,1),2)=2,COLORBLUE;
    var data17 = HQIndexFormula.COUNT(HQIndexFormula.ARRAY_GT(dataClose, HQIndexFormula.REF(dataClose, 1)), 2);
    var data18 = HQIndexFormula.COUNT(HQIndexFormula.ARRAY_LT(dataVol, HQIndexFormula.REF(dataVol, 1)), 2);
    var dataSLZ = HQIndexFormula.ARRAY_AND(HQIndexFormula.ARRAY_EQ(data17, 2), HQIndexFormula.ARRAY_EQ(data18, 2));
    paint[6].Data.Data = dataSLZ;
    var dataSLZStick = HQIndexFormula.STICKLINE(dataSLZ, 0, dataVol);
    paint[15].Data.Data = dataSLZStick;

    //STICKLINE(C>=REF(C,1),V,0,2,0),COLORRED;
    //STICKLINE(C<REF(C,1),V,0,2,0),COLORGREEN;
    var data19 = HQIndexFormula.ARRAY_GTE(dataClose, HQIndexFormula.REF(dataClose, 1));
    var data20 = HQIndexFormula.STICKLINE(data19, dataVol, 0);
    paint[7].Data.Data = data20;
    var data21 = HQIndexFormula.ARRAY_LT(dataClose, HQIndexFormula.REF(dataClose, 1));
    var data22 = HQIndexFormula.STICKLINE(data21, dataVol, 0);
    paint[8].Data.Data = data22;

    var titleIndex = windowIndex + 1;

    for (var i in paint) {
      hqChart.TitlePaint[titleIndex].Data[i] = new DynamicTitleData(paint[i].Data, this.Index[i].Name, this.Index[i].LineColor);
    }

    hqChart.TitlePaint[titleIndex].Title = this.FormatIndexTitle();
    return true;
  }


}

/*
    信息地雷
*/

/*
    信息地雷列表
*/
function JSKLineInfoMap() {
}

JSKLineInfoMap.Get = function (id) {
  var infoMap = new Map(
    [
      ["互动易", { Create: function () { return new InvestorInfo() } }],
      ["公告", { Create: function () { return new AnnouncementInfo() } }],
      ["业绩预告", { Create: function () { return new PforecastInfo() } }],
      ["调研", { Create: function () { return new ResearchInfo() } }],
      ["大宗交易", { Create: function () { return new BlockTrading() } }],
      ["龙虎榜", { Create: function () { return new TradeDetail() } }]
    ]
  );

  return infoMap.get(id);
}

JSKLineInfoMap.GetIconUrl = function (type) {
  switch (type) {
    case KLINE_INFO_TYPE.INVESTOR:
      return g_JSChartResource.KLine.Info.Investor.Icon;
      break;
    case KLINE_INFO_TYPE.PFORECAST:
      return g_JSChartResource.KLine.Info.Pforecast.Icon;
    case KLINE_INFO_TYPE.ANNOUNCEMENT:
      return g_JSChartResource.KLine.Info.Announcement.Icon;
    case KLINE_INFO_TYPE.ANNOUNCEMENT_QUARTER_1:
    case KLINE_INFO_TYPE.ANNOUNCEMENT_QUARTER_2:
    case KLINE_INFO_TYPE.ANNOUNCEMENT_QUARTER_3:
    case KLINE_INFO_TYPE.ANNOUNCEMENT_QUARTER_4:
      return g_JSChartResource.KLine.Info.Announcement.IconQuarter;
    case KLINE_INFO_TYPE.RESEARCH:
      return g_JSChartResource.KLine.Info.Research.Icon;
    case KLINE_INFO_TYPE.BLOCKTRADING:
      return g_JSChartResource.KLine.Info.BlockTrading.Icon;
    case KLINE_INFO_TYPE.TRADEDETAIL:
      return g_JSChartResource.KLine.Info.TradeDetail.Icon;
    default:
      return g_JSChartResource.KLine.Info.Announcement.Icon;
  }
}


function IKLineInfo() {
  this.MaxReqeustDataCount = 1000;
  this.StartDate = 20160101;
  this.Data;

  this.GetToday = function () {
    var date = new Date();
    var today = date.getFullYear() * 10000 + (date.getMonth() + 1) * 100 + date.getDate();
    return today;
  }
}


/*
    互动易
*/
function InvestorInfo() {
  this.newMethod = IKLineInfo;   //派生
  this.newMethod();
  delete this.newMethod;

  this.RequestData = function (hqChart) {
    var self = this;
    var param =
      {
        HQChart: hqChart,
      };

    this.Data = [];

    //请求数据
    $.ajax({
      url: g_JSChartResource.KLine.Info.Investor.ApiUrl,
      data:
        {
          "filed": ["question", "answerdate", "symbol", "id"],
          "symbol": [param.HQChart.Symbol],
          "querydate": { "StartDate": this.StartDate, "EndDate": this.GetToday() },
          "start": 0,
          "end": this.MaxReqeustDataCount,
        },
      type: "post",
      dataType: "json",
      async: true,
      success: function (recvData) {
        self.RecvData(recvData, param);
      }
    });

    return true;
  }

  this.RecvData = function (recvData, param) {
    if (recvData.list.length <= 0) return;

    for (var i in recvData.list) {
      var item = recvData.list[i];
      var infoData = new KLineInfoData();
      infoData.Date = item.answerdate;
      infoData.Title = item.question;
      infoData.InfoType = KLINE_INFO_TYPE.INVESTOR;
      this.Data.push(infoData);
    }

    param.HQChart.UpdataChartInfo();
    param.HQChart.Draw();
  }
}

/*
    公告
*/
function AnnouncementInfo() {
  this.newMethod = IKLineInfo;   //派生
  this.newMethod();
  delete this.newMethod;

  this.RequestData = function (hqChart) {
    var self = this;
    var param =
      {
        HQChart: hqChart,
      };

    this.Data = [];

    //请求数据
    $.ajax({
      url: g_JSChartResource.KLine.Info.Announcement.ApiUrl,
      data:
        {
          "filed": ["title", "releasedate", "symbol", "id"],
          "symbol": [param.HQChart.Symbol],
          "querydate": { "StartDate": this.StartDate, "EndDate": this.GetToday() },
          "start": 0,
          "end": this.MaxReqeustDataCount,
        },
      type: "post",
      dataType: "json",
      async: true,
      success: function (recvData) {
        self.RecvData(recvData, param);
      }
    });

    return true;
  }

  this.RecvData = function (recvData, param) {
    if (recvData.report.length <= 0) return;

    for (var i in recvData.report) {
      var item = recvData.report[i];
      var infoData = new KLineInfoData();
      infoData.Date = item.releasedate;
      infoData.Title = item.title;
      infoData.InfoType = KLINE_INFO_TYPE.ANNOUNCEMENT;
      for (var j in item.type) {
        var typeItem = item.type[j];
        switch (typeItem) {
          case "一季度报告":
            infoData.InfoType = KLINE_INFO_TYPE.ANNOUNCEMENT_QUARTER_1;
            break;
          case "半年度报告":
            infoData.InfoType = KLINE_INFO_TYPE.ANNOUNCEMENT_QUARTER_2;
            break;
          case "三季度报告":
            infoData.InfoType = KLINE_INFO_TYPE.ANNOUNCEMENT_QUARTER_3;
            break;
          case "年度报告":
            infoData.InfoType = KLINE_INFO_TYPE.ANNOUNCEMENT_QUARTER_4;
            break;
        }
      }
      this.Data.push(infoData);
    }

    param.HQChart.UpdataChartInfo();
    param.HQChart.Draw();
  }
}


/*
    业绩预告
*/
function PforecastInfo() {
  this.newMethod = IKLineInfo;   //派生
  this.newMethod();
  delete this.newMethod;

  this.RequestData = function (hqChart) {
    var self = this;
    var param =
      {
        HQChart: hqChart,
      };

    this.Data = [];

    //请求数据
    $.ajax({
      url: g_JSChartResource.KLine.Info.Pforecast.ApiUrl,
      data:
        {
          "field": ["pforecast.type", "pforecast.reportdate", "fweek"],
          "condition":
            [
              { "item": ["pforecast.reportdate", "int32", "gte", this.StartDate] }
            ],
          "symbol": [param.HQChart.Symbol],
          "start": 0,
          "end": this.MaxReqeustDataCount,
        },
      type: "post",
      dataType: "json",
      async: true,
      success: function (recvData) {
        self.RecvData(recvData, param);
      }
    });

    return true;
  }

  this.RecvData = function (recvData, param) {
    if (recvData.stock.length != 1) return;
    if (recvData.stock[0].stockday.length <= 0) return;

    for (var i in recvData.stock[0].stockday) {
      var item = recvData.stock[0].stockday[i];
      if (item.pforecast.length > 0) {
        var dataItem = item.pforecast[0];
        var infoData = new KLineInfoData();
        infoData.Date = item.date;
        infoData.Title = dataItem.type;
        infoData.InfoType = KLINE_INFO_TYPE.PFORECAST;
        infoData.ExtendData = { Type: dataItem.type, ReportDate: dataItem.reportdate }
        if (item.fweek)  //未来周涨幅
        {
          infoData.ExtendData.FWeek = {};
          if (item.fweek.week1 != null) infoData.ExtendData.FWeek.Week1 = item.fweek.week1;
          if (item.fweek.week4 != null) infoData.ExtendData.FWeek.Week4 = item.fweek.week4;
        }
        this.Data.push(infoData);
      }
    }

    param.HQChart.UpdataChartInfo();
    param.HQChart.Draw();
  }
}

/*
   投资者关系 (调研)
*/
function ResearchInfo() {
  this.newMethod = IKLineInfo;   //派生
  this.newMethod();
  delete this.newMethod;

  this.RequestData = function (hqChart) {
    var self = this;
    var param =
      {
        HQChart: hqChart,
      };

    this.Data = [];

    //请求数据
    $.ajax({
      url: g_JSChartResource.KLine.Info.Research.ApiUrl,
      data:
        {
          "filed": ["releasedate", "researchdate", "level", "symbol", "id"],
          "querydate": { "StartDate": this.StartDate, "EndDate": this.GetToday() },
          "symbol": [param.HQChart.Symbol],
          "start": 0,
          "end": this.MaxReqeustDataCount,
        },
      type: "post",
      dataType: "json",
      async: true,
      success: function (recvData) {
        self.RecvData(recvData, param);
      }
    });

    return true;
  }

  this.RecvData = function (recvData, param) {
    if (recvData.list.length <= 0) return;

    for (var i in recvData.list) {
      var item = recvData.list[i];
      var infoData = new KLineInfoData();
      infoData.ID = item.id;
      infoData.Date = item.researchdate;
      infoData.InfoType = KLINE_INFO_TYPE.RESEARCH;
      infoData.ExtendData = { Level: item.level };
      this.Data.push(infoData);

    }

    param.HQChart.UpdataChartInfo();
    param.HQChart.Draw();
  }
}

/*
    大宗交易
*/
function BlockTrading() {
  this.newMethod = IKLineInfo;   //派生
  this.newMethod();
  delete this.newMethod;

  this.RequestData = function (hqChart) {
    var self = this;
    var param =
      {
        HQChart: hqChart,
      };

    this.Data = [];

    //请求数据
    $.ajax({
      url: g_JSChartResource.KLine.Info.BlockTrading.ApiUrl,
      data:
        {
          "field": ["blocktrading.price", "blocktrading.vol", "blocktrading.premium", "fweek", "price"],
          "condition":
            [
              { "item": ["date", "int32", "gte", this.StartDate] },
              { "item": ["blocktrading.vol", "int32", "gte", "0"] }
            ],
          "symbol": [param.HQChart.Symbol],
          "start": 0,
          "end": this.MaxReqeustDataCount,
        },
      type: "post",
      dataType: "json",
      async: true,
      success: function (recvData) {
        self.RecvData(recvData, param);
      }
    });

    return true;
  }

  this.RecvData = function (recvData, param) {
    if (recvData.stock.length != 1) return;
    if (recvData.stock[0].stockday.length <= 0) return;

    for (var i in recvData.stock[0].stockday) {
      var item = recvData.stock[0].stockday[i];
      var infoData = new KLineInfoData();
      infoData.Date = item.date;
      infoData.InfoType = KLINE_INFO_TYPE.BLOCKTRADING;
      infoData.ExtendData =
        {
          Price: item.blocktrading.price,          //交易价格
          Premium: item.blocktrading.premium,      //溢价 （百分比%)
          Vol: item.blocktrading.vol,              //交易金额单位（万元)
          ClosePrice: item.price,                  //收盘价
        };

      if (item.fweek)  //未来周涨幅
      {
        infoData.ExtendData.FWeek = {};
        if (item.fweek.week1 != null) infoData.ExtendData.FWeek.Week1 = item.fweek.week1;
        if (item.fweek.week4 != null) infoData.ExtendData.FWeek.Week4 = item.fweek.week4;
      }

      this.Data.push(infoData);
    }

    param.HQChart.UpdataChartInfo();
    param.HQChart.Draw();
  }
}


/*
    龙虎榜
*/
function TradeDetail() {
  this.newMethod = IKLineInfo;   //派生
  this.newMethod();
  delete this.newMethod;

  this.RequestData = function (hqChart) {
    var self = this;
    var param =
      {
        HQChart: hqChart,
      };

    this.Data = [];

    //请求数据
    $.ajax({
      url: g_JSChartResource.KLine.Info.TradeDetail.ApiUrl,
      data:
        {
          "field": ["tradedetail.typeexplain", "tradedetail.type", "fweek"],
          "condition":
            [
              { "item": ["date", "int32", "gte", this.StartDate] },
              { "item": ["tradedetail.type", "int32", "gte", "0"] }
            ],
          "symbol": [param.HQChart.Symbol],
          "start": 0,
          "end": this.MaxReqeustDataCount,
        },
      type: "post",
      dataType: "json",
      async: true,
      success: function (recvData) {
        self.RecvData(recvData, param);
      }
    });

    return true;
  }

  this.RecvData = function (recvData, param) {
    if (recvData.stock.length != 1) return;
    if (recvData.stock[0].stockday.length <= 0) return;

    for (var i in recvData.stock[0].stockday) {
      var item = recvData.stock[0].stockday[i];

      var infoData = new KLineInfoData();
      infoData.Date = item.date;
      infoData.InfoType = KLINE_INFO_TYPE.TRADEDETAIL;
      infoData.ExtendData = { Detail: new Array() };

      for (var j in item.tradedetail) {
        var tradeItem = item.tradedetail[j];
        infoData.ExtendData.Detail.push({ "Type": tradeItem.type, "TypeExplain": tradeItem.typeexplain });
      }

      if (item.fweek)  //未来周涨幅
      {
        infoData.ExtendData.FWeek = {};
        if (item.fweek.week1 != null) infoData.ExtendData.FWeek.Week1 = item.fweek.week1;
        if (item.fweek.week4 != null) infoData.ExtendData.FWeek.Week4 = item.fweek.week4;
      }

      this.Data.push(infoData);
    }

    param.HQChart.UpdataChartInfo();
    param.HQChart.Draw();
  }
}

//是否是指数代码
function IsIndexSymbol(symbol) {
  var upperSymbol = symbol.toUpperCase();
  if (upperSymbol.indexOf('.SH') > 0) {
    upperSymbol = upperSymbol.replace('.SH', '');
    if (upperSymbol.charAt(0) == '0' && parseInt(upperSymbol) <= 3000) return true;

  }
  else if (upperSymbol.indexOf('.SZ') > 0) {
    upperSymbol = upperSymbol.replace('.SZ', '');
    if (upperSymbol.charAt(0) == '3' && upperSymbol.charAt(1) == '9') return true;
  }
  else if (upperSymbol.indexOf('.CI') > 0)  //自定义指数
  {
    return true;
  }

  return false;
}

//导出统一使用JSCommon命名空间名
module.exports =
  {
    JSCommon:
      {
        JSCanvasElement: JSCanvasElement,
        JSChart: JSChart,
        Guid: Guid,
        IFrameSplitOperator: IFrameSplitOperator
      }
  };



